# sccsid = "@(#) src/hpcc/accting/Accounting.pm, hpc.cloud.accting, hpcc_rbei, rbeis002a 1.4 9/30/11 05:43:53";
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
#  
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# (C) COPYRIGHT International Business Machines Corp. 2010,2011 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 

package Accounting;

use CloudUtils;
use strict;
use warnings;

sub getProvInfo {
    my ($class) = @_;
    my $st;
    my $rv;

    $st = $::DBH->prepare("select *
                           from thc_request");
    $rv = $st->execute;

    if (!$rv) {
        #log the error $DBI::errstr
        return undef;
    }

    my $provHash = $st->fetchall_hashref('name');

    $st = $::DBH->prepare("select * from thcr_request_machine");
    $rv = $st->execute;
    if (!$rv) {
        #log the error $DBI::errstr
        return undef;
    }
    while (my $mach = $st->fetchrow_hashref()) {
        if (defined($provHash->{$mach->{'request_name'}})) {
            $provHash->{$mach->{'request_name'}}->{'machList'}->{$mach->{'machine_name'}} = {};
        }
    }


    $st = $::DBH->prepare("select * from thc_provision_machine_history");
    $rv = $st->execute;
    if (!$rv) {
        #log the error $DBI::errstr
        return undef;
    }
    while (my $mach = $st->fetchrow_hashref()) {
        if (defined($provHash->{$mach->{'request_name'}})) {
            $provHash->{$mach->{'request_name'}}->{'machList'}->{$mach->{'machine_name'}} = $mach;
        }
    }

    $st = $::DBH->prepare("select * from thcr_request_user");
    $rv = $st->execute;
    if (!$rv) {
        #log the error $DBI::errstr
        return undef;
    }

    while (my $u = $st->fetchrow_hashref()) {
        if (defined($provHash->{$u->{'request_name'}})) {
            if ($u->{'is_user_group'} == 1) {
                push @{$provHash->{$u->{'request_name'}}->{'incGrps'}}, $u->{'user_name'};
            } else {
                push @{$provHash->{$u->{'request_name'}}->{'incUsers'}}, $u->{'user_name'};
            }
        }
    }

    return $provHash;
}

sub getAllUserName {
    my ($self) = @_;
    my $h = CloudUtils->getAllUserName();
    return () unless (defined($h));
    return @$h;
}

sub getAllProvName {
    my ($self) = @_;
    my $h = Accounting->getProvInfo();
    return () unless (defined($h));
    return keys(%$h);
}

sub getProvInfoById {
    my ($self, $provId) = @_;
    
    my $h = Accounting->getProvInfo();
    return {} unless (defined($h));
    return $h->{$provId};
}

sub getProvNameByUser {
    my ($self, $uid) = @_;
    my $h = Accounting->getProvInfo();
    return () unless (defined($h));
    
    my @result = ();
    foreach my $pid (keys(%$h)) {
        push(@result, $pid) if ($h->{$pid}->{'owner'} eq $uid)
    }
    return @result;
}

sub getAllJobName {
    my ($class) = @_;
    my $st;
    my $rv;

#    $st = $::DBH->prepare("select * from THC_Job");
#    $rv = $st->execute;

#    if (!$rv) {
        #log the error $DBI::errstr
#        return ();
#    }

#    my $h=$st->fetchall_hashref('jobId');
#    unless (defined($h)) {
#        return ();
#    }

#    return keys(%$h);
    return ();
}

sub getJobInfoById {
    my ($class, $jid) = @_;
    my $st;
    my $rv;

#    $st = $::DBH->prepare("select * from THC_Job where jobId = $jid");
#    $rv = $st->execute;

#    if (!$rv) {
        #log the error $DBI::errstr
#        return undef;
#    }

#    return $st->fetchall_hashref('jobId');
    return undef;
}

sub getJobInfoByOwner {
    my ($class, $uid) = @_;
    my $st;
    my $rv;

#    $st = $::DBH->prepare("select * from THC_Job where jobOwner = '$uid'");
#    $rv = $st->execute;

#    if (!$rv) {
        #log the error $DBI::errstr
#        return ();
#    }

#    my $h= $st->fetchall_hashref('jobId');
#    unless (defined($h)) {
#        return ();
#    }

#    return keys(%$h);

    return ();
}

sub prov_ut {
    my @all_provs = Accounting->getAllProvName();
    printf("All provision: %d\n---------------------\n", scalar(@all_provs));
    foreach (@all_provs) {
        printf("|%s|\n", $_);
        my $prov = Accounting->getProvInfoById($_);
        foreach my $k (sort(keys(%$prov))) {
            printf("   %s : %s\n", uc($k), $prov->{$k});
        }
    }

    printf("\n");

    printf("Provision Owner:\n---------------------\n");
    my $u = CloudUtils->getAllUser();
    if (defined($u)) {
        foreach (keys(%$u)) {
            my @pids = Accounting->getProvNameByUser($_);
            printf("  %s : %s\n", $_, join(',', @pids));
        }
    }

    printf("\n");
}


1;
