# sccsid = "@(#) src/hpcc/common/db/ConfigDAO.pm, hpc.cloud.comm, hpcc_rbei, rbeis002a 1.4 9/30/11 05:46:02";
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
#  
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# (C) COPYRIGHT International Business Machines Corp. 2010,2011 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 
package ConfigDAO;

# --------------------------- #
#
# Config:
#    id
#    name
#    value
#
# --------------------------- #

require Exporter;
use warnings;
use strict;
require DB::DBA;
our @ISA = qw(Exporter DAO);
require DB::DAO;


use Utils::Logger;

sub new {
    my $self = DAO->new();
    bless ($self);
    return $self;
}

sub query {
    my ($self) = @_;

    my ($rc, $param);
    my $st;
    my $result;
    my $ugroup;

    # get all user info;

    my $sql = 'select #>sysconfig.*<# from #>sysconfig<#';

    ($rc, $param) = $self->{'dba'}->querySQL($sql);
    if ($rc != 0) {
	    Logger->get()->warning('db', 'query sysconfig', "Failed to query all sys config info. Reason: $param");
        return (-1, "Failed to query all sys config info. Reason: $param");
    }

    ($rc, $param) = $self->{'dba'}->fetchall_hashref('#>sysconfig.name<#', '#>sysconfig<#');
    if ($rc != 0) {
	    Logger->get()->warning('db', 'query sysconfig', "Failed to query all sys config info. Reason: $param");
        return (-1, "Failed to query all sys config info. Reason: $param");
    }
    
    $result = $param;

    if (!scalar(%$param)) {
	Logger->get()->warning('db', 'query sysconfig', "No record in sysconfig");
    	return (100, "No record.");
    }

    return (0, $result);
}

sub insert {
    my ($self, $name, $value) = @_;

    my $sql = 'insert into #>sysconfig<# (#>sysconfig.name<#, #>sysconfig.value<#) values (?, ?)';
    my @args = ([$name], [$value]);

    my ($rc, $param) = $self->{'dba'}->execSQL($sql, \@args);
    if ($rc != 0) {
    	Logger->get()->warning('db', 'insert sysconfig', "Failed to insert new sys config record. Reason: $param");
        return (-1, "Failed to insert new sys config record. Reason: $param");
    }

    return (0);
}

sub modify {
    my ($self, $name, $value) = @_;

    my $sql = 'update #>sysconfig<# set #>sysconfig.value<#=? where #>sysconfig.name<#=?';
    my @args = ([$value], [$name]);

    my ($rc, $param) = $self->{'dba'}->execSQL($sql, \@args);
    if ($rc != 0) {
    	Logger->get()->warning('db', 'modify sysconfig', "Failed to modify sys config record. Reason: $param");
        return (-1, "Failed to modify sys config record. Reason: $param");
    }

    return (0);
}

sub delete {
    my ($self, $name) = @_;

    my $sql = 'delete from #>sysconfig<# where #>sysconfig.name<#=?';
    my @args = ([$name]);

    my ($rc, $param) = $self->{'dba'}->execSQL($sql, \@args);
    if ($rc != 0) {
    	Logger->get()->warning('db', 'delete sysconfig', "Failed to delete sys config record. Reason: $param");
        return (-1, "Failed to delete sys config record. Reason: $param");
    }

    return (0);
}

1;
