# sccsid = "@(#) src/hpcc/common/db/DBA.pm, hpc.cloud.comm, hpcc_rbei, rbeis002a 1.7 12/15/11 04:19:42";
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
#  
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# (C) COPYRIGHT International Business Machines Corp. 2010,2011 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 
package DBA;

use DBI;
use strict;
use warnings;
use DB::SQLUtils;
use DB::NameUtils;
use Utils::Logger;

# Internal functions
sub getConnection {
	my $DB_FILE = {};
	my $cmd = "/opt/ibm/hpccloud/cloudbin/utils/thcsu -u root \"/opt/ibm/hpccloud/cloudbin/utils/getConffromcfg\"";
	my @out;
	eval {
	    @out = `$cmd 2>&1`;
	};
	if($@) {
	    print("@out\n");
		return undef;
	}

	my $rv = $? >> 8;
	if ($rv) {
	    print("@out\n");
	    return undef;
	}
	if (scalar(@out) == 0){
	    print ("Failed to get configuration from hpccloud.cfg.\n");
	    return undef;
	}
	foreach (@out){
	    if (/(\S+)\s*=\s*(\S+)/) {
			$DB_FILE->{$1} = $2;
	    }
	}

	my $dsn = $DB_FILE->{'DATA_SOURCE'} ? $DB_FILE->{'DATA_SOURCE'} : 'dbi:mysql:database=HCDB;host=127.0.0.1';
	my $user = $DB_FILE->{'DB_USER'} ? $DB_FILE->{'DB_USER'} : 'root';
	my $pass = $DB_FILE->{'DB_PASSWORD'} ? $DB_FILE->{'DB_PASSWORD'} : '';

	my $dbh = DBI->connect($dsn, $user, $pass, {AutoCommit=>0, RaiseError=>1, PrintError=>0});

	unless ($dbh) {
		print ("Failed to connect to DB. $DBI::errstr");
	}

	return $dbh;
}

sub releaseConnection {
	my ($dbh) = @_;
	$dbh->disconnect();
}

# Pubic functions
sub new {
	my $self = {};
	$self->{'st'} = 0;
	$self->{'re'} = 0;
	$self->{'dbh'} = &getConnection;
	bless($self);
	return $self;
}

sub DESTROY {
	my ($self) = @_;
	if (defined($self->{'dbh'})) {
		releaseConnection($self-> {'dbh'});
	}
}

sub commit {
	my ($self) = @_;
	my $hdl = $self->{'dbh'};
	$hdl->commit();
}

sub rollback {
	my ($self) = @_;
	my $hdl = $self->{'dbh'};
	$hdl->rollback();
}


sub execSQL {
	my ($self, $sql, $args) = @_;
	my $rc;
	($rc, $sql) = NameUtils->prepare($sql);
	if ($rc != 0) {
		Logger->get()->error('DBA', 'NA', "Failed to decode SQL statement. Reason: $sql");
		return ($rc, "Failed to decode SQL statement. Reason: $sql");
	}
	return SQLUtils->execSQL($self->{'dbh'}, $sql, $args);
}

sub querySQL {
	my ($self, $sql, $args) = @_;
	my $rc;
	my $replacement;
	($rc, $sql, $replacement) = NameUtils->prepare($sql);
	if ($rc != 0) {
		Logger->get()->error('DBA', 'NA', "Failed to decode SQL statement. Reason: $sql");
		return ($rc, "Failed to decode SQL statement. Reason: $sql");
	}
	$self->{'re'} = $replacement;
	my $st;
	($rc, $st) = SQLUtils->querySQL($self->{'dbh'}, $sql, $args);
	if ($rc != 0) {
		Logger->get()->error('DBA', "$args", "Failed to do the query SQL statement. Reason: $st");
		return ($rc, "Failed to do the query SQL statement. Reason: $st");
	}
	$self->{'st'} = $st;
	return (0);
}

sub fetchall_hashref {
	my ($self, $key, $default_table) = @_;
	return NameUtils->fetchall_hashref($self->{'st'}, $key, $default_table, $self->{'re'});
}

sub fetchrow_hashref {
	my ($self, $key, $default_table) = @_;
	return NameUtils->fetchrow_hashref($self->{'st'}, $key, $default_table, $self->{'re'});
}

sub finish {
	my ($self) = @_;
	if (defined($self->{'st'})) {
		$self-> {'st'}->finish();
	}
}


sub fetchrow_arrayref {
	my ($self) = @_;
	return NameUtils->fetchrow_arrayref($self->{'st'});
}

sub fetchall_arrayref {
	my ($self) = @_;
	return NameUtils->fetchall_arrayref($self->{'st'});
}

1;
