# sccsid = "@(#) src/hpcc/common/db/DBLogger.pm, hpc.cloud.comm, hpcc_rbei, rbeis002a 1.4 9/30/11 05:46:04";
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
#  
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# (C) COPYRIGHT International Business Machines Corp. 2010,2011 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 
package DBLogger;

use strict;
use warnings;
require Exporter;
use DBI;
use DB::DBA;
require DB::DAO;
our @ISA = qw(Exporter DAO);

sub new {
    my $self = {};
    $self->{'dbh'} = DBA::getConnection();
    bless ($self);
    return $self;
}

# Public functions
sub store {
    my ($self, $now, $pid, $func, $sev, $catalog, $obj, $body) = @_;
    my $dbh = $self->{'dbh'};
    
    my $sql = "insert into thc_log (log_level, log_time, pid, obj_type, obj_name, caller, message) values (?, ?, ?, ?, ?, ?, ?)";
    my $args = [[$sev],[$now],[$pid],[$catalog],[$obj],[$func],[$body]];

    my ($rc, $param) = execSQL($dbh, $sql, $args);
    if ($rc != 0) {
        $dbh->rollback();
        printf STDERR ("Error: failed to write log into Database. Reason: %s\n", $param);
    } else {
        $dbh->commit();
    }
}

sub execSQL {
    my ($dbh, $sql, $args) = @_;
    my $sth;
    my $error = 0;
    my $errmsg;
    my $valid_express;

    $valid_express = 1;
    $sth = $dbh->prepare($sql) or $valid_express = 0;

    if (defined($args) && scalar(@$args)>0) {
        my $idx = 1;
        foreach my $arg_hdl (@$args) {
            $sth->bind_param($idx, @$arg_hdl);
            $idx++;
        }
    }

    if (!$valid_express) {
        $errmsg = $dbh->errstr;
        return (-1, $errmsg);
    };

    eval {
        unless ( $sth->execute() ) {
            $error = 1;
        }
    };
    if ($@ or $error) {
        $errmsg = $DBI::errstr;
        $sth->finish();
        return (-2, $errmsg);
    }

    $sth->finish();
    return (0, 'SUCC');  # succeed
}

1;

