# sccsid = "@(#) src/hpcc/common/db/EventDAO.pm, hpc.cloud.comm, hpcc_rbei, rbeis002a 1.3 9/30/11 05:46:00";
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
#  
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# (C) COPYRIGHT International Business Machines Corp. 2010,2011 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 
package EventDAO;

# --------------------------- #
#
# Event:
#    id
#    originator
#    operater
#    type
#    object
#    time 
#    message
#
# --------------------------- #

use warnings;
use strict;
require Exporter;
require DB::DBA;

require DB::DAO;
use Utils::Logger;
our @ISA = qw(Exporter DAO);


sub new {
    my $self = DAO->new();
    bless ($self);
    return $self;
}

sub queryEvent {
    my ($self, $args) = @_;

    my $sql;
    my @where = ();
    my $bind = [];
    my $rc;
    my $param;
    my $result;

    foreach my $i (keys(%$args)) {
        if ($i =~ /^[a-z\.]+$/) {
            push(@where, "#>event.$i<#=?");
            push(@$bind, [$args->{$i}]);
        }
    }

    if (defined($args->{'time>='})) {
        push(@where, '#>event.time<#>=?');
        push(@$bind, [$args->{'time>='}]);
    }
    if (defined($args->{'time>'})) {
        push(@where, '#>event.time<#>?');
        push(@$bind, [$args->{'time>'}]);
    }
    if (defined($args->{'time<='})) {
        push(@where, '#>event.time<#<=?');
        push(@$bind, [$args->{'time<='}]);
    }
    if (defined($args->{'time<'})) {
        push(@where, '#>event.time<#<?');
        push(@$bind, [$args->{'time<'}]);
    }

    if (defined($args->{'message~'})) {
        push(@where, '#>event.message<# LIKE ?');
        push(@$bind, ['%' . $args->{'message~'} . '%']);
    }

    if (scalar(@where) > 0) {
        $sql = 'select #>event.*<# from #>event<# where ' . join(' AND ', @where);
        ($rc, $param) = $self->{'dba'}->querySQL($sql, $bind);
    } else {
        $sql = 'select #>event.*<# from #>event<#';
        ($rc, $param) = $self->{'dba'}->querySQL($sql);
    }

    if ($rc != 0) {
		Logger->get()->warning('EventDAO', "queryEvent", "Failed to query event. Reason: $param");
        return (-1, "Failed to query event. Reason: $param");
    }

    ($rc, $param) = $self->{'dba'}->fetchall_hashref('#>event.id<#', '#>event<#');
    if ($rc != 0) {
		Logger->get()->warning('EventDAO', "queryEvent", "Failed to fetch event info. Reason: $param");
        return (-1, "Failed to fetch event info. Reason: $param");
    }

    $result = $param;

	if (!scalar(%$result)){
		Logger->get()->info('EventDAO', "queryEvent", "No record.");
	    return (100, "No record.");
	}
    return (0, $result);
}

1;
