# sccsid = "@(#) src/hpcc/common/db/LogDAO.pm, hpc.cloud.comm, hpcc_rbei, rbeis002a 1.4 9/30/11 05:46:21";
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
#  
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# (C) COPYRIGHT International Business Machines Corp. 2010,2011 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 
package LogDAO;

# --------------------------- #
#
# Log:
#    id
#    level
#    time
#    pid
#    type
#    object
#    machine
#    caller
#    message
#
# --------------------------- #

use warnings;
use strict;
require Exporter;
require DB::DBA;
#@ISA = qw(Exporter, DAO);
our @ISA = qw(Exporter DAO);
#@EXPORT=qw(queryLog);

require DB::DAO;

use Utils::Logger;

sub new {
    my $self = DAO->new();
    bless ($self);
    return $self;
}

sub queryLog {
    my ($self, $args) = @_;

    my $sql;
    my @where = ();
    my $bind = [];
    my $rc;
    my $param;
    my $result;

    foreach my $i (keys(%$args)) {
        if ($i =~ /^[a-z\.]+$/) {
            push(@where, "#>log.$i<#=?");
            push(@$bind, [$args->{$i}]);
        }
    }

    if (defined($args->{'level>='})) {
        push(@where, '#>log.level<#>=?');
        push(@$bind, [$args->{'level>='}]);
    }

    if (defined($args->{'level>'})) {
        push(@where, '#>log.level<#>?');
        push(@$bind, [$args->{'level>'}]);
    }

    if (defined($args->{'level<='})) {
        push(@where, '#>log.level<#<=?');
        push(@$bind, [$args->{'level<='}]);
    }

    if (defined($args->{'level<'})) {
        push(@where, '#>log.level<#<?');
        push(@$bind, [$args->{'level<'}]);
    }

    if (defined($args->{'time>='})) {
        push(@where, '#>log.time<#>=?');
        push(@$bind, [$args->{'time>='}]);
    }
    if (defined($args->{'time>'})) {
        push(@where, '#>log.time<#>?');
        push(@$bind, [$args->{'time>'}]);
    }
    if (defined($args->{'time<='})) {
        push(@where, '#>log.time<#<=?');
        push(@$bind, [$args->{'time<='}]);
    }
    if (defined($args->{'time<'})) {
        push(@where, '#>log.time<#<?');
        push(@$bind, [$args->{'time<'}]);
    }

    if (defined($args->{'message~'})) {
        push(@where, '#>log.message<# LIKE ?');
        push(@$bind, ['%' . $args->{'message~'} . '%']);
    }

    if (scalar(@where) > 0) {
        $sql = 'select #>log.*<# from #>log<# where ' . join(' AND ', @where);
        ($rc, $param) = $self->{'dba'}->querySQL($sql, $bind);
    } else {
        $sql = 'select #>log.*<# from #>log<#';
        ($rc, $param) = $self->{'dba'}->querySQL($sql);
    }

    if ($rc != 0) {
    	Logger->get()->warning('LogDAO', 'query log', "Failed to query log. Reason: $param");
        return (-1, "Failed to query log. Reason: $param");
    }

    ($rc, $param) = $self->{'dba'}->fetchall_hashref('#>log.id<#', '#>log<#');
    if ($rc != 0) {
    	Logger->get()->warning('LogDAO', 'query log', "Failed to query log info. Reason: $param");
        return (-1, "Failed to query log info. Reason: $param");
    }

    $result = $param;

    if (!scalar(%$result)) {
	Logger->get()->warning('LogDAO', 'query log', "No record.");
    	return (100, "No record.");
    }

    return (0, $result);
}

1;
