# sccsid = "@(#) src/hpcc/common/db/NameSchema.pm, hpc.cloud.comm, hpcc_rbei, rbeis002a 1.15 11/28/11 04:23:30";
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
#  
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# (C) COPYRIGHT International Business Machines Corp. 2010,2011 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 
package NameSchema;

use strict;
use warnings;

# ------------------------------------------------- #
# Table name mapping (directory)
#    key : logical table name;
#  value : physical/real table name;
# ------------------------------------------------- #
%NameSchema::TableSchema = (
    'capability' => 'thc_capability',
    'role'       => 'thc_role',
    'role_capability' => 'thcr_role_capability',
    'user'       => 'thc_user',
    'user_group' => 'thc_user_group',
    'user_group_user' => 'thcr_user_group_user',
    'image' => 'thc_image',
    'image_user_group' => 'thcr_image_user_group',
    'sysconfig' => 'thc_sysconfig',
    'log' => 'thc_log',
    'event' => 'thc_event_log',
    'machine' => 'thc_machine',
    'machine_group' => 'thc_machine_group',
    'energy_policy' => 'thc_energy_policy',
    'energy_scheme' => 'thc_energy_scheme',
    'energy_usage' => 'thc_energy_usage',
    'escheme_machine' => 'thcr_escheme_machine',
	'request' => 'thc_request',
	'request_machine' => 'thcr_request_machine',
	'request_user' => 'thcr_request_user',
    'provision_machine_history' => 'thc_provision_machine_history',
    'switchportconfig'=>'thc_switchportconfig',
    'switchconfig'=>'thc_switchconfig',
	'pkglist'=>'thc_pkglist',
	'script'=>'thc_script',
	'infrastr_script'=>'thc_infrastr_script',
);


# ------------------------------------------------- #
# Colum name mapping (2-level directory)
#     outer key : logical table name;
#         value : column logical name to
#                 physical name mapping list
# ------------------------------------------------- #
%NameSchema::ColumnSchema = (
    'capability' => [
        {'id'    => 'id'},
        {'name'  => 'cap_name'},
        {'value' => 'cap_value'},
    ],
    'role' => [
        {'id'    => 'id'},
        {'name'  => 'role_name'},
        {'desc' => 'role_desc'},
    ],
    'role_capability' => [
        {'id'    => 'id'},
        {'role_name'  => 'role_name'},
        {'cap_name' => 'cap_name'},
    ],
    'user' => [
        {'id'       => 'id'},
        {'name'     => 'user_name'},
        {'uid'      => 'uid'},
        {'role'  => 'role_name'},
        {'first_name' => 'first_name'},
        {'last_name'  => 'last_name'},
        {'email'    => 'email'},
        {'phone'    => 'phone'},
        {'department'   => 'department'},
        {'organization' => 'organization'},
        {'comments' => 'comments'},
    ],
    'user_group' => [
        {'id'       => 'id'},
        {'name'     => 'group_name'},
        {'owner'    => 'owner'},
        {'description' => 'description'},
    ],
    'user_group_user' => [
        {'id'       => 'id'},
        {'group_name' => 'group_name'},
        {'user_name' => 'user_name'},
    ],
    'image' => [
        {'id'				=> 'id'},
        {'name'				=> 'image_name'},
        {'status'			=> 'status'},
        {'base'				=> 'base_os'},
        {'arch'				=> 'architecture'},
        {'profile'			=> 'profile'},
        {'captured_time'	=> 'captured_time'},
        {'captured_on'		=> 'captured_on'},
        {'captured_by'		=> 'captured_by'},
        {'approved_by'		=> 'approved_by'},
        {'description'		=> 'description'},
        {'pkglist_path'		=> 'pkglist_path'},
        {'pkg_location' 	=> 'pkg_location'},
        {'scheduler'		=> 'scheduler'},
        {'parallel_env'		=> 'parallel_env'},
        {'pre_scripts'		=> 'pre_scripts'},
        {'post_scripts'		=> 'post_scripts'},
        {'interconnect'		=> 'interconnect'},
        {'shared_fs'		=> 'shared_fs'},
        {'install_to_disk'	=> 'install_to_disk'},
    ],
    'image_user_group' => [
        {'id'       => 'id'},
        {'image_name' => 'image_name'},
        {'user_group_name' => 'authorized_group_name'},
    ],
    'sysconfig' => [
        {'id'       => 'id'},
        {'name'     => 'conf_name'},
        {'value'    => 'conf_value'},
        {'comments' => 'comments'},
    ],
    'log' => [
        {'id'       => 'id'},
        {'level'    => 'log_level'},
        {'time'     => 'log_time'},
        {'pid'      => 'pid'},
        {'type'     => 'obj_type'},
        {'object'   => 'obj_name'},
        {'machine'  => 'machine_name'},
        {'caller'   => 'caller'},
        {'message'  => 'message'},
    ],
    'event' => [
        {'id'       => 'id'},
        {'originator' => 'originator'},
        {'operater'   => 'operater'},
        {'type'     => 'event_type'},
        {'object'   => 'event_target'},
        {'time'     => 'event_time'},
        {'message'  => 'event_desc'},
    ],
    'machine' => [
        {'id'       => 'id'},
        {'name' => 'name'},
        {'provision_mode'   => 'provision_mode'},
        {'status'     => 'status'},
        {'power_state'   => 'power_state'},
        {'fail_count'     => 'fail_count'},
        {'hypv_flag'  => 'hypv_flag'},
        {'interfaces'  => 'interfaces'},
        {'physicial_name'  => 'physicial_machine_name'},
        {'location'  => 'loc'},
        {'cpu_load_avg'  => 'cpu_load_avg'},
        {'virtual_memory_used'  => 'virt_mem_used'},
        {'hostname'  => 'hostname'},
        {'hypervisor'  => 'hypervisor'},
        {'swap_space_used'  => 'swap_space_used'},
        {'machine_group'  => 'machine_group'},
        {'ip'  => 'ip'},
		{'arch'   => 'arch'},
		{'type'  => 'type'},
		{'default_os'  => 'default_os'},
		{'current_os'  => 'current_os'},
    ],
    'machine_group' => [
        {'id'       => 'id'},
        {'name' => 'name'},
        {'catalog'   => 'cat'},
        {'core_count'     => 'core_count'},
        {'cpu_count'   => 'cpu_count'},
        {'memory_size'     => 'memory_size'},
        {'architecture'  => 'architecture'},
        {'num_ethernet_interfaces'  => 'num_ethernet_interfaces'},
        {'num_high_speed_interfaces'  => 'num_high_speed_interfaces'},
        {'high_speed_interface_type'  => 'high_speed_interface_type'},
        {'description'  => 'description'},
    ],
    'energy_policy' => [
	{'id' => 'id'},
	{'name' => 'name'},
	{'mach_status' => 'mach_status'},
	{'prov_mode' => 'prov_mode'},
	{'mach_group' => 'mach_group'},
	{'power_status' => 'power_status'},
	{'energy_scheme' => 'energy_scheme'},
	{'flag' => 'flag'},
	{'description' => 'description'},
    ],
    'energy_scheme' => [
	{'id' => 'id'},
	{'name' => 'name'},
	{'owner' => 'owner'},
	{'cat' => 'cat'},
	{'cpu_freq_fixed' => 'cpu_freq_fixed'},
	{'cpu_freq_min' => 'cpu_freq_min'},
	{'cpu_freq_max' => 'cpu_freq_max'},
	{'threshold_up' => 'threshold_up'},
	{'threshold_down' => 'threshold_down'},
	{'sampling_rate' => 'sampling_rate'},
	{'freq_step' => 'freq_step'},
	{'description' => 'description'},
    ],
    'energy_usage' => [
	{'id' => 'id'},
	{'machine_name' => 'machine_name'},
	{'request_name' => 'request_name'},
	{'avg_power' => 'avg_power'},
	{'acc_power' => 'acc_power'},
	{'sampling_times' => 'sampling_times'},
	{'start_time' => 'start_time'},
	{'start_energy' => 'start_energy'},
	{'pre_energy' => 'pre_energy'},
	{'cur_energy' => 'cur_energy'},
	{'update_interval' => 'update_interval'},
    ],
    'escheme_machine' => [
	{'id' => 'id'},
	{'machine_name' => 'machine_name'},
	{'is_machine_group' => 'is_machine_group'},
	{'energy_scheme' => 'energy_scheme'},
    ],
	'request' => [
	{'id'               => 'id'},
	{'name'             => 'name'},
	{'owner'            => 'owner'},
	{'description'      => 'description'},
	{'select_method'    => 'select_method'},
	{'machine_type'     => 'request_machine_type'},
	{'machine_num'      => 'request_machine_num'},
	{'machine_os'       => 'request_machine_os'},
	{'machine_cpu'      => 'request_machine_cpu'},
	{'machine_memory'   => 'request_machine_memory'},
	{'machine_disk'     => 'request_machine_disk'},
	{'ll_jobid'         => 'll_jobid'},
	{'ll_resid'         => 'll_resid'},
	{'ll_jobid_new'       => 'll_jobid_new'},
	{'energy'           => 'energy'},
	{'status'           => 'status'},
	{'modify'			=> 'modify'},
	{'error_code'       => 'error_code'},
	{'create_time'      => 'request_create_time'},
	{'cluster'          => 'request_cluster'},
	{'setup_time'       => 'request_setup_time'},
	{'start_time'       => 'request_start_time'},
	{'expiry_time'      => 'request_expiry_time'},
	{'hypervisor'       => 'hypervisor'},
	{'account'          => 'request_account'},
	{'approved_by'      => 'approved_by'},
	{'actual_start_time'    => 'actual_start_time'},
	{'actual_stop_time' => 'actual_stop_time'},
	{'hypv_flag'        => 'hypv_flag'},
	{'vlan_flag'		=> 'vlan_flag'},
	{'vlan_id'			=> 'vlan_id'},
	],
	'request_machine' => [
	{'id'               => 'id'},
	{'request_name'     => 'request_name'},
	{'machine_name'     => 'machine_name'},
	{'hypervisor'       => 'hypervisor'},
	{'using_ip'			=> 'using_ip'},
	{'using_hostname'	=> 'using_hostname'},
	{'status'			=> 'status'},
	{'inuse_time'		=> 'inuse_time'},
	],
	'request_user' => [
	{'id'               => 'id'},
	{'request_name'     => 'request_name'},
	{'user_name'        => 'user_name'},
	{'is_user_group'    => 'is_user_group'},
	],
	'provision_machine_history' => [
	{'id' => 'id'},
	{'machine_name' => 'machine_name'},
	{'request_name' => 'request_name'},
	{'arch' => 'arch'},
	{'cat' => 'cat'},
	{'os' => 'os'},
	{'ip' => 'ip'},
	{'prov_start_time' => 'prov_start_time'},
	{'prov_stop_time' => 'prov_stop_time'},
	{'energy' => 'energy'},
	{'vlan_id' => 'vlan_id'},
	{'vlan_flag' => 'vlan_flag'},
    ],
	'switchconfig' => [
	{'id' => 'id'},
	{'switch_name'=>'switch_name'},
	{'port_number'=>'port_number'},
	{'ipaddress'=>'ipaddress'},
	{'description'=>'description'},
	],
	'switchportconfig' => [
	{'id' => 'id'},
	{'node_name' => 'node_name'},
	{'switch_name'=>'switch_name'},
	{'bandwidth'=>'bandwidth'},
	{'port_id'=>'port_id'},
	{'vlan_id'=>'vlan_id'},
	{'description'=>'description'},
	],
	'pkglist' => [
	{'id' => 'id'},
	{'name' => 'name'},
	{'path_orig'=>'path_orig'},
	{'status'=>'status'},
	{'creator'=>'creator'},
	{'description'=>'description'},
	],
	'script' => [
	{'id' => 'id'},
	{'name' => 'name'},
	{'flag'=>'flag'},
	{'status'=>'status'},
	{'description'=>'description'},
	],
	'infrastr_script' => [
	{'id' => 'id'},
	{'name' => 'name'},
	{'type'=>'type'},
	{'pre_scripts'=>'pre_scripts'},
	{'post_scripts'=>'post_scripts'},
	],
);

%NameSchema::TableColumns = ();
%NameSchema::LogicalColumnNameMapping = ();
%NameSchema::PhysicalColumnNameMapping= ();

1;

#
# DESC:
#   Find the real table name
# INPUT:
#   param1: package name;
#   param2: the table name;
#   param3: the logical column name;
# OUTPUT:
#   ret1: return code
#         0 - SUCC
#         others - FAIL
#   ret2 : error msg
#
sub getTableRealName {
    my ($package, $table_name) = @_;
    if (defined($NameSchema::TableSchema{$table_name})) {
        return (0, $NameSchema::TableSchema{$table_name});
    }

    # the column physical name must be defined!
    my $errmsg = sprintf('The specified table `%s\' has not been defined.', $table_name);
    return (-1, $errmsg);
}

sub addTableSchemaCache {
    my ($table_name) = @_;

    my $hash1 = {};
    my $hash2 = {};
    my $list1 = [];

    $NameSchema::TableColumns{$table_name} = $list1;
    $NameSchema::LogicalColumnNameMapping{$table_name} = $hash1;
    $NameSchema::PhysicalColumnNameMapping{$table_name} = $hash2;

    my $hdl = $NameSchema::ColumnSchema{$table_name};
    foreach my $i (@$hdl) {
        my @keys = keys(%$i);
        my $k = $keys[0];
        my $v = $i->{$k};

        $hash1->{$k} = $v;
        $hash2->{$v} = $k;
        push(@$list1, $table_name . '.' . $k);
    }
}


#
# DESC:
#   Find the real column name
# INPUT:
#   param1: package name;
#   param2: the table name;
#   param3: the logical column name;
# OUTPUT:
#   ret1: return code
#         0 - SUCC
#         others - FAIL
#   ret2 : error msg
#
sub getColumnRealName {
    my ($package, $table_name, $column_name) = @_;
    my $hdl;

    if (!defined($NameSchema::LogicalColumnNameMapping{$table_name})) {
        &addTableSchemaCache($table_name);
    }

    if (defined($NameSchema::LogicalColumnNameMapping{$table_name})) {
        my $hdl = $NameSchema::LogicalColumnNameMapping{$table_name};
        if (defined($hdl->{$column_name})) {
            return (0, $hdl->{$column_name});
        }
    }
    
    # the column physical name must be defined!
    my $errmsg = sprintf('The specified column (table: `%s\', column: `%s\') has not been defined.', $table_name, $column_name);
    return (-1, $errmsg);
}

#
# DESC:
#   Find the column external name
# INPUT:
#   param1: package name;
#   param2: the table name;
#   param3: the column real name;
# OUTPUT:
#   ret1: the column external name;
#
sub getColumnExternalName {
    my ($package, $table_name, $column_name) = @_;
    my $hdl;

    if (!defined($NameSchema::PhysicalColumnNameMapping{$table_name})) {
        &addTableSchemaCache($table_name);
    }

    if (defined($NameSchema::PhysicalColumnNameMapping{$table_name})) {
        $hdl = $NameSchema::PhysicalColumnNameMapping{$table_name};
        if (defined($hdl->{$column_name})) {
            return $hdl->{$column_name};
        }
    } 

    # if there is no external name for this column, 
    # the physical name, raw column name, will be used.
    return $column_name;
}

sub getTableColumnExternalNames {
    my ($package, $table_name) = @_;

    if (!defined($NameSchema::TableColumns{$table_name})) {
        &addTableSchemaCache($table_name);
    }

    if (defined($NameSchema::TableColumns{$table_name})) {
        return $NameSchema::TableColumns{$table_name};
    }

    return [];
}

1;
