# sccsid = "@(#) src/hpcc/common/db/ProvisionDAO.pm, hpc.cloud.db, hpcc_rbei, rbeis002a 1.24 1/16/12 03:27:31";
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
#  
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# (C) COPYRIGHT International Business Machines Corp. 2010,2012 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 
package ProvisionDAO;

use strict;
use warnings;
require Exporter;
require DB::DBA;
our @ISA = qw(Exporter DAO);
require DB::DAO;
use Utils::Logger;
use GeneralDefine;

sub new {
	my $self = DAO->new();
	bless($self);

	return $self;
}

sub queryAllRequestName {
	my ($self) = @_;

	my $sql = "select #>request.name<# from #>request<#";

	my ($rc, $param) = $self->{'dba'}->querySQL($sql);
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', 'NA', "Failed to query request info. Reason: $param");
		return (-1, "Failed to query request info. Reason: $param");
	}

	($rc, $param) = $self->{'dba'}->fetchall_hashref('#>request.name<#', '#>request<#');
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', 'NA', "Failed to fetch request info. Reason: $param");
		return (-1, "Failed to fetch request info. Reason: $param");
	}

	my @result = keys(%$param);

	$self->{'dba'}->finish();

	return (0, \@result);
}

=comment
$args: for where_key
		For and relationship, use HASH
		For or relationship, use ARRAY
$flag: indicates how to organize the machine list
       0: array; 1: hash
$fuzzy: 
       0: get machines of cloudadm_10.27.2011_01:53:45 only
       1: get machines of request cloudadm_10.27.2011_01:53:45a or cloudadm_10.27.2011_01:53:45d also
       2. get machines of request cloudadm_10.27.2011_01:53:45a also but not ***d
       3. get machines of request cloudadm_10.27.2011_01:53:45d also but not ***a
=cut
sub queryRequest {
	my ($self, $args, $flag, $fuzzy) = @_;
	if (!defined($fuzzy)) { $fuzzy = 0; }

	my $where = '';
	my $machine_where = '';
	my $bind = [];
	my $machine_bind = [];

	#support more kinds of query
	if(ref($args) eq "HASH"){
		my @whereKeyList= keys(%$args);
		if( scalar(@whereKeyList)==0){
			return ($GeneralDefine::FAILED, "No query key.");
		}
		foreach my $where_key (@whereKeyList){
			if($where eq ""){
				$where = ' #>request.'.$where_key.'<#=?';
			}
			else{
				$where .= ' and #>request.'.$where_key.'<#=?';
			}
			push(@$bind, [$args->{$where_key}]);
		}
	}elsif(ref($args) eq "ARRAY"){
		my @whereKeyList= @$args;
		if( scalar(@whereKeyList)==0){
			return ($GeneralDefine::FAILED, "No query key.");
		}
		foreach my $where_key (@whereKeyList){
			my @tmpKey = keys(%$where_key);
			my @tmpValue = values(%$where_key);
			if(scalar(@tmpKey) > 0){
				if($where eq ""){
					$where = ' #>request.'.$tmpKey[0].'<#=?';
				}
				else{
					$where .= ' or #>request.'.$tmpKey[0].'<#=?';
				}
				push(@$bind, [$tmpValue[0]]);
			}
		}
	}else{
		Logger->get()->warning('ProvisionDAO', ref($args), "Failed to query request info. Reason: error args");
		return ($GeneralDefine::FAILED, "Failed to query request info. Reason: error args");
	}

	# step 1: Get requestion information from thc_request table
	my $sql = 'select #>request.*<# from #>request<# where ' . $where;
	my ($rc, $param) = $self->{'dba'}->querySQL($sql, $bind);
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "$where", "Failed to query request info. Reason: $param");
		return ($GeneralDefine::FAILED, "Failed to query request info. Reason: $param");
	}

	($rc, $param) = $self->{'dba'}->fetchall_hashref('#>request.name<#', '#>request<#');
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "$where", "Failed to fetch request info. Reason: $param");
		return ($GeneralDefine::FAILED, "Failed to fetch request info. Reason: $param");
	}

	my $result = $param;
	if (!scalar(%$param)) {
		Logger->get()->info('ProvisionDAO', "$where", "No record.");
		return ($GeneralDefine::NORECORD, "No record.");
	}

	# If args is not the request name, it's possible that we get multiple requests
	foreach my $req_name(keys(%$param)) {
		if ($machine_where eq "") {
			if ($fuzzy == $GeneralDefine::QUERY_NAME_RELATED_ALL) {
				$machine_where = ' thcr_request_machine.request_name like \'' . $req_name . '%\'';
			} elsif ($fuzzy == $GeneralDefine::QUERY_NAME_ADD) {
				$machine_where = ' thcr_request_machine.request_name=\'' . $req_name . '\' or thcr_request_machine.request_name=\'' . $req_name . 'a\'';
			} elsif ($fuzzy == $GeneralDefine::QUERY_NAME_DEL) {
				$machine_where = ' thcr_request_machine.request_name=\'' . $req_name . '\' or thcr_request_machine.request_name=\'' . $req_name . 'd\'';
			} else {
				$machine_where = ' #>request_machine.request_name<#=?';
				push(@$machine_bind, [$req_name]);
			}
		}
		else {
			if ($fuzzy == $GeneralDefine::QUERY_NAME_RELATED_ALL) {
				$machine_where .= ' or thcr_request_machine.request_name like \''. $req_name . '%\'';
			} elsif ($fuzzy == $GeneralDefine::QUERY_NAME_ADD) {
				$machine_where .= ' or thcr_request_machine.request_name=\'' . $req_name . '\' or thcr_request_machine.request_name=\'' . $req_name . 'a\'';
			} elsif ($fuzzy == $GeneralDefine::QUERY_NAME_DEL) {
				$machine_where .= ' or thcr_request_machine.request_name=\'' . $req_name . '\' or thcr_request_machine.request_name=\'' . $req_name . 'd\'';
			} else {
				$machine_where .= ' or #>request_machine.request_name<#=?';
				push(@$machine_bind, [$req_name]);
			}
		}
	}

	# step2: join multiple tables(request_machine, machine, escheme_machine) to get all the related information
	#$sql = 'select #>request_machine.id<#, #>request_machine.request_name<#, #>request_machine.using_ip<#, #>request_machine.using_hostname<#, #>machine.name<#, #>machine.provision_mode<#, #>machine.arch<#, #>machine.type<#, #>machine.status<#, #>machine.power_state<#, #>machine.default_os<#, #>machine.current_os<#, #>machine.ip<#, #>machine.fail_count<#, #>escheme_machine.energy_scheme<# from #>machine<# join #>request_machine<# on #>request_machine.machine_name<#=#>machine.name<# left join #>escheme_machine<# on #>request_machine.machine_name<#=#>escheme_machine.machine_name<# where' . $machine_where;
	$sql = 'select #>request_machine.id<#, #>request_machine.request_name<#, #>request_machine.hypervisor<#, #>request_machine.using_ip<#, #>request_machine.using_hostname<#, #>request_machine.status<#, #>request_machine.inuse_time<#, #>machine.name<#, #>machine.provision_mode<#, #>machine.arch<#, #>machine.type<#, #>machine.power_state<#, #>machine.default_os<#, #>machine.current_os<#, #>machine.ip<#, #>machine.fail_count<#, #>escheme_machine.energy_scheme<# from #>machine<# join #>request_machine<# on #>request_machine.machine_name<#=#>machine.name<# left join #>escheme_machine<# on #>request_machine.machine_name<#=#>escheme_machine.machine_name<# where' . $machine_where;
	($rc, $param) = $self->{'dba'}->querySQL($sql, $machine_bind);
	if ($rc != 0) {
		print "SQL: $sql\n";
		foreach my $bindValue(@$machine_bind){
			print "@$bindValue,";
		}
		print "\n";
		Logger->get()->warning('ProvisionDAO', "NA", "Failed to query all request_machine info. Reason: $param");
		return ($GeneralDefine::FAILED, "Failed to query all request_machine info. Reason: $param");
	}

	($rc, $param) = $self->{'dba'}->fetchall_hashref('request_machine.id', 'machine');
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA", "Failed to fetch row request_machine info. Reason: $param");
		return ($GeneralDefine::FAILED, "Failed to fetch row request_machine info. Reason: $param");
	}

	while (my ($id, $mach) = each(%$param)) {
		my $req_name = $mach->{'request_machine.request_name'};

		if ($fuzzy) {
			$req_name =~ s/a$//g;
			$req_name =~ s/d$//g;
		}

		if (!$flag) {
			push(@{$result->{$req_name}->{'machList'}}, $mach);
		}
		else {
			$result->{$req_name}->{'machList'}->{$mach->{'machine.name'}} = $mach;
		}
		delete($mach->{'request_machine.id'});
		delete($mach->{'request_machine.request_name'});
		if($result->{$req_name}->{'request.hypv_flag'} == 1){
			my $hyname = $mach->{'machine.name'};
			$sql = 'select #>request_machine.machine_name<# from #>request_machine<# where #>request_machine.hypervisor<#='."\'$hyname\'";
			my $tparam;
			($rc, $tparam) = $self->{'dba'}->querySQL($sql);
			if ($rc != 0) {
				Logger->get()->warning('ProvisionDAO', "$where", "Failed to query request_machine info for hypv. Reason: $param");
				return ($GeneralDefine::FAILED, "Failed to query request_machine info for hypv. Reason: $param");
			}

			($rc, $tparam) = $self->{'dba'}->fetchall_hashref('#>request_machine.machine_name<#', '#>request_machine<#');
			if ($rc != 0) {
				Logger->get()->warning('ProvisionDAO', "$where", "Failed to fetch request_machine info for hypv. Reason: $param");
				return ($GeneralDefine::FAILED, "Failed to fetch request_machine info for hypv. Reason: $param");
			}
			my @vnodes = keys(%$tparam);
			if(scalar(@vnodes) > 0){
				$mach->{'vnodes'} = join(" ",@vnodes);
			}
		}
	}

	# step3: join the request_user table to get user info
	$sql = 'select #>request_user.*<# from #>request_user<# join #>request<# on #>request_user.request_name<#=#>request.name<# where #>request_user.is_user_group<#=0 and ' . $where;
	($rc, $param) = $self->{'dba'}->querySQL($sql, $bind);
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA", "Failed to query all request_user info. Reason: $param");
		return ($GeneralDefine::FAILED, "Failed to query all request_user info. Reason: $param");
	}

	($rc, $param) = $self->{'dba'}->fetchall_hashref('#>request_user.id<#', '#>request_user<#');
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA", "Failed to query all request_user info. Reason: $param");
		return ($GeneralDefine::FAILED, "Failed to query all request_user info. Reason: $param");
	}

	my $user_list = $param;
	foreach my $user_id (keys(%$user_list)) {
		my $user_name = $user_list->{$user_id}->{'request_user.user_name'};
		my $req_name = $user_list->{$user_id}->{'request_user.request_name'};
		my $hdl;
		if (defined($result->{$req_name}->{'incUsers'})) {
			$hdl = $result->{$req_name}->{'incUsers'};
		}
		else {
			$hdl = [];
		}

		push(@$hdl, $user_name);
		$result->{$req_name}->{'incUsers'} = $hdl;
	}

	# step4: join the request_user table to get group info
	$sql = 'select #>request_user.*<# from #>request_user<# join #>request<# on #>request_user.request_name<#=#>request.name<# where #>request_user.is_user_group<#=1 and ' . $where;
	($rc, $param) = $self->{'dba'}->querySQL($sql, $bind);
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA", "Failed to query all group info. Reason: $param");
		return ($GeneralDefine::FAILED, "Failed to query all group info. Reason: $param");
	}

	($rc, $param) = $self->{'dba'}->fetchall_hashref('#>request_user.id<#', '#>request_user<#');
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA", "Failed to query all group info. Reason: $param");
		return ($GeneralDefine::FAILED, "Failed to query all group info. Reason: $param");
	}

	my $group_list = $param;
	foreach my $group_id (keys(%$group_list)) {
		my $group_name = $group_list->{$group_id}->{'request_user.user_name'};
		my $req_name = $group_list->{$group_id}->{'request_user.request_name'};
		my $hdl;
		if (defined($result->{$req_name}->{'incGrps'})) {
			$hdl = $result->{$req_name}->{'incGrps'};
		}
		else {
			$hdl = [];
		}

		push(@$hdl, $group_name);
		$result->{$req_name}->{'incGrps'} = $hdl;
	}

	$self->{'dba'}->finish();

	return ($GeneralDefine::SUCCESS, $result);
}
sub queryRequestfromhistory {
	my ($self, $args, $flag) = @_;

	my $where = '';
	my $machine_where = '';
	my $bind = [];
	my $machine_bind = [];
	#support more kinds of query
	if(ref($args) eq "HASH"){
		my @whereKeyList= keys(%$args);
		if( scalar(@whereKeyList)==0){
			return ($GeneralDefine::FAILED, "No query key.");
		}
		foreach my $where_key (@whereKeyList){
			if($where eq ""){
				$where = ' #>request.'.$where_key.'<#=?';
			}
			else{
				$where .= ' and #>request.'.$where_key.'<#=?';
			}
			push(@$bind, [$args->{$where_key}]);
		}
	}elsif(ref($args) eq "ARRAY"){
		my @whereKeyList= @$args;
		if( scalar(@whereKeyList)==0){
			return ($GeneralDefine::FAILED, "No query key.");
		}
		foreach my $where_key (@whereKeyList){
			my @tmpKeys = keys(%$where_key);
			my @tmpValue = values(%$where_key);
			if(scalar(@tmpKeys) != 0){
				if($where eq ""){
					$where = ' #>request.'."$tmpKeys[0]".'<#=?';
				}
				else{
					$where .= ' or #>request.'."$tmpKeys[0]".'<#=?';
				}
				push(@$bind, [$tmpValue[0]]);
			}
		}
	}else{
		Logger->get()->warning('ProvisionDAO', ref($args), "Failed to query request info. Reason: error args");
		return ($GeneralDefine::FAILED, "Failed to query request info. Reason: error args");
	}
	my $sql = 'select #>request.*<# from #>request<# where ' . $where;
	my ($rc, $param) = $self->{'dba'}->querySQL($sql, $bind);
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "$where", "Failed to query request info. Reason: $param");
		return ($GeneralDefine::FAILED, "Failed to query request info. Reason: $param");
	}

	($rc, $param) = $self->{'dba'}->fetchall_hashref('#>request.name<#', '#>request<#');
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "$where", "Failed to fetch request info. Reason: $param");
		return ($GeneralDefine::FAILED, "Failed to fetch request info. Reason: $param");
	}

	my $result = $param;
	if (!scalar(%$param)) {
		Logger->get()->info('ProvisionDAO', "$where", "No record.");
		return ($GeneralDefine::NORECORD, "No record.");
	}
#not query by name, we need get all req name
	foreach my $req_name(keys(%$param)){
		if($machine_where eq ""){
			$machine_where = ' #>provision_machine_history.request_name<#=?';
		}
		else{
			$machine_where .= ' or #>provision_machine_history.request_name<#=?';
		}
		push(@$machine_bind, [$req_name]);
	}
	
	$sql = 'select #>provision_machine_history.id<#, #>provision_machine_history.request_name<#, #>machine.name<#, #>machine.provision_mode<#, #>machine.arch<#, #>machine.type<#, #>machine.status<#, #>machine.power_state<#, #>machine.default_os<#, #>machine.current_os<#, #>machine.ip<#, #>machine.fail_count<#, #>escheme_machine.energy_scheme<# from #>machine<# join #>provision_machine_history<# on #>provision_machine_history.machine_name<#=#>machine.name<# left join #>escheme_machine<# on #>provision_machine_history.machine_name<#=#>escheme_machine.machine_name<# where' . $machine_where;
	($rc, $param) = $self->{'dba'}->querySQL($sql, $machine_bind);
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA", "Failed to query all provision_machine_history info. Reason: $param");
		return ($GeneralDefine::FAILED, "Failed to query all provision_machine_history info. Reason: $param");
	}

	($rc, $param) = $self->{'dba'}->fetchall_hashref('provision_machine_history.id', 'machine');
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA", "Failed to fetch row provision_machine_history info. Reason: $param");
		return ($GeneralDefine::FAILED, "Failed to fetch row provision_machine_history info. Reason: $param");
	}

	while (my ($id, $mach) = each(%$param)) {
		my $req_name = $mach->{'provision_machine_history.request_name'};
		if (!$flag){
			push(@{$result->{$req_name}->{'machList'}}, $mach);
		}
		else {
			$result->{$req_name}->{'machList'}->{$mach->{'machine.name'}} = $mach;
		}
	}

	$sql = 'select #>request_user.*<# from #>request_user<# join #>request<# on #>request_user.request_name<#=#>request.name<# where #>request_user.is_user_group<#=0 and ' . $where;
	($rc, $param) = $self->{'dba'}->querySQL($sql, $bind);
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA", "Failed to query all request_user info. Reason: $param");
		return ($GeneralDefine::FAILED, "Failed to query all request_user info. Reason: $param");
	}

	($rc, $param) = $self->{'dba'}->fetchall_hashref('#>request_user.id<#', '#>request_user<#');
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA", "Failed to query all request_user info. Reason: $param");
		return ($GeneralDefine::FAILED, "Failed to query all request_user info. Reason: $param");
	}

	my $user_list = $param;
	foreach my $user_id (keys(%$user_list)) {
		my $user_name = $user_list->{$user_id}->{'request_user.user_name'};
		my $req_name = $user_list->{$user_id}->{'request_user.request_name'};
		my $hdl;
		if (defined($result->{$req_name}->{'incUsers'})) {
			$hdl = $result->{$req_name}->{'incUsers'};
		}
		else {
			$hdl = [];
		}

		push(@$hdl, $user_name);
		$result->{$req_name}->{'incUsers'} = $hdl;
	}

	$sql = 'select #>request_user.*<# from #>request_user<# join #>request<# on #>request_user.request_name<#=#>request.name<# where #>request_user.is_user_group<#=1 and ' . $where;
	($rc, $param) = $self->{'dba'}->querySQL($sql, $bind);
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA", "Failed to query all group info. Reason: $param");
		return ($GeneralDefine::FAILED, "Failed to query all group info. Reason: $param");
	}

	($rc, $param) = $self->{'dba'}->fetchall_hashref('#>request_user.id<#', '#>request_user<#');
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA", "Failed to query all group info. Reason: $param");
		return ($GeneralDefine::FAILED, "Failed to query all group info. Reason: $param");
	}

	my $group_list = $param;
	foreach my $group_id (keys(%$group_list)) {
		my $group_name = $group_list->{$group_id}->{'request_user.user_name'};
		my $req_name = $group_list->{$group_id}->{'request_user.request_name'};
		my $hdl;
		if (defined($result->{$req_name}->{'incGrps'})) {
			$hdl = $result->{$req_name}->{'incGrps'};
		}
		else {
			$hdl = [];
		}

		push(@$hdl, $group_name);
		$result->{$req_name}->{'incGrps'} = $hdl;
	}

	$self->{'dba'}->finish();

	return ($GeneralDefine::SUCCESS, $result);
}

sub queryAllRequest {
	my ($self) = @_;

	my ($rc, $param) = $self->queryAllRequestName();
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA", "Failed to query all request name. Reason: $param");
		return (-1, "Failed to query all request name. Reason: $param");
	}

	my $ids = $param;
	my $result;

	foreach my $id (@$ids) {
		my ($rc, $param) = $self->queryRequest({'name' => $id});
		if ($rc != 0) {
			Logger->get()->warning('ProvisionDAO', "NA","Failed to query all request info. Reason: $param");
			return (-1, "Failed to query all request info. Reason: $param");
		}
		if(!exists($param->{$id}->{'machList'})&&
			($param->{$id}->{'request.status'} eq 'Expired' || $param->{$id}->{'request.status'} eq 'Canceled' || $param->{$id}->{'request.status'} eq 'Failed' )){
			my $tmpParam;
			($rc, $tmpParam) = $self->queryRequestfromhistory({'name' => $id});
			if(($rc==0)&&(exists($tmpParam->{$id}->{'machList'}))){
				$param = $tmpParam;
			}
		}

		$result->{$id} = $param;
	}

	$self->{'dba'}->finish();

	if (!scalar(@$ids)) {
		Logger->get()->info('ProvisionDAO', "NA","No record.");
		return (100, "No record.");
	}

	return (0, $result);
}

sub insertRequest {
	my ($self, $name, $attrs) = @_;

	my @cols = ();
	my @vals = ();
	my @args = ();

	push(@cols, "#>request.name<#");
	push(@vals, '?');
	push(@args, [$name]);

	if (defined($attrs)) {
		foreach my $key (keys(%$attrs)) {
			push(@cols, "#>request.$key<#");
			push(@vals, '?');
			push(@args, [$attrs->{$key}]);
		}
	}

	my $sql = sprintf('insert into #>request<# (%s) values (%s)', join(',', @cols), join(',', @vals));

	my ($rc, $param) = $self->{'dba'}->execSQL($sql, \@args);
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA","Failed to create new request. Reason: $param");
		return (-1, "Failed to create new request. Reason: $param");
	}

	return (0);
}

sub deleteRequest {
	my ($self, $args) = @_;

	my $where = '';
	my $acc;

	if (defined($args->{'id'})) {
		$where = ' #>request.id<#=?';
		$acc = $args->{'id'};
	}
	elsif (defined($args->{'name'})) {
		$where = ' #>request.name<#=?';
		$acc = $args->{'name'};
	}
	else {
		Logger->get()->warning('ProvisionDAO', "NA","Unknown delete.");
		return (-1, "Unknown delete.");
	}

	my $sql = 'delete from #>request<# where ' . $where;

	my ($rc, $param) = $self->{'dba'}->execSQL($sql, [[$acc]]);
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA","Failed to delete request. Reason: $param");
		return (-1, "Failed to delete request. Reason: $param");
	}

	return (0);
}

sub modifyRequest {
	my ($self, $query, $attrs) = @_;

	my @cols = ();
	my @args = ();
	my $where = '';

	if (defined($attrs)) {
		foreach my $key (keys(%$attrs)) {
			push(@cols, "#>request.$key<#=?");
			push(@args, [$attrs->{$key}]);
		}
	}

	if (defined($query)) {
		if (defined($query->{'id'})) {
			$where = "#>request.id<#=?";
			push(@args, [$query->{'id'}]);
		}
		elsif (defined($query->{'name'})) {
			$where = "#>request.name<#=?";
			push(@args, [$query->{'name'}]);
		}
		else {
			Logger->get()->warning('ProvisionDAO', "NA","Unsuported request select.");
			return (-1, "Unsuported request select.");
		}
	}

	my $sql = sprintf('update #>request<# set %s where %s', join(',', @cols), $where);
	my ($rc, $param) = $self->{'dba'}->execSQL($sql, \@args);
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA","Failed to modify request. Reason: $param");
		return (-1, "Failed to modify request. Reason: $param");
	}

	return (0);
}

sub queryRequestMachine {
	my ($self, $args) = @_;

	my $where = '';
	my $bind = [];
	my @cols= ();
	if (defined($args)) {
		foreach my $key (keys(%$args)) {
			push(@cols, " #>request_machine.$key<#=?");
			push(@$bind, [$args->{$key}]);
		}
	}else{
		Logger->get()->warning('ProvisionDAO', "NA", "Unknown query.");
		return (-1, "Unknown query.");
	}
	$where = join(" and ", @cols);

	my $sql = 'select #>request_machine.*<# from #>request_machine<# where ' . $where;

	my ($rc, $param) = $self->{'dba'}->querySQL($sql, $bind);
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA","Failed to query request_machine basic info. Reason: $param");
		return (-1, "Failed to query request_machine basic info. Reason: $param");
	}

	($rc, $param) = $self->{'dba'}->fetchall_hashref('#>request_machine.id<#', '#>request_machine<#');
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA","Failed to query request_machine basic info. Reason: $param");
		return (-1, "Failed to query request_machine basic info. Reason: $param");
	}

	if (!scalar(%$param)) {
		Logger->get()->info('ProvisionDAO', "NA","No record.");
		return (100, "No record.");
	}

	$self->{'dba'}->finish();

	return (0, $param);
}

sub queryAllRequestMachine {
	my ($self) = @_;

	my $sql = 'select #>request_machine.*<# from #>request_machine<#';

	my ($rc, $param) = $self->{'dba'}->querySQL($sql);
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA","Failed to query all request_machine info. Reason: $param");
		return (-1, "Failed to query all request_machine info. Reason: $param");
	}

	($rc, $param) = $self->{'dba'}->fetchall_hashref('#>request_machine.id<#', '#>request_machine<#');
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA","Failed to query all request_machine info. Reason: $param");
		return (-1, "Failed to query all request_machine info. Reason: $param");
	}

	if (!scalar(%$param)) {
		Logger->get()->info('ProvisionDAO', "NA","No record.");
		return (100, "No record.");
	}

	$self->{'dba'}->finish();

	return (0, $param);
}

sub insertRequestMachine {
	my ($self, $name, $attrs) = @_;

	my @cols = ();
	my @vals = ();
	my @args = ();

	push(@cols, "#>request_machine.request_name<#");
	push(@vals, '?');
	push(@args, [$name]);

	if (defined($attrs)) {
		foreach my $key (keys(%$attrs)) {
			push(@cols, "#>request_machine.$key<#");
			push(@vals, '?');
			push(@args, [$attrs->{$key}]);
		}
	}

	my $sql = sprintf('insert into #>request_machine<# (%s) values (%s)', join(',', @cols), join(',', @vals));
	my ($rc, $param) = $self->{'dba'}->execSQL($sql, \@args);
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA","Failed to create new request_machine. Reason: $param");
		return (-1, "Failed to create new request_machine. Reason: $param");
	}

	return (0);
}

sub deleteRequestMachine {
	my ($self, $request) = @_;

	my $where = '';
	my @args = ();
	my @cols= ();

	if (defined($request)) {
		foreach my $key (keys(%$request)) {
			push(@cols, " #>request_machine.$key<#=?");
			push(@args, [$request->{$key}]);
		}
	}else{
		Logger->get()->warning('ProvisionDAO', "NA", "Unknown delete.");
		return (-1, "Unknown delete.");
	}
	$where = join(" and ", @cols);
	my $sql = 'delete from #>request_machine<# where ' . $where;

	my ($rc, $param) = $self->{'dba'}->execSQL($sql, \@args);
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA", "Failed to delete request_machine. Reason: $param");
		return (-1, "Failed to delete request_machine. Reason: $param");
	}

	return (0);

}

sub modifyRequestMachine {
	my ($self, $query, $attrs) = @_;

	my @cols = ();
	my @args = ();
	my $where = '';

	if (defined($attrs)) {
		foreach my $key (keys(%$attrs)) {
			push(@cols, "#>request_machine.$key<#=?");
			push(@args, [$attrs->{$key}]);
		}
	}

	my @where_cols= ();
	if (defined($query)) {
		foreach my $key (keys(%$query)) {
			push(@where_cols, " #>request_machine.$key<#=?");
			push(@args, [$query->{$key}]);
		}
	}else{
		Logger->get()->warning('ProvisionDAO', "NA", "Unknown modify.");
		return (-1, "Unknown modify.");
	}
	$where = join(" and ", @where_cols);

	my $sql = sprintf('update #>request_machine<# set %s where %s', join(',', @cols), $where);
	my ($rc, $param) = $self->{'dba'}->execSQL($sql, \@args);
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA", "Failed to update request_machine info. Reason: $param");
		return (-1, "Failed to update request_machine info. Reason: $param");
	}

	return (0);
}

sub queryRequestUser {
	my ($self, $args) = @_;

	my $where = '';
	my $bind = [];
	my @cols= ();
	if (defined($args)) {
		foreach my $key (keys(%$args)) {
			push(@cols, " #>request_user.$key<#=?");
			push(@$bind, [$args->{$key}]);
		}
	}else{
		Logger->get()->warning('ProvisionDAO', "NA", "Unknown query.");
		return (-1, "Unknown modify.");
	}
	$where = join(" and ", @cols);

	my $sql = 'select #>request_user.*<# from #>request_user<# where ' . $where;

	my ($rc, $param) = $self->{'dba'}->querySQL($sql, $bind);
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA", "Failed to query request_user basic info. Reason: $param");
		return (-1, "Failed to query request_user basic info. Reason: $param");
	}

	($rc, $param) = $self->{'dba'}->fetchrow_hashref('#>request_user.id<#', '#>request_user<#');
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA", "Failed to query request_user basic info. Reason: $param");
		return (-1, "Failed to query request_user basic info. Reason: $param");
	}

	$self->{'dba'}->finish();

	if (!scalar(%$param)) {
		Logger->get()->info('ProvisionDAO', "NA", "No record.");
		return (100, "No record.");
	}

	return (0, $param);
}

sub queryAllRequestUser {
	my ($self) = @_;

	my $sql = 'select #>request_user.*<# from #>request_user<#';

	my ($rc, $param) = $self->{'dba'}->querySQL($sql);
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA", "Failed to query all request_user info. Reason: $param");
		return (-1, "Failed to query all request_user info. Reason: $param");
	}

	($rc, $param) = $self->{'dba'}->fetchrow_hashref('#>request_user.id<#', '#>request_user<#');
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA", "Failed to query all request_user info. Reason: $param");
		return (-1, "Failed to query all request_user info. Reason: $param");
	}

	$self->{'dba'}->finish();

	if (!scalar(%$param)) {
		Logger->get()->info('ProvisionDAO', "NA", "No record.");
		return (100, "No record.");
	}

	return (0, $param);
}

sub insertRequestUser {
	my ($self, $name, $attrs) = @_;

	my @cols = ();
	my @vals = ();
	my @args = ();

	push(@cols, "#>request_user.request_name<#");
	push(@vals, '?');
	push(@args, [$name]);

	if (defined($attrs)) {
		foreach my $key (keys(%$attrs)) {
			push(@cols, "#>request_user.$key<#");
			push(@vals, '?');
			push(@args, [$attrs->{$key}]);
		}
	}

	my $sql = sprintf('insert into #>request_user<# (%s) values (%s)', join(',', @cols), join(',', @vals));
	my ($rc, $param) = $self->{'dba'}->execSQL($sql, \@args);
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA", "Failed to create new request_user. Reason: $param");
		return (-1, "Failed to create new request_user. Reason: $param");
	}

	return (0);
}

sub deleteRequestUser{
	my ($self, $request) = @_;

	my $where = '';
	my @args = ();
	my @cols= ();

	if (defined($request)) {
		foreach my $key (keys(%$request)) {
			push(@cols, " #>request_user.$key<#=?");
			push(@args, [$request->{$key}]);
		}
	}else{
		Logger->get()->warning('ProvisionDAO', "NA", "Unknown delete.");
		return (-1, "Unknown delete.");
	}
	$where = join(" and ", @cols);
	my $sql = 'delete from #>request_user<# where ' . $where;

	my ($rc, $param) = $self->{'dba'}->execSQL($sql, \@args);
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA", "Failed to delete request_user. Reason: $param");
		return (-1, "Failed to delete request_user. Reason: $param");
	}

	return (0);

}

sub modifyRequestUser {
	my ($self, $query, $attrs) = @_;

	my @cols = ();
	my @args = ();
	my $where = '';

	if (defined($attrs)) {
		foreach my $key (keys(%$attrs)) {
			push(@cols, "#>request_user.$key<#=?");
			push(@args, [$attrs->{$key}]);
		}
	}

	my @where_cols= ();
	if (defined($query)) {
		foreach my $key (keys(%$query)) {
			push(@where_cols, " #>request_user.$key<#=?");
			push(@args, [$query->{$key}]);
		}
	}else{
		Logger->get()->warning('ProvisionDAO', "NA", "Unknown modify.");
		return (-1, "Unknown modify.");
	}
	$where = join(" and ", @where_cols);
	my $sql = sprintf('update #>request_user<# set %s where %s', join(',', @cols), $where);
	my ($rc, $param) = $self->{'dba'}->execSQL($sql, \@args);
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA", "Failed to update request_user info. Reason: $param");
		return (-1, "Failed to update request_user info. Reason: $param");
	}

	return (0);
}

sub insertProvisionMachineHistory {
	my ($self, $name, $attrs) = @_;

	my @cols = ();
	my @vals = ();
	my @args = ();

	push(@cols, "#>provision_machine_history.request_name<#");
	push(@vals, '?');
	push(@args, [$name]);

	if (defined($attrs)) {
		foreach my $key (keys(%$attrs)) {
			push(@cols, "#>provision_machine_history.$key<#");
			push(@vals, '?');
			push(@args, [$attrs->{$key}]);
		}
	}

	my $sql = sprintf('insert into #>provision_machine_history<# (%s) values (%s)', join(',', @cols), join(',', @vals));

	my ($rc, $param) = $self->{'dba'}->execSQL($sql, \@args);
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA", "Failed to create new provision_machine_history. Reason: $param");
		return (-1, "Failed to create new provision_machine_history. Reason: $param");
	}

	return (0);
}

sub queryProvisionMachineHistory {
	my ($self, $args) = @_;

	my $where = '';
	my $bind = [];

	my @cols= ();
	if (defined($args)) {
		foreach my $key (keys(%$args)) {
			push(@cols, " #>provision_machine_history.$key<#=?");
			push(@$bind, [$args->{$key}]);
		}
	}else{
		Logger->get()->warning('ProvisionDAO', "NA", "Unknown query.");
		return (-1, "Unknown modify.");
	}
	$where = join(" and ", @cols);

	my $sql = 'select #>provision_machine_history.*<# from #>provision_machine_history<# where ' . $where;

	my ($rc, $param) = $self->{'dba'}->querySQL($sql, $bind);
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA","Failed to query provision_machine_history basic info. Reason: $param");
		return (-1, "Failed to query provision_machine_history basic info. Reason: $param");
	}

	($rc, $param) = $self->{'dba'}->fetchrow_hashref('#>provision_machine_history.id<#', '#>provision_machine_history<#');
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA","Failed to query provision_machine_history basic info. Reason: $param");
		return (-1, "Failed to query provision_machine_history basic info. Reason: $param");
	}

	$self->{'dba'}->finish();

	if (!scalar(%$param)) {
		Logger->get()->info('ProvisionDAO', "NA","No record.");
		return (100, "No record.");
	}

	return (0, $param);
}

sub modifyProvisionMachineHistory {
	my ($self, $query, $attrs) = @_;

	my @cols = ();
	my @args = ();
	my $where = '';

	if (defined($attrs)) {
		foreach my $key (keys(%$attrs)) {
			push(@cols, "#>provision_machine_history.$key<#=?");
			push(@args, [$attrs->{$key}]);
		}
	}

	my @where_cols= ();
	if (defined($query)) {
		foreach my $key (keys(%$query)) {
			push(@where_cols, " #>provision_machine_history.$key<#=?");
			push(@args, [$query->{$key}]);
		}
	}else{
		Logger->get()->warning('ProvisionDAO', "NA", "Unknown modify.");
		return (-1, "Unknown modify.");
	}
	$where = join(" and ", @where_cols);

	my $sql = sprintf('update #>provision_machine_history<# set %s where %s', join(',', @cols), $where);
	my ($rc, $param) = $self->{'dba'}->execSQL($sql, \@args);
	if ($rc != 0) {
		Logger->get()->warning('ProvisionDAO', "NA","Failed to update provision_machine_history info. Reason: $param");
		return (-1, "Failed to update provision_machine_history info. Reason: $param");
	}

	return (0);
}

1;
