# sccsid = "@(#) src/hpcc/common/db/SQLUtils.pm, hpc.cloud.comm, hpcc_rbei, rbeis001a 1.2 6/15/11 11:34:51";
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
#  
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# (C) COPYRIGHT International Business Machines Corp. 2010,2011 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 
package SQLUtils;

use strict;
use warnings;

use DBI;

sub execSQL
{
    my ($package, $dbh, $sql, $args) = @_;
    my $sth;
    my $error = 0;
    my $errmsg;
    my $valid_express;

    $valid_express = 1;
    $sth = $dbh->prepare($sql) or $valid_express = 0;

    if (defined($args) && scalar(@$args)>0) {
        my $idx = 1;
        foreach my $arg_hdl (@$args) {
            $sth->bind_param($idx, @$arg_hdl);
            $idx++;
        }
    }

    if (!$valid_express) {
        $errmsg = $dbh->errstr;
        return (-1, $errmsg);
    };
    
    eval {
        unless ( $sth->execute() ) {
            $error = 1;
        }
    };
    if ($@ or $error) {
        $errmsg = $DBI::errstr;
        $sth->finish();
        return (-2, $errmsg);
    }

    $sth->finish();
    return (0, 'SUCC');  # succeed
}

sub querySQL
{
    my ($package, $dbh, $sql, $args) = @_;
    my $sth;
    my $errmsg;
    my $error = 0;
    my $valid_express;

    $valid_express = 1;
    $sth = $dbh->prepare($sql) or $valid_express = 0;

    if (defined($args) && scalar(@$args)>0) {
        my $idx = 1;
        foreach my $arg_hdl (@$args) {
            $sth->bind_param($idx, @$arg_hdl);
            $idx++;
        }
    }

    if (!$valid_express) {
        $errmsg = $dbh->errstr;
        return (-1, $errmsg);
    };

    eval {
        unless ( $sth->execute() ) {
            $error = 1;
        }
    };
    if ($@ or $error) {
        $errmsg = $DBI::errstr;
        $sth->finish();
        return (-2, $errmsg);
    }

    return (0, $sth);   # succeed
}


1;
