# sccsid = "@(#) src/hpcc/common/utils/Logging.pm, hpc.cloud.comm, hpcc_rbei, rbeis001a 1.2 6/15/11 11:35:04";
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
#  
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# (C) COPYRIGHT International Business Machines Corp. 2010,2011 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 
package Logging;

use strict;
use warnings;

use constant LEVEL_ERROR     => 1;
use constant LEVEL_WARNING   => 2;
use constant LEVEL_INFO      => 3;
use constant LEVEL_DEBUG     => 4;

$Logging::Instance = &new();

sub new {
    my ($class, $storage_hdl) =@_;
    my $self = {};
    $self->{'storage'} = $storage_hdl;
    bless($self);
    return $self;
}

sub get {
    return $Logging::Instance;
}

sub setLogger {
    my ($self, $logger) = @_;
    $self->{'storage'} = $logger;
}

sub msg {
    my ($hdl, $sev, $obj, $catalog, $fmt, @args) = @_;

    my ($package, $filename, $line, $func) = caller(3);
    my $pid = $$;
    
#   my ($sec,$min,$hour,$day,$month,$year,@rest) = localtime(time);
#   $header = sprintf("%d-%02d-%02d %02d:%02d:%02d [%d]",
#               $year+1900, $month, $day, $hour, $min, $sec, $pid);
              
    my $now = time();
    my $body = sprintf($fmt, @args);

    $hdl->store($now, $pid, $func, $sev, $catalog, $obj, $body);
}

sub error {
    my ($ins, $obj, $catalog, @args) = @_;
    &msg($ins->{'storage'}, LEVEL_ERROR, $obj, $catalog, @args);
}

sub warning {
    my ($ins, $obj, $catalog, @args) = @_;
    &msg($ins->{'storage'}, LEVEL_WARNING, $obj, $catalog, @args);
}

sub info {
    my ($ins, $obj, $catalog, @args) = @_;
    &msg($ins->{'storage'}, LEVEL_INFO, $obj, $catalog, @args);
}

sub debug {
    my ($ins, $obj, $catalog, @args) = @_;
    &msg($ins->{'storage'}, LEVEL_DEBUG, $obj, $catalog, @args);
}

1;

