#!/usr/bin/perl 
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
#  
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# (C) COPYRIGHT International Business Machines Corp. 2011 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 
# sccsid = "@(#) src/hpcc/common/utils/xCatUtils.pm, hpc.cloud.sysmgt, hpcc_rbei, rbeis002a 1.2 9/13/11 07:22:12";

package xCatUtils;

use strict;
use warnings;

use Utils::Logger;
use GeneralDefine;
my $bname="xCatUtils";
=des 
	transfer the input to xcat table column name
=cut
sub mapSwitchportconfig2xCat{
	my ($self, $table, $action, $items) = @_;
	if(!defined($table) || !defined($action)||!defined($items)){
		Logger->get()->warning('xCatUtils', 'mapSwitchportconfig2xCat', "Not speicify the table name or action or changed value");
		return ($GeneralDefine::FAILED, "$bname:Not speicify the table name or action or changed value");
    }
	my $xCatkey={
		'node'=>$items->{'node_name'},
	};
    my $xCatSwitch;
	if(exists($items->{'switch_name'})){
		$xCatSwitch->{'switch'}=$items->{'switch_name'};
	}
	if(exists($items->{'port_id'})){
		$xCatSwitch->{'port'}=$items->{'port_id'};
	}
	if(exists($items->{'description'})){
		$xCatSwitch->{'comments'} = "\"$items->{'description'}\"";
	}
	if(!defined($xCatSwitch) and ($action ne 'delete')){#nothing to do
		return ($GeneralDefine::SUCCESS);
	}
	my($rc, $errStr) = change_table($table, $action, $xCatSwitch, $xCatkey);
	return $rc;
}

=des 
	transfer the input to xcat table column name
=cut
sub mapSwitchconfig2xCat{
	my ($self, $table, $action, $items) = @_;
	if(!defined($table) || !defined($action)||!defined($items)){
		Logger->get()->warning('xCatUtils', 'mapSwitchconfig2xCat', "Not speicify the table name or action or changed value");
		return ($GeneralDefine::FAILED, "$bname:Not speicify the table name or action or changed value");
	}
	#switch,snmpversion,username,password,privacy,auth,linkports,comments,disable
    my $xCatSwitch;
	my $xCatkey->{'switch'}=$items->{'switchName'};

	if(exists($items->{'snmpVersion'})){
		$xCatSwitch->{'snmpversion'} = $items->{'snmpVersion'};
	}
	if(exists($items->{'userName'})){
		$xCatSwitch->{'username'} = $items->{'userName'};
	}
	if(exists($items->{'password'})){
		$xCatSwitch->{'password'} = $items->{'password'};
	}
	if(exists($items->{'authMethod'})){
		$xCatSwitch->{'auth'} = $items->{'authMethod'};
	}
	if(exists($items->{'linkPorts'})){
		$xCatSwitch->{'linkports'} = $items->{'linkPorts'};
	}
	if(exists($items->{'comments'})){
		$xCatSwitch->{'comments'} = "\"$items->{'comments'}\"";
	}
	if(!defined($xCatSwitch) and $action ne 'delete'){#nothing do
		return ($GeneralDefine::SUCCESS);
	}
	my($rc, $errStr) = change_table($table, $action, $xCatSwitch, $xCatkey);
	return $rc;
}

=desc
	internal used

=cut
sub change_table {
	my ($table, $action, $items, $key) = @_;
	if(!defined($table) || !defined($action)||!defined($key)){
		Logger->get()->warning('xCatUtils', 'change_table', "Not speicify the table name or action or changed value");
		return ($GeneralDefine::FAILED, "$bname:Not speicify the table name or action or changed value");
    }
	if(($action ne "delete") && !defined($items)){
		Logger->get()->warning('xCatUtils', 'change_table', "Not speicify the items for $action");
		return ($GeneralDefine::FAILED, "$bname:Not speicify the items for $action");
    }
    #currently do not use full path to invoke chtab, maybe we can add a define for the path
    my $actStr=" ";
    if($action eq "delete"){
       	$actStr='-d';
    }
    my $tmpS = sprintf("/opt/xcat/sbin/chtab %s %s=%s", $actStr, keys(%$key), values(%$key));

	if(defined($items)){
    	foreach my $col(keys(%$items)){
       		$tmpS .= sprintf(" %s.%s=%s", $table, $col, $items->{$col});
		}
	}else{
		$tmpS .= " $table";
	}
    my $cmd = "/opt/ibm/hpccloud/cloudbin/utils/thcsu -u root  \'$tmpS\'";
    my $rc;
    eval{
		$rc = system("$cmd");
	};
	if($@) {
		Logger->get()->warning('xCatUtils', 'change_table', "catch implement $cmd crash.");
		return ($GeneralDefine::FAILED, "$bname:catch implement $cmd crash.");
	}
	if($rc){
		Logger->get()->warning('xCatUtils', 'change_table', "Failed to implement $cmd.");
		return ($GeneralDefine::FAILED, "$bname:Failed to implement $cmd.");
	}
	return ($GeneralDefine::SUCCESS);
}

sub dumpTab2Hash{
	my ($class, $table ) = @_;
	my $cmd = "/opt/ibm/hpccloud/cloudbin/utils/thcsu -u root \'/opt/xcat/sbin/tabdump $table\' 2>/dev/null";
	my $output = `$cmd`;
	$output =~ s/\"//g;
	my @lines=split("\n",$output);
	if(scalar(@lines) <= 1){
		return ($GeneralDefine::NORECORD);
	}
	$lines[0] =~ s/#//g;	
	my @keys=split(",",$lines[0]);
	my $result;
	for (my $count=1; $count < scalar(@lines); $count++){
		my @values=split(",",$lines[$count]);
		my $idx=0;
		foreach my $key (@keys){
			$result->{$values[0]}->{$key}=$values[$idx++];
		}
	}
	return $result;
}
sub getIpbyHost{
	my ($class, $hostname) = @_;
	my $cmd = "/opt/ibm/hpccloud/cloudbin/utils/thcsu -u root \'/usr/bin/gethostip -d $hostname\'  2>/dev/null";
	my $output = `$cmd`;
	chomp($output);
	my @tmp = split('\.', $output);
	if(scalar(@tmp) ne "4"){
		return ($GeneralDefine::FAILED);
	}
	return ($output);
}
sub updatexCathostTable{
	my ($class, $hostname) = @_;
	my $ipAdd = xCatUtils->getIpbyHost($hostname);
	if($ipAdd eq $GeneralDefine::FAILED){
		return ($GeneralDefine::FAILED);
	}
	my $table="hosts";
	my $action="add";
	my $key;
	$key->{'node'}=$hostname;
	my $hosts;
	$hosts->{'ip'}=$ipAdd;
	my($rc, $errStr) = change_table($table, $action, $hosts, $key);
	return $rc;
}

1;

