# sccsid = "@(#) src/hpcc/webui/hpccloud/WebuiUtils.pm, hpc.cloud.ui, hpcc_rbei, rbeis002a 1.6 9/30/11 05:43:38";
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
#  
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# (C) COPYRIGHT International Business Machines Corp. 2010,2011 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 

package WebuiUtils;

use CloudUtils;
use strict;
use warnings;
use EnergyUtils;

sub genProvXml {
    my ($class, $allprovs) = @_;
    my $pcolor = CloudUtils->status2Color;
    
    my $returnXML = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
    $returnXML .= "<reservations>";
    $returnXML .= "<timeDateStamp>" . scalar (localtime) . "</timeDateStamp>";
	
    foreach my $prov (keys %$allprovs) {
	$returnXML .= "<reservation>";
	$returnXML .= "<reservationId>" . $allprovs->{$prov}->{'request.name'} . "</reservationId>";
	$returnXML .= "<owner>" . $allprovs->{$prov}->{'request.owner'} . "</owner>";
	$returnXML .= "<startTime>" . $allprovs->{$prov}->{'request.start_time'}*1000 . "</startTime>";
	$returnXML .= "<duration>" . ($allprovs->{$prov}->{'request.expiry_time'}-$allprovs->{$prov}->{'request.start_time'}) . "</duration>";
	$returnXML .= "<endTime>" . $allprovs->{$prov}->{'request.expiry_time'}*1000 . "</endTime>";
	$returnXML .= "<status>" . $allprovs->{$prov}->{'request.status'} . "</status>";
	my @machines = ();
	foreach my $mach (@{$allprovs->{$prov}->{'machList'}}) {
		push(@machines, $mach->{'machine.name'});
  	}
	$returnXML .= "<reservedNodes>" . (join " ", @machines) . "</reservedNodes>";

	if ($allprovs->{$prov}->{'incUsers'}) {
	    $returnXML .= "<mode_u>" . "include" . "</mode_u>";
	    $returnXML .= "<users>" . (join " ", @{$allprovs->{$prov}->{'incUsers'}}) . "</users>";
	} elsif ($allprovs->{$prov}->{'excUsers'}) {
            $returnXML .= "<mode_u>" . "exclude" . "</mode_u>";
	    $returnXML .= "<users>" . (join " ", @{$allprovs->{$prov}->{'excUsers'}}) . "</users>";
	}
	if ($allprovs->{$prov}->{'incGrps'}) {
            $returnXML .= "<mode_g>" . "include" . "</mode_g>";
	    $returnXML .= "<groups>" . (join " ", @{$allprovs->{$prov}->{'incGrps'}}) . "</groups>";
	} elsif ($allprovs->{$prov}->{'excGrps'}) {
	    $returnXML .= "<mode_g>" . "exclude" . "</mode_g>";
	    $returnXML .= "<groups>" . (join " ", @{$allprovs->{$prov}->{'excGrps'}}) . "</groups>";
	}
	$returnXML .= "<subCluster>" . $allprovs->{$prov}->{'request.cluster'} . "</subCluster>";
	my $energy = EnergyUtils->getEnergyOfProv($prov);
	if ($energy) {
	$returnXML .= "<energy>" . $energy  . " kWh</energy>";
	} else {
		$returnXML .= "<energy>NA</energy>";
	}
	$returnXML .= "<color>" . $pcolor->{$allprovs->{$prov}->{'request.status'}} . "</color>";
	$returnXML .= "</reservation>"; 
    }
    
    $returnXML .= "</reservations>";
    
    return $returnXML;
}

1;
