#!/usr/bin/perl
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
#  
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# (C) COPYRIGHT International Business Machines Corp. 2010,2012 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 

# sccsid = "@(#) src/hpcc/webui/hpccloud/GetInfoXML.cgi, hpc.cloud.ui, hpcc_rbei, rbeis002a 1.24 1/16/12 03:27:50";

use XML::Simple;
use lib "/opt/ibm/hpccloud/lib";
use LoadL;
use CloudUtils;
use WebuiUtils;
use ProvUtils;
use CGI;
my $query = new CGI;

print $query->header(-type=>'text/xml', -charset=>'UTF-8');
my $REMOTE_USER = $ENV{REMOTE_USER};
$REMOTE_USER =~ s/['"`]//g;
my $USERID = $REMOTE_USER;
if (!CloudUtils->isCloudUser($USERID)) {
	print "Sorry, you are not HPC Cloud user.";
	exit(1);
}
$::ISADMIN = CloudUtils->isAdmin($USERID);
my $CLOUD_BIN_DIR = $::CONFIG{'CLOUD_TOOL_DIR'};
my $BIN_DIR = $::CONFIG{'BIN_DIR'};

sub listUserXML {
	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/usermgt/hclsuser --all\"";
	my $output = `$cmd`;

	my $xml = new XML::Simple(KeyAttr=>[]);
	my $data = $xml->XMLin($output);

	#print Dumper($data);
	$output = "<users>\n";

	if (ref($data->{users}->{user_name}) eq "ARRAY") {
		foreach my $elem (@{$data->{users}->{user_name}}) {
			$cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/usermgt/hclsuser --userid=$elem\"";
			$output .= `$cmd`;
			#print $output;
		}
	} else {
		$cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/usermgt/hclsuser --userid=$data->{users}->{user_name}\"";
		$output .= `$cmd`;
	}
	$output .= "</users>\n";

	print $output;
	#$data = $xml->XMLin($output);
	#print Dumper($data);
}

sub listRoleXML {
	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/usermgt/hclsrole --all\"";
	my $output = `$cmd`;

	my $xml = new XML::Simple(KeyAttr=>[]);
	my $data = $xml->XMLin($output);

	#print Dumper($data);
	$output = "<roles>\n";

	if (ref($data->{role}->{name}) eq "ARRAY") {
		foreach my $elem (@{$data->{role}->{name}}) {
			$cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/usermgt/hclsrole --role=$elem\"";
			$output .= `$cmd`;
		}
	} else {
		$cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/usermgt/hclsrole --role=$data->{role}->{name}\"";
		$output .= `$cmd`;
	}
	$output .= "</roles>\n";

	print $output;
	#$data = $xml->XMLin($output);
	#print Dumper($data);
}

sub listGroupXML {
	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/usermgt/hclsgroup --all\"";
	my $output = `$cmd`;

	my $xml = new XML::Simple(KeyAttr=>[]);
	my $data = $xml->XMLin($output);

	#print $data->{options}->{option}->[0]->{value};

	#print Dumper($data);
	$output = "<groups>\n";
	if (ref($data->{user_groups}->{group_name}) eq "ARRAY") {
		foreach my $elem (@{$data->{user_groups}->{group_name}}) {
			$cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/usermgt/hclsgroup --groupid=$elem\"";
			$output .= `$cmd`;
			#print $output;
		}
	} else {
		$cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/usermgt/hclsgroup --groupid=$data->{user_groups}->{group_name}\"";
		$output .= `$cmd`;
	}
	$output .= "</groups>";

	print $output;
	#$data = $xml->XMLin($output);
	#print Dumper($data);
}

sub listImageXML {
	my ($query) = @_;
	my $cmdstr=$query->param("cmdstr") ;
	my $cmd;
	if(defined($cmdstr)){
	   $cmdstr =~ s/\%20/ /;

 	$cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/imgmgt/hclsimage $cmdstr\"";
	}else{
		$cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/imgmgt/hclsimage\"";
	}

	my $output = `$cmd`;
	print $output;
}

sub listESchemeXML {
	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/energy/hclsescheme --owner=$USERID\"";
	my $output = `$cmd`;
	print $output;
}

sub listEPolicyXML {
	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/energy/hclsepolicy\"";
	my $output = `$cmd`;
	print $output;
}

sub listReqXML {
	my ($query) = @_;
	my $output;
	my $cmd;
	my $status=$query->param('status');
	if ($::ISADMIN){
		$cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/prov/hclsreq --status=$status\"";
	}
	else{
		$cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/prov/hclsreq --userid=$USERID --status=$status\"";
	}
	$output = `$cmd`;
	print $output;
}

sub listReqXML4Calendar {
	my ($query) = @_;
	my $allprovs;
	if ($::ISADMIN) {
	# The 2nd argument 2 indicates the machines being added should be included.
		$allprovs = CloudUtils->getProvInfo(0,2);
	} else {
		$allprovs = CloudUtils->getProvByUser($USERID, 1);
	}
	my $ownerfilter = $query->param("owner");
	if ($ownerfilter) {
		foreach my $provId (keys %$allprovs) {
			if ($ownerfilter ne $allprovs->{$provId}->{'request.owner'}) {
				delete $allprovs->{$provId};
			}
		}
	}
	my $xml = WebuiUtils->genProvXml($allprovs);
	print "$xml\n";
}
sub listVlanXML
{
	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/sysconfig/hclsswitchport\"";	
	my $output = `$cmd`;
	print $output;
}
sub listSwitchXML
{
	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/sysconfig/hclsswitch\"";	
	my $output = `$cmd`;
	print $output;
}
sub listPackageXML
{
	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/imgmgt/hclspkglist\"";	
	my $output = `$cmd`;
	print $output;
}
sub listScriptXML
{
	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/imgmgt/hclsscript\"";	
	my $output = `$cmd`;
	print $output;
}

sub getbilling4modify{
	my ($query) = @_;
    my $duration = $query->param('duration');
    my @machList = $query->param('machList');
    my $machType = $query->param('machType');
    my $machNum = $query->param('addmachnum');
    my $reqname = $query->param('reqname');
	my $oriMachList = $query->param('orimachList');
	my $vcpu = $query->param('vcpunum');
    my %prov;
    $prov{'request.owner'} = $USERID;
    $prov{'duration'} = $duration;
    $prov{'reqid'} = $reqname;
	if(defined($machType)){
		if($machNum > 0){
    		$prov{'addmachnum'} = $machNum;
		}elsif($machNum < 0){
			my @oriMachListArr = sort(split(",", $oriMachList));
			my @rmmachs=();
			my $rmnum = 0 - $machNum;
			$machNum = scalar(@oriMachListArr);
			for( my $idx=1; $idx<=$rmnum; $idx++){
				push(@rmmachs, $oriMachListArr[$machNum - $idx]);
			}
			$prov{'rmmach'} = join(',', @rmmachs);
		}
        $prov{'select_method'} = 1;
	}else{
		$prov{'machlist'} = join(",", @machList);
        $prov{'select_method'} = 0;
	}
	if(defined($vcpu)){
		$prov{'cpus'} = $vcpu;
	}

	my ($enough, $cost, $changed) = ProvUtils->getBilling(\%prov,'Modify');

    my $cost_str = sprintf("%d.%02d", ($cost/100), ($cost%100));
    my $changed_str = sprintf("%d.%02d", ($changed/100), ($changed%100));
    print "$enough|$cost_str|$changed_str";
} 

#main function 
#
my $function = $query->param('function');
$function =~ s/['"`]//g;
if ($function eq 'listUserXML')			 { listUserXML($query); }
elsif ($function eq 'listGroupXML')		 { listGroupXML($query); }
elsif ($function eq 'listImageXML')		 { listImageXML($query); }
elsif ($function eq 'listESchemeXML')	   { listESchemeXML($query); }
elsif ($function eq 'listEPolicyXML')	   { listEPolicyXML($query); }
elsif ($function eq 'listRoleXML')		  { listRoleXML($query); }
elsif ($function eq 'listReqXML')		   { listReqXML($query); }
elsif ($function eq 'listVlanXML')		   { listVlanXML($query); }
elsif ($function eq 'listSwitchXML')		{listSwitchXML($query);}
elsif ($function eq 'listPackageXML')	 {listPackageXML($query);}
elsif ($function eq 'listScriptXML')		 {listScriptXML($query);}
elsif ($function eq 'listReqXML4Calendar')		 {listReqXML4Calendar($query);}
elsif ($function eq 'getbilling4modify')		 {getbilling4modify($query);}

