/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* Restricted Materials of IBM                                            */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2010,2012          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* sccsid = "@(#) src/hpcc/webui/hpccloud/scripts/EnergyPolicyView.js, hpc.cloud.ui, hpcc_rbei, rbeis002a 1.12 1/16/12 03:27:46"; */

var epolicyData;
var sortBname= 0;
var sortBenergy = 0;
var sortBmachine= 0;
var sortBpower= 0;
var sortBmode= 0;

function showEPolicies() {
    var xhrArgs = {
        url: "GetInfoXML.cgi?function=listEPolicyXML",
        handleAs: "xml",
        preventCache: true,
        load: function(data) {
            onEPolicyUpdate(data);
        },
        error: function(error) {
            showInfo("An unexpected error occurred: " + error);
        }
    }

    //Call the asynchronous xhrGet
    var deferred = dojo.xhrGet(xhrArgs);
}

function onEPolicyUpdate(xmlDoc) {
    epolicyData = parseEPolicyXML(xmlDoc);
	//sortEPolicyTab("id");
    refreshEPolicyTab();
}

function convertProvMode(mode_int) {
    var mode_str;
    switch (mode_int) {
    case 0:
        mode_str = "None";
        break;
    case 1:
        mode_str = "JO";
        break;
    case 2:
        mode_str = "PO";
        break;
    case 3:
        mode_str = "J+P";
        break;
    default:
        mode_str = "UNKNOWN";
    }
    return mode_str;
}

function refreshEPolicyTab() {
    clearEPolicyTab();
    var theTable = document.getElementById("epolicylistTab");
    for (var i=0; i < epolicyData.epolicies.length; ++i) {
        var row = theTable.insertRow(theTable.rows.length);
        row.className = "tab_content";

        // isAdm is defined in subroutine sysEnergy in portal.cgi
		if (isAdm) {
			var cell1 = row.insertCell(0);
			if (epolicyData.epolicies[i].flag == "0")
				if (epolicyData.epolicies[i].check ){
					cell1.innerHTML = "<input type=checkbox name=energyPolicyId value=\"" + epolicyData.epolicies[i].id + "\" checked>";
				}else{	
					cell1.innerHTML = "<input type=checkbox name=energyPolicyId value=\"" + epolicyData.epolicies[i].id + "\">";
				}	
			var cell2 = row.insertCell(1);
			if (epolicyData.epolicies[i].flag != "2")
				cell2.innerHTML = "<a href=\"javascript:showModPolicyDlg('" + epolicyData.epolicies[i].id + "');\" title=\"Click to modify\">" + epolicyData.epolicies[i].name + "</a>";
			else
				cell2.innerHTML = epolicyData.epolicies[i].name;
			var cell3 = row.insertCell(2);
			cell3.innerHTML = epolicyData.epolicies[i].scheme;
			// Do not support machine group for now.
			// var cell4 = row.insertCell(3);
			// cell4.innerHTML = epolicyData.epolicies[i].mach_group;
			var cell4 = row.insertCell(3);
			cell4.innerHTML = epolicyData.epolicies[i].mach_status;
			var cell5 = row.insertCell(4);
			cell5.innerHTML = epolicyData.epolicies[i].power_status;
			var cell6 = row.insertCell(5);
			cell6.innerHTML = epolicyData.epolicies[i].prov_mode;
			var cell7 = row.insertCell(6);
			cell7.innerHTML = epolicyData.epolicies[i].description;
		} else {
			var cell1 = row.insertCell(0);
			cell1.innerHTML = epolicyData.epolicies[i].name;
			var cell2 = row.insertCell(1);
			cell2.innerHTML = epolicyData.epolicies[i].scheme;
			var cell3 = row.insertCell(2);
			cell3.innerHTML = epolicyData.epolicies[i].mach_status;
			var cell4 = row.insertCell(3);
			cell4.innerHTML = epolicyData.epolicies[i].power_status;
			var cell5 = row.insertCell(4);
			cell5.innerHTML = epolicyData.epolicies[i].prov_mode;
			var cell6 = row.insertCell(5);
			cell6.innerHTML = epolicyData.epolicies[i].description;
		}
    }
}

function parseEPolicyXML(xmlDoc) {
    var result = new Object();
    result.epolicies = [];
    var items = xmlDoc.documentElement.getElementsByTagName('energyPolicy');
    for(var n=0; n < items.length; n++) {
        var epolicy = new Object();
        epolicy.id = getElementDataFromNode(items[n], "energy_policy.id");
        epolicy.name = getElementDataFromNode(items[n], "name");
        epolicy.scheme = getElementDataFromNode(items[n], "energy_scheme");
        epolicy.flag = getElementDataFromNode(items[n], "flag");
        epolicy.mach_group = getElementDataFromNode(items[n], "mach_group");
        epolicy.mach_status = getElementDataFromNode(items[n], "mach_status");
        epolicy.power_status = getElementDataFromNode(items[n], "power_status");
        epolicy.prov_mode = convertProvMode(parseInt(getElementDataFromNode(items[n], "prov_mode")));
        epolicy.description = getElementDataFromNode(items[n], "energy_policy.description");
		epolicy.check = false;

        result.epolicies.push(epolicy);
    }

    return result;
}

function clearEPolicyTab() {
    var theTable = document.getElementById("epolicylistTab");
    for(var i = (theTable.rows.length-1); theTable.rows.length > 2; i--) {
        theTable.deleteRow(i);
    }
}

function keepcheckinfo(){
	// Keep the selected items.
	var form = dojo.byId("energyPolicyForm");
	var inputs = form.getElementsByTagName("input");
	var i,j;

	for(j = 0;j < epolicyData.epolicies.length;j++){
		epolicyData.epolicies[j].check = false;
		for(i=0;i<inputs.length;i++){
			if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].checked == true) {
				if (inputs[i].value == epolicyData.epolicies[j].id){
					epolicyData.epolicies[j].check = true;
				}
			}
		}
	}
}

function sortEPolicyTab(sortingBy) {
	keepcheckinfo();
    if (sortingBy == "name") {
		sortBname= 1-sortBname;
        epolicyData.epolicies.sort(sortByEPolicyName);
    } else if (sortingBy == "energy") {
		sortBenergy = 1- sortBenergy;
        epolicyData.epolicies.sort(sortByEPolicyenergy);
    } else if (sortingBy == "machine") {
		sortBmachine = 1- sortBmachine;
        epolicyData.epolicies.sort(sortByEPolicymachine);
    } else if (sortingBy == "power") {
		sortBpower = 1- sortBpower;
        epolicyData.epolicies.sort(sortByEPolicypower);
    } else if (sortingBy == "mode") {
		sortBmode = 1- sortBmode;
        epolicyData.epolicies.sort(sortByEPolicymode);
    }
    refreshEPolicyTab();
}

function sortByEPolicyName(a, b) {
    var x = a.name.toLowerCase();
    var y = b.name.toLowerCase();
	if(sortBname==1){
	    return ((x < y) ? -1 : ((x > y) ? 1 : 0));}
	else{
		return ((x < y) ? 1 : ((x > y) ? -1 : 0));}
}

function sortByEPolicyenergy(a, b) {
    var x = a.scheme.toLowerCase();
    var y = b.scheme.toLowerCase();
	if(sortBenergy==1){
	    return ((x < y) ? -1 : ((x > y) ? 1 : 0));}
	else{
		return ((x < y) ? 1 : ((x > y) ? -1 : 0));}
}
function sortByEPolicymachine(a, b) {
    var x = a.mach_status.toLowerCase();
    var y = b.mach_status.toLowerCase();
	if(sortBmachine==1){
	    return ((x < y) ? -1 : ((x > y) ? 1 : 0));}
	else{
		return ((x < y) ? 1 : ((x > y) ? -1 : 0));}
}
function sortByEPolicypower(a, b) {
    var x = a.power_status.toLowerCase();
    var y = b.power_status.toLowerCase();
	if(sortBpower==1){
	    return ((x < y) ? -1 : ((x > y) ? 1 : 0));}
	else{
		return ((x < y) ? 1 : ((x > y) ? -1 : 0));}
}
function sortByEPolicymode(a, b) {
    var x = a.prov_mode.toLowerCase();
    var y = b.prov_mode.toLowerCase();
	if(sortBmode==1){
	    return ((x < y) ? -1 : ((x > y) ? 1 : 0));}
	else{
		return ((x < y) ? 1 : ((x > y) ? -1 : 0));}
}

function showNewPolicyDlg() {
    resetPolicyForm();
    dojo.byId("epolicyAction").value = "addEnergyPolicy";
    dojo.byId("policyFormTitle").innerHTML = "New Energy Policy";
    dojo.byId("policyName").disabled = false;
    dojo.byId("mach_status").disabled = false;
    dojo.byId("pmode").disabled = false;
    dojo.byId("policyId").disabled = true;
    dijit.byId("epolicyDlg").show();
}

function showModPolicyDlg(id) {
    resetPolicyForm();
    dojo.byId("policyFormTitle").innerHTML = "Modify Energy Policy";
    dojo.byId("epolicyAction").value = "modEnergyPolicy";
    dojo.byId("policyId").disabled = false;
    dojo.byId("policyId").value = id;
    for (var i=0; i < epolicyData.epolicies.length; ++i) {
        if (epolicyData.epolicies[i].id == id) {
            dojo.byId("policyName").value = epolicyData.epolicies[i].name;

            for (var j=0; j < dojo.byId("pmode").options.length; ++j) {
                if ((dojo.byId("pmode").options[j].value == "PO" && epolicyData.epolicies[i].prov_mode == "PO")
                    || (dojo.byId("pmode").options[j].value == "J+P" && epolicyData.epolicies[i].prov_mode == "J+P"))
                    dojo.byId("pmode").options[j].selected = true;
                else
                    dojo.byId("pmode").options[j].selected = false;
            }
            for (var j=0; j < dojo.byId("mach_status").options.length; ++j) {
                if (dojo.byId("mach_status").options[j].value == epolicyData.epolicies[i].mach_status)
                    dojo.byId("mach_status").options[j].selected = true;
                else
                    dojo.byId("mach_status").options[j].selected = false;
            }
            for (var j=0; j < dojo.byId("escheme").options.length; ++j) {
                if (dojo.byId("escheme").options[j].text == epolicyData.epolicies[i].scheme)
                    dojo.byId("escheme").options[j].selected = true;
                else
                    dojo.byId("escheme").options[j].selected = false;
            }
            dojo.byId("policyDesc").value = epolicyData.epolicies[i].description;

            if (epolicyData.epolicies[i].flag == "1") {
                dojo.byId("policyName").disabled = true;
                dojo.byId("mach_status").disabled = true;
                dojo.byId("pmode").disabled = true;
            } else {
                dojo.byId("policyName").disabled = false;
                dojo.byId("mach_status").disabled = false;
                dojo.byId("pmode").disabled = false;
            }
        }
    }
    dijit.byId("epolicyDlg").show();
}

function resetPolicyForm() {
    document.epolicyForm.reset();
}



function deleteEPolicy() {
	var select = false;
	var form = document.getElementById("energyPolicyForm");
	if (form) {
		var inputs = form.getElementsByTagName("input");
		for(var i=0;i<inputs.length;i++) {
			if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].getAttribute("name") == "energyPolicyId") {
				if (inputs[i].checked == true) {
					select = true;
					break;
				}
			}
		}
	} else {
		return;
	}
	if (!select) { alert("No Policy selected."); return; }
    var doit = confirm("Do you want to delete these energy policies?");
    if(!doit) return;
    var xhrArgs = {
        form: dojo.byId('energyPolicyForm'),
        handleAs: "text",
        load: function(data) {
            hideWaitingDlg();
            showInfo(data);
            dijit.byId("mainContent").refresh();
        },
        error: function(error) {
            hideWaitingDlg();
            showInfo(error);
        }
    }
    showWaitingDlg();
    var deferred = dojo.xhrPost(xhrArgs);
}

function submitEnergyPolicyForm() {
	if(!checkFormAllInput('epolicyForm')){
		alert("Please Remove Illegal Character!");
		return false;
	}
    var xhrArgs = {
        form: dojo.byId('epolicyForm'),
        handleAs: "text",
        load: function(data) {
            hideWaitingDlg();
            showInfo(data);
            dijit.byId("mainContent").refresh();
        },
        error: function(error) {
            hideWaitingDlg();
            showInfo(error);
        }
    }
    showWaitingDlg();
    var deferred = dojo.xhrPost(xhrArgs);
}
