/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* Restricted Materials of IBM                                            */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2010,2012          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* sccsid = "@(#) src/hpcc/webui/hpccloud/scripts/EnergySchemeView.js, hpc.cloud.ui, hpcc_rbei, rbeis002a 1.14 1/16/12 03:27:52"; */

var eschemeData;
var sortBname = 0;
var sortBowner =0;
var sortBtype =0;

function showESchemes() {
    var xhrArgs = {
        url: "GetInfoXML.cgi?function=listESchemeXML",
        handleAs: "xml",
        preventCache: true,
        load: function(data) {
            onESchemeUpdate(data);
        },
        error: function(error) {
            showInfo("An unexpected error occurred: " + error);
        }
    }

    //Call the asynchronous xhrGet
    var deferred = dojo.xhrGet(xhrArgs);
}

function onESchemeUpdate(xmlDoc) {
    eschemeData = parseESchemeXML(xmlDoc);
    refreshESchemeTab();
}

function refreshESchemeTab() {
    clearESchemeTab();
    var theTable = document.getElementById("eschemelistTab");
    if (!theTable) {
        return false;
    }
    for (var i=0; i < eschemeData.eschemes.length; ++i) {
        var row = theTable.insertRow(theTable.rows.length);
        row.className = "tab_content";
        var cell1 = row.insertCell(0);
        var cell2 = row.insertCell(1);
        if (eschemeData.eschemes[i].owner != "default") {
			if (eschemeData.eschemes[i].check ){
            	cell1.innerHTML = "<input type=checkbox name=energySchemeName value=\"" + eschemeData.eschemes[i].owner + ":" + eschemeData.eschemes[i].name + "\" checked>";
			}else{
            	cell1.innerHTML = "<input type=checkbox name=energySchemeName value=\"" + eschemeData.eschemes[i].owner + ":" + eschemeData.eschemes[i].name + "\">";
			}
            cell2.innerHTML = "<a href=\"javascript:showModSchemeDlg('" + eschemeData.eschemes[i].owner + "','" + eschemeData.eschemes[i].name + "');\" title=\"Click to modify\">" + eschemeData.eschemes[i].name + "</a>";
        } else {
            cell2.innerHTML = eschemeData.eschemes[i].name;
        }

        var cell3 = row.insertCell(2);
        cell3.innerHTML = eschemeData.eschemes[i].owner;
        var cell4 = row.insertCell(3);
        cell4.innerHTML = eschemeData.eschemes[i].cat == "1" ? "Dynamic" : "Static";
        var cell5 = row.insertCell(4);
        cell5.innerHTML = mapCpuFreq(eschemeData.eschemes[i].cpu_freq_fixed);
        var cell6 = row.insertCell(5);
        cell6.innerHTML = mapCpuFreq(eschemeData.eschemes[i].cpu_freq_min) + " ~ " + mapCpuFreq(eschemeData.eschemes[i].cpu_freq_max);
        var cell7 = row.insertCell(6);
        cell7.innerHTML = eschemeData.eschemes[i].threshold_up;
        var cell8 = row.insertCell(7);
        cell8.innerHTML = eschemeData.eschemes[i].threshold_down;
        var cell9 = row.insertCell(8);
        cell9.innerHTML = eschemeData.eschemes[i].sampling_rate;
        var cell10 = row.insertCell(9);
        cell10.innerHTML = eschemeData.eschemes[i].freq_step;
        var cell11 = row.insertCell(10);
        cell11.innerHTML = eschemeData.eschemes[i].applied_to;
        var cell12 = row.insertCell(11);
        cell12.innerHTML = eschemeData.eschemes[i].description;
    }
}

// TODO: hard code 1, 2
function mapCpuFreq(freq) {
	if (freq == 1) {
		freq = "MIN_AVAIL_FREQ";
	} else if (freq == 2) {
		freq = "MAX_AVAIL_FREQ";
	}
	return freq;
}

function parseESchemeXML(xmlDoc) {
    var result = new Object();
    result.eschemes = [];
    var items = xmlDoc.documentElement.getElementsByTagName('energyScheme');
    for(var n=0; n < items.length; n++) {
        var escheme = new Object();
        escheme.name = getElementDataFromNode(items[n], "name");
        escheme.cat = getElementDataFromNode(items[n], "cat");
        escheme.cpu_freq_fixed = getElementDataFromNode(items[n], "cpu_freq_fixed");
        escheme.cpu_freq_max = getElementDataFromNode(items[n], "cpu_freq_max");
        escheme.cpu_freq_min = getElementDataFromNode(items[n], "cpu_freq_min");
        escheme.owner = getElementDataFromNode(items[n], "owner");
        escheme.threshold_up = getElementDataFromNode(items[n], "threshold_up");
        escheme.threshold_down = getElementDataFromNode(items[n], "threshold_down");
        escheme.sampling_rate = getElementDataFromNode(items[n], "sampling_rate");
        escheme.freq_step = getElementDataFromNode(items[n], "freq_step");
        escheme.applied_to = getElementDataFromNode(items[n], "appliedTo");
        escheme.description = getElementDataFromNode(items[n], "description");
		escheme.check = false;

        if (escheme.name != "") {
            result.eschemes.push(escheme);
        }
    }

    return result;
}

function clearESchemeTab() {
    var theTable = document.getElementById("eschemelistTab");
    if (!theTable) {
        return false;
    }
    for(var i = (theTable.rows.length-1); theTable.rows.length > 2; i--) {
        theTable.deleteRow(i);
    }
}

function keepcheckinfo(){
	// Keep the selected items.
	var form = dojo.byId("energySchemeForm");
	var inputs = form.getElementsByTagName("input");
	var i,j;

	for(j = 0;j < eschemeData.eschemes.length;j++){
		eschemeData.eschemes[j].check = false;
		for(i=0;i<inputs.length;i++){
			if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].checked == true) {
				if (inputs[i].value.indexOf(eschemeData.eschemes[j].name)>=0){
					eschemeData.eschemes[j].check = true;
				}
			}
		}
	}
}

function sortESchemeTab(sortingBy) {
	keepcheckinfo();
    if (sortingBy == "name") {
		sortBname = 1-sortBname;
        eschemeData.eschemes.sort(sortByESchemeName);
    } else if (sortingBy == "owner") {
		sortBowner =1- sortBowner;
        eschemeData.eschemes.sort(sortByESchemeOwner);
    } else if (sortingBy == "type") {
		sortBtype =1- sortBtype;
        eschemeData.eschemes.sort(sortByESchemeType);
    }
    refreshESchemeTab();
}

function sortByESchemeName(a, b) {
    var x = a.name.toLowerCase();
    var y = b.name.toLowerCase();
	if(sortBname==1){
	    return ((x < y) ? -1 : ((x > y) ? 1 : 0));}
	else{
		return ((x < y) ? 1 : ((x > y) ? -1 : 0));}
}

function sortByESchemeOwner(a, b) {
    var x = a.owner.toLowerCase();
    var y = b.owner.toLowerCase();
	if(sortBowner==1){
	    return ((x < y) ? -1 : ((x > y) ? 1 : 0));}
	else{
		return ((x < y) ? 1 : ((x > y) ? -1 : 0));}
}
function sortByESchemeType(a, b) {
    var x = a.cat.toLowerCase();
    var y = b.cat.toLowerCase();
	if(sortBtype==1){
	    return ((x < y) ? -1 : ((x > y) ? 1 : 0));}
	else{
		return ((x < y) ? 1 : ((x > y) ? -1 : 0));}
}

function showNewSchemeDlg() {
    resetSchemeForm();
    dojo.byId("eschemeAction").value = "addEnergyScheme";
    dojo.byId("schemeFromTitle").innerHTML = "New Energy Scheme";
    dojo.byId("schemeName").readOnly = false;
    dojo.byId("schemeOwner").disabled = true;
    dojo.byId("eschemeForce").style.visibility = "collapse";
    dojo.byId("up_threshold").value = 80;
    dojo.byId("down_threshold").value = 20;
    dojo.byId("samplingRate").value = 300000;
    dojo.byId("freqStep").value = 5;
    activeSchemeFormField();
    dijit.byId("schemeDiv").show();
}

function showModSchemeDlg(owner, name) {
    resetSchemeForm();
    dojo.byId("schemeFromTitle").innerHTML = "Modify Energy Scheme";
    dojo.byId("eschemeAction").value = "modEnergyScheme";
    dojo.byId("schemeName").value = name;
    dojo.byId("schemeName").readOnly = true;
    dojo.byId("schemeOwner").value = owner;
    dojo.byId("schemeOwner").disabled = false;
    dojo.byId("eschemeForce").style.visibility = "visible";
    for (var i=0; i < eschemeData.eschemes.length; ++i) {
        if (eschemeData.eschemes[i].owner == owner && eschemeData.eschemes[i].name == name) {
            for (var j=0; j < dojo.byId("schemeType").options.length; ++j) {
                if ((dojo.byId("schemeType").options[j].value == "static" && eschemeData.eschemes[i].cat == "0")
                    || (dojo.byId("schemeType").options[j].value == "dynamic" && eschemeData.eschemes[i].cat == "1"))
                    dojo.byId("schemeType").options[j].selected = true;
                else
                    dojo.byId("fixedFreq").options[j].selected = false;
            }
            dojo.byId("up_threshold").value = eschemeData.eschemes[i].threshold_up;
            dojo.byId("down_threshold").value = eschemeData.eschemes[i].threshold_down;
            for (var j=0; j < dojo.byId("fixedFreq").options.length; ++j) {
                if (dojo.byId("fixedFreq").options[j].value == eschemeData.eschemes[i].cpu_freq_fixed)
                    dojo.byId("fixedFreq").options[j].selected = true;
                else
                    dojo.byId("fixedFreq").options[j].selected = false;
            }
            for (var j=0; j < dojo.byId("scopeHighest").options.length; ++j) {
                if (dojo.byId("scopeHighest").options[j].value == eschemeData.eschemes[i].cpu_freq_max)
                    dojo.byId("scopeHighest").options[j].selected = true;
                else
                    dojo.byId("scopeHighest").options[j].selected = false;
            }
            for (var j=0; j < dojo.byId("scopeLowest").options.length; ++j) {
                if (dojo.byId("scopeLowest").options[j].value == eschemeData.eschemes[i].cpu_freq_min)
                    dojo.byId("scopeLowest").options[j].selected = true;
                else
                    dojo.byId("scopeLowest").options[j].selected = false;
            }
            dojo.byId("samplingRate").value = eschemeData.eschemes[i].sampling_rate;
            dojo.byId("freqStep").value = eschemeData.eschemes[i].freq_step;
            dojo.byId("schemeDesc").value = eschemeData.eschemes[i].description;
        }
    }
    activeSchemeFormField();
    dijit.byId("schemeDiv").show();
}

function resetSchemeForm() {
    document.eschemeForm.reset();
    document.getElementById('fixedFreq').disabled = false;
    document.getElementById('scopeHighest').disabled = true;
    document.getElementById('scopeLowest').disabled = true;
    document.getElementById('up_threshold').disabled = true;
    document.getElementById('down_threshold').disabled = true;
    document.getElementById('samplingRate').disabled = true;
    document.getElementById('freqStep').disabled = true;
}

function deleteEScheme() {
	var select = false;
	var form = document.getElementById("energySchemeForm");
	if (form) {
		var inputs = form.getElementsByTagName("input");
		for(var i=0;i<inputs.length;i++) {
			if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].getAttribute("name") == "energySchemeName") {
				if (inputs[i].checked == true) {
					select = true;
					break;
				}
			}
		}
	} else {
		return;
	}
	if (!select) { alert("No Scheme selected."); return; }
    var doit = confirm("Do you want to delete these energy schemes?");
    if(!doit) return;
    var xhrArgs = {
        form: dojo.byId('energySchemeForm'),
        handleAs: "text",
        load: function(data) {
            hideWaitingDlg();
            showInfoScheme(data);
            dijit.byId("mainContent").refresh();
        },
        error: function(error) {
            hideWaitingDlg();
            showInfoScheme(error);
        }
    }
    showWaitingDlg();
    var deferred = dojo.xhrPost(xhrArgs);
}

function validateSchemeForm() {
    var form = dojo.byId('eschemeForm');
    if (form.schemeName.value == "") {
        alert("Specify a name for Energy Scheme.");
        return false;
    }

    var type = dojo.byId('schemeType');
    if(type.value == "dynamic") {
        if (parseInt(form.scopeHighest.value) <= parseInt(form.scopeLowest.value)) {
            alert("Min CPU Frequency should be smaller than max CPU Frequency");
            return false;
        }
        if (form.up_threshold.value == "" || form.down_threshold.value == "") {
            alert("Specify the value for threshold");
            return false;
        }
        if (parseInt(form.up_threshold.value) < 20 || parseInt(form.up_threshold.value) > 95
            || parseInt(form.down_threshold.value) < 20 || parseInt(form.down_threshold.value) > 95) {
            alert("The value of threshold is out of range");
            return false;
        }
        if (parseInt(form.up_threshold.value) <= parseInt(form.down_threshold.value)) {
            alert("Down threshold should be smaller than up threshold");
            return false;
        }
        if (form.samplingRate.value == "") {
            alert("Specify the value for sampling rate");
            return false;
        }
        if (parseInt(form.samplingRate.value) < 60000) {
            alert("The value of sampling rate is out of range");
            return false;
        }
        if (form.freqStep.value == "") {
            alert("Specify the value for Frequency Step");
            return false;
        }
        if (parseInt(form.freqStep.value) < 5 || parseInt(form.freqStep.value) > 100) {
            alert("The value of Freq Step is out of range");
            return false;
        }
       }

    return true;
}

function submitEnergySchemeForm() {
	if(!checkFormAllInput('eschemeForm')){
		alert("Please Remove Illegal Character!");
		return false;
	}
    var doit = validateSchemeForm();
    if (!doit) return false;
    var xhrArgs = {
        form: dojo.byId('eschemeForm'),
        handleAs: "text",
        load: function(data) {
            hideWaitingDlg();
            showInfo(data);
            dijit.byId("mainContent").refresh();
        },
        error: function(error) {
            hideWaitingDlg();
            showInfo(error);
        }
    }
    showWaitingDlg();
    var deferred = dojo.xhrPost(xhrArgs);
}
