/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* Restricted Materials of IBM                                            */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2010,2012          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* sccsid = "@(#) src/hpcc/webui/hpccloud/scripts/ImageView.js, hpc.cloud.ui, hpcc_rbei, rbeis002a 1.22 1/4/12 04:49:01"; */

var imageData;
var sortBname = 0;
var sortBbase =0;
var sortBstatus =0;
var showRmImg = 0;
var ptimerID;
var interval = 20000;
var existReq=0;
String.prototype.Trim=function() {
    return this.replace(/(^\s*)|(\s*$)/g,"");
}
var xhrArgs = {
        url: "GetInfoXML.cgi?function=listImageXML",
        handleAs: "xml",
        preventCache: true,
        load: function(data) {
            onImageUpdate(data);
        },
        error: function(error) {
            showInfo("An unexpected error occurred: " + error);
        }
    }
function showImages() {
    

    //Call the asynchronous xhrGet
    var deferred = dojo.xhrGet(xhrArgs);
	pollImageStatus();
}

function pollImageStatus() {
    if(!ptimerID) ptimerID = setInterval("onPTimer()", interval);
}
function onImageUpdate(xmlDoc) {
    imageData = parseImageXML(xmlDoc);
    refreshImageTab();
}
function onPTimer() {
	if(existReq > 0){
    	var deferred = dojo.xhrGet(xhrArgs);
	}
}

function refreshImageTab() {
    var theTable = dojo.byId("imagelistTab");
    if (!theTable) {
        if(ptimerID) { clearInterval(ptimerID); ptimerID = null; }
	    return;
	}
    clearImageTab();
	existReq = 0;//we can accept next refresh
    for (var i=0; i < imageData.images.length; ++i) {
		if((showRmImg == 0) && (imageData.images[i].status=="REMOVED")){
			continue;
		}
        var row = theTable.insertRow(theTable.rows.length);
        row.className = "tab_content";
        var cell1 = row.insertCell(0);
	if((imageData.images[i].status=="INIT")||(imageData.images[i].status=="AVAILABLE")
		||(imageData.images[i].status=="FAIL")){
			if (imageData.images[i].check) {
				cell1.innerHTML = "<input type=checkbox name=imageId value=" + imageData.images[i].name + " checked>";
			} else {
				cell1.innerHTML = "<input type=checkbox name=imageId value=" + imageData.images[i].name + " >";
			}
	}
        var cell2 = row.insertCell(1);
		cell2.innerHTML = "<a href=\"javascript:navLink('listImage', '?function=listImageDetail&imagename=" + imageData.images[i].name + "')\" title=\"Detailed Information\">" + imageData.images[i].name + "</a>";
        var cell3 = row.insertCell(2);
        var logo = "";
        var base = imageData.images[i].base.toLowerCase();
        if (base.indexOf("rhel") != -1) {
            logo = "<img src=\"/hpccloud/images/redhat_logo.png\" height=30 width=30>";
	    base = "RedHat Enterprise Linux";
        } else if (base.indexOf("redhat") != -1) {
            logo = "<img src=\"/hpccloud/images/redhat_logo.png\" height=30 width=30>";
	    base = "RedHat Enterprise Linux";
        } else if (base.indexOf("sles") != -1) {
            logo = "<img src=\"/hpccloud/images/suse_logo.png\" height=30 width=30>";
	    base = "SuSE Enterprise Linux";
        } else if (base.indexOf("suse") != -1) {
            logo = "<img src=\"/hpccloud/images/suse_logo.png\" height=30 width=30>";
	    base = "SuSE Enterprise Linux";
        } else if (base.indexOf("imagex") != -1) {
            logo = "<img src=\"/hpccloud/images/windows_logo.png\" height=30 width=30>";
	    base = "Microsoft Windows";
        } else if (base.indexOf("microsoft") != -1) {
            logo = "<img src=\"/hpccloud/images/windows_logo.png\" height=30 width=30>";
	    base = "Microsoft Windows";
        } else if (base.indexOf("ms") != -1) {
            logo = "<img src=\"/hpccloud/images/windows_logo.png\" height=30 width=30>";
	    base = "Microsoft Windows";
        } else if (base.indexOf("windows") != -1) {
            logo = "<img src=\"/hpccloud/images/windows_logo.png\" height=30 width=30>";
	    base = "Microsoft Windows";
        } else if (base.indexOf("centos") != -1) {
            logo = "<img src=\"/hpccloud/images/centos_logo.png\" height=30 width=30>";
	    base = "CentOS";
        } else {
            base = imageData.images[i].base;
            logo = "";
        }

        cell3.innerHTML = "<td><table><tr><td>" + logo +"</td><td>" + base + "</td></tr></table></td>";

        var cell4 = row.insertCell(3);
		var statePic;
		if( imageData.images[i].status == "SETUP" ) {
			existReq++;
			statePic = "loader.gif";
			cell4.innerHTML = "<img src=\"/hpccloud/images/" + statePic + "\" style=\"float:left\">" +imageData.images[i].status;
			//cell4.innerHTML = "NA";//"<img src=\"/hpccloud/images/" + statePic + "\" style=\"float:left\">" ;
		} else {
        	cell4.innerHTML = imageData.images[i].status;
		}
		var cell5 = row.insertCell(4);
		cell5.innerHTML = imageData.images[i].arch;
		var cell6 = row.insertCell(5);
		cell6.innerHTML = imageData.images[i].infrastructure;
		var cell7 = row.insertCell(6);
		cell7.innerHTML = imageData.images[i].description;
		//var cell7 = row.insertCell(6);
	}
}

function parseImageXML(xmlDoc) {
	var result = new Object();
	result.images = [];
	var infra_item = ["parallel_env","scheduler","shared_fs","interconnect"];
	var items = xmlDoc.documentElement.getElementsByTagName('image');
	for(var n=0; n < items.length; n++) {
		var image = new Object();
		image.name = getElementDataFromNode(items[n], "name");
		image.arch = getElementDataFromNode(items[n], "arch");
		image.base = getElementDataFromNode(items[n], "base");
		image.status = getElementDataFromNode(items[n], "status");
		image.description = getElementDataFromNode(items[n], "description");
		image.infrastructure = "";
		for(var i=0; i<infra_item.length; i++){
			if(getElementDataFromNode(items[n], infra_item[i]) != ""){
				if(image.infrastructure == ""){
					image.infrastructure = getElementDataFromNode(items[n], infra_item[i]);
				}else{
					image.infrastructure += ','+getElementDataFromNode(items[n], infra_item[i]);
				}
			}
		}
		image.check = false;
		result.images.push(image);
	}

	return result;
}

function clearImageTab() {
	var theTable = document.getElementById("imagelistTab");
	for(var i = (theTable.rows.length-1); theTable.rows.length > 2; i--) {
		theTable.deleteRow(i);
	}
}

function keepcheckinfo(){
	// Keep the selected items.
	var form = dojo.byId("allImageForm");
	var inputs = form.getElementsByTagName("input");
	var i,j;

	for(j = 0;j < imageData.images.length;j++){
		imageData.images[j].check = false;
		for(i=0;i<inputs.length;i++){
			if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].checked == true) {
				if (inputs[i].value == imageData.images[j].name){
					imageData.images[j].check = true;
				}
			}
		}
	}
}

function sortImageTab(sortingBy) {
	keepcheckinfo();
	if (sortingBy == "name") {
		sortBname = 1-sortBname;
		imageData.images.sort(sortByImageName);
	} else if (sortingBy == "base") {
		sortBbase = 1-sortBbase;
		imageData.images.sort(sortByImageBase);
	} else if (sortingBy == "status") {
		sortBstatus = 1-sortBstatus;
		imageData.images.sort(sortByImageStatus);
	}
	refreshImageTab();
}

function sortByImageName(a, b) {
	var x = a.name.toLowerCase();
	var y = b.name.toLowerCase();
	if(sortBname==1){
		return ((x < y) ? -1 : ((x > y) ? 1 : 0));}
	else{
		return ((x < y) ? 1 : ((x > y) ? -1 : 0));}
}

function sortByImageBase(a, b) {
	var x = a.base.toLowerCase();
	var y = b.base.toLowerCase();
	if(sortBbase==1){
		return ((x < y) ? -1 : ((x > y) ? 1 : 0));}
	else{
		return ((x < y) ? 1 : ((x > y) ? -1 : 0));}
}

function sortByImageStatus(a, b) {
	var x = a.status.toLowerCase();
	var y = b.status.toLowerCase();
	if(sortBstatus==1){
		return ((x < y) ? -1 : ((x > y) ? 1 : 0));}
	else{
		return ((x < y) ? 1 : ((x > y) ? -1 : 0));}
}

function deleteImage() {
	var select = false;
	var theTable = dojo.byId("imagelistTab");
	var ckboxidx=-1;
	var statusidx=-1;
	for(var i=0; i< theTable.rows[1].cells.length; i++){
		if(theTable.rows[1].cells[i].innerHTML.indexOf("Select") >= 0){
			ckboxidx=i;
		}else if(theTable.rows[1].cells[i].innerHTML.indexOf("Status") >= 0){
			statusidx=i;
		}
	}
	if((ckboxidx < 0)||(statusidx < 0)){
		alert("Failed get checkbox or Status information");
		return;
	}

	for(var i=2; i < theTable.rows.length; i++){
		var inputs=theTable.rows[i].cells[ckboxidx].getElementsByTagName("input");
		if(inputs[0].checked == true){
			if(theTable.rows[i].cells[statusidx].innerHTML == "AVAILABLE"){
				var conResult = confirm("Image "+inputs[0].value+" may be used, are you sure to delete it?");
				if(!conResult){
					inputs[0].checked = false;
				}else{
					select = true;
				}
			}else{
				select = true;
			}
		}
	}
	if (!select) { alert("No Image selected."); return; }
	var doit = confirm("Do you want to delete these images?");
	if(!doit) return;

	dojo.byId("imageAction").value = "deleteImage";
	submitDeleteImage();
}


function approveImage() {
	var select = false;
	var form = document.getElementById("allImageForm");
	if (form) {
		var inputs = form.getElementsByTagName("input");
		for(var i=0;i<inputs.length;i++) {
			if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].getAttribute("name") == "imageId") {
				if (inputs[i].checked == true) {
					select = true;
					break;
				}
			}
		}
	} else {
		return;
	}
	if (!select) { alert("No Image selected."); return; }
	dojo.byId("imageAction").value = "approveImage";
	submitImageForm();
}

function submitImageForm() {
	if(!checkFormAllInput('allImageForm')){
		alert("Please Remove Illegal Character!");
		return false;
	}
	var xhrArgs = {
		form: dojo.byId('allImageForm'),
		handleAs: "text",
		load: function(data) {
			hideWaitingDlg();
		showInfobySearch(data, "<");
			dijit.byId("mainContent").refresh();
		},
		error: function(error) {
			showInfo(error);
		}
	}
	showWaitingDlg();
	var deferred = dojo.xhrPost(xhrArgs);
}

function submitDeleteImage() {
	var xhrArgs = {
		form: dojo.byId('allImageForm'),
		handleAs: "text",
		load: function(data) {
			hideWaitingDlg();
			showInfoDeleteImage(data);
			dijit.byId("mainContent").refresh();
		},
		error: function(error) {
			showInfo(error);
		}
	}
	showWaitingDlg();
	var deferred = dojo.xhrPost(xhrArgs);
}

function submitNewImage() {
	if(!checkFormAllInput('newImageForm')){
		alert("Please Remove Illegal Character!");
		return false;
	}
	var doit = checkNewImageForm();
	if(!doit) return;

	var prefieldtaken = dojo.byId('prefieldtaken');
	for (var i = 0; i < prefieldtaken.options.length; i++) {
		prefieldtaken.options[i].selected = true;
	}

	var postfieldtaken = dojo.byId('postfieldtaken');
	for (var i = 0; i < postfieldtaken.options.length; i++) {
		postfieldtaken.options[i].selected = true;
	}

	var xhrArgs = {
		form: dojo.byId('newImageForm'),
		handleAs: "text",
		load: function(data) {
			hideWaitingDlg();
			showInfobySearch(data, "<");
			navLink("listImage");
		},
		error: function(error) {
			hideWaitingDlg();
			showInfo(error);
		}
	}
	showWaitingDlg();
	var deferred = dojo.xhrPost(xhrArgs);
}

function checkNewImageForm() {
	var profile_name = dojo.byId('newImageForm').profile.value;
	if (profile_name == "") {
		alert("Error: Specify a string identifier for this image in the profile field.");
		return false;
	}
	if (profile_name.indexOf("-") != -1) {
		alert("Error: The specified profile name is not valid. Character '-' is not allowed.");
		return false;
	}
	if (profile_name.indexOf(" ") != -1) {
		alert("Error: The specified profile name is not valid. White space is not allowed.");
		return false;
	}

	if (dojo.byId("arch").value == "") {
		alert("Error: Select a target processor architecture for this image.");
		return false;
	}

	if (dojo.byId("os").value == "") {
		alert("Error: Select an operating system for this image.");
		return false;
	}

	var desc = dojo.byId('newImageForm').desc.value;
	if (desc == "") {
		alert("Error: Provide some descriptive text for this image.");
		return false;
	}

	return true;
}

function submitCapImage() {
	if(!checkFormAllInput('capImageForm')){
		alert("Please Remove Illegal Character!");
		return false;
	}
	var doit = checkCapImageForm();
	if(!doit) return;

	var postfieldtaken = dojo.byId('postfieldtaken');
	for (var i = 0; i < postfieldtaken.options.length; i++) {
		postfieldtaken.options[i].selected = true;
	}

	var xhrArgs = {
		form: dojo.byId('capImageForm'),
		handleAs: "text",
		load: function(data) {
			hideWaitingDlg();
		showInfobySearch(data, "<");
			navLink("listImage");
		},
		error: function(error) {
			hideWaitingDlg();
			showInfo(error);
		}
	}
	showWaitingDlg();
	var deferred = dojo.xhrPost(xhrArgs);
}

function checkCapImageForm() {
	var image_name = dojo.byId('capImageForm').profile.value;
	if (image_name == "") {
		alert("Error: no name specified.");
		return false;
	}
	if (image_name.indexOf("-") != -1) {
		alert("Error: The specified name is not valid. Character '-' is not allowed.");
		return false;
	}
	if (image_name.indexOf(" ") != -1) {
		alert("Error: The specified name is not valid. White space is not allowed.");
		return false;
	}

	if (dojo.byId('capImageForm').capMach.value == "") {
		alert("Error: no machine selected.");
		return false;
	}

	return true;
}

function checkImagefirstpage() {
	if(!checkFormAllInput('newImageForm')){
		alert("Please Remove Illegal Character!");
		return false;
	}
	var imageName = dojo.byId('newImageForm').profile.value;
	if (imageName == ""){
		alert("Error: Please specify profile name.");
		return false;
	}
	if (imageName.indexOf("-") != -1) {
		alert("Error: The specified profile name is not valid. Character '-' is not allowed.");
		return false;
	}
	if (imageName.indexOf(" ") != -1) {
		alert("Error: The specified profile name is not valid. White space is not allowed.");
		return false;
	}
	var comments = dojo.byId('newImageForm').desc.value;
	if (comments== ""){
		alert("Error: Please fill description field.");
		return false;
	}
	return true;
}
function checkImageCapfirstpage() {
	if(!checkFormAllInput('capImageForm')){
		alert("Please Remove Illegal Character!");
		return false;
	}
	var imageName = dojo.byId('capImageForm').profile.value;
	if (imageName == ""){
		alert("Error: Please specify profile name.");
		return false;
	}
	if (imageName.indexOf("-") != -1) {
		alert("Error: The specified profile name is not valid. Character '-' is not allowed.");
		return false;
	}
	if (imageName.indexOf(" ") != -1) {
		alert("Error: The specified profile name is not valid. White space is not allowed.");
		return false;
	}
	var comments = dojo.byId('capImageForm').desc.value;
	if (comments== ""){
		alert("Error: Please fill description field.");
		return false;
	}
	return true;
}
function onDispRmImageCheckBox()
{
	var chbox = dojo.byId('allImageForm').showrmimage.checked;//form.getElementsByTagName("showfailedprov");
	if(chbox){
		showRmImg = 1;
	}else{
		showRmImg = 0;
	}
	refreshImageTab();
}
