/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* Restricted Materials of IBM                                            */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2010,2011          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* sccsid = "@(#) src/hpcc/webui/hpccloud/scripts/LLWebUI.js, hpc.cloud.ui, hpcc_rbei, rbeis001a 1.2 12/31/10 03:46:49"; */

//UI library
//Global layout consts
var vspanel_w = 30;
var zoombar_h = 150;

//Configurations
var ie = false;
var font_s = 9;
var font_m = 10;
var font_l = 12;
var font_xl = 14;
var tipColor = "#a9d8e9";
var noBrowserSupportError = "This version of the LoadLeveler Web User Interface is supported only on Internet Explorer and Firefox!"
var tableSize = 0;

function setFontSize(small, middle, large, xlarge) {
	if (small) font_s = small;
	if (middle) font_m = middle;
	if (large) font_l = large;
	if (xlarge) font_xl = xlarge;
}
function setIE(is_ie) {
	ie = is_ie;
}

// drag and drop
var dropContainers = [];
function registerDropContainer(obj) {
	dropContainers.push(obj);
}
function resetDropContainer(obj) {
	dropContainers=[];
}
var curDragObj = null;
var inDragging = false;
var dragStartPos;
var dragStartMPos;

function getPosition(obj) {
	return {x:obj.offsetLeft, y:obj.offsetTop};
}
function getMousePosition(event) {
	if(event.pageX || event.pageY){
		return {x:event.pageX, y:event.pageY};
	}
	return {
		x:event.clientX + document.body.scrollLeft - document.body.clientLeft,
		y:event.clientY + document.body.scrollTop - document.body.clientTop
	};	
}
var save_mouseover = null;
function startDrag(obj, event) {
	var e = getEvent(event);
	inDragging = true;
	curDragObj = obj;
	save_mouseover = curDragObj.onmouseover;
	curDragObj.onmouseover = null;
	dragStartPos = getPosition(curDragObj);
	dragStartMPos = getMousePosition(e);

	if (document.addEventListener) {
		document.addEventListener("mousemove", dragMouseMove, false);
		document.addEventListener("mouseup", dragMouseUp, false);
	}
	else if (document.attachEvent) {
		document.attachEvent("onmousemove", dragMouseMove, false);
		document.attachEvent("onmouseup", dragMouseUp, false);
	}
}


function dragMouseMove(event){
	if (!inDragging) return;
	var e = getEvent(event);
	curMPos = getMousePosition(e);
	curDragObj.style.left = dragStartPos.x + curMPos.x - dragStartMPos.x +"px";
	curDragObj.style.top = dragStartPos.y + curMPos.y - dragStartMPos.y +"px";
	curDragObj.style.zIndex = 1000;

}
function getRealRect(obj) {
	var left = obj.offsetLeft; 
	var top = obj.offsetTop;
	var width =  obj.offsetWidth; 
	var height =  obj.offsetHeight; 
	while (obj.offsetParent) {
		left += obj.offsetParent.offsetLeft;
		top += obj.offsetParent.offsetTop;
		obj = obj.offsetparent;
	}
	return {left:left, top:top, width:width, height:height};
}
function stopDrag() {
	if (!inDragging) return;
	inDragging = false;
	curDragObj.onmouseover = save_mouseover;
	curDragObj.style.left = dragStartPos.x +"px";
	curDragObj.style.top = dragStartPos.y +"px";
	curDragObj.style.zIndex = 0;
	curDragObj = null;
	if (document.removeEventListener) {
		document.removeEventListener("mousemove", dragMouseMove, false);
		document.removeEventListener("mouseup", dragMouseUp, false);
	}
	else if (document.detachEvent) {
		document.detachEvent("onmousemove", dragMouseMove, false);
		document.detachEvent("onmouseup", dragMouseUp, false);
	}
}
function dragMouseUp(event){
	if (!inDragging) return;
	var e = getEvent(event);
	curMPos = getMousePosition(e);
	for (var i in dropContainers) {
		var cur = dropContainers[i];
		var con = dropContainers[i];
		var left = con.offsetLeft; 
		var top = con.offsetTop;
		var width =  con.offsetWidth; 
		var height =  con.offsetHeight; 
		while (con.offsetParent) {
			left += con.offsetParent.offsetLeft;
			top += con.offsetParent.offsetTop;
			con = con.offsetParent;
		}
		var right = left + width;
		var bottom = top + height;
		if ((left < curMPos.x) && (right > curMPos.x) && (top < curMPos.y) && (bottom > curMPos.y)) {
			onDrop(curDragObj, cur, event, {dx:curMPos.x - dragStartMPos.x,dy:curMPos.y - dragStartMPos.y});
			break;
		}
	}
	stopDrag();
}

// ajax functions
function createRequest() {
	var request;
	try {
		request = new XMLHttpRequest();
		setIE(false);
		try {
			xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
			delete request;
			request = xmlhttp;
			//IE 7
			setIE(true);
		}catch(err) {
		}
	} catch (microsoft) {
		try {
			request = new ActiveXObject("Msxml2.XMLHTTP");
			setIE(true);
		} catch (oldmicrosoft) {
			try {
				request = new ActiveXObject("Microsoft.XMLHTTP");
				setIE(true);
			} catch (failed) {
				request = false;
			}
		}
	}
	return request;
}
function clearRequest(request) {
	if (request) {
		request.onreadystatechange = function (){};
		request.abort();
		delete request;
		request = false;
	}
}

// Tip functions
var tip_target_id = "";
var tip_x = "";
var tip_y = "";
var tip_label = "";
var tip_color;
var tip_root;

function initTip(obj) {
	if(!obj.popup) {
		var popup = createGraphics(obj.id+"popup");
		popup.setStyle("visibility","hidden");
		popup.setStyle("z-index","999");
		popup.setBorder("1px solid black");
		obj.popup = popup;
		obj.showPopup = false;
		obj.appendChild(obj.popup);
		obj.popup.div.onmouseout = function (event) {
			tip_root.showPopup(false);
		}
	}
	obj.showPopup = function (show,x,y,label,color) {
		this.showed = show;
		if(show) {
			if(color){
				this.popup.setColor(color);
			}else{
				this.popup.setColor("#ffffe1");
			}
			
			var winWidth, winHeight, scrollX, scrollY;
			if (ie) {
				scrollX = document.body.scrollLeft;
				scrollY = document.body.scrollTop;
				winWidth = document.body.offsetWidth;
				winHeight = document.body.offsetHeight;
			}else{
				scrollX = window.scrollX;
				scrollY = window.scrollY;
				winWidth = window.innerWidth;
				winHeight = window.innerHeight;
			}
		
			var left = x-this.div.offsetLeft+10+scrollX;
			var top = y-this.div.offsetTop+10+scrollY;
			var dump = createGraphics("dump");
			this.appendChild(dump);
			dump.setInnerHTML("<div style='font-size:"+font_s+"px'>"+label+"</div>");
			var width = dump.div.offsetWidth;
			var height = dump.div.offsetHeight;
			this.removeChild(dump);
			delete dump;
			
			if (left + width + this.div.offsetLeft - scrollX> winWidth) {
				left = winWidth - width - this.div.offsetLeft + scrollX - 10;
			}
			if (top + height + this.div.offsetTop - scrollY > winHeight) {
				top = winHeight - height - this.div.offsetTop + scrollY - 10;
			}		
			this.popup.setInnerHTML("<div style='font-size:"+font_s+"px'>"+label+"</div>");
			this.popup.setSize(width,height);
			this.popup.setPosition(left,top);
			this.popup.setStyle("visibility","visible");
			this.popup.setStyle("position","fixed");
			
		}else {
			this.popup.setStyle("visibility","hidden");
			tip_target_id = "";
			
		}
	}
	tip_root = obj;
}
function onTipTimeout(org_id) {
	if (tip_target_id == org_id) {
		tip_root.showPopup(true, tip_x, tip_y,tip_label,tip_color);
	}
}
function onTipDivMouseOver(event){
	var e = getEvent(event);
	tip_x = e.clientX;
	tip_y = e.clientY;
	tip_label = this.tip;
	if(this.tip_color){
		tip_color = this.tip_color;	
	}else{
		tip_color = false;
	}
	if (tip_target_id == this.id) return;
	if(this.mouseOverColor) {
		if(this.style["backgroundColor"] != "aqua")
			this.style["background"] = this.mouseOverColor;
	}
	tip_target_id = this.target_id;
	setTimeout("onTipTimeout('"+this.target_id+"')",1000);
}
function onTipDivMouseOut(event){
	var e = getEvent(event);
	if (tip_target_id == this.target_id) {
		tip_target_id = "";
	}
	var node = e.relatedTarget;
	while(node && !node.id)
		node = node.nodeParent;
	if(node && node.id != "popup")
		tip_root.showPopup(false);
	if(this.mouseOutColor) {
		if(this.style["backgroundColor"] != "aqua")
			this.style["background"] = this.mouseOutColor;
	}
}
function addTip(obj, tip, color, mouseOverColor, mouseOutColor) { 
	obj.div.tip = tip;
	obj.div.target_id = obj.id;
	if(color){
		obj.div.tip_color = color;
	}
	if(mouseOverColor) {
		obj.div.mouseOverColor = mouseOverColor;
	}
	if(mouseOutColor) {
		obj.div.mouseOutColor = mouseOutColor;
	}
	obj.div.onmouseover = onTipDivMouseOver;
	obj.div.onmousemove = onTipDivMouseOver;
	obj.div.onmouseout = onTipDivMouseOut;
}

//Scroll and Zoom context and bars
var context = new Context();
function Context() {
	this.xZoom = 0;
	this.xScroll = 0;
	this.yZoom = 0;
	this.yScroll = 0;
	this.zoom = 0;
	this.listeners = [];
	
	this.getZoom = function () {
		return this.zoom; 
	}
	this.getXZoom = function () {
		return this.xZoom; 
	}
	this.getYZoom = function () {
		return this.yZoom; 
	}
	this.getXScroll = function () {
		return this.xScroll; 
	}
	this.getYScroll = function () { 
		return this.yScroll; 
	}
	this.register = function (obj) {		
		this.listeners[0] = obj;
	}
	this.setZoom = function (pos) {
		this.zoom = pos; 
		for (var i in this.listeners) {
			this.listeners[i].onZoom();
		}
	}
	this.setXZoom = function (pos) {
		this.xZoom = pos; 
		for (var i in this.listeners) {
			this.listeners[i].onXZoom();
		}
	}
	this.setYZoom = function (pos) { 
		this.yZoom = pos; 
		for (var i in this.listeners) {
			this.listeners[i].onYZoom();
		}
	}
	this.setXScroll = function (pos) {
		this.xScroll = pos; 
		for (var i in this.listeners) {
			this.listeners[i].onXScroll();
		}
	}
	this.setYScroll = function (pos) {
		this.yScroll = pos; 
		for (var i in this.listeners) {
			this.listeners[i].onYScroll();
		}
	}
	this.idListeners = [];
	this.idValues = [];
	this.registerIdListener = function (id, obj) {
		if(!this.idListeners[id]) {
			this.idListeners[id] = [];
			this.idValues[id] = 0;
		}
		this.idListeners[id].push(obj);
	}
	this.setPos = function (id,pos) {
		this.idValues[id] = pos;
		if(this.idListeners[id]) {
			for (var i in this.idListeners[id]) {
				this.idListeners[id][i].onPosChange();
			}
		}
	}
	this.getPos = function (id) {
		return this.idValues[id];
	}
}
function createVZoomBar(id, width, height) {
	var vzbar = createRect(id,0,0,width,height);
	vzbar.appendChild(createVLine(id+".line",5,height-5,width/2,"black",1));
	vzbar.slider = createRect(id+".slider",0,0,9,5,"white","1px solid gray");
	vzbar.appendChild(vzbar.slider);

	vzbar.setPos = function (pos) {
		this.slider.setPosition(this.width/2-5,(this.height-10)*pos+1);
		onPosChange(this.id, pos);
		this.pos = pos;
	}

	vzbar.div.parent = vzbar;
	vzbar.div.onclick = function (event) {
		var e = getEvent(event);
		if (e.target.id != this.parent.id && e.target.id != this.parent.id+".line") return;
		this.parent.setPos(normalPos((e.layerY-5)/(this.parent.height-10)));
	}

	vzbar.div.onmousedown = function (event) {
		var e = getEvent(event);
		if (e.target.id != this.parent.id+".slider") return;
		this.drag = true;
		this.old_pos = this.parent.pos;
		this.startY = e.screenY;
	}
	vzbar.div.onmousemove = function (event) {
		if (!this.drag) return;
		var e = getEvent(event);
		this.parent.setPos(normalPos((e.screenY-this.startY)/(this.parent.height-10) + this.old_pos));
	}
	vzbar.div.onmouseup = function (event) {
		if (!this.drag) return;
		this.parent.setPos(this.parent.pos);
		this.drag = false;
	}
	vzbar.div.onmouseout = function (event) {
		if (!this.drag) return;
		var e = getEvent(event);
		if (e.relatedTarget.id == this.parent.id+".slider") return;
		if (e.relatedTarget.id == this.parent.id+".line") return;
		if (e.relatedTarget.id == this.parent.id) return;
		this.parent.setPos(this.parent.pos);
		this.drag = false;
	}
	vzbar.setPos(0.5);
	return vzbar;	
}
function createVScrollBar(id, width, height) {
	var vsbar = createRect(id,0,0,width,height,"silver","1px solid gray");
	vsbar.pos = 0.5;
	vsbar.scope = 0.5;
	
	var center_x = width/2+(ie?-1:0);
	var center_y = width/2+(ie?-2:0);

	var uprect = createRect(id+".up",-1,-1,width,width-1,"white","1px solid gray");
	uprect.appendChild(createRect(id+".up",center_x-1,center_y,1,1,"black"));
	uprect.appendChild(createRect(id+".up",center_x,center_y,1,1,"black"));
	uprect.appendChild(createRect(id+".up",center_x+1,center_y,1,1,"black"));
	uprect.appendChild(createRect(id+".up",center_x,center_y-1,1,1,"black"));
	uprect.appendChild(createRect(id+".up",center_x-2,center_y+1,1,1,"black"));
	uprect.appendChild(createRect(id+".up",center_x-1,center_y+1,1,1,"black"));
	uprect.appendChild(createRect(id+".up",center_x,center_y+1,1,1,"black"));
	uprect.appendChild(createRect(id+".up",center_x+1,center_y+1,1,1,"black"));
	uprect.appendChild(createRect(id+".up",center_x+2,center_y+1,1,1,"black"));
	vsbar.appendChild(uprect);
	var downrect = createRect(id+".down",-1,height-width,width,width-1,"white","1px solid gray");
	downrect.appendChild(createRect(id+".down",center_x-1,center_y,1,1,"black"));
	downrect.appendChild(createRect(id+".down",center_x,center_y,1,1,"black"));
	downrect.appendChild(createRect(id+".down",center_x+1,center_y,1,1,"black"));
	downrect.appendChild(createRect(id+".down",center_x,center_y+1,1,1,"black"));
	downrect.appendChild(createRect(id+".down",center_x-2,center_y-1,1,1,"black"));
	downrect.appendChild(createRect(id+".down",center_x-1,center_y-1,1,1,"black"));
	downrect.appendChild(createRect(id+".down",center_x,center_y-1,1,1,"black"));
	downrect.appendChild(createRect(id+".down",center_x+1,center_y-1,1,1,"black"));
	downrect.appendChild(createRect(id+".down",center_x+2,center_y-1,1,1,"black"));
	vsbar.appendChild(downrect);

	vsbar.slider = createRect(id+".slider",-1,0,width,(height-2*width)*vsbar.scope,"white","1px solid gray");
	vsbar.appendChild(vsbar.slider);

	vsbar.setPos = function (pos) {
		this.slider.setPosition(-1,this.logic_h*pos+this.width-(ie?3:1));
		onPosChange(this.id, pos);
		this.pos = pos;
	}
	vsbar.setScope = function (scope) {
		this.scope = normalPos(scope);
		if (this.scope == 1) {
			this.setStyle("visibility","hidden");
		} else {
			this.setStyle("visibility","visible");
		}
		this.slider.height = (this.height-this.width*2)*this.scope;
		this.logic_h = this.height-this.width*2-this.slider.height;
		this.slider.setSize(this.width, this.slider.height+(ie?4:0));
		this.setPos(this.pos);
	}
	vsbar.div.parent = vsbar;
	vsbar.div.onclick = function (event) {
		var e = getEvent(event);
		if (e.target.id == this.parent.id) {
			var pos = (e.layerY-this.parent.width)/(this.parent.logic_h);
			if(pos>this.parent.pos) {
				pos = this.parent.pos + this.parent.scope;
			}else if (pos<this.parent.pos) {
				pos = this.parent.pos - this.parent.scope;
			}
		}else if (e.target.id == this.parent.id+".up") {
				pos = this.parent.pos-0.1;
		}else if (e.target.id == this.parent.id+".down") {
				pos = this.parent.pos+0.1;
		}else {
			return;
		}
		this.parent.setPos(normalPos(pos));
	}

	vsbar.div.onmousedown = function (event) {
		var e = getEvent(event);
		this.drag = true;
		this.old_pos = this.parent.pos;
		this.startY = e.screenY;
	}
	vsbar.div.onmousemove = function (event) {
		if (!this.drag) return;
		var e = getEvent(event);
		this.parent.setPos(normalPos((e.screenY-this.startY)/(this.parent.logic_h) + this.old_pos));
	}
	vsbar.div.onmouseup = function (event) {
		if (!this.drag) return;
		this.parent.setPos(this.parent.pos);
		this.drag = false;
	}
	vsbar.div.onmouseout = function (event) {
		if (!this.drag) return;
		var e = getEvent(event);
		if (e.relatedTarget.id == this.parent.id) return;
		this.parent.setPos(this.parent.pos);
		this.drag = false;
	}
	vsbar.setScope(1);
	vsbar.setPos(0.5);
	return vsbar;	
}

function createHScrollBar(id, width, height) {
	var hsbar = createRect(id,0,0,width,height,"silver","1px solid gray");
	hsbar.pos = 0.5;
	hsbar.scope = 0.5;
	var center_x = height/2+(ie?-1:0);
	var center_y = height/2+(ie?-1:0);

	var leftrect = createRect(id+".left",-1,-1,height-1,height,"white","1px solid gray");
	leftrect.appendChild(createRect(id+".left",center_x-1,center_y+1,1,1,"black"));
	leftrect.appendChild(createRect(id+".left",center_x-1,center_y,1,1,"black"));
	leftrect.appendChild(createRect(id+".left",center_x-1,center_y-1,1,1,"black"));
	leftrect.appendChild(createRect(id+".left",center_x-2,center_y,1,1,"black"));
	leftrect.appendChild(createRect(id+".left",center_x,center_y-2,1,1,"black"));
	leftrect.appendChild(createRect(id+".left",center_x,center_y-1,1,1,"black"));
	leftrect.appendChild(createRect(id+".left",center_x,center_y,1,1,"black"));
	leftrect.appendChild(createRect(id+".left",center_x,center_y+1,1,1,"black"));
	leftrect.appendChild(createRect(id+".left",center_x,center_y+2,1,1,"black"));
	hsbar.appendChild(leftrect);

	var rightrect = createRect(id+".right",width-height,-1,height-1,height,"white","1px solid gray");
	rightrect.appendChild(createRect(id+".right",center_x,center_y+1,1,1,"black"));
	rightrect.appendChild(createRect(id+".right",center_x,center_y,1,1,"black"));
	rightrect.appendChild(createRect(id+".right",center_x,center_y-1,1,1,"black"));
	rightrect.appendChild(createRect(id+".right",center_x+1,center_y,1,1,"black"));
	rightrect.appendChild(createRect(id+".right",center_x-1,center_y-2,1,1,"black"));
	rightrect.appendChild(createRect(id+".right",center_x-1,center_y-1,1,1,"black"));
	rightrect.appendChild(createRect(id+".right",center_x-1,center_y,1,1,"black"));
	rightrect.appendChild(createRect(id+".right",center_x-1,center_y+1,1,1,"black"));
	rightrect.appendChild(createRect(id+".right",center_x-1,center_y+2,1,1,"black"));
	hsbar.appendChild(rightrect);
	
	
	hsbar.slider = createRect(id+".slider",-1,-1,height-1,height,"white","1px solid gray");
	hsbar.appendChild(hsbar.slider);

	hsbar.setPos = function (pos) {
		this.slider.setPosition(this.logic_w*pos+this.height-(ie?3:1),-1);
		onPosChange(this.id, pos);
		this.pos = pos;
	}
	
	hsbar.setScope = function (scope) {
		this.scope = normalPos(scope);
		if (this.scope == 1) {
			this.setStyle("visibility","hidden");
		} else {
			this.setStyle("visibility","visible");
		}
		this.slider.width = (this.width-this.height*2)*this.scope;
		this.logic_w = this.width-this.height*2-this.slider.width;
		this.slider.setSize(this.slider.width+(ie?5:0), this.height);
		this.slider.setSize(this.slider.width, this.height);
		this.setPos(this.pos);
	}
	
	hsbar.div.parent = hsbar;
	hsbar.div.onclick = function (event) {
		var e = getEvent(event);
		if (e.target.id == this.parent.id) {
			var pos = (e.layerX-this.parent.height)/(this.parent.logic_w);
			if(pos>this.parent.pos) {
				pos = this.parent.pos + this.parent.scope;
			}else if (pos<this.parent.pos) {
				pos = this.parent.pos - this.parent.scope;
			}
		}else if (e.target.id == this.parent.id+".left") {
				pos = this.parent.pos-0.1;
		}else if (e.target.id == this.parent.id+".right") {
				pos = this.parent.pos+0.1;
		}else {
			return;
		}
		this.parent.setPos(normalPos(pos));
	}
	hsbar.div.onmousedown = function (event) {
		var e = getEvent(event);
		this.drag = true;
		this.old_pos = this.parent.pos;
		this.startX = e.screenX;
	}
	hsbar.div.onmousemove = function (event) {
		if (!this.drag) return;
		var e = getEvent(event);
		var pos = (e.screenX-this.startX)/(this.parent.logic_w) + this.old_pos;
		this.parent.setPos(normalPos(pos));
	}
	hsbar.div.onmouseup = function (event) {
		if (!this.drag) return;
		this.parent.setPos(this.parent.pos);
		this.drag = false;
	}
	hsbar.div.onmouseout = function (event) {
		if (!this.drag) return;
		var e = getEvent(event);
		if (e.relatedTarget.id == this.parent.id) return;
		this.parent.setPos(this.parent.pos);
		this.drag = false;
	}

	hsbar.setScope(1);
	hsbar.setPos(0.5);
	return hsbar;	
}

function onPosChange(id, pos) {
	if (id == "X.Zoom") {
		context.setXZoom(pos);
	} else if (id == "X.Scroll") {
		context.setXScroll(pos);
	} else if (id == "Y.Zoom") {
		context.setYZoom(pos);
	} else if (id == "Y.Scroll") {
		context.setYScroll(pos);
	} else if (id == "Zoom") {
		context.setZoom(pos);
	} else {
		context.setPos(id,pos);
	}
}

// Rectangle
function createRect(id,left, top, width, height, color, border) {
	var rect = new Graphics(id);
	rect.setPosition(left,top);
	if (width) rect.setSize(width,height);
	if (color) rect.setColor(color);
	if (border) rect.setBorder(border);
	//this is going to avoid min-height issue in ie.
	rect.setInnerHTML("<div style='font-size:0px'><div>");
	return rect;
}

// CompoundBar
function createCompoundBar(id, width, height) {
	var combar = createRect(id,0,0,width, height);
	combar.setItems = function(items) {
		var total_size = 0;
		this.removeAllChildren();
		for (var i = 0; i < items.length; i++) {
			total_size += items[i].size;
		}
		var cur_x = 0;
		for (var i = 0; i < items.length; i++) {
			if (items[i].size > 0) {
				var rect = createRect(id+"."+items[i].id,cur_x,0,items[i].size*this.width/total_size+(ie?2:0),height,items[i].color,"1px solid black");
				this.appendChild(rect);
				var label = createTruncatedLabel(id+".label_"+items[i].id,items[i].label,0,0,font_s,items[i].size*this.width/total_size+(ie?2:0),height,"center","middle");
				rect.appendChild(label);
				addTip(label,items[i].label,items[i].color);
				cur_x+=items[i].size*this.width/total_size;
			}
		}		
	}
	return combar;
}

//Lines
function createHLine (id, start, end, y, color, thick) {
	return createRect(id, start, y, end - start, thick, color, "0px");
}

function createVLine (id, start, end, x, color, thick) {
	return createRect(id, x,start, thick, end - start, color, "0px");
}
// Input controls
function createInput(id,name,type,label,onchange,left,top,width,height,value,title) {
	var container = createGraphics("");
	var input;
	if (ie) {
		input = document.createElement("<input type='"+type+"' name='"+name+"' onchange='"+onchange+"' onclick='"+onchange+"' value='"+value+"'>");
		input.title = title;
	}
	else {
		input = document.createElement("input");
		input.setAttribute("name", name);  
		input.setAttribute("type", type);  
		input.setAttribute("value", value);  
		input.setAttribute("onclick", onchange); 
		input.setAttribute("onchange", onchange); 
		input.setAttribute("title", title);
	}
	input.setAttribute("id", id);  
	container.div.appendChild(input);
	if (label != "") {
		container.appendChild(createLabel(id+".label",label,20,0,font_m,width,height,"left","middle",title));
	}else {
		input.setAttribute("width", width);
		input.setAttribute("height", height);
	}
	container.setPosition(left,top);
	container.setSize(width,height);
	return container;
}
function createInput2(id,name,type,label,onchange,onblur,left,top,width,height,size,value,title) {
	var container = createGraphics("");
	var input;
	if (ie) {
		input = document.createElement("<input type='"+type+"' name='"+name+"' id='"+id+"' onchange='"+onchange+"' onclick='"+onchange+"' onblur='"+onblur+"' size='"+size+"' value='"+value+"'>");
		input.title = title;
	}
	else {
		input = document.createElement("input");
		input.setAttribute("name", name);  
		input.setAttribute("type", type);  
		input.setAttribute("value", value);  
		input.setAttribute("onclick", onchange); 
		input.setAttribute("onchange", onchange); 
		input.setAttribute("onblur", onblur);
		input.setAttribute("title", title);
		input.setAttribute("size", size);
	}
	input.setAttribute("id", id);  
	container.div.appendChild(input);
	if (label != "") {
		container.appendChild(createLabel(id+".label",label,20,0,font_m,width,height,"left","middle",title));
	}else {
		input.setAttribute("width", width);
		input.setAttribute("height", height);
	}
	input.style.width = width + "px";
	input.style.height = height + "px";
	container.setPosition(left,top);
	container.setSize(width,height);
	return container;
}
// ListBox
function createListBox(id,labels,values,left,top,width,height,selectedLabel,onchange) {
	var container = createGraphics("");
	var select;
	if(ie) {
		var selectString = "<select id='"+id+"' onchange='"+onchange+"'>";
		select = document.createElement(selectString);
	} else {
		select = document.createElement("select");
	}
	for (var i = 0; i < labels.length; i++) {
		select.appendChild(document.createElement("option"));
		select.options[i].text = labels[i];
		select.options[i].value = values[i];
		if(selectedLabel == labels[i]) {
			select.options[i].selected = true;
		}
	}
	if(!ie && onchange)
		select.setAttribute("onChange",onchange);
	if (onchange)
		select.onchange = onchange;
	select.setAttribute("id", id);  
	container.div.appendChild(select);
	container.setPosition(left,top);
	container.setSize(width,height);
	return container;
}

//Label
function createTruncatedLabel(id,text,left,top,fontsize,width,height,align,valign,title) {
	if (width > text.length*fontsize/2) {
		return createLabel(id,text,left,top,fontsize,width,height,align,valign,title);
	}else{
		var showLen = width*2/fontsize - (ie?3:0) ;
		if (showLen > 3) {
			var showLabel = text.substr(0,showLen-3)+"...";
			return createLabel(id,showLabel,left,top,fontsize,width,height,align,valign,title);
		} else {
			return createLabel(id,"",left,top,fontsize,width,height,align,valign,title);
		}
	}
}

function createLabel (id,text,left,top,fontsize,width,height,align,valign,title,color) {
	var label = new Graphics(id);
	label.fontsize = fontsize;
	label.color = color;
	label.setPosition(left,top);
	if (width) {
		label.setSize(width,height);
		if(valign)label.valign = valign;
		if(align)label.align = align;
		if(title)label.title = title;
	}
	label.setText = function(text) {
		if (this.valign) {
			if (ie) {
				// this piece of code is deal with the vertical align in IE. It doesn't support multiline label.
				if (valign == "middle") {
					var l = new Graphics(this.id+".l");
					l.setPosition(0,(this.height - this.fontsize)/2);
					l.setSize(this.width,this.fontsize);
					l.setInnerHTML("<div style=\"font-size:"+this.fontsize+";color:"+this.color+"\">"+text+"</div>");
					this.appendChild(l);
				}else if (valign == "bottom") {
					var l = new Graphics(this.id+".l");
					l.setPosition(0,this.height - this.fontsize);
					l.setSize(this.width,this.fontsize);
					l.setInnerHTML("<div style=\"font-size:"+this.fontsize+";color:"+this.color+"\">"+text+"</div>");
					this.appendChild(l);
				}else {
					this.setInnerHTML("<div style=\"font-size:"+this.fontsize+";color:"+this.color+"\">"+text+"</div>");
				}
			}else {
				this.setInnerHTML("<div style=\"font-size:"+this.fontsize+";color:"+this.color+";height:"+this.height+"px;display:table-cell;vertical-align:"+this.valign+"\">"+text+"</div>");
			}
		} else {
			this.setInnerHTML("<div style=\"font-size:"+this.fontsize+";color:"+this.color+"\">"+text+"</div>");
		}
		this.setAttribute("align",this.align);
		if (this.title) {
			this.setAttribute("title",this.title);
		}
	}
	label.setText(text);
	return label;
}

// Image
function createImg(src, left, top, title, onclick) {
	var container = createGraphics("");
	var image;
	
	if (ie) {
		var string = "<IMG border='0' src='"+src+"'";
		if(onclick)
			string += " onclick='"+onclick+"'";
		string += ">";
	
		image = document.createElement(string);	
	}
	else {
		image = document.createElement("img");
		image.setAttribute("src", src);
	}
	
	if(title)
		image.setAttribute("title", title);
	if(onclick)
		image.setAttribute("onclick", onclick);
		
	container.div.appendChild(image);

	container.setPosition(left,top);
	return container;
}

//Basic graphics
function createGraphics (id) {
	return new Graphics(id);
}
function Graphics(id) {

	this.setInnerHTML = function (html) {
		this.div.innerHTML = html;
	}
	this.appendChild = function (child) {
		this.div.appendChild(child.div);
	}
	this.insertBefore = function (new_child, target_child) {
		this.div.insertBefore(new_child.div, target_child.div);
	}
	this.setAttribute = function (name,value) {
		this.div.setAttribute(name,value);
	}
	this.setStyle = function (name,value) {
		this.div.style[name] = value;
	}
	this.setSize = function (width, height) {
		this.width = width;
		this.height = height;
		this.setStyle("height",height+"px");
		this.setStyle("width",width+"px");
	}
	this.setPosition = function (left, top) {
		this.left = left;
		this.top = top;
		this.setStyle("left",left+"px");
		this.setStyle("top",top+"px");
	}
	this.setColor = function (color) {
		this.div.style["background"] = color;
		this.color = color;
	}
	this.setBorder = function (border) {
		this.div.style["border"] = border;
		this.border=border;
	}
	this.removeAllChildren = function () {
		while (this.div.hasChildNodes()) {
			this.div.removeChild(this.div.lastChild);
		}
	}
	this.transferChildren = function (other) {
		while (other.div.hasChildNodes()) {
			var child = other.div.firstChild;
			other.div.removeChild(child);
			this.div.appendChild(child);
		}
	}
	this.removeChild = function (child) {
		this.div.removeChild(child.div);
	}
	this.div = document.getElementById(id);
	this.id = id;
	if (!this.div) {
		this.div = document.createElement("div");
		this.div.setAttribute("id",id);
	}else {
		this.removeAllChildren();
	}
	this.setStyle("position","absolute");
}

//Dialog
function Field(type,label,def) {
	var field = new Object();
	field.type = type;
	field.label = label;
	field.def = def;
	field.value = def;
	field.visible = (label!="");
	return field;
}
function onUpdateDialogUI(obj, event, prefix) {
	var dialog = hX_5.getComponentById(getRealID(prefix,"div"));
	if (dialog.onUpdateUI) {
		dialog.updateValues();
		dialog.onUpdateUI();
	}
}

// clearButton - if false, do not show clearButton
function createDialog(modeless, showClearButton) {
	if (!hX_5) {
		//the hxclient has not been initialized. dialog can't be showed.
		return null;
	}
	var prefix = "genericDialog";
	if (modeless) {
		prefix = "modelessDialog";
	}
	else {
		modeless = false;
	}
	
	/* hide the clear button if it is not applicable to the dialog */
	var resetID = prefix + "_buttonReset";		
	var clearButton = document.getElementById(getRealID(resetID, "input"));
	
	if(showClearButton == false) 
		clearButton.style["display"] = "none";
	else
		clearButton.style["display"] = "";
		
	var dialog = hX_5.getComponentById(getRealID(prefix,"div"));
	dialog.modeless = modeless;
	dialog.prefix = prefix;
	dialog.prompt = "";
	dialog.text = "";
	dialog.title = "LoadLeveler";
	dialog.onOK = null;
	dialog.onValidate = null;
	dialog.onUpdateUI = null;
	dialog.updateValues = function () {
		for (var id in this.fields) {
			if (this.fields[id].visible && this.fields[id].type != 'OUTPUT') {
				if(this.fields[id].type == 'RADIO') {
					var options = document.getElementsByName(this.prefix+"Field_"+id);
					for(var i = 0; i < options.length; i ++) {
						if (options[i].checked) {
							this.fields[id].value = options[i].value;
						}
					}
				}
				else if(this.fields[id].type == 'CHECKBOX' || this.fields[id].type == 'LCHECKBOX' ) {
					this.fields[id].value = document.getElementById(this.prefix+"Field_"+id).checked;
				}
				else {
					this.fields[id].value = document.getElementById(this.prefix+"Field_"+id).value;
				}
			}
		}
	}
	dialog.resetValues = function () {
		for (var id in this.fields) {
			if (this.fields[id].visible && this.fields[id].type != 'OUTPUT') {
				if(this.fields[id].type == 'RADIO') {
					var options = document.getElementsByName(this.prefix+"Field_"+id);
					for(var i = 0; i < options.length; i ++) {
						if (options[i].value == this.fields[id].def) {
							options[i].checked = true;
							break;
						}
					}
				}
				else if(this.fields[id].type == 'CHECKBOX' || this.fields[id].type == 'LCHECKBOX') {
					document.getElementById(this.prefix+"Field_"+id).checked = this.fields[id].def;
				}
				else {
					document.getElementById(this.prefix+"Field_"+id).value = this.fields[id].def;
				}
			}
		}
	}
	dialog.hideField = function (fieldId) {
		var row = document.getElementById(this.prefix+"Field_"+fieldId+"_row");
		if(row)	row.style["display"] = "none";
	}
	dialog.showField = function (fieldId) {
		var row = document.getElementById(this.prefix+"Field_"+fieldId+"_row");
		if(row)	row.style["display"] = "";
	}
	dialog.showDialog = function (event, width) {
		if(document.createEventObject) {
			event = document.createEventObject();
			event.type = "click";
		}else{
			event = document.createEvent("HTMLEvents");
			event.initEvent("click",true,true);
		}

		//set attributes of dialog
		if(this.modeless) {
			this.dlgType = "modeless";
		}else{
			this.dlgType = "modal";
		}
		if(width) {
			this.DOMobj.style["width"] = width;
		}else{
			this.DOMobj.style["width"] = 400;
		}
		
		//set the title of dialog
		var titlebar = document.getElementById(getRealID(this.prefix+"_tb","div"));
		titlebar.lastChild.nodeValue = this.title;
		
		//generate fields
		var content = document.getElementById(this.prefix+"Content");
		content.dialog = this;
		var innerHTML = "<strong>"+this.prompt+"</strong><br><br>";
		if(this.text != "")
			innerHTML += "<div style='font-size:"+font_m+"px'><font color='black'>"+this.text+"</font></div>";
		innerHTML += "<table align='center' width='100%'>";
		for (var id in this.fields) {
			if (this.fields[id].visible) {
				innerHTML += "<tr id='"+this.prefix+"Field_"+id+"_row'>";
				if(this.fields[id].type != "LCHECKBOX") {
					innerHTML += "<td><strong>"+this.fields[id].label+"</strong></td><td>";
				}			
				//we might add more type here, like "SELECT", "CHECKBOX"...
				if(this.fields[id].type == "TEXT") {
					innerHTML += "<input type=text id='"+this.prefix+"Field_"+id+"' value='"+this.fields[id].def+"'></input>";
				}
				else if (this.fields[id].type == "SELECT") {
					innerHTML += "<select id='"+this.prefix+"Field_"+id+"' value='"+this.fields[id].def +"' onchange='onUpdateDialogUI(this,event,\""+this.prefix+"\");'>";
					if(this.fields[id].options) {
						for (var v in this.fields[id].options) {
							if (v == this.fields[id].def) {
								innerHTML += "<option selected  value='"+v+"'>"+this.fields[id].options[v]+"</option>";
							}else{
								innerHTML += "<option value='"+v+"'>"+this.fields[id].options[v]+"</option>";
							}
						}
					}
					innerHTML += "</select>";
				}
				else if (this.fields[id].type == "OUTPUT") {
					innerHTML += "</td></tr><tr><td colspan='2'>";
					innerHTML += "<div style='width: 100%; height: 200px; overflow: auto; border: 1px solid gray;'>";
					innerHTML += this.fields[id].value +"</div>";
				}
				else if (this.fields[id].type == "RADIO") {
					if(this.fields[id].options) {
						for (var v in this.fields[id].options) {
							if (v == this.fields[id].def) {
								innerHTML += "<input type='radio' name='"+this.prefix+"Field_"+id+"' value='"+v+"' checked='true' onclick='onUpdateDialogUI(this,event,\""+this.prefix+"\");'>" 
											+this.fields[id].options[v] + "</input>";
							}else{
								innerHTML += "<input type='radio' name='"+this.prefix+"Field_"+id+"' value='"+v+"' onclick='onUpdateDialogUI(this,event,\""+this.prefix+"\");'>"
											+this.fields[id].options[v] + "</input>";
							}
						}
					}					
				}
				else if (this.fields[id].type == "CHECKBOX") {
					if (this.fields[id].def == true) {
						innerHTML += "<input type='checkbox' id='"+this.prefix+"Field_"+id+"' checked='true' onclick='onUpdateDialogUI(this,event,\""+this.prefix+"\");'>";
					}
					else {
						innerHTML += "<input type='checkbox' id='"+this.prefix+"Field_"+id+"' onclick='onUpdateDialogUI(this,event,\""+this.prefix+"\");'>";
					}
				}
				else if (this.fields[id].type == "LCHECKBOX") {
					if (this.fields[id].def == true) {
						innerHTML += "<td align='right'><input type='checkbox' id='"+this.prefix+"Field_"+id+"' checked='true' onclick='onUpdateDialogUI(this,event,\""+this.prefix+"\");'></td>";
					}
					else {
						innerHTML += "<td align='right'><input type='checkbox' id='"+this.prefix+"Field_"+id+"' onclick='onUpdateDialogUI(this,event,\""+this.prefix+"\");'></td>";
					}
					innerHTML += "<td><strong>"+this.fields[id].label+"</strong>";
				}
				innerHTML += "</td></tr>";
			}
		}
		innerHTML += "</table><br>";
		content.innerHTML = innerHTML;
		
		//set the validate hook to ok button
		var okButton = document.getElementById(getRealID(this.prefix+"_buttonOk","input"));
		okButton.prefix = this.prefix;
		okButton.onclick = function (event) {
			var dialog = document.getElementById(this.prefix+"Content").dialog;
			dialog.updateValues();
			if (dialog.onValidate) {
				if (dialog.onValidate()) 
					hX_5.runEvent(this,event);
			}
			else 
				hX_5.runEvent(this,event);
			return false;
		}
		//set the hook to reset button
		var resetButton = document.getElementById(getRealID(this.prefix+"_buttonReset","input"));
		resetButton.prefix = this.prefix;
		resetButton.onclick = function (event) {
			var dialog = document.getElementById(this.prefix+"Content").dialog;
			dialog.resetValues();
			onUpdateDialogUI(this,event,this.prefix);
			return ;
		}
		
		//set the close handler
		this.onhide = function(thisEvent) {
			if (thisEvent.dialogAction == "OK") {
				var dialog = document.getElementById(prefix+"Content").dialog;
				dialog.updateValues();
				if (dialog.onOK) {
					dialog.onOK();
				}
			}
			return;
		}
		
		this.show(event);
		onUpdateDialogUI(this, event, this.prefix);
	}
	return dialog;
}

//Menu
function createMenu(id) {
	return null;
	if (!hX_5) {
		//the hxclient has not been initialized. menu can't be showed.
		return null;
	}
	id = getRealID(id,"div");
	if (id == "") {
		return null;
	}
	var menu = new hX_5.JSFMenu("relative:mouse","fly-open:true","vertical:true");
	hX_5.addComponent(id,menu);
	
	menu.idmap = [];
	menu.sub_num = 0;
	
	menu.addMenuItem = function (parentid, itemid, label, action) {
		var item = new hX_5.JSFMenuItem("label:"+label,"onchange:"+action, "id:"+itemid);
		hX_5.addSubComponent(parentid,itemid,item);
		this.idmap[itemid] = this.id+"_table_A_" + this.sub_num;
		this.sub_num += 1;
	}
	menu.addSeparator = function (parentid, itemid) {
		var item = new hX_5.JSFMenuItem("separator");
		hX_5.addSubComponent(parentid,itemid,item);
		this.sub_num += 1;
	}
	menu.hideMenuItem = function (itemid) {
		var item = document.getElementById(this.idmap[itemid]);
		item.style["display"] = "none";
		item.parentNode.style["display"] = "none";
		item.parentNode.parentNode.style["display"] = "none";
	}
	menu.showMenuItem = function (itemid) {
		var item = document.getElementById(this.idmap[itemid]);
		item.style["display"] = "";
		item.parentNode.style["display"] = "";
		item.parentNode.parentNode.style["display"] = "";
	}
	return menu;
}

//Table
function createOneColTable (rows, font_size) {
	var table = "<table style='font-size:" + font_size + "px'>";
	for (var i in rows) {
		table += "<tr><td>" + rows[i] + "</td></tr>";
	}
	table += "</table>";
	return table;
}

//Utils
function setCookie (name, value) {
	document.cookie = name+"="+value;
}

function getCookie (name) {
	cookies = document.cookie.split("; ");
	for (var i = 0; i < cookies.length; i++) {
		if (cookies[i].search(name+"=")!=-1) {
			return cookies[i].split(name+"=")[1];
		}
	}
	return null;
}

function getRealID(id, type) {
	var comps = document.getElementsByTagName(type);
	for (var i = 0; i < comps.length; i++) {
		var pos = comps[i].id.indexOf(id);
		if (pos!=-1 && (pos+id.length) == comps[i].id.length) {
			return comps[i].id;
		}
	}
	return "";
}
function isInteger(string) {
	var value = parseInt(string);
	if(isNaN(value) || value!=string) {
		return false;
	}
	return true;
}

function normalPos(pos) {
	if (pos > 1) return 1;
	if (pos < 0) return 0;
	return pos;
}
function getEvent(event) {
	// this function is going to deal with the differences between firefox and IE for mouse event
	if (!ie){
		return event;
	}
	var event = window.event;
	event.layerX = event.offsetX;
	event.layerY = event.offsetY;
	event.target = event.srcElement;
	event.relatedTarget = event.toElement;
	return event;
}
function trim_domain(longid) {
	var ids = longid.split(".");
	return ids[0]+"."+ids[ids.length-2]+"."+ids[ids.length-1];
}

function getElementDataFromNode(node,attr) {
	var elements = node.getElementsByTagName(attr);
	if (elements && elements.length>0) {
		if (elements[0].firstChild && elements[0].firstChild.data) {
			if (elements[0].firstChild.data!="null"){
				return elements[0].firstChild.data;
			} else {
				return "";
			}
		}
	}
	return "";
}

/* 
 *  Function: getMachineData(data, filterList)
 *  Input: data object containing ClusterMachines XML data, filter selected array
 *  Return: return an object containing information about the machine, color, schedd and startd
 *          states.  Return null if machine should not be displayed. 
 */ 
function getMachineData(data, filterList) {
	var machineData = new Object();
	machineData.machineColor = "lime";
	machineData.scheddStateName;
	machineData.startdStateName;

	var showRUNNING = true;
	var showTRANSITION = true;
	var showDOWN = true;
	var showOK = true;

	for(i in filterList) {
		if(i == "filter.RUN" && filterList[i] == false) 
			showRUNNING = false;
		if(i == "filter.TRANSITION" && filterList[i] == false)
			showTRANSITION = false;
		if(i == "filter.DOWN" && filterList[i] == false) 
			showDOWN = false;
		if(i == "filter.OK" && filterList[i] == false) 
			showOK = false;
	}

	if(data.nodeAvail == 0) { 
		machineData.machineColor = "red";
	}

	// check schedd
	machineData.scheddStateName = getScheddStateName(data.scheddAvail, data.scheddState);
	machineData.machineColor = getScheddColor(data.scheddAvail, data.scheddState);

	// check startd
	machineData.startdStateName = getStartdStateName(data.startdAvail, data.startdState);
	if(machineData.machineColor == "lime") {
		machineData.machineColor = getStartdColor(data.startdAvail, data.startdState);
		// startd will be white if start = true and there are 0 initiators defined
		// however, if central manager is defined on this node, we want to have the node
		// show up as green
		if(machineData.machineColor  == "white") {  
			if(data.activeCM == true)
				machineData.machineColor = "lime";
		}
	}

	if((machineData.machineColor == "lime" && !showRUNNING) || 
		(machineData.machineColor == "yellow" && !showTRANSITION) ||
		(machineData.machineColor == "red" && !showDOWN) ||
		(machineData.machineColor == "white" && !showOK)) {
			delete machineData;
			return null;
	}
	return machineData;
}

function getScheddStateName(scheddAvail, scheddState) {
	var scheddStateName = "";
	if(scheddAvail == 1) { // if schedd is suppose to run here, check states
		switch(scheddState) {
		case '0':				// schedd running
			scheddStateName = "Schedd running";
			break;
		case '1':				// schedd drained
			scheddStateName = "Schedd drained";
			break;
		case '3':				// schedd flushed
			scheddStateName = "Schedd flushed";
			break;
		case '7':				// schedd down
			scheddStateName = "Schedd down";
			break;
		case '2':				// schedd draining
			scheddStateName = "Schedd draining";
			break;
		case '4':				// schedd flushing
			scheddStateName = "Schedd flushing";
			break;
		default:
			break;
		}
	}
	return scheddStateName;
}

function getScheddColor(scheddAvail, scheddState) {
	var machineColor = "lime";
	if(scheddAvail == 1) { 			// if schedd is suppose to run here, check states
		switch(scheddState) {
		case '0':				// schedd running
			machineColor = "lime";
			break;
		case '-2':				// schedd absent
		case '1':				// schedd drained
		case '3':				// schedd flushed
		case '7':				// schedd down
			machineColor = "red";
			break;
		case '2':				// schedd draining
		case '4':				// schedd flushing
			machineColor = "yellow";	
			break;
		case '-3':
			machineColor = "white";
			break;
		default:
			break;
		}
	}
	return machineColor;
}

function getStartdStateName(startdAvail, startdState) {
	var startdStateName = "";
	if(startdAvail == 1) { // if startd is suppose to run here, check states
		switch(startdState) {
		case '0':				// startd down
			startdStateName = "Startd down";
			break;
		case '3':				// startd drained
			startdStateName = "Startd drained";
			break;
		case '4':				// startd draining
			startdStateName = "Startd draining";
			break;
		case '5': 				// startd flush
			startdStateName = "Startd flush";
			break;
		case '9':				// startd suspend
			startdStateName = "Startd suspend";
			break;
		case '7': 				// startd none
			startdStateName = "Startd none";
			break;
		case '2':				// startd busy
			startdStateName = "Startd busy";
			break;
		case '8': 				// startd running
			startdStateName = "Startd running";
			break;
		case '6': 				// startd idle
			startdStateName = "Startd idle";
			break;
		case '1': 				// startd avail
			startdStateName = "Startd avail";
			break;
		default:
			break; 
		}
	}
	return startdStateName;
}

function getStartdColor(startdAvail, startdState) {
	var machineColor = "lime";
	if(startdAvail == 1) { // if startd is suppose to run here, check states
		switch(startdState) {
		case '-2':				// startd absent
		case '0':				// startd down
		case '3':				// startd drained
			machineColor = "red";
			break;
		case '4':				// startd draining
		case '5': 				// startd flush
		case '9':				// startd suspend
			machineColor = "yellow";
			break;
		case '7': 				// startd none
		case '-3':				// submit_only
			machineColor = "white";
			break;
		case '2':				// startd busy
		case '8': 				// startd running
		case '6': 				// startd idle
		case '1': 				// startd avail
			machineColor = "lime";
			break;
		default:
			break; 
		}
	}
	return machineColor;
}

/* 
 *  Function: getTableViewSelection(viewType)
 *  Input: viewType - String value identifying the graphical view calling the function
 *  Return: Return the selectedElements from the table view
 *  Description:  This function is called when entering the graphical view from
 *                the tabular view.  Any rows that are selected from the tabular
 *                view are set to be selected in the graphical view.
 */  
function getTableViewSelection(viewType) {
	var selectedElements = [];
	selectedElements.length = 0;
	var inputs = document.getElementsByTagName("input");
	for (var i = 0; i < inputs.length; i++) {
		if (inputs[i].id.indexOf("rowSelect1__input_sel")!=-1) {
			// eg: views_****_:form1:jobTable:17:rowSelect1__input_sel
			var input_sel_id = inputs[i].id;
			var elements = input_sel_id.split(":"); 
			var view = elements[0];
			var table = elements[2];
			var index = elements[3];

			var elementID = "null";

			if(viewType == "GraphicMachineView")
				elementID = input_sel_id.substr(0,input_sel_id.length-11)+":UserSelectedMachines";
			if(viewType == "GraphicJobQueueView")
				elementID = input_sel_id.substr(0,input_sel_id.length-11)+":UserSelectedJobs";

			// eg: elementID: views_****_:form1:jobTable:17:rowSelect:UserSelectedJobs
			if(elementID != "null") {
				var element = document.getElementById(elementID);
				if (tableSize > 0) index = index%tableSize;
				if (this["hx_"+view+"_form1_"+table+"__jsObjGroup"].arrayMembers[index].isSelected()) {
					selectedElements[element.value]=1;
					selectedElements.length++;
				}
			}
		}
	}
	return selectedElements;
}
function getTableViewUnSelection(viewType) {
	var unselectedElements = [];
	unselectedElements.length = 0;
	var inputs = document.getElementsByTagName("input");
	for (var i = 0; i < inputs.length; i++) {
		if (inputs[i].id.indexOf("rowSelect1__input_sel")!=-1) {
			var input_sel_id = inputs[i].id;
			var elements = input_sel_id.split(":");
			var view = elements[0];
			var table = elements[2];
			var index = elements[3];
			var elementID = "null";
			if(viewType == "GraphicMachineView")
				elementID = input_sel_id.substr(0,input_sel_id.length-11)+":UserSelectedMachines";
			if(viewType == "GraphicJobQueueView")
				elementID = input_sel_id.substr(0,input_sel_id.length-11)+":UserSelectedJobs"; 
				
			if(elementID != "null") {
				var element = document.getElementById(elementID);
				if (tableSize > 0) index = index%tableSize;
				if (!this["hx_"+view+"_form1_"+table+"__jsObjGroup"].arrayMembers[index].isSelected()) {
					unselectedElements[element.value]=1;
					unselectedElements.length++;
				}
			}
		}
	}
	return unselectedElements;
}

/*
 *  Function: setTableViewSelection(selectedData, viewType)
 *  Input: selectedData - elements of the data selected in graphical view
 *         viewType - String value identifying the graphical view calling the function
 *  Return: None
 *  Description:  This function is called when switching from the graphical
 *                view to the tabular view.  Any elements that are selected
 *                from the graphical views are set to be selected on the 
 *                tabular view
 */ 
function setTableViewSelection(selectedData, viewType) {
	var inputs = document.getElementsByTagName("input");
	for (var i = 0; i < inputs.length; i++) {
		if (inputs[i].id.indexOf("rowSelect1__input_sel")!=-1) {
			var input_sel_id = inputs[i].id;
			var elements = input_sel_id.split(":");
			var view = elements[0];
			var table = elements[2];
			var index = elements[3];
			
			var elementID = "null";
			if(viewType == "GraphicMachineView")
				elementID = input_sel_id.substr(0,input_sel_id.length-11)+":UserSelectedMachines";
			if(viewType == "GraphicJobQueueView")
				elementID = input_sel_id.substr(0,input_sel_id.length-11)+":UserSelectedJobs";
				
			if(elementID != "null") {
				if (tableSize > 0) index = index%tableSize;
				var element = document.getElementById(elementID);
				if (element.value in selectedData) {
					this["hx_"+view+"_form1_"+table+"__jsObjGroup"].arrayMembers[index].setSelected(true);
					document.getElementById(inputs[i].id.replace(/input/,"hidden")).value = true;
				}else {
					this["hx_"+view+"_form1_"+table+"__jsObjGroup"].arrayMembers[index].setSelected(false);
					document.getElementById(inputs[i].id.replace(/input/,"hidden")).value = false;
				}
			}
		}
	}
}

/* Action Object 
 * This object is used to store information about the action
 *
 * Parameters:
 *   parentID  - ID of the menu item which to is the parent of the current item.  Item
 *               will show up under the parent heading
 *   ID        - ID of the current menu item
 *   label     - Label that will be displayed on the Context Menu
 *   action    - function that will be called when item is selected
 *   command   - LoadLeveler command to be run
 *   comment   - Message that is given back to the user
 *   markGray  - [ true or false ] - indicates if machines/jobs should be grayed
 *               out after the command is issued
 *   destructive - [ true | false ] if true, requires confirm before command is issued
 */
function Action(parentID, id, label, action, command, comment, markGray, destructive) {
	this.parentID = parentID;
	this.id = id;
	this.label = label;
	this.action = action;
	this.command = command;
	this.comment = comment;
	this.markGray = markGray;
	this.destructive = destructive;
}

var MONTH_MAP = [];
MONTH_MAP[0] = "Jan ";
MONTH_MAP[1] = "Feb ";
MONTH_MAP[2] = "Mar ";
MONTH_MAP[3] = "Apr ";
MONTH_MAP[4] = "May ";
MONTH_MAP[5] = "Jun ";
MONTH_MAP[6] = "Jul ";
MONTH_MAP[7] = "Aug ";
MONTH_MAP[8] = "Sep ";
MONTH_MAP[9] = "Oct ";
MONTH_MAP[10] = "Nov ";
MONTH_MAP[11] = "Dec ";

// Function: getDateOnlyString(inDate)
// Format Returned: Oct 14, 2007
function getDateOnlyString(inDate) {
	var dateString = "";
	dateString += MONTH_MAP[inDate.getMonth()];
	dateString += inDate.getDate() + ", ";
	dateString += inDate.getFullYear();
	return(dateString);
}

// Function: getTimeOnlyString(inDate)
// Format Returned: 11:53
function getTimeOnlyString(inDate) {
	var timeString = "";
	timeString += inDate.getHours() < 10?"0"+inDate.getHours():inDate.getHours();
	timeString += ":" + (inDate.getMinutes()<10?"0"+inDate.getMinutes():inDate.getMinutes());
	// timeString += ":" + (inDate.getSeconds()<10?"0"+inDate.getSeconds():inDate.getSeconds());
	return(timeString);
}

// Function: getDateTimeString(inDate)
// Format Returned: Sept 24, 2007 04:09
function getDateTimeString(inDate) {
	var dateString = "";
	dateString += getDateOnlyString(inDate) + " ";
	dateString += getTimeOnlyString(inDate);

	return(dateString);
}

function getCalendarValue(type, inDate) {
	var dateString = "";
	if(type == "date") {
		dateString += MONTH_MAP[inDate.getMonth()];
		dateString += inDate.getDate() + ", ";
		dateString += inDate.getFullYear();
	}
	if(type == "time") {
		dateString = getTimeOnlyString(inDate);
	}
	return dateString;
}

// Function: getShortDateString(inDate)
// Format Returned: 09/24/07 11:53
function getShortDateString(inDate) {
	var dateString = "";
	var month = inDate.getMonth()+1;
	dateString += month < 10?"0"+month:month;
	dateString += "/"
	dateString += inDate.getDate() < 10? "0"+inDate.getDate():inDate.getDate();
	dateString += "/" + inDate.getFullYear();
	dateString += " " + getTimeOnlyString(inDate); 
	return(dateString);
}

var REVERSE_MONTH_MAP = [];
REVERSE_MONTH_MAP["Jan"] = "01";
REVERSE_MONTH_MAP["Feb"] = "02";
REVERSE_MONTH_MAP["Mar"] = "03";
REVERSE_MONTH_MAP["Apr"] = "04";
REVERSE_MONTH_MAP["May"] = "05";
REVERSE_MONTH_MAP["Jun"] = "06";
REVERSE_MONTH_MAP["Jul"] = "07";
REVERSE_MONTH_MAP["Aug"] = "08";
REVERSE_MONTH_MAP["Sep"] = "09";
REVERSE_MONTH_MAP["Oct"] = "10";
REVERSE_MONTH_MAP["Nov"] = "11";
REVERSE_MONTH_MAP["Dec"] = "12";

function processCalendarDateString(inDate) {
	inDate = inDate.replace(/,/,"");
	var temp = inDate.split(" ");
	var newStringDate = REVERSE_MONTH_MAP[temp[0]] + "/" + temp[1] + "/" + temp[2];
	return newStringDate;
}
// Function: getMMDDYYYYDateString(inDate)
// Format Returned: 09/24/2007
function getMMDDYYYYDateString(inDate) {
	var dateString = "";
	var month = inDate.getMonth()+1;
	dateString += month < 10?"0"+month:month;
	dateString += "/"
	dateString += inDate.getDate() < 10? "0"+inDate.getDate():inDate.getDate();
	dateString += "/" + inDate.getFullYear();
	return(dateString);
}
