/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* Restricted Materials of IBM                                            */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2011,2012          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* sccsid = "@(#) src/hpcc/webui/hpccloud/scripts/PackageView.js, hpc.cloud.ui, hpcc_rbei, rbeis002a 1.6 1/4/12 05:48:41"; */

var packageData;
var sortBname = 0;
var sortBstatus= 0;

function showPackage() 
{
    var xhrArgs = 
    {
        url: "GetInfoXML.cgi?function=listPackageXML",
        handleAs: "xml",
        preventCache: true,
        load: function(data) 
        {
            onPackageUpdate(data);
        },
        error: function(error) 
        {
            showInfo("An unexpected error occurred: " + error);
        }
    }
    var deferred = dojo.xhrGet(xhrArgs);
}

function onPackageUpdate(xmlDoc) {
    packageData = parsePackageXML(xmlDoc);
    refreshPackageTab();
}

function refreshPackageTab() {
    var showremoved = dojo.byId('PackageForm').showremoved.value;	
    clearPackageTab();
    var theTable = document.getElementById("packageListTab");
    for (var i=0; i < packageData.packages.length; ++i) 
    {
        if (showremoved == 0 && packageData.packages[i].status == "REMOVED")
        {
        	continue;
        }
        var row = theTable.insertRow(theTable.rows.length);
        row.className = "tab_content";
        var cell1 = row.insertCell(0);
	 if (packageData.packages[i].status != "REMOVED")
	 {
		 if ( packageData.packages[i].check ){
	 		cell1.innerHTML = "<input type=checkbox name=PackageCheck value=" + packageData.packages[i].name + " checked>";
		 }else{
	 		cell1.innerHTML = "<input type=checkbox name=PackageCheck value=" + packageData.packages[i].name + ">";
		 }
	 }
	//cell1.innerHTML = "<tr>success</tr>";
        var cell2 = row.insertCell(1);
        cell2.innerHTML = packageData.packages[i].name;
        //packageData.packages[i].nodename;
        var cell3 = row.insertCell(2);
	 cell3.innerHTML = packageData.packages[i].pathorig;
	 var cell5 = row.insertCell(3);
	 cell5.innerHTML = packageData.packages[i].status;
	 var cell6 = row.insertCell(4);
	 cell6.innerHTML = packageData.packages[i].creator;
	 var cell7 = row.insertCell(5);
	 cell7.innerHTML = packageData.packages[i].description;
    }
}

function parsePackageXML(xmlDoc) {
    var result = new Object();
    result.packages = [];
    var items = xmlDoc.documentElement.getElementsByTagName('pkgList');
    for(var n=0; n < items.length; n++) {
        var package = new Object();
        package.name = getElementDataFromNode(items[n], "name");
        package.pathorig = getElementDataFromNode(items[n], "path_orig");
        package.status = getElementDataFromNode(items[n], "status");
        package.creator = getElementDataFromNode(items[n], "creator");
        package.description = getElementDataFromNode(items[n], "description");
		package.check = false;
        result.packages.push(package);
    }
    return result;
}

function clearPackageTab() {
    var theTable = document.getElementById("packageListTab");
    for(var i = (theTable.rows.length-1); theTable.rows.length > 2; i--) {
        theTable.deleteRow(i);
    }
}

function keepcheckinfo(){
	// Keep the selected items.
    var form = dojo.byId("PackageForm");
	var inputs = form.getElementsByTagName("input");
	var i,j;
	
	for(j = 0;j < packageData.packages.length;j++){
		packageData.packages[j].check = false;
		for(i=0;i<inputs.length;i++){
			if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].checked == true) {
				if (inputs[i].value == packageData.packages[j].name){
					packageData.packages[j].check = true;
				}
			}
		}
	}
}
		

function sortPackageTab(sortingBy) {
    keepcheckinfo();
	if (sortingBy == "name") {
        sortBname = 1 - sortBname;
        packageData.packages.sort(sortByName);
    } else if (sortingBy == "status") {
        sortBstatus= 1 - sortBstatus;
        packageData.packages.sort(sortByStatus);
    }
    refreshPackageTab();
}

function sortByName(a, b) {
    var x = a.name.toLowerCase();
    var y = b.name.toLowerCase();
    if(sortBname){
        return ((x < y) ? 1 : ((x > y) ? -1 : 0));
    } else {
        return ((x < y) ? -1 : ((x > y) ? 1 : 0));
    }
}

function sortByStatus(a, b) {
    var x = a.status.toLowerCase();
    var y = b.status.toLowerCase();
    if(sortBstatus){
        return ((x < y) ? 1 : ((x > y) ? -1 : 0));
    } else {
    	return ((x < y) ? -1 : ((x > y) ? 1 : 0));
    }
}

function submitAddPackage() {
	if(dojo.byId('addPackageForm').pathorig.value=="" && dojo.byId('addPackageForm').localPkg.value=="") {
        alert("Specify a path.");
        return false;
    }
    if(dojo.byId('addPackageForm').description.value==""){
        alert("Specify a description.");
        return false;
    }
    showWaitingDlg();
    dojo.io.iframe.send({
        form: 'addPackageForm',
        handleAs: "text",

        load: function(response, ioArgs) {
            hideWaitingDlg();
            showInfo(response);
            navLink('listImagePackage');
            return response;
        }
    });
}


function submitApprovePackage()
{
	var select = false;
	var form = document.getElementById("PackageForm");
	if (form) {
		var inputs = form.getElementsByTagName("input");
		for(var i=0;i<inputs.length;i++) {
			if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].getAttribute("name") == "PackageCheck") {
				if (inputs[i].checked == true) {
					select = true;
					break;
				}
			}
		}
	} else {
		return;
	}
	if (!select) { alert("No Package selected."); return; }
    if(!confirm("Do you want to approve these packages?")) {
        return false;
    }
    dojo.byId("packageAction").value = "approvePackage";
    var xhrArgs = {
        form: dojo.byId('PackageForm'),
        handleAs: "text",
        load: function(data) {
            hideWaitingDlg();
            showInfo(data);
            dijit.byId('mainContent').refresh();
        },
        error: function(error) {
            hideWaitingDlg();
            showInfo(error);
            dijit.byId('mainContent').refresh();
        }
    }
    showWaitingDlg();
    var deferred = dojo.xhrPost(xhrArgs);
}
function submitDeletePackage()
{
	var select = false;
	var theTable = dojo.byId("packageListTab");
	var ckboxidx=-1;
	var statusidx=-1;
	for(var i=0; i< theTable.rows[1].cells.length; i++){
		if(theTable.rows[1].cells[i].innerHTML.indexOf("Select") >= 0){
			ckboxidx=i;
		}else if(theTable.rows[1].cells[i].innerHTML.indexOf("Status") >= 0){
			statusidx=i;
		}
	}
	if((ckboxidx < 0)||(statusidx < 0)){
		alert("Failed get checkbox or Status information");
		return;
	}
	for(var i=2; i < theTable.rows.length; i++){
		var inputs=theTable.rows[i].cells[ckboxidx].getElementsByTagName("input");
		if(inputs[0].checked == true){
			if(theTable.rows[i].cells[statusidx].innerHTML == "APPROVED"){
				var conResult = confirm("Package list "+inputs[0].value+" may be used, are you sure to delete it?");
				if(!conResult){
					inputs[0].checked = false;
				}else{
					select = true;
				}
			}else{
				select = true;
			}
		}
	}
	if (!select) { alert("No package list selected."); return; }
    if(!confirm("Do you want to delete these package lists?")) {
        return false;
    }
    var xhrArgs = {
        form: dojo.byId('PackageForm'),
        handleAs: "text",
        load: function(data) {
            hideWaitingDlg();
            showInfo(data);
            dijit.byId('mainContent').refresh();
        },
        error: function(error) {
            hideWaitingDlg();
            showInfo(error);
            dijit.byId('mainContent').refresh();
        }
    }
    showWaitingDlg();
    var deferred = dojo.xhrPost(xhrArgs);
}

