/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* Restricted Materials of IBM                                            */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2010,2011          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* sccsid = "@(#) src/hpcc/webui/hpccloud/scripts/ProvisionCalendarView.js, hpc.cloud.ui, hpcc_rbei, rbeis001a 1.5 6/8/11 09:30:15"; */

var cv_ui;
var cv_header_h = 15;
var cv_resByDay;
var cv_resHeight = 15;
function cv_init() { 
    //initialize UI component
    setFontSize(10,12,14);

    var options = createGraphics("cv_options");
    var leftImg = createImg("/hpccloud/images/left.gif", -60, 5, "", "changeCalendar(false)");
    var rightImg = createImg("/hpccloud/images/right.gif", 105, 5, "", "changeCalendar(true)");
    var datePicker = createImg("/hpccloud/images/cal.gif", 85, 2, "", "displayDatePicker('cv_calendar', false, 'Mdy', '/')");
    
    options.appendChild(leftImg);
    var curTime = new Date();
    options.appendChild(createInput2("cv_calendar","cv_calendar","text","","cv_onDataUpdate();","",-50,0,148,15,14,getDateOnlyString(curTime), "Date"));
    options.appendChild(datePicker);
    options.appendChild(rightImg);

    options.appendChild(createLabel("label_FilterbyOwner","Filter by owner:",120,0,10,100,16,"left","middle"));
    var filterInput = createInput2("filterbyowner","filterbyowner","text","","","onFilterInput();",210,0,50,15,5,"","Filter");
    options.appendChild(filterInput);
    //document.getElementById("filterbyowner").onblur = onFilterInput;

    //// This funciton is duplicated with that in the list view. Remove it.
    ////labels = ["- Actions -"];
    ////keys = ["NONE"];

    ////labels.push("Cancel the request(s)");
    ////keys.push("cancel");
    ////labels.push("View details and update");
    ////keys.push("update");
    ////labels.push("Submit Job");
    ////keys.push("submitJob");

    ////options.appendChild(createListBox("prov.actions",labels,keys,300,0,50,28,0,onActionSelected));

    //var cancelBtn = createInput("cancelButton","cancelButton","button","","onClickCancelButton(event)",350,-2,70,28,"Cancel","Cancel selected requests");
    //options.appendChild(cancelBtn);
    //var modifyBtn = createInput("modifyButton","modifyButton","button","","onClickModifyButton(event)",420,-2,70,28,"Modify","Modify a selected requests");
    //options.appendChild(modifyBtn);
    
    cv_ui = createGraphics("reservation_calendar_view");
    cv_ui.setStyle("position","relative");
    cv_createHeader();
    cv_ui.viewport = createGraphics("cv.viewport");
    cv_ui.div.onclick = function(event) {
        var e = getEvent(event);
        if ((e.target.id != "reservation_calendar_view") 
        && (e.target.id.substr(0,11) != "cv.viewport"))
            return;
        var selections = lib_getSelection();
        for (var id in selections) {
            cv_unselectRes(resData.get(selections[id]), true);
        }
    }
    
    cv_ui.appendChild(cv_ui.viewport);
}

function changeCalendar(advance) { 
    var date = new Date(document.getElementById("cv_calendar").value);
    var thisMonth = date.getMonth();
    if(advance)
        date.setMonth(++thisMonth);
    else
        date.setMonth(--thisMonth);
    document.getElementById("cv_calendar").value = getDateOnlyString(date);
    cv_onDataUpdate();
}

// Return the value from the calendar
// if myDate is passed in, substitute that for day of the month (1-31)
function getCalendar(myDate) { 
    var date = new Date(document.getElementById("cv_calendar").value);
    if((myDate)&&(myDate>0)&&(myDate<32))
        date.setDate(myDate);
    return date;
}

function cv_show() {
    //show view
    lib_showView("reservation_calendar_view");
    cv_showCalendarViewOptions();
    cv_onDataUpdate();
    //register data update listener
    lib_registerListener("CalendarView",cv_onDataUpdate);
    initTip(cv_ui);
}

function cv_hide() {
    //unregister data update listener
    lib_unregisterListener("CalendarView");
    
    //hide view
    lib_hideView("reservation_calendar_view");
    cv_hideCalendarViewOptions();
}
function cv_groupResByDay(now) {
    cv_resByDay = [];
    for (var i=1; i <= 31; i++) {
        cv_resByDay[i] = [];
    }
    if (!resData) 
        return;
    for (var i in resData.reservations) {
        var res = resData.reservations[i];
        if ((res.startTime.getYear()==now.getYear())&&(res.startTime.getMonth()==now.getMonth())) {
            cv_resByDay[res.startTime.getDate()].push(res);
        }
    }
}
function cv_selectRes(res) {
    if(res.cv_rect) {
        res.cv_rect.setColor(resSelectColor);
        res.cv_rect.setBorder("1px dotted navy");
        lib_setSelection(res.reservationId);
        //detail_showReservation(res.reservationId);
    }
}
function cv_unselectRes(res, hideDetails) {
    if(res.cv_rect) {
        var resColor;
        resColor = res.color;
        res.cv_rect.setColor(resColor);
        res.cv_rect.setBorder("1px solid black");
        lib_unsetSelection(res.reservationId, hideDetails);
    }
}

function cv_onClickResRect(event) {
    var e = getEvent(event);
    
    if(!e.ctrlKey) {
        var selections = lib_getSelection();
        for (var id in selections) {
            cv_unselectRes(resData.get(selections[id]), false);
        }
    }
    var id = e.target.id;
    if (!id) {
        id = e.target.parentNode.id;
    }
    var res = resData.get(id.substr(5));
    if(res) {
        cv_selectRes(res);    
    }
    return false;
}

function cv_createDayBlock(parent, date, left, top, width, height) {
    var d = date.getDate();
    parent.appendChild(createRect("cv.viewport.d."+d,left,top,width,height,"#f0f0f0","0px solid black"));
    parent.appendChild(createLabel("cv.viewport.dl."+d,d,left+2,top,'0.7em',width,height+(ie?0:3),"left","top"));
    if(cv_resByDay[d].length != 0) {
        var viewlet = createRect("cv.viewport.vl."+d,left,top+12,width-10,height-10,"#f0f0f0");
        viewlet.setStyle("overflow","hidden");
        
        viewlet.buffer = createGraphics("cv.viewport.vlf."+d);
        for (var i in cv_resByDay[d]) {
            var res = cv_resByDay[d][i];
            var resColor;
            resColor = res.color;
            var rect = createRect("cv.r."+res.reservationId,0,cv_resHeight*i,width-12,cv_resHeight,resColor,"1px solid black");
            rect.appendChild(createLabel("cv.l."+res.reservationId,res.reservationId,0,0,"10px",width-20,cv_resHeight,"right"));
            viewlet.buffer.appendChild(rect);
            rect.div.onclick=cv_onClickResRect;
            res.cv_rect = rect;
            if(lib_isSelected(res.reservationId)) {
                rect.setColor(resSelectColor);
                rect.setBorder("1px dotted navy");
            }
            addTip(rect, res.tip, "", resHighlightColor, resColor);
        }
        viewlet.buffer.setSize(viewlet.width,cv_resByDay[d].length*cv_resHeight);
        viewlet.buffer.setPosition(0,0);
        viewlet.appendChild(viewlet.buffer);
        
        var scrollbar = createVScrollBar("cv.sb."+d,8,height-10);
        scrollbar.setPosition(left+width-10,top+12);
        scrollbar.setPos(0);
        parent.appendChild(scrollbar);
        
        viewlet.sbId = "cv.sb."+d;
        viewlet.onPosChange = function () {
            var pos = context.getPos(this.sbId);
            this.buffer.setPosition(0,pos*(this.height-this.buffer.height-2));
        }
        context.registerIdListener(viewlet.sbId,viewlet);
        
        parent.appendChild(viewlet);
        scrollbar.setScope(viewlet.height/viewlet.buffer.height);
    }
}
function cv_onDataUpdate() {
    var date = new Date(document.getElementById("cv_calendar").value);
    cv_groupResByDay(date);
    //get day number of the month
    var lastday = new Date(date.getTime());
    lastday.setMonth(date.getMonth()+1);
    lastday.setDate(0);
    var days_num = lastday.getDate();
    
    //get week number of the month
    var firstday = new Date(date.getTime());
    firstday.setDate(1);
    var weeks_num = 1 + Math.ceil((days_num - (7-firstday.getDay()))/7);
    
    //draw the blocks day by day.
    cv_ui.viewport.removeAllChildren();
    cv_ui.viewport.setSize(view_width,view_height-cv_header_h);
    var week = 0;
    for (var i = 1; i <= days_num; i++) {
        date.setDate(i);
        var left = date.getDay()*view_width/7;
        var top = cv_header_h+week*(view_height-cv_header_h)/weeks_num+1;
        var width = view_width/7-2;
        var height = (view_height-cv_header_h)/weeks_num-1;
        cv_createDayBlock(cv_ui.viewport,date,left,top,width,height-(ie?2:0));
        if(date.getDay() == 6) week++;
    }
}
var DAY_FULL_MAP = ["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"];

function cv_createHeader() {
    for (var i = 0; i < 7; i++) {
        cv_ui.appendChild(createRect("cv.viewport.h"+i,i*view_width/7-1,-1,view_width/7,cv_header_h,"#2B547E","1px solid black"));        
        cv_ui.appendChild(createLabel("cv.viewport.l"+i,DAY_FULL_MAP[i],i*view_width/7-1,-1,cv_header_h-4,view_width/7,cv_header_h,"center","middle","","#f7f9e5"));
    }
}
function cv_showCalendarViewOptions() {
    var options = document.getElementById("cv_options");
    options.style["display"]="";
    options.style["visibility"]="visible";
    //hX_5.addConverter("c", new hX_5.DateTimeConverter("strict:1","format:MMM d, yyyy"));
    //hX_5.addComponent("cv_calendar", new hX_5.JSFDatePicker("converter:c"));
}
function cv_hideCalendarViewOptions() {
    var options = document.getElementById("cv_options");
    options.style["display"]="none";
    options.style["visibility"]="hidden";
}

function onActionSelected() {
    var action = document.getElementById("prov.actions").value;
    if (action == "cancel")
        onClickCancelButton();
    else if (action == "update")
        onClickModifyButton();
    else if (action == "submitJob")
        onClickSubmitJob();
    //alert(action);
}

function onClickCancelButton(event) {
    var selections = lib_getSelection();
        if(selections.length == 0) {
                alert("No request selected!");
                return;
        }
    if(confirm("Do you want to cancel these requests?")) {
        var list = selections.join(",");
        window.location.href = "portal.cgi?function=removeProv&list=" + list;
    }
}

function onClickModifyButton(event) {
    var selections = lib_getSelection();
    if(selections.length == 0) {
        alert("No request selected!");
        return;
    }
    var id = selections[0];
    window.location.href = "portal.cgi?function=editProv&id=" + id;
}

function onClickSubmitJob(event) {
    var selections = lib_getSelection();
    if(selections.length == 0) {
        alert("No request selected!");
        return;
    }
    var id = selections[0];
    window.location.href = "portal.cgi?function=submitJCF&pid=" + id;
}

function onFilterInput() {
    //alert("Filter");
    var origURL = _requestURL;
    var o = document.getElementById("filterbyowner");
    if (o && o.value != "") {
        _requestURL = _requestURLBase + "&owner=" + o.value;
    } else {
        _requestURL = _requestURLBase;
    }
    //alert(_requestURL);
    if (origURL != _requestURL) {
        _lib_onTimer();
    }
}

