/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* Restricted Materials of IBM                                            */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2010,2012          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* sccsid = "@(#) src/hpcc/webui/hpccloud/scripts/ProvisionStatus.js, hpc.cloud.ui, hpcc_rbei, rbeis002a 1.38 1/31/12 04:25:27"; */

var ptimerID;
var reqData;
var sortBy = "name";
var interval = 20000;
var sortbNflag = 0;
var sortbOflag = 0;
var sortbSTflag = 0;
var sortbETflag = 0;
var sortbDflag = 0;
var sortbStatusflag = 0;
var sortbMflag = 0;
var existReq=0;
var showFaileProv=0;
//all status
//Reserved,Failed,Expired,Canceled,Ready,None,Canceling,Setup,Verifying,Waiting
var defaultStatus="Reserved,Failed,Ready,Canceling,Setup,Verifying,Waiting";
var statusXhrArgs = {
    url: "GetInfoXML.cgi?function=listReqXML&status="+defaultStatus,
    handleAs: "xml",
    preventCache: true,
    load: function(data) {
        onPDataUpdate(data);
    },
    error: function(error) {
        //showInfo("An unexpected error occurred: " + error);
    }
}

dojo.xhrGet(statusXhrArgs);
pollProvStatus();

function confirm2deleteProv() {
    if(confirm("Do you want to cancel these requests?")) {
        return true;
    } else {
        return false;
    }
}

function provAction(formID, action) {
    var action;
    var select = false;

    var plist = "";
    var form = document.getElementById(formID);

    if (form) {
        var inputs = form.getElementsByTagName("input");
        for(var i=0;i<inputs.length;i++) {
            if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].getAttribute("name") == "provID") {
                if (inputs[i].checked == true) {
                    select = true;
                    break;
                }
            }
        }
    } else {
        return;
    }
    if (!select) { alert("No request selected."); return; }
    var doit = confirm2deleteProv();
    if (!doit) return;

    if (form) {
        var inputs = form.getElementsByTagName("input");
        for(var i=0;i<inputs.length;i++) {
            if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].getAttribute("name") == "provID") {
                if (inputs[i].checked == true) {
                    plist = plist + "&provID=" + inputs[i].value;
                    var td = document.getElementById("prov_status_"+inputs[i].value);
                    if(td) {
                        td.innerHTML = "<img src=\"/hpccloud/images/loader.gif\" style=\"float:left\">Canceling";
                    }
                }
            }
        }
    }

    var xhrArgs = {
        url: "portal.cgi",
        postData: "function=removeProv&action="+ action + plist,
        handleAs: "text",
        load: function(data) {
			showInfo(data);
        },
        error: function(error) {
            showInfo(error);
        }
    }
    var deferred = dojo.xhrPost(xhrArgs);

    setTimeout("onPTimer()", interval);
    if(ptimerID) { clearInterval(ptimerID); ptimerID = null; }
}

function pollProvStatus() {
    if(!ptimerID) ptimerID = setInterval("onPTimer()", interval);
}

function onPTimer() {
	existReq++;
	if((existReq == 1)||(existReq>100)){
    	var deferred = dojo.xhrGet(statusXhrArgs);
	}
}

function onPDataUpdate(xmlDoc) {
    reqData = parseReqXML(xmlDoc);
    if (reqData) {
        //sortReqTab(sortBy);
        refreshReqTab();
		existReq = 0;//we can accept next refresh
    }
}

function refreshReqTab() {
    if ( onTop != "list") {
        if(ptimerID) { clearInterval(ptimerID); ptimerID = null; }
        return;
    }
    clearReqTab();
    var theTable = dojo.byId("reqlistTab");
    if (!theTable) {
        if(ptimerID) { clearInterval(ptimerID); ptimerID = null; }
        return;
    }

    for (var i=0; i < reqData.reqs.length; ++i) {
        var pStatus = reqData.reqs[i].status;
        // Filter out the requests in status Canceled or Expired.		
        if (pStatus == "Canceled" || pStatus == "Expired" || reqData.reqs[i].name == "") {
            continue;
        }
		if((showFaileProv == 0) && (pStatus == "Failed")){
			continue;
		}
        var row = theTable.insertRow(theTable.rows.length);
        row.className = "tab_content";
        var cell1 = row.insertCell(0);
//if(pStatus != "Failed"){ 
		if(reqData.reqs[i].status != "Failed"){ 
			if(reqData.reqs[i].check){
        		cell1.innerHTML = "<input type=checkbox name=provID value=" + reqData.reqs[i].name + " checked>";
			}else{
        		cell1.innerHTML = "<input type=checkbox name=provID value=" + reqData.reqs[i].name + ">";
			}
		}
        var cell2 = row.insertCell(1);
        cell2.innerHTML = "<a href=\"javascript:navLink('listProv', 'portal.cgi?function=editProv&id=" + reqData.reqs[i].name + "')\">" + reqData.reqs[i].name + "</a>";
        var cell3 = row.insertCell(2);
        cell3.innerHTML = reqData.reqs[i].owner;

        var d = new Date();
        d.setTime(reqData.reqs[i].start_time * 1000);
        var cell4 = row.insertCell(3);
        cell4.innerHTML = d;
        var cell5 = row.insertCell(4);
        cell5.innerHTML = (reqData.reqs[i].expiry_time - reqData.reqs[i].start_time) / 60;

        d.setTime(reqData.reqs[i].expiry_time * 1000);
        var cell6 = row.insertCell(5);
        cell6.innerHTML = d;

        var cell7 = row.insertCell(6);
        var statePic;
        if (pStatus == "Ready" || pStatus == "Reserved") {
            statePic = "greenLed.gif";
        } else if (pStatus == "Failed") {
            statePic = "redLed.gif";
        } else if (pStatus == "Setup" || pStatus == "Canceling" || pStatus == "Canceling") {
            statePic = "loader.gif";
        } else {
            statePic = "yellowLed.gif";
        }
        if (pStatus == "Failed") {
            var msg = "<b>Error</b>: " + reqData.reqs[i].description;
            cell7.innerHTML = "<img src=\"/hpccloud/images/" + statePic + "\" style=\"float:left\"><a class='no_under' href=\"javascript:void(0);\" onmouseover=\"bubble('bubbles', '" + msg + "');\" onmouseout=\"bubble('bubbles','');\">" +pStatus+ "</a>";
        } else {
            cell7.innerHTML = "<img src=\"/hpccloud/images/" + statePic + "\" style=\"float:left\">" +pStatus;
        }
        cell7.id = "prov_status_" + reqData.reqs[i].name;


		//alert(  reqData.reqs[i].name + " " +  reqData.reqs[i].modify );
        var cell7m = row.insertCell(7);
        statePic = "loader.gif";
        if ( reqData.reqs[i].modify  == 0) {
            cell7m.innerHTML = " ";
        } else {
            cell7m.innerHTML = "<img src=\"/hpccloud/images/" + statePic + "\" style=\"float:left\">Updating" ;
        }
        var cell8 = row.insertCell(8);


        cell8.innerHTML = reqData.reqs[i].machine_type;
        var cell9 = row.insertCell(9);
        var num = reqData.reqs[i].machine_num ? reqData.reqs[i].machine_num : reqData.reqs[i].machines.length;
        cell9.innerHTML = "<a style=\"display:block;\" href=\"javascript:;\" onclick=\"createMachListDlg(reqData.reqs[" + i + "]);\">" + num + "</a>";
        var cell10 = row.insertCell(10);
        cell10.innerHTML = reqData.reqs[i].machine_os;
        var cell11 = row.insertCell(11);
        cell11.innerHTML = reqData.reqs[i].cluster;
        var cell12 = row.insertCell(12);  // Energy
        var energy = reqData.reqs[i].energy>0 ? reqData.reqs[i].energy : "NA";
        if (energy == "NA") {
            cell12.innerHTML = energy;
        } else {
            // Show the energy graph on click.		
            cell12.innerHTML = "<a style=\"display:block;\" href=\"javascript:;\" onclick=\"createEnergyDlg(reqData.reqs[" + i + "]);\">" + energy + "</a>";
        }
        var cell13 = row.insertCell(13);
        cell13.innerHTML = reqData.reqs[i].vlanflag;
        var cell14 = row.insertCell(14);
        cell14.innerHTML = reqData.reqs[i].vlanid;
//        var cell13 = row.insertCell(12);  // Charge - do not show it for now
    }

    var tab = dojo.byId('tabProvList');
    dijit.byId('tabProv').resize({h:tab.scrollHeight+50});
    dijit.byId('tabProv').resize({h:tab.scrollHeight+50});

/*
    if (pxmlhttp.readyState == 4 && pxmlhttp.status == 200) {
        var ids = new Array();
        var ret = pxmlhttp.responseText;
        var provs = ret.split("|");
        for(var i=0; i < provs.length; i++) {
            var kv = provs[i].split("#");
            ids.push(kv[0]);
            var td = document.getElementById("prov_status_"+kv[0]);
            var pStatus = kv[1]; var eMsg = kv[2];
            if(td) {
                var statePic;
                if (pStatus == "Ready" || pStatus == "Reserved") {
                    statePic = "greenLed.gif";
                } else if (pStatus == "Failed") {
                    statePic = "redLed.gif";
                } else if (pStatus == "Setup" || pStatus == "Canceling" || pStatus == "Canceling") {
                    statePic = "loader.gif";
                } else {
                    statePic = "yellowLed.gif";
                }
                if (pStatus == "Failed") {
                    var msg = "<b>Error</b>: " + eMsg;
                    if (!eMsg || eMsg == "") msg = "<b>Error</b>: Request could not be serviced within the setup time";
                    td.innerHTML = "<img src=\"/hpccloud/images/" + statePic + "\" style=\"float:left\"><a class='no_under' href=\"javascript:void(0);\" onmouseover=\"bubble('bubbles', '" + msg + "');\" onmouseout=\"bubble('bubbles','');\">" +pStatus+ "</a>";
                } else {
                    td.innerHTML = "<img src=\"/hpccloud/images/" + statePic + "\" style=\"float:left\">" +pStatus;
                }

                var mform = document.getElementById("machForm_"+kv[0]);
                if (pStatus == "Ready") {
                    mform.machActionMenu.disabled = false;
                    mform.selectAllM.disabled = false;
                    var theLinks = mform.getElementsByTagName("a");
                for(var k = 0; k < theLinks.length; k++) {
                        if (theLinks[k].getAttribute('name') == "vnc_link")
                    theLinks[k].onclick = null;
                }
                } else {
                    mform.machActionMenu.disabled = true;
                    mform.selectAllM.disabled = true;
                    var theLinks = mform.getElementsByTagName("a");
                    for(var k = 0; k < theLinks.length; k++) {
                        if (theLinks[k].getAttribute('name') == "vnc_link")
                            theLinks[k].onclick = function() {
                                return false;
                            }
                    }
                }
            }
        }

        var pids = document.getElementsByName("td_provID");
        if (pids.length == 0) {
            pids = new Array();
            var elems = document.getElementsByTagName("font");
            for (var j=0; j<elems.length; j++){
                att = elems[j].getAttribute('name');
                if(att == "td_provID") {
                    pids.push(elems[j]);
                }
            }
        }

        var tt = document.getElementById("total_prov");
        if (tt) {
            var num = tt.innerHTML.split(" ")[1];
            for (var i=0; i < pids.length; i++) {
                //if (!ids.has(pids[i].innerHTML)){
                if (dojo.indexOf(ids, pids[i].innerHTML) == -1) {
                    var tr = pids[i].parentNode.parentNode.parentNode;
                    tr.parentNode.removeChild(tr);
                    --num;
                    tt.innerHTML = "Total " + num + " Provision requests";
                }
            }
        }
    }
*/

    if(!ptimerID) ptimerID = setInterval("onPTimer()", interval);
}

function parseReqXML(xmlDoc) {
    var result = new Object();
    result.reqs = [];
    var items = xmlDoc.documentElement.getElementsByTagName('request');
    for(var n=0; n < items.length; n++) {
        var req = new Object();
        req.id = getElementDataFromNode(items[n], "request.id");
        req.name = getElementDataFromNode(items[n], "request.name");
        req.owner = getElementDataFromNode(items[n], "request.owner");
        req.description = getElementDataFromNode(items[n], "request.description");
        req.start_time = getElementDataFromNode(items[n], "request.start_time");
        req.expiry_time = getElementDataFromNode(items[n], "request.expiry_time");
        req.status = getElementDataFromNode(items[n], "request.status");
        req.select_method = getElementDataFromNode(items[n], "request.select_method");
        req.machine_type = getElementDataFromNode(items[n], "request.machine_type");
        req.machine_num = getElementDataFromNode(items[n], "request.machine_num");
        req.machine_os = getElementDataFromNode(items[n], "request.machine_os");
        req.machine_cpu = getElementDataFromNode(items[n], "request.machine_cpu");
        req.machine_memory = getElementDataFromNode(items[n], "request.machine_memory");
        req.machine_disk = getElementDataFromNode(items[n], "request.machine_disk");
        req.cluster = getElementDataFromNode(items[n], "request.cluster");
        req.hypv_flag = getElementDataFromNode(items[n], "request.hypv_flag");
        req.energy = getElementDataFromNode(items[n], "request.energy");
        req.vlanflag = getElementDataFromNode(items[n], "request.vlan_flag");
        req.vlanid = getElementDataFromNode(items[n], "request.vlan_id");
        req.modify = getElementDataFromNode(items[n], "request.modify");

        req.machines = [];
        var mach_items = items[n].getElementsByTagName('machList');
        for(var i=0; i < mach_items.length; i++) {
            var mach = new Object();
            mach.name = getElementDataFromNode(mach_items[i], "name");
            mach.id = getElementDataFromNode(mach_items[i], "request_machine.id");
            mach.status = getElementDataFromNode(mach_items[i], "status");
            mach.type = getElementDataFromNode(mach_items[i], "type");
            mach.request_name = getElementDataFromNode(mach_items[i], "request_machine.request_name");
            mach.ip = getElementDataFromNode(mach_items[i], "ip");
            mach.arch = getElementDataFromNode(mach_items[i], "arch");
            mach.acc_power = getElementDataFromNode(mach_items[i], "acc_power");
            mach.avg_power = getElementDataFromNode(mach_items[i], "avg_power");
            mach.power_state = getElementDataFromNode(mach_items[i], "power_state");
            mach.provision_mode = getElementDataFromNode(mach_items[i], "provision_mode");
            mach.sampling_times = getElementDataFromNode(mach_items[i], "sampling_times");
            mach.default_os = getElementDataFromNode(mach_items[i], "default_os");
            // Report the machine information based on the request. Currently the machines of a request use the same image.
            // Use req.machine_os instead of getElementDataFromNode(mach_items[i], "current_os").
            mach.current_os = req.machine_os;
            mach.energy_scheme = getElementDataFromNode(mach_items[i], "energy_scheme");
            mach.using_ip = getElementDataFromNode(mach_items[i], "request_machine.using_ip");
            mach.using_hostname = getElementDataFromNode(mach_items[i], "request_machine.using_hostname");
            mach.child_vnodes = getElementDataFromNode(mach_items[i], "vnodes");
            mach.parent_hypv = getElementDataFromNode(mach_items[i], "hypervisor");
            req.machines.push(mach);
        }

		req.check = false;
        result.reqs.push(req);
    }

    return result;
}

function createEnergyDlg(reqItem) {
    var dlg = dijit.byId("energy_gra_" + reqItem.name);
    if (dlg) dlg.destroy();

    energyDlg = new dijit.Dialog({
        id: "energy_gra_" + reqItem.name,
        title: "Energy Information of " + reqItem.name,
        content: "<iframe id=\"iframe_energy_" + reqItem.name + "\" frameborder=1 width=100% height=400 scrolling=auto src=\"provenergy.cgi?d=" + reqItem.name + "\"></iframe></div>",
        style: "width: 650px; height: 400px"
    });
    energyDlg.show();
}

function createMachListDlg(reqItem) {
    var dlg = dijit.byId("mach_list_" + reqItem.name);
    if (dlg) dlg.destroy();
    var dis_power = "";
    var dis_scheme = "";

    // Disable the power setting function for hypv.
    if (reqItem.status != "Ready" || reqItem.hypv_flag == 1)
        dis_power = "disabled";

    // Disable the energy scheme function for virtual machines.
    if (reqItem.status != "Ready" || reqItem.hypv_flag == -1)
        dis_scheme = "disabled";

    var mlst = "<form name=machForm id=machForm_" + reqItem.name + " method=post action=portal.cgi>";
    mlst += "<table id=mach_tab_" + reqItem.name + " width=100% border=0 cellpadding=1 cellspacing=1 bgcolor=#e3e3d1 style=\"text-align:center\">";
    mlst += "<tr><td colspan=10 align=left>";
    mlst += "<table><tr>";
    mlst += "<td style=\"font-size: 10pt;\">Power Settings</td>";
    mlst += "<td>";
    mlst += "<input type=hidden name=function value=setMachPower>";
    mlst += "<select id=\"machPowerMenu_" + reqItem.name + "\" name=machPowerMenu size=1 " + dis_power + " >";
    mlst += "<option value=none selected>- Select Action -</option>";
    mlst += "<option value=powerOn>Power On</option>";
    mlst += "<option value=powerOff>Power Off</option>";
    mlst += "<option value=powerReset>Power Reset</option>";
    mlst += "</select>";
    mlst += "</td>";
    mlst += "<td>";
    // TODO: disabled does not work for href, need enhancement later.
    mlst += "<a href=\"javascript:void(0);\" onclick=\"machPower('machForm_" + reqItem.name + "', 'machPowerMenu_" +reqItem.name+"');\" title=\"Select an action from the menu on the left and click this button to execute the action\" " + dis_power + "><img src=/hpccloud/images/go.gif border=0 align=middle></a>";
    mlst += "</td>";
    mlst += "<td></td>";
    mlst += "<td style=\"font-size: 10pt;\">Energy Schemes</td>";
    mlst += "<td>";
    mlst += "<select id=\"machEScheme_" + reqItem.name + "\" name=\"machEScheme\" size=1 " + dis_scheme + " >";
    mlst += "<option value=\"none\" selected>- Select Energy Scheme -</option>";
    mlst += "</select>";
    mlst += "</td>";
    mlst += "<td>";
    mlst += "<button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"machEScheme('machForm_" + reqItem.name + "', 'machEScheme_" +reqItem.name+"');\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconTabIndent\" title=\"Select an energy scheme from the menu on the left and click this button to apply it\" " + dis_scheme + " >Apply</button>";
    mlst += "</td>";
    mlst += "<td></td>";
    mlst += "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"refreshMachStatus();\" baseClass=tundra iconClass=\"dijitIcon dijitIconUndo\" title=\"Click to refresh machine status\">Refresh</button></td>\n";
    mlst += "</tr></table>";
    mlst += "</td></tr>";

    mlst += "<tr bgcolor=#0066CC>";
    mlst += "<td width=10><input $dis type=checkbox id=selectAllM_$pid name=selectAllM onClick=\"select_allM('machForm_" + reqItem.name + "')\" title=\"Select/Deselect all\"></td>";
    mlst += "<td width=50><font color=#f7f9e5><b>Name</b></td>";
    mlst += "<td width=50><font color=#f7f9e5><b>Arch</b></font></td>";
    mlst += "<td width=100><font color=#f7f9e5><b>Type</b></font></td>";
    mlst += "<td width=60><font color=#f7f9e5><b>Image</b></font></td>";
    mlst += "<td width=50><font color=#f7f9e5><b>Status</b></font></td>";
    mlst += "<td width=80><font color=#f7f9e5><b>Power Status</b></font></td>";
    mlst += "<td width=50><font color=#f7f9e5><b>Hypvisor</b></font></td>";
    mlst += "<td width=80><font color=#f7f9e5><b>Vnodes</b></font></td>";
    mlst += "<td width=100><font color=#f7f9e5><b>Energy Schemes</b></font></td>";
    mlst += "<td width=100><font color=#f7f9e5><b>Using IP</b></font></td>";
    mlst += "<td width=100><font color=#f7f9e5><b>Using Hostname</b></font></td>";
//    mlst += "<td><font color=#f7f9e5><b>Energy</b></font></td></tr>";
    mlst += "</tr>";

    machListDlg = new dijit.Dialog({
        id: "mach_list_" + reqItem.name,
        title: "Machine List of " + reqItem.name,
        content: mlst,
        style: "width: 800px"
    });

    machListDlg.show();

    var theTable = dojo.byId("mach_tab_" + reqItem.name);
    if (!theTable) {
        return;
    }

    for( var i=0; i < array_scheme.length; i++) {
        if (array_scheme[i].name == "poweroff-default") {
            continue;
        }
        var newopt = document.createElement('option');
        newopt.text = array_scheme[i].name;
        newopt.value = array_scheme[i].name + "|" + array_scheme[i].owner;
        dojo.byId("machEScheme_" + reqItem.name).options.add(newopt);
    }

    for (var i=0; i < reqItem.machines.length; ++i) {
        var mach = reqItem.machines[i];
        var row = theTable.insertRow(theTable.rows.length);
        row.className = "tab_content";
        var cell1 = row.insertCell(0);

        if (reqItem.status == "Ready") {
            cell1.innerHTML = "<input type=checkbox name=machName value=" + mach.name + ">";
        }
        var cell2 = row.insertCell(1);
        if (reqItem.status == "Ready" && reqItem.hypv_flag != 1) {
            cell2.innerHTML = "<a title=\"Click to open VNC to login this node\" target=\"_blank\" href=\"/vnc/" + mach.name + "\">" + mach.name + "</a>";
        } else {
            cell2.innerHTML = mach.name;
        }

        var cell3 = row.insertCell(2);
        cell3.innerHTML = mach.arch;
        var cell4 = row.insertCell(3);
        cell4.innerHTML = mach.type;
        var cell5 = row.insertCell(4);
        cell5.innerHTML = mach.current_os ? mach.current_os : "NA";
        var cell6 = row.insertCell(5);
        cell6.innerHTML = mach.status;
        cell6.setAttribute('name', "st_" + mach.name);
        var cell7 = row.insertCell(6);
        cell7.innerHTML = mach.power_state;
        cell7.setAttribute('name', "pst_" + mach.name);
        var cell8= row.insertCell(7);
        cell8.innerHTML = mach.parent_hypv?mach.parent_hypv:"NA";
        var cell9= row.insertCell(8);
        cell9.innerHTML = mach.child_vnodes?mach.child_vnodes : "NA";
        var cell10 = row.insertCell(9);
        var energy = mach.energy_scheme ? mach.energy_scheme : "NA";
        cell10.innerHTML = energy;
        cell10.setAttribute('name', "psav_" + mach.name);
        var cell11 = row.insertCell(10);
        cell11.innerHTML = mach.using_ip;
        var cell12 = row.insertCell(11);
        cell12.innerHTML = mach.using_hostname;
//        var cell9 = row.insertCell(8);
//        cell9.innerHTML = mach.acc_power;
    }
}

function clearReqTab() {
    var theTable = document.getElementById("reqlistTab");
    if (!theTable) {
        if(ptimerID) { clearInterval(ptimerID); ptimerID = null; }
        return;
    }
    for(var i = (theTable.rows.length-1); theTable.rows.length > 2; i--) {
        theTable.deleteRow(i);
    }
}

function keepcheckinfo(){
	// Keep the selected items.
	var form = dojo.byId("provForm");
	var inputs = form.getElementsByTagName("input");
	var i,j;
    for(j = 0;j < reqData.reqs.length;j++){
		reqData.reqs[j].check = false;
		for(i=0;i<inputs.length;i++){
			if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].checked == true) {
				if (inputs[i].value == reqData.reqs[j].name){
					reqData.reqs[j].check = true;
				}
			}
		}
	}
}

function sortReqTab(sortingBy) {
	keepcheckinfo();
    sortBy = sortingBy;
    if (sortingBy == "name") {
		sortbNflag = 1-sortbNflag;
        reqData.reqs.sort(sortByReqName);
    } else if (sortingBy == "owner") {
		sortbOflag = 1-sortbOflag;
        reqData.reqs.sort(sortByReqOwner);
    } else if (sortingBy == "sdate") {
		sortbSTflag = 1-sortbSTflag;
        reqData.reqs.sort(sortByReqSTime);
    } else if (sortingBy == "duration") {
		sortbDflag = 1-sortbDflag;
        reqData.reqs.sort(sortByReqDuration);
    } else if (sortingBy == "edate") {
		sortbETflag = 1-sortbETflag;
        reqData.reqs.sort(sortByReqETime);
    } else if (sortingBy == "state") {
		sortbStatusflag = 1-sortbStatusflag;
        reqData.reqs.sort(sortByReqStatus);
    } else if (sortingBy == "num") {
		sortbMflag = 1- sortbMflag;
        reqData.reqs.sort(sortByReqMachNum);
    }

    refreshReqTab();
}

function sortByReqName(a, b) {
    var x = a.name.toLowerCase();
    var y = b.name.toLowerCase();
	if(sortbNflag == 1){
    	return ((x < y) ? -1 : ((x > y) ? 1 : 0));}
	else{
    	return ((x < y) ? 1 : ((x > y) ? -1 : 0));}
}

function sortByReqOwner(a, b) {
    var x = a.owner.toLowerCase();
    var y = b.owner.toLowerCase();
	if(sortbOflag ==1){
    	return ((x < y) ? -1 : ((x > y) ? 1 : 0));}
	else {
		return ((x < y) ? 1 : ((x > y) ? -1 : 0));}
}

function sortByReqSTime(a, b) {
    var x = parseInt(a.start_time);
    var y = parseInt(b.start_time);
	if(sortbSTflag==1){
	    return ((x < y) ? -1 : ((x > y) ? 1 : 0));}
	else {
		return ((x < y) ? 1 : ((x > y) ? -1 : 0));}
}

function sortByReqETime(a, b) {
    var x = parseInt(a.expiry_time);
    var y = parseInt(b.expiry_time);
	if(sortbETflag==1){
	    return ((x < y) ? -1 : ((x > y) ? 1 : 0));}
	else {
		return ((x < y) ? 1 : ((x > y) ? -1 : 0));}
}

function sortByReqDuration(a, b) {
    var x = parseInt(a.expiry_time) - parseInt(a.start_time);
    var y = parseInt(b.expiry_time) - parseInt(b.start_time);
	if(sortbDflag==1){
	    return ((x < y) ? -1 : ((x > y) ? 1 : 0));}
	else {
		return ((x < y) ? 1 : ((x > y) ? -1 : 0));}
}

function sortByReqStatus(a, b) {
    var x = a.status.toLowerCase();
    var y = b.status.toLowerCase();
	if(sortbStatusflag){
	    return ((x < y) ? -1 : ((x > y) ? 1 : 0));}
	else {
		return ((x < y) ? 1 : ((x > y) ? -1 : 0));}
}

function sortByReqMachNum(a, b) {
    var x = parseInt(a.machine_num);
    var y = parseInt(b.machine_num);
	if(sortbMflag){
	    return ((x < y) ? -1 : ((x > y) ? 1 : 0));}
	else {
		return ((x < y) ? 1 : ((x > y) ? -1 : 0));}
}

function onDispFailedProvCheckBox()
{
	//var form = document.getElementById("provForm");
	var chbox = dojo.byId('provForm').showfailedprov.checked;//form.getElementsByTagName("showfailedprov");
	if(chbox){
		showFaileProv = 1;
	}else{
		showFaileProv = 0;
	}
	//var deferred = dojo.xhrGet(statusXhrArgs);	
	refreshReqTab();
}
