/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* Restricted Materials of IBM                                            */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2010,2012          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* sccsid = "@(#) src/hpcc/webui/hpccloud/scripts/ReservationViewLib.js, hpc.cloud.ui, hpcc_rbei, rbeis002a 1.3 1/16/12 03:27:57"; */

// view width and height
var view_width=700;
var view_height=400;
var resHighlightColor = "#90EE90";
var resNormalColor = "#A9D8E9";
var resSelectColor = "aqua";
var userName;
var isAdmin;
var resData;

var _requestURL;
var _requestURLBase;
var _contextPath;
var _httpRequest;
var _callback = null;

var _refreshInterval;
var _timerID = 0;
var _listeners = [];
var _menu = null;
var _actions = [];

function lib_init(url) { 
	_contextPath = url;
	_requestURLBase = _requestURL = _contextPath  + "/GetInfoXML.cgi?function=listReqXML4Calendar";
	
	userName = document.getElementById("userName").value;
	isAdmin = document.getElementById(getRealID("isAdmin","input")).value;
	_refreshInterval = document.getElementById("refreshInterval").value;

	resData = new Object();
	resData.scope = 1;
	resData.reservations = [];
	
	_lib_onTimer();
	_refreshInterval = document.getElementById(getRealID("refreshInterval","input")).value;
	_timerID = setInterval("_lib_onTimer()",parseInt(_refreshInterval));
	// function Action(parentID, id, label, action, command, comment, markGray) {
	//_actions.push(new Action("resMenu", "LLDELETE","Delete Selected Reservations", _lib_onActionDelete));
	//_menu = _lib_createMenu();
	//lib_hideMenu();
}

function _lib_createMenu() {
	var id = "resMenu";
	var menu = createMenu(id);
	//var item = new hX_5.JSFMenuItem("label:Create A New Reservation", "target:"+getRealID("dialogMkRes","div"),"action:SHOW;STOP","id:LLCREATE");
	//hX_5.addSubComponent(id,"LLCREATE",item);
	//for (var i = 0; i < _actions.length; i++) {
	//	menu.addMenuItem(id,"menu_"+_actions[i].id,_actions[i].label,"_lib_onContextMenu('"+_actions[i].id+"',event);");
	//}
	return menu;
}

function lib_showView(id) {
	var view = document.getElementById(id);
	view.style["display"]="";
	view.style["visibility"]="visible";
	view.style["width"]=view_width+"px";
	view.style["height"]=view_height+"px"; 
}

function lib_hideView(id) {
	var view = document.getElementById(id);
	view.style["display"]="none";
	view.style["visibility"]="hidden";
	view.style["width"]="0px";
	view.style["height"]="0px"; 
}

function lib_requestResData(type,func) {
	var request = createRequest(); 
	if(!func) {
		request.open("GET", _requestURL+type, false);
		request.send(null);
		return _lib_parseResXML(request);		
	}else{
		request.open("GET", _requestURL+type, true);
		request.onreadystatechange = function() {
			if(request.readyState == 4 && request.status == 200) {
				func(_lib_parseResXML(request));
			}
		}
		request.send(null);
		return;
	}
}

function lib_registerListener(id,func) {
	_listeners[id] = func;
}
function lib_unregisterListener(id) {
	delete _listeners[id];
}

function _lib_onResDataReady() {
	var result;
	if(_httpRequest.readyState == 4 && _httpRequest.status == 200) {
		resData = _lib_parseResXML(_httpRequest);
		for( var id in _selected_res) {
			if (!resData.get(id)) {
				delete _selected_res[id];
			}
		}
		// call registered callbacks
		for (var id in _listeners) {
			_listeners[id]();
		}
	}else if (_httpRequest.readyState == 4 && _httpRequest.status == 401) {
			alert("Your session is unavailable, please re-login.");
			clearInterval(_timerID);
			_timerID = 0;
	}
	return null;
}

function _lib_onTimer() {
	clearRequest(_httpRequest);
	_httpRequest = createRequest(); 
	_httpRequest.open("GET", _requestURL, true);
	_httpRequest.onreadystatechange = _lib_onResDataReady;
	_httpRequest.send(null);
}

function _lib_parseResXML(xmlHttp) {
	var result = new Object();
	result.reservations = [];
	result.selected_res = [];
	result.timeDateStamp = xmlHttp.responseXML.documentElement.getElementsByTagName('timeDateStamp')[0].firstChild.data;
	var items = xmlHttp.responseXML.documentElement.getElementsByTagName('reservation');
	for(var n=0; n < items.length; n++) {
		var reservation = new Object();

		reservation.reservedNodes = getElementDataFromNode(items[n], "reservedNodes").split(" ");
		reservation.owner = getElementDataFromNode(items[n], "owner");
		reservation.status = getElementDataFromNode(items[n], "status");
		reservation.endTime =  new Date(parseInt(getElementDataFromNode(items[n], "endTime")));
		reservation.mode_g = getElementDataFromNode(items[n], "mode_g");
		reservation.groups = getElementDataFromNode(items[n], "groups").split(" ");
		reservation.mode_u = getElementDataFromNode(items[n], "mode_u");
		reservation.users = getElementDataFromNode(items[n], "users").split(" ");
		reservation.reservationId = getElementDataFromNode(items[n], "reservationId");
		reservation.startTime =  new Date(parseInt(getElementDataFromNode(items[n], "startTime")));
		reservation.duration = getElementDataFromNode(items[n], "duration");
		//reservation.strict = getElementDataFromNode(items[n], "strict");
		reservation.subCluster = getElementDataFromNode(items[n], "subCluster");
		reservation.energy = getElementDataFromNode(items[n], "energy");
		reservation.color = getElementDataFromNode(items[n], "color");
		
		// set up the hover help
		//reservation.tip = "<div align='center'>"+reservation.reservationId+"</br>"+ getShortDateString(reservation.startTime) + " to "+getShortDateString(reservation.endTime)+ "<br>Duration: " + (reservation.duration/60) + " min</div>";
		reservation.tip = "<div>";
		
		var tableData = "";
                //tableData = "<table style='font-size:14px'>";
		//tableData += "<tr><td><b>Provision: "+reservation.reservationId+"</td></tr></table>";
		tableData += "<table style='font-size:11px'>";
		tableData += "<tr><td width=100><b>ID:</b></td><td>" + reservation.reservationId + "</td></tr>";
		tableData += "<tr><td><b>Owner:</b></td><td>" + reservation.owner + "</td></tr>";
		tableData += "<tr><td><b>Start Time:</b></td><td>" + getDateTimeString(reservation.startTime) + "</td></tr>";
		tableData += "<tr><td><b>Duration (mins):</b></td><td>" + (reservation.duration/60) + "</td></tr>";
		tableData += "<tr><td><b>End Time:</b></td><td>" + getDateTimeString(reservation.endTime) + "</td></tr>";
		//tableData += createEditableTextField("strict", "<b>Strict:</b>", reservation.strict==1?"yes":"no", "radio", false);
		tableData += createEditableTextField("subc", "<b>Sub Cluster:</b>", reservation.subCluster=="Sub"?"yes":"no", "radio", false);
		tableData += "<tr><td><b>Status:</b></td><td>" + reservation.status + "</td></tr>";
		tableData += "<tr><td><b>Energy:</b></td><td>" + reservation.energy + "</td></tr>";
		tableData += "<tr><td><b>Users:</b></td><td><b>" + reservation.mode_u + "</b></td></tr>";
		tableData += "<tr><td> &nbsp; </td>";
                tableData += convertMachineListFromArray(reservation.users);
                tableData += "</td></tr>";

		tableData += "<tr><td><b>Groups:</b></td><td><b>" + reservation.mode_g + "</b></td></tr>";
		tableData += "<tr><td> &nbsp; </td>";
                tableData += convertMachineListFromArray(reservation.groups);
                tableData += "</td></tr>";

		// Reserved Nodes
		tableData += "<tr><td><b>Machines:</b></td><td>" + reservation.reservedNodes.length + "</td></tr>";
		tableData += "<tr><td> &nbsp; </td>";
		tableData += convertMachineListFromArray(reservation.reservedNodes);
		// Bound Steps
		tableData += "</td></tr>";

		tableData += "</tr>";
		tableData += "</table><br>";
		reservation.tip += tableData;
		reservation.tip += "</div>";
		result.reservations.push(reservation);
	}
	result.get = function(rid) {
		for(var i in result.reservations) {
			if (result.reservations[i].reservationId == rid) {
				return result.reservations[i];
			}
		}
		return null;
	}
	return result;
}

function convertMachineListFromArray(array) {
	var returnString = "";
	if(array.length > 1) { 
		returnString += "<td>";
		for(var x = 0; x < array.length; x++) {
				returnString += array[x] + "<br>";
		}
		returnString+= "</td>";
	}
	else {
		returnString += "<td>" + array[0] + "</td>";
	}
	return returnString;
}

// this function will return a string that will allow the field to be editable
function createEditableTextField(categoryID, categoryLabel, categoryValue, inputType, editable) {
	var fieldString = "<tr>";	
	fieldString += "<td class='resDetailTitle'>" + categoryLabel + "</td>";
	if(inputType == "text") {
		fieldString += "<td>";
		fieldString += "<input class='notEditing' type='text' id='" + categoryID + "' value='" + categoryValue + "' readonly='true'></input>";
		fieldString += "</td>";
		/*if(editable) {
			fieldString += "<td>";
			fieldString += "<input class='editButton' type='text' value='edit' readonly='true' onclick='editTextField(\"" + categoryID + "\")'></input>";
			fieldString += "<input class='resetButton' type='text' value='reset' readonly='true' onclick='resetTextField(\"" + categoryID + "\")'></input>";
			fieldString += "</td>";
		}*/
	}
	else if(inputType == "radio") {
		fieldString += "<td>";
		
		fieldString += "<input type='radio'	name='" + categoryID + "' value='yes' disabled='true'";
		if(categoryValue == "yes")
			fieldString += " checked='checked'";
		fieldString += ">Yes";
		
		fieldString += "<input type='radio'	name='" + categoryID + "' value='no' disabled='true'";
		if(categoryValue == "no")
			fieldString += " checked='checked'";
		fieldString += ">No";
		
		fieldString += "</td>";
		/*if(editable) {
			fieldString += "<td>";
			fieldString += "<input class='editButton' type='text' value='edit' readonly='true' onclick='editRadioField(\"" + categoryID + "\")'></input>";
			fieldString += "<input class='resetButton' type='text' value='reset' readonly='true' onclick='resetRadioField(\"" + categoryID + "\")'></input>";
			fieldString += "</td>";
		}*/
	}
	else if(inputType == "time") {
		fieldString += "<td>";
		fieldString += "<input class='notEditing' style='width: 123px' type='text' id='" + categoryID + "_date' value='" + getCalendarValue("date", categoryValue) + "' readonly='true'></input>&nbsp;&nbsp;";
		fieldString += "<input class='notEditing' style='width: 120px' type='text' id='" + categoryID + "_time' value='" + getCalendarValue("time", categoryValue) + "' readonly='true'></input>&nbsp;";
		fieldString += "</td>";
		/*if(editable) {
			fieldString += "<td>";
			fieldString += "<input class='editButton' type='text' value='edit' readonly='true' onclick='editTimeField(\"" + categoryID + "\")'></input>";
			fieldString += "<input class='resetButton' type='text' value='reset' readonly='true' onclick='resetTimeField(\"" + categoryID + "\")'></input>";
			fieldString += "</td>";
		}*/
	}
	fieldString += "</tr>";
	return fieldString;
}

var _selected_res = [];

function lib_setSelection(reservationId) {
	_selected_res[reservationId] = 1;
	//detail_showReservation(reservationId);
}
function lib_unsetSelection(reservationId, hideDetails) {
	//if(hideDetails)
	//	detail_hideReservation();
	delete _selected_res[reservationId];
}

function lib_getSelection() {
	var result = [];
	for (var id in _selected_res) {
		result.push(id);
	}
	return result;
}

function lib_isSelected(id) {
	if(_selected_res[id]) {
		return true;
	}
	return false;
}

