/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* Restricted Materials of IBM                                            */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2010,2012          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* sccsid = "@(#) src/hpcc/webui/hpccloud/scripts/RoleView.js, hpc.cloud.ui, hpcc_rbei, rbeis002a 1.7 1/4/12 05:48:33"; */

var roleData;
var sortRoleFlag=0;

function showRoles(user) {
    var xhrArgs = {
        url: "GetInfoXML.cgi?function=listRoleXML",
        handleAs: "xml",
        preventCache: true,
        load: function(data) {
            onRoleUpdate(data,user);
        },
        error: function(error) {
            showInfo("An unexpected error occurred: " + error);
        }
    }

    //Call the asynchronous xhrGet
    var deferred = dojo.xhrGet(xhrArgs);
}

function onRoleUpdate(xmlDoc, user) {
    roleData = parseRoleXML(xmlDoc);
    refreshRoleTab(user);
}

function refreshRoleTab(user) {
    clearRoleTab();
    var theTable = document.getElementById("rolelistTab");
    for (var i=0; i < roleData.roles.length; ++i) {
        var row = theTable.insertRow(theTable.rows.length);
        row.className = "tab_content";
        var cell1 = row.insertCell(0);
		if(roleData.roles[i].name!="admin"){
			if(user == "cloudadm"){
				if(roleData.roles[i].check){
        			cell1.innerHTML = "<input type=checkbox name=roleName value=" + roleData.roles[i].name + " checked>";
				}else{	
        			cell1.innerHTML = "<input type=checkbox name=roleName value=" + roleData.roles[i].name + ">";
				}	
			}		
		}
        var cell2 = row.insertCell(1);
		cell2.innerHTML = "<a href=\"javascript:navLink('listRole', '?function=updateRoleForm&rname=" + roleData.roles[i].name + "')\">" + roleData.roles[i].name + "</a>";
        var cell3 = row.insertCell(2);
        cell3.innerHTML = roleData.roles[i].capability;
        var cell4 = row.insertCell(3);
		cell4.innerHTML = roleData.roles[i].desc;
    }
}

function parseRoleXML(xmlDoc) {
    var result = new Object();
    result.roles = [];
    var items = xmlDoc.documentElement.getElementsByTagName('role');
    for(var n=0; n < items.length; n++) {
        var role = new Object();
        role.name = getElementDataFromNode(items[n], "name");
		var cap = items[n].getElementsByTagName('cap-list');
        role.capability = getElementDataFromNode(cap[0], "name", true).join(',');
        role.desc = getElementDataFromNode(items[n], "role.desc");
		role.check=false;

        result.roles.push(role);
    }

    return result;
}

function clearRoleTab() {
    var theTable = document.getElementById("rolelistTab");
    for(var i = (theTable.rows.length-1); theTable.rows.length > 2; i--) {
        theTable.deleteRow(i);
    }
}

function keepcheckinfo(){
	// Keep the selected items.
	var form = dojo.byId("roleForm");
	var inputs = form.getElementsByTagName("input");
	var i,j;

	for(j = 0;j < roleData.roles.length;j++){
		roleData.roles[j].check = false;
		for(i=0;i<inputs.length;i++){
			if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].checked == true) {
				if (inputs[i].value == roleData.roles[j].name){
					roleData.roles[j].check = true;
				}
			}
		}
	}
}

function sortRoleTab(sortingBy) {
	keepcheckinfo();
    if (sortingBy == "name") {
		sortRoleFlag = 1-sortRoleFlag;
        roleData.roles.sort(sortByRoleName);
    }
    refreshRoleTab();
}

function sortByRoleName(a, b) {
    var x = a.name.toLowerCase();
    var y = b.name.toLowerCase();
	if(sortRoleFlag==1){
	    return ((x < y) ? 1 : ((x > y) ? -1 : 0));}
	else{
	    return ((x < y) ? -1 : ((x > y) ? 1 : 0));}
}

function submitDeleteRole() {
	var select = false;
	var form = document.getElementById("roleForm");
	if (form) {
		var inputs = form.getElementsByTagName("input");
		for(var i=0;i<inputs.length;i++) {
			if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].getAttribute("name") == "roleName") {
				if (inputs[i].checked == true) {
					select = true;
					break;
				}
			}
		}
	} else {
		return;
	}
	if (!select) { alert("No Role selected."); return; }
    if(!confirm("Do you want to delete these roles?")) {
        return false;
    }
    var xhrArgs = {
        form: dojo.byId('roleForm'),
        handleAs: "text",
        load: function(data) {
            hideWaitingDlg();
            showInfo(data);
            dijit.byId('mainContent').refresh();
        },
        error: function(error) {
            hideWaitingDlg();
            showInfo(error);
            dijit.byId('mainContent').refresh();
        }
    }
    showWaitingDlg();
    var deferred = dojo.xhrPost(xhrArgs);
}

function submitAddRole() {
	if(!checkFormAllInput('addRoleForm')){
		alert("Please Remove Illegal Character!");
		return false;
	}
	if (dojo.byId('addRoleForm').rolename.value == "") {
		alert("Specify a name for the role");
		return false;
	}
	if(!criticalcheckinput(dojo.byId('addRoleForm').rolename.value)){
		alert("Role name only accept 0-9, a-z,  A-Z and _");
		return false;
	}
    var capSel = dojo.byId("roleCaps");

    for (var i = 0; i < capSel.options.length; i++) {
        capSel.options[i].selected = true;
    }

    var xhrArgs = {
        form: dojo.byId('addRoleForm'),
        handleAs: "text",
        load: function(data) {
            hideWaitingDlg();
            showInfo(data);
            navLink("listRole");
        },
        error: function(error) {
            hideWaitingDlg();
            showInfo(error);
        }
    }
    showWaitingDlg();
    var deferred = dojo.xhrPost(xhrArgs);
}

function submitUpdateRole() {
	if(!checkFormAllInput('updateRoleForm')){
		alert("Please Remove Illegal Character!");
		return false;
	}
	if (dojo.byId('updateRoleForm').rolename.value == "") {
		alert("Specify a name for the role");
		return false;
	}
	var capSel = dojo.byId("roleCaps");

	for (var i = 0; i < capSel.options.length; i++) {
		capSel.options[i].selected = true;
	}

	var xhrArgs = {
		form: dojo.byId('updateRoleForm'),
		handleAs: "text",
		load: function(data) {
			hideWaitingDlg();
			showInfo(data);
			navLink("listRole");
	},
		error: function(error) {
			hideWaitingDlg();
			showInfo(error);
		}
	}
	showWaitingDlg();
	var deferred = dojo.xhrPost(xhrArgs);
}


