/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* Restricted Materials of IBM                                            */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2011,2012          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* sccsid = "@(#) src/hpcc/webui/hpccloud/scripts/ScriptView.js, hpc.cloud.ui, hpcc_rbei, rbeis002a 1.4 1/4/12 05:48:44"; */

var scriptData;
var sortBname = 0;
var sortBflag = 0;
var sortBstatus = 0;

function showScript() 
{
    var xhrArgs = 
    {
        url: "GetInfoXML.cgi?function=listScriptXML",
        handleAs: "xml",
        preventCache: true,
        load: function(data) 
        {
            onScriptUpdate(data);
        },
        error: function(error) 
        {
            showInfo("An unexpected error occurred: " + error);
        }
    }
    var deferred = dojo.xhrGet(xhrArgs);
}

function onScriptUpdate(xmlDoc) {
    scriptData = parseScriptXML(xmlDoc);
    refreshScriptTab();
}

function refreshScriptTab() {
    var showremoved = dojo.byId('ScriptForm').showremoved.value;
    clearScriptTab();
    var theTable = document.getElementById("scriptListTab");
    for (var i=0; i < scriptData.scripts.length; ++i) 
    {
        if (showremoved == 0 && scriptData.scripts[i].status == "REMOVED") { continue; }
        var row = theTable.insertRow(theTable.rows.length);
        row.className = "tab_content";
        var cell1 = row.insertCell(0);
        if (scriptData.scripts[i].status != "REMOVED")
        {
			if (scriptData.scripts[i].check){  
            	cell1.innerHTML = "<input type=checkbox name=ScriptCheck value=" + scriptData.scripts[i].name + " checked>";
			}else{
            	cell1.innerHTML = "<input type=checkbox name=ScriptCheck value=" + scriptData.scripts[i].name + ">";
			}
        }
        var cell2 = row.insertCell(1);
        cell2.innerHTML = scriptData.scripts[i].name;
        var cell3 = row.insertCell(2);
        cell3.innerHTML = scriptData.scripts[i].flag;
        var cell5 = row.insertCell(3);
        cell5.innerHTML = scriptData.scripts[i].status;
        var cell6 = row.insertCell(4);
        cell6.innerHTML = scriptData.scripts[i].description;
    }
}

function parseScriptXML(xmlDoc) {
    var result = new Object();
    result.scripts = [];
    var items = xmlDoc.documentElement.getElementsByTagName('script');
    for(var n=0; n < items.length; n++) {
        var script = new Object();
        script.name = getElementDataFromNode(items[n], "name");
        script.flag = getElementDataFromNode(items[n], "flag");
        script.status = getElementDataFromNode(items[n], "status");
        script.description = getElementDataFromNode(items[n], "description");
		script.check = false;
        result.scripts.push(script);
    }
    return result;
}

function clearScriptTab() {
    var theTable = document.getElementById("scriptListTab");
    for(var i = (theTable.rows.length-1); theTable.rows.length > 2; i--) {
        theTable.deleteRow(i);
    }
}

function  keepcheckinfo(){
    // Keep the selected items.
	var form = dojo.byId("ScriptForm");
	var inputs = form.getElementsByTagName("input");
	var i,j;

	for(j = 0;j < scriptData.scripts.length;j++){
		scriptData.scripts[j].check = false;
		for(i=0;i<inputs.length;i++){
			if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].checked == true) {
				if (inputs[i].value == scriptData.scripts[j].name){
					scriptData.scripts[j].check = true;
				}	
			}
		}
	}
}	

function sortScriptTab(sortingBy) {
	keepcheckinfo();
    if (sortingBy == "name") {
        sortBname = 1 - sortBname;
        scriptData.scripts.sort(sortByName);
    } else if (sortingBy == "flag") {
        sortBflag = 1 - sortBflag;
        scriptData.scripts.sort(sortByFlag);
    } else if (sortingBy == "status") {
        sortBstatus= 1 - sortBstatus;
        scriptData.scripts.sort(sortByStatus);
    }

    refreshScriptTab();
}

function sortByName(a, b) {
    var x = a.name.toLowerCase();
    var y = b.name.toLowerCase();
    if(sortBname==1){
        return ((x < y) ? 1 : ((x > y) ? -1 : 0));
    } else {
    	return ((x < y) ? -1 : ((x > y) ? 1 : 0));
    }
}

function sortByFlag(a, b) {
    var x = a.flag.toLowerCase();
    var y = b.flag.toLowerCase();
    if(sortBflag==1){
        return ((x < y) ? 1 : ((x > y) ? -1 : 0));
    } else {
    	return ((x < y) ? -1 : ((x > y) ? 1 : 0));
    }
}

function sortByStatus(a, b) {
    var x = a.status.toLowerCase();
    var y = b.status.toLowerCase();
    if(sortBstatus==1){
        return ((x < y) ? 1 : ((x > y) ? -1 : 0));
    } else {
    	return ((x < y) ? -1 : ((x > y) ? 1 : 0));
    }
}

function submitAddScript() {
     if(dojo.byId('addScriptForm').script_path.value=="" && dojo.byId('addScriptForm').localS.value==""){
         alert("Specify a path.");
         return false;
     }
    if(dojo.byId('addScriptForm').flag_select.value==""){
        alert("Specify a flag.");
        return false;
    }
    if(dojo.byId('addScriptForm').description.value==""){
        alert("Specify a description.");
        return false;
    }	
    showWaitingDlg();
	dojo.io.iframe.send({
        form: 'addScriptForm',
        handleAs: "text",

        load: function(response, ioArgs) {
            hideWaitingDlg();
            showInfo(response);
            navLink('listImageScript');
            return response;
        }
    });
}

function submitApproveScript() {
	var select = false;
	var form = document.getElementById("ScriptForm");
	if (form) {
		var inputs = form.getElementsByTagName("input");
		for(var i=0;i<inputs.length;i++) {
			if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].getAttribute("name") == "ScriptCheck") {
				if (inputs[i].checked == true) {
					select = true;
					break;
				}
			}
		}
	} else {
		return;
	}

	if (!select) { alert("No script selected."); return; }
	if(!confirm("Do you want to approve these scripts?")) {
		return false;
	}

	dojo.byId("ScriptAction").value = "approveScript";
	var xhrArgs = {
		form: dojo.byId('ScriptForm'),
		handleAs: "text",
		load: function(data) {
			hideWaitingDlg();
			showInfo(data);
			dijit.byId('mainContent').refresh();
		},
		error: function(error) {
			hideWaitingDlg();
			showInfo(error);
			dijit.byId('mainContent').refresh();
		}
	}
	showWaitingDlg();
	var deferred = dojo.xhrPost(xhrArgs);
}

function submitDeleteScript() {
	var select = false;
	var theTable = dojo.byId("scriptListTab");
    var ckboxidx=-1;
    var statusidx=-1;
    for(var i=0; i< theTable.rows[1].cells.length; i++){
		if(theTable.rows[1].cells[i].innerHTML.indexOf("Select") >= 0){
			ckboxidx=i;
		}else if(theTable.rows[1].cells[i].innerHTML.indexOf("Status") >= 0){
			statusidx=i;
		}
	}
	if((ckboxidx < 0)||(statusidx < 0)){
		alert("Failed get checkbox or Status information");
		return;
	}
	for(var i=2; i < theTable.rows.length; i++){
		var inputs=theTable.rows[i].cells[ckboxidx].getElementsByTagName("input");
		if(inputs[0].checked == true){
			if(theTable.rows[i].cells[statusidx].innerHTML == "APPROVED"){
				var conResult = confirm("Script "+inputs[0].value+" may be used, are you sure to delete it?");
				if(!conResult){
					inputs[0].checked = false;
				}else{
					select = true;
				}
			}else{
				select = true;
			}
		}
	}
	if (!select) { alert("No Script selected."); return; }
    if(!confirm("Do you want to delete these scripts?")) {
        return false;
    }
    var xhrArgs = {
        form: dojo.byId('ScriptForm'),
        handleAs: "text",
        load: function(data) {
            hideWaitingDlg();
            showInfo(data);
            dijit.byId('mainContent').refresh();
        },
        error: function(error) {
            hideWaitingDlg();
            showInfo(error);
            dijit.byId('mainContent').refresh();
        }
    }
    showWaitingDlg();
    var deferred = dojo.xhrPost(xhrArgs);
}


