/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* Restricted Materials of IBM                                            */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2011,2012          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* sccsid = "@(#) src/hpcc/webui/hpccloud/scripts/SwitchView.js, hpc.cloud.ui, hpcc_rbei, rbeis002a 1.5 1/6/12 03:22:51";*/
var switchData;
var switchSortFlag = 0;

function showSwitch() 
{
    var xhrArgs = 
    {
        url: "GetInfoXML.cgi?function=listSwitchXML",
        handleAs: "xml",
        preventCache: true,
        load: function(data) 
        {
            onSwitchUpdate(data);
        },
        error: function(error) 
        {
            showInfo("An unexpected error occurred: " + error);
        }
    }
    var deferred = dojo.xhrGet(xhrArgs);
}

function onSwitchUpdate(xmlDoc) {
    switchData = parseSwitchXML(xmlDoc);
    refreshSwitchTab();
}

function refreshSwitchTab() {
    clearSwitchTab();
    var theTable = document.getElementById("switchListTab");
    for (var i=0; i < switchData.switchs.length; ++i) 
    {
		if(switchData.switchs[i].switchname == ""){
			continue;
		}
        var row = theTable.insertRow(theTable.rows.length);
        row.className = "tab_content";
        var cell1 = row.insertCell(0);
		if ( switchData.switchs[i].check ){
        	cell1.innerHTML = "<input type=checkbox name=SwitchCheck value=" + switchData.switchs[i].switchname + " checked>";
		}else{
        	cell1.innerHTML = "<input type=checkbox name=SwitchCheck value=" + switchData.switchs[i].switchname + ">";
		}
		var cell2 = row.insertCell(1);
        cell2.innerHTML = "<a href=\"javascript:navLink('listUser', '?function=updateSwitchForm&switchname=" + switchData.switchs[i].switchname + "')\">" + switchData.switchs[i].switchname + "</a>";
        var cell3 = row.insertCell(2);
				cell3.innerHTML = switchData.switchs[i].ipaddress;
				var cell5 = row.insertCell(3);
				cell5.innerHTML = switchData.switchs[i].portnumber;
				var cell6 = row.insertCell(4);
				cell6.innerHTML = switchData.switchs[i].comments;
    }
}

function parseSwitchXML(xmlDoc) {
    var result = new Object();
    result.switchs = [];
    var items = xmlDoc.documentElement.getElementsByTagName('switch');
    for(var n=0; n < items.length; n++) {
        var switchnode = new Object();
        switchnode.switchname = getElementDataFromNode(items[n], "switch_name");
        switchnode.ipaddress = getElementDataFromNode(items[n], "ipaddress");
				switchnode.portnumber = getElementDataFromNode(items[n], "port_number");
				switchnode.comments = getElementDataFromNode(items[n], "description");
		switchnode.check = false;		
        result.switchs.push(switchnode);
    }
    return result;
}

function clearSwitchTab() {
    var theTable = document.getElementById("switchListTab");
    for(var i = (theTable.rows.length-1); theTable.rows.length > 2; i--) {
        theTable.deleteRow(i);
    }
}

function keepcheckinfo(){
	// Keep the selected items.
	var form = dojo.byId("switchConfForm");
	var inputs = form.getElementsByTagName("input");
	var i,j;

	for(j = 0;j < switchData.switchs.length;j++){
		switchData.switchs[j].check = false;
		for(i=0;i<inputs.length;i++){
			if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].checked == true) {
				if (inputs[i].value == switchData.switchs[j].switchname){
					switchData.switchs[j].check = true;
				}
			}
		}
	}
}

function sortSwitchTab(sortingBy) {
	keepcheckinfo();
    if (sortingBy == "name") {
		switchSortFlag = 1- switchSortFlag;
        switchData.switchs.sort(sortBySwitchName);
    }
    refreshSwitchTab();
}

function sortBySwitchName(a, b) {
    var x = a.switchname.toLowerCase();
    var y = b.switchname.toLowerCase();
	if(switchSortFlag){
    return ((x < y) ? 1 : ((x > y) ? -1 : 0));
}
	else{
    	return ((x < y) ? -1 : ((x > y) ? 1 : 0));
	}
}

function submitUpdateSwitch()
{
		if(!checkFormAllInput('updateSwitchForm')){
		alert("Please Remove Illegal Character!");
		return false;
	}
    if(dojo.byId('updateSwitchForm').switchname.value==""){
        alert("Specify switch name.");
        return false;
    }
    if(dojo.byId('updateSwitchForm').ipaddress.value==""){
        alert("Specify the IP Address name.");
        return false;
    }
	if(!criticalcheckinput(dojo.byId('updateSwitchForm').switchname.value)){
		alert("User name only accept 0-9, a-z, A-Z and _");
		return false;
	}
	if((dojo.byId('updateSwitchForm').switchportnum.value != "") &&(!integercheck(dojo.byId('updateSwitchForm').switchportnum.value))){
		alert("Switchportnum only accept 0-9");
		return false;
	}
	if((dojo.byId('updateSwitchForm').snmpversion.value != "") &&(!criticalcheckinput(dojo.byId('updateSwitchForm').snmpversion.value))){
		alert("Snmpversion only accept 0-9, a-z, A-Z and _");
		return false;
	}
	if(!checkIP(dojo.byId('updateSwitchForm').ipaddress.value)){
		alert("IP Address format not correct.");
		return false;
	}
	 var xhrArgs = {
        form: dojo.byId('updateSwitchForm'),
        handleAs: "text",
        load: function(data) {
            hideWaitingDlg();
            showInfo(data);
            navLink("switchConfigInfo");
        },
        error: function(error) {
            hideWaitingDlg();
            showInfo(error);
        }
    }
    showWaitingDlg();
    var deferred = dojo.xhrPost(xhrArgs);
}

function submitAddSwitch() {
	if(!checkFormAllInput('addSwitchForm')){
		alert("Please Remove Illegal Character!");
		return false;
	}
	if(dojo.byId('addSwitchForm').switchname.value==""){
        alert("Specify switch name.");
        return false;
    }
    if(dojo.byId('addSwitchForm').ipaddress.value==""){
        alert("Specify the IP Address name.");
        return false;
    }
	if(!criticalcheckinput(dojo.byId('addSwitchForm').switchname.value)){
		alert("User name only accept 0-9, a-z, A-Z and _");
		return false;
	}
	if((dojo.byId('addSwitchForm').switchportnum.value != "") &&(!integercheck(dojo.byId('addSwitchForm').switchportnum.value))){
		alert("Switchportnum only accept 0-9");
		return false;
	}
	if((dojo.byId('addSwitchForm').snmpversion.value != "") &&(!criticalcheckinput(dojo.byId('addSwitchForm').snmpversion.value))){
		alert("Snmpversion only accept 0-9, a-z, A-Z and _");
		return false;
	}
	if(!checkIP(dojo.byId('addSwitchForm').ipaddress.value)){
		alert("IP Address format not correct.");
		return false;
	}
	
    
    var xhrArgs = {
        form: dojo.byId('addSwitchForm'),
        handleAs: "text",
        load: function(data) {
            hideWaitingDlg();
            showInfo(data);
            navLink("switchConfigInfo");
        },
        error: function(error) {
            hideWaitingDlg();
            showInfo(error);
        }
    }
    showWaitingDlg();
    var deferred = dojo.xhrPost(xhrArgs);
}
function submitDeleteSwitch()
{
	var select = false;
	var form = document.getElementById("switchConfForm");
	if (form) {
		var inputs = form.getElementsByTagName("input");
		for(var i=0;i<inputs.length;i++) {
			if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].getAttribute("name") == "SwitchCheck") {
				if (inputs[i].checked == true) {
					select = true;
					break;
				}
			}
		}
	} else {
		return;
	}
	if (!select) { alert("No Switch selected."); return; }
    if(!confirm("Do you want to delete these switchs?")) {
        return false;
    }
    var xhrArgs = {
        form: dojo.byId('switchConfForm'),
        handleAs: "text",
        load: function(data) {
            hideWaitingDlg();
            showInfoUser(data);
            dijit.byId('mainContent').refresh();
        },
        error: function(error) {
            hideWaitingDlg();
            showInfoUser(error);
            dijit.byId('mainContent').refresh();
        }
    }
    showWaitingDlg();
    var deferred = dojo.xhrPost(xhrArgs);
}


