/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* Restricted Materials of IBM                                            */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2010,2012          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* sccsid = "@(#) src/hpcc/webui/hpccloud/scripts/UserGroupView.js, hpc.cloud.ui, hpcc_rbei, rbeis002a 1.4 1/4/12 05:48:23"; */

var groupData;
var sortGbOFlag=0;
var sortGbMFlag=0;

function showUserGroups() {
    var xhrArgs = {
        url: "GetInfoXML.cgi?function=listGroupXML",
        handleAs: "xml",
        preventCache: true,
        load: function(data) {
            onGroupUpdate(data);
        },
        error: function(error) {
            showInfo("An unexpected error occurred: " + error);
        }
    }

    //Call the asynchronous xhrGet
    var deferred = dojo.xhrGet(xhrArgs);
}

function onGroupUpdate(xmlDoc) {
    groupData = parseGroupXML(xmlDoc);
    refreshGroupTab();
}

function refreshGroupTab() {
    clearGroupTab();
    var theTable = document.getElementById("grouplistTab");
    for (var i=0; i < groupData.groups.length; ++i) {
        var row = theTable.insertRow(theTable.rows.length);
        row.className = "tab_content";
        var cell1 = row.insertCell(0);
		if (groupData.groups[i].check) { 
        	cell1.innerHTML = "<input type=checkbox name=groupID value=" + groupData.groups[i].name + " checked>";
		}else{	
        	cell1.innerHTML = "<input type=checkbox name=groupID value=" + groupData.groups[i].name + ">";
			}
        var cell2 = row.insertCell(1);
        cell2.innerHTML = "<a href='javascript:navLink(\"listGroup\", \"?function=updateGroupForm&gname=" + groupData.groups[i].name + "\");'>" + groupData.groups[i].name + "</a>";
        var cell3 = row.insertCell(2);
        cell3.innerHTML = groupData.groups[i].owner;
        var cell4 = row.insertCell(3);
        cell4.innerHTML = groupData.groups[i].users;
        var cell5 = row.insertCell(4);
		cell5.innerHTML = groupData.groups[i].desc;
    }
}

function parseGroupXML(xmlDoc) {
    var result = new Object();
    result.groups = [];
    var items = xmlDoc.documentElement.getElementsByTagName('result');
    for(var n=0; n < items.length; n++) {
        var group = new Object();
        group.name = getElementDataFromNode(items[n], "group_name");
        group.owner = getElementDataFromNode(items[n], "owner");
        group.users = getElementDataFromNode(items[n], "user_name", true).join(',');
		group.desc = getElementDataFromNode(items[n], "user_group.description");
		group.check = false;
        result.groups.push(group);
    }

    return result;
}

function clearGroupTab() {
    var theTable = document.getElementById("grouplistTab");
    for(var i = (theTable.rows.length-1); theTable.rows.length > 2; i--) {
        theTable.deleteRow(i);
    }
}

function keepcheckinfo(){
	// Keep the selected items.
	var form = dojo.byId("groupForm");
	var inputs = form.getElementsByTagName("input");
	var i,j;

	for(j = 0;j < groupData.groups.length;j++){
		groupData.groups[j].check = false;
		for(i=0;i<inputs.length;i++){
			if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].checked == true) {
				if (inputs[i].value == groupData.groups[j].name){
					groupData.groups[j].check = true;
				}
			}
		}
	}
}

function sortGroupTab(sortingBy) {
	keepcheckinfo();
    if (sortingBy == "name") {
		sortGbMFlag =1-sortGbMFlag;
        groupData.groups.sort(sortByGroupName);

    } else if (sortingBy == "owner") {
		sortGbOFlag = 1- sortGbOFlag;
        groupData.groups.sort(sortByGroupOwner);
    }
    refreshGroupTab();
}

function sortByGroupName(a, b) {
    var x = a.name.toLowerCase();
    var y = b.name.toLowerCase();
	if(sortGbMFlag ==1){
	    return ((x < y) ? 1 : ((x > y) ? -1 : 0));}
	else{
		return ((x < y) ? -1 : ((x > y) ? 1 : 0));}
}

function sortByGroupOwner(a, b) {
    var x = a.owner.toLowerCase();
    var y = b.owner.toLowerCase();
	if(sortGbOFlag ==1){
	    return ((x < y) ? 1 : ((x > y) ? -1 : 0));}
	else{
		return ((x < y) ? -1 : ((x > y) ? 1 : 0));}
}

