/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* Restricted Materials of IBM                                            */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2010,2012          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* sccsid = "@(#) src/hpcc/webui/hpccloud/scripts/UserView.js, hpc.cloud.ui, hpcc_rbei, rbeis002a 1.11 1/4/12 05:48:25"; */

var userData;
var userSortFlag = 0;

function showUsers() {
    var xhrArgs = {
        url: "GetInfoXML.cgi?function=listUserXML",
        handleAs: "xml",
        preventCache: true,
        load: function(data) {
            onUserUpdate(data);
        },
        error: function(error) {
            showInfo("An unexpected error occurred: " + error);
        }
    }

    //Call the asynchronous xhrGet
    var deferred = dojo.xhrGet(xhrArgs);
}

function onUserUpdate(xmlDoc) {
    userData = parseUserXML(xmlDoc);
    refreshUserTab();
}

function refreshUserTab() {
    clearUserTab();
    var theTable = document.getElementById("userlistTab");
    for (var i=0; i < userData.users.length; ++i) {
        var row = theTable.insertRow(theTable.rows.length);
        row.className = "tab_content";
        var cell1 = row.insertCell(0);
        var cell2 = row.insertCell(1);
        if (userData.users[i].name != "default") {
            if (userData.users[i].name != "cloudadm") {
				if (userData.users[i].check ){
                	cell1.innerHTML = "<input type=checkbox name=userID value=" + userData.users[i].name + " checked>";
				}else{
                	cell1.innerHTML = "<input type=checkbox name=userID value=" + userData.users[i].name + ">";
				}
            }
            cell2.innerHTML = "<a href=\"javascript:navLink('listUser', '?function=updateUserForm&uname=" + userData.users[i].name + "')\">" + userData.users[i].name + "</a>";
        } else {
            cell2.innerHTML = userData.users[i].name;
        }
        var cell3 = row.insertCell(2);
		cell3.innerHTML = userData.users[i].role;
		var cell5 = row.insertCell(3);
		cell5.innerHTML = userData.users[i].firstname;
		var cell6 = row.insertCell(4);
		cell6.innerHTML = userData.users[i].lastname;
		var cell7 = row.insertCell(5);
		cell7.innerHTML = userData.users[i].email;
		var cell8 = row.insertCell(6);
		cell8.innerHTML = userData.users[i].phone;
		var cell9 = row.insertCell(7);
		cell9.innerHTML = userData.users[i].dep;
		var cell10 = row.insertCell(8);
		cell10.innerHTML = userData.users[i].org;
		var cell11 = row.insertCell(9);
		cell11.innerHTML = userData.users[i].groups;
		var cell_balance = row.insertCell(10);
		cell_balance.innerHTML = userData.users[i].balance/100;
		var cell_shell= row.insertCell(11);
		cell_shell.innerHTML = userData.users[i].shell;
		var cell12 = row.insertCell(12);
		cell12.innerHTML = userData.users[i].comments
    }
}

function parseUserXML(xmlDoc) {
    var result = new Object();
    result.users = [];
    var items = xmlDoc.documentElement.getElementsByTagName('user');
    for(var n=0; n < items.length; n++) {
        var user = new Object();
        user.id = getElementDataFromNode(items[n], "user.id");
        user.name = getElementDataFromNode(items[n], "user_name");
		user.uid = getElementDataFromNode(items[n], "user.uid");
        user.role = getElementDataFromNode(items[n], "user.role");
		user.firstname = getElementDataFromNode(items[n], "FN");
		user.lastname = getElementDataFromNode(items[n], "LN");
		user.email = getElementDataFromNode(items[n], "user.email");
		user.phone = getElementDataFromNode(items[n], "user.phone");
		user.dep = getElementDataFromNode(items[n], "department");
		user.org = getElementDataFromNode(items[n], "user.organization");
        user.groups = getElementDataFromNode(items[n], "group.name", true).join(',');
        user.balance= getElementDataFromNode(items[n], "balance");
        user.shell= getElementDataFromNode(items[n], "shell");
        user.comments = getElementDataFromNode(items[n], "comments");
		user.check = false;
        result.users.push(user);
    }

    return result;
}

function clearUserTab() {
    var theTable = document.getElementById("userlistTab");
    for(var i = (theTable.rows.length-1); theTable.rows.length > 2; i--) {
        theTable.deleteRow(i);
    }
}

function keepcheckinfo(){
	// Keep the selected items.
	var form = dojo.byId("userForm");
	var inputs = form.getElementsByTagName("input");
	var i,j;

	for(j = 0;j < userData.users.length;j++){
		userData.users[j].check = false;
		for(i=0;i<inputs.length;i++){
			if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].checked == true) {
				if (inputs[i].value == userData.users[j].name){
					userData.users[j].check = true;
				}
			}
		}
	}
}

function sortUserTab(sortingBy) {
	keepcheckinfo();
    if (sortingBy == "name") {
		userSortFlag = 1- userSortFlag;
        userData.users.sort(sortByUserName);
    }
    refreshUserTab();
}

function sortByUserName(a, b) {
    var x = a.name.toLowerCase();
    var y = b.name.toLowerCase();
	if(userSortFlag){
    return ((x < y) ? 1 : ((x > y) ? -1 : 0));
}
	else{
    	return ((x < y) ? -1 : ((x > y) ? 1 : 0));
	}
}

function submitUpdateUser() {
	if(dojo.byId('updateUserForm').oldpasswd)
	{
		if((dojo.byId('updateUserForm').oldpasswd.value!="")&&
			(dojo.byId('updateUserForm').newpasswd.value!="")&&
			(dojo.byId('updateUserForm').rePasswd.value!=""))
		{
			if(dojo.byId('updateUserForm').newpasswd.value!=dojo.byId('updateUserForm').rePasswd.value)
			{
				alert("New Password and Repeat Password do not match.");
				return false;
			}
		}
		else{
			if((dojo.byId('updateUserForm').oldpasswd.value!="")||
				(dojo.byId('updateUserForm').newpasswd.value!="")||
				(dojo.byId('updateUserForm').rePasswd.value!="")){
				alert("You must fill Old Password, New Password and Repeat Password at same time to change password.");
				return false;
			}
		}
	}
	if(dojo.byId('updateUserForm').Recharge.value == ""){
		dojo.byId('updateUserForm').Recharge.value = 0;
	}else{
		if(!decimalcheck(dojo.byId('updateUserForm').Recharge.value)){
			alert("Only accept decimal in Recharge field!");
			return false;
		}
	}
	if(!checkFormAllInput('updateUserForm')){
			alert("Please Remove Illegal Character!");
			return false;
	}
    var xhrArgs = {
        form: dojo.byId('updateUserForm'),
        handleAs: "text",
        load: function(data) {
            hideWaitingDlg();
            showInfo(data);
            navLink("listUser");
        },
        error: function(error) {
            hideWaitingDlg();
            showInfo(error);
        }
    }
    showWaitingDlg();
    var deferred = dojo.xhrPost(xhrArgs);
}


function resetpwdcontrol(){
	var select = false;
  var form = document.getElementById("userForm");
  if (form) {
      var inputs = form.getElementsByTagName("input");
      for(var i=0;i<inputs.length;i++) {
          if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].getAttribute("name") == "userID") {
              if (inputs[i].checked == true) {
                  select = true;
                  break;
              }
          }
      }
  } else {
      return;
  }
  if (!select) { alert("No User selected."); return; }
  
  dijit.byId('resetpwdDialog').show();
}

function checkresetpwd(){
	var pwd1 = document.getElementById("resetpwd1");
	var pwd2 = document.getElementById("resetpwd2");
	if ((pwd1.value !="") &&(pwd2.value !="")){
		if (pwd1.value != pwd2.value) {
			alert("New Password and Repeat Password do not match.");
			return false;
		}
	}else {
		alert("Please fill the New Password and Repeat Password at same time to change the password.");
		return false;
	}
	document.getElementById('usr_resetpwd').value = pwd2.value;
	//keep the original function value for future use;
	var tempfunctionname = document.getElementById("usr_functioncntl").value;
	document.getElementById("usr_functioncntl").value='resetUser';
	dijit.byId('resetpwdDialog').hide();
	
	  var xhrArgs = {
      form: dojo.byId('userForm'),
      handleAs: "text",
      load: function(data) {
          hideWaitingDlg();
          showInfoUser(data);
          dijit.byId('mainContent').refresh();
      },
      error: function(error) {
          hideWaitingDlg();
          showInfoUser(error);
          dijit.byId('mainContent').refresh();
      }
  }
  showWaitingDlg();
  var deferred = dojo.xhrPost(xhrArgs);
  //document.getElementById("usr_functioncntl").value='deleteUser';
  //recover the original value of the function.
  document.getElementById("usr_functioncntl").value=tempfunctionname;
  pwd1.value = "";
  pwd2.value = "";	
}