/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* Restricted Materials of IBM                                            */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2011,2012          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* sccsid = "@(#) src/hpcc/webui/hpccloud/scripts/VlanView.js, hpc.cloud.ui, hpcc_rbei, rbeis002a 1.6 1/6/12 03:22:54";*/
var vlanData;
var vlanSortFlag = 0;

function showVlan() 
{
    var xhrArgs = 
    {
        url: "GetInfoXML.cgi?function=listVlanXML",
        handleAs: "xml",
        preventCache: true,
        load: function(data) 
        {
            onVlanUpdate(data);
        },
        error: function(error) 
        {
            showInfo("An unexpected error occurred: " + error);
        }
    }
    var deferred = dojo.xhrGet(xhrArgs);
}

function onVlanUpdate(xmlDoc) {
    vlanData = parseVlanXML(xmlDoc);
    refreshVlanTab();
}

function refreshVlanTab() {
    clearVlanTab();
    var theTable = document.getElementById("vlanListTab");
    for (var i=0; i < vlanData.vlans.length; ++i) 
    {
		if(vlanData.vlans[i].nodename == ""){
			continue;
		}
        var row = theTable.insertRow(theTable.rows.length);
        row.className = "tab_content";
        var cell1 = row.insertCell(0);
		if ( vlanData.vlans[i].check ){  
        	cell1.innerHTML = "<input type=checkbox name=VlanCheck value=" + vlanData.vlans[i].nodename + " checked>";
		}else{
        	cell1.innerHTML = "<input type=checkbox name=VlanCheck value=" + vlanData.vlans[i].nodename + ">";
		}
        //cell1.innerHTML = "<tr>success</tr>";
        var cell2 = row.insertCell(1);
        cell2.innerHTML = "<a href=\"javascript:navLink('listUser', '?function=updateVlanForm&nodename=" + vlanData.vlans[i].nodename + "')\">" + vlanData.vlans[i].nodename + "</a>";
        //vlanData.vlans[i].nodename;
        var cell3 = row.insertCell(2);
				cell3.innerHTML = vlanData.vlans[i].switchname;
				var cell5 = row.insertCell(3);
				cell5.innerHTML = vlanData.vlans[i].bandwidth;
				var cell6 = row.insertCell(4);
				cell6.innerHTML = vlanData.vlans[i].portid;
				var cell7 = row.insertCell(5);
				cell7.innerHTML = vlanData.vlans[i].vlanid;
				var cell8 = row.insertCell(6);
				cell8.innerHTML = vlanData.vlans[i].comments;
    }
}

function parseVlanXML(xmlDoc) {
    var result = new Object();
    result.vlans = [];
    var items = xmlDoc.documentElement.getElementsByTagName('node');
    for(var n=0; n < items.length; n++) {
        var vlan = new Object();
       // vlan.id = getElementDataFromNode(items[n], "id");
        vlan.nodename = getElementDataFromNode(items[n], "node_name");
				vlan.switchname = getElementDataFromNode(items[n], "switch_name");
        vlan.bandwidth = getElementDataFromNode(items[n], "bandwidth");
				vlan.portid = getElementDataFromNode(items[n], "port_id");
				vlan.vlanid = getElementDataFromNode(items[n], "vlanId");
				vlan.comments = getElementDataFromNode(items[n], "description");
		vlan.check = false;
        result.vlans.push(vlan);
    }
    return result;
}

function clearVlanTab() {
    var theTable = document.getElementById("vlanListTab");
    for(var i = (theTable.rows.length-1); theTable.rows.length > 2; i--) {
        theTable.deleteRow(i);
    }
}

function keepcheckinfo(){
	// Keep the selected items.
	var form = dojo.byId("vlanConfForm");
	var inputs = form.getElementsByTagName("input");
	var i,j;
		
	for(j = 0;j < vlanData.vlans.length;j++){
		vlanData.vlans[j].check = false;
		for(i=0;i<inputs.length;i++){
			if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].checked == true) {
				if (inputs[i].value == vlanData.vlans[j].nodename){
					vlanData.vlans[j].check = true;
				}	
			}
		}
	}
}

function sortVlanTab(sortingBy) {
	keepcheckinfo();
    if (sortingBy == "name") {
		vlanSortFlag = 1- vlanSortFlag;
        vlanData.vlans.sort(sortByVlanName);
    }
    refreshVlanTab();
}

function sortByVlanName(a, b) {
    var x = a.nodename.toLowerCase();
    var y = b.nodename.toLowerCase();
	if(vlanSortFlag){
    return ((x < y) ? 1 : ((x > y) ? -1 : 0));
}
	else{
    	return ((x < y) ? -1 : ((x > y) ? 1 : 0));
	}
}
function submitUpdateVlan()
{
	if(!checkFormAllInput('updateVlanForm')){
		alert("Please Remove Illegal Character!");
		return false;
	}
	if(dojo.byId('updateVlanForm').nodename.value==""){
        alert("Specify a node name.");
        return false;
    }
	if(dojo.byId('updateVlanForm').swithselect.value==""){
        alert("Specify a switch name.");
        return false;
    }
	if(dojo.byId('updateVlanForm').portid.value==""){
        alert("Specify a port ID.");
        return false;
    }
	if(!criticalcheckinput(dojo.byId('updateVlanForm').nodename.value)){
		alert("Node name only accept 0-9, a-z, A-Z and _");
		return false;
	}
	if(!criticalcheckinput(dojo.byId('updateVlanForm').swithselect.value)){
		alert("Switch name only accept 0-9, a-z, A-Z and _");
		return false;
	}
	if((dojo.byId('updateVlanForm').bandwidth.value != "") && (!integercheck(dojo.byId('updateVlanForm').bandwidth.value))){
		alert("Bandwidth only accept 0-9");
		return false;
	}
	if(!integercheck(dojo.byId('updateVlanForm').portid.value)){
		alert("Port ID only accept 0-9");
		return false;
	}
	
	 var xhrArgs = {
        form: dojo.byId('updateVlanForm'),
        handleAs: "text",
        load: function(data) {
            hideWaitingDlg();
            showInfo(data);
            navLink("vlanConfigInfo");
        },
        error: function(error) {
            hideWaitingDlg();
            showInfo(error);
        }
    }
    showWaitingDlg();
    var deferred = dojo.xhrPost(xhrArgs);
}
function submitAddVlan() {
	if(!checkFormAllInput('addVlanForm')){
		alert("Please Remove Illegal Character!");
		return false;
	}
    if(dojo.byId('addVlanForm').nodename.value==""){
        alert("Specify a node name.");
        return false;
    }
	if(dojo.byId('addVlanForm').swithselect.value=="none"){
        alert("Specify a switch name.");
        return false;
    }
	if(dojo.byId('addVlanForm').portid.value==""){
        alert("Specify a port ID.");
        return false;
    }
	if(!criticalcheckinput(dojo.byId('addVlanForm').nodename.value)){
		alert("Node name only accept 0-9, a-z, A-Z and _");
		return false;
	}
	/*
	if(!criticalcheckinput(dojo.byId('addVlanForm').switchname.value)){
		alert("Switch name only accept 0-9, a-z, A-Z and _");
		return false;
	}
	*/
	if((dojo.byId('addVlanForm').bandwidth.value != "") && (!integercheck(dojo.byId('addVlanForm').bandwidth.value))){
		alert("Bandwidth only accept 0-9");
		return false;
	}
	if(!integercheck(dojo.byId('addVlanForm').portid.value)){
		alert("Port ID only accept 0-9");
		return false;
	}
    var xhrArgs = {
        form: dojo.byId('addVlanForm'),
        handleAs: "text",
        load: function(data) {
            hideWaitingDlg();
            showInfo(data);
            navLink("vlanConfigInfo");
        },
        error: function(error) {
            hideWaitingDlg();
            showInfo(error);
        }
    }
    showWaitingDlg();
    var deferred = dojo.xhrPost(xhrArgs);
}
function submitDeleteVlan()
{
	var select = false;
	var form = document.getElementById("vlanConfForm");
	if (form) {
		var inputs = form.getElementsByTagName("input");
		for(var i=0;i<inputs.length;i++) {
			if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].getAttribute("name") == "VlanCheck") {
				if (inputs[i].checked == true) {
					select = true;
					break;
				}
			}
		}
	} else {
		return;
	}
	if (!select) { alert("No Vlan selected."); return; }
    if(!confirm("Do you want to delete these vlans?")) {
        return false;
    }
    var xhrArgs = {
        form: dojo.byId('vlanConfForm'),
        handleAs: "text",
        load: function(data) {
            hideWaitingDlg();
            showInfoUser(data);
            dijit.byId('mainContent').refresh();
        },
        error: function(error) {
            hideWaitingDlg();
            showInfoUser(error);
            dijit.byId('mainContent').refresh();
        }
    }
    showWaitingDlg();
    var deferred = dojo.xhrPost(xhrArgs);
}
