/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* Restricted Materials of IBM                                            */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2010,2011          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* sccsid = "@(#) src/hpcc/webui/hpccloud/scripts/machAction.js, hpc.cloud.ui, hpcc_rbei, rbeis002a 1.6 12/13/11 01:12:34"; */

var timerID;
var machStatusXhrArgs = {
    url: "portal.cgi?function=machStatus",
    handleAs: "text",
    preventCache: true,
    load: function(data) {
        onMachDataUpdate(data);
    },
    error: function(error) {
        //showInfo("An unexpected error occurred: " + error);
    }
}

function machPower(formID, menuID) {
    var action;
    if (!menuID) action = dojo.byId('machPowerMenu');
    else action = dojo.byId(menuID);
    if (action) {
        if (action.value == "powerOn" || action.value == "powerOff" || action.value == "powerReset") {
            prefix = "pst_";
        } else {
            alert("No power action selected.");
            return;
        }
    } 

    var select = false;
    var form = dojo.byId(formID);
    if (form) {
        form.function.value = "setMachPower";
        var inputs = form.getElementsByTagName("input");
        for(var i=0;i<inputs.length;i++) {
            if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].getAttribute("name") == "machName") {
                if (inputs[i].checked == true) {
                    select = true
                    var tds = document.getElementsByName(prefix+inputs[i].value);
                    for (var j=0; j<tds.length; j++) {
                        tds[j].innerHTML = "<img src=\"/hpccloud/images/loader.gif\">";
                    }
                }
            }
        }
    } else {
        return;
    }
    if (!select) { alert("No machine selected."); return; }
    if(!checkFormAllInput(formID)){
        alert("Please Remove Illegal Character!");
        return false;
    }
    var xhrArgs = {
        form: dojo.byId(formID),
        handleAs: "text",
        load: function(data) {
        },
        error: function(error) {
            showInfo(error);
        }
    }
    var deferred = dojo.xhrPost(xhrArgs);

    for(var i=0;i<inputs.length;i++) {
        if(inputs[i].getAttribute("type") == "checkbox" ) {
            inputs[i].checked = false; 
        }
    }

    setTimeout("onMachTimer()", 20000);
}

function machEScheme(formID, menuID) {
    if (!menuID) action = dojo.byId('machEScheme');
    else action = dojo.byId(menuID);
    if (action) {
        if (action.value != "none") {
            prefix = "psav_";
        } else {
            alert("No energy scheme selected.");
            return;
        }
    } 

    var select = false;
    var form = dojo.byId(formID);
    if (form) {
        form.function.value = "applyEScheme";
        var inputs = form.getElementsByTagName("input");
        for(var i=0;i<inputs.length;i++) {
            if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].getAttribute("name") == "machName") {
                if (inputs[i].checked == true) {
                    select = true
                    var tds = document.getElementsByName(prefix+inputs[i].value);
                    for (var j=0; j<tds.length; j++) {
                        tds[j].innerHTML = "<img src=\"/hpccloud/images/loader.gif\">";
                    }
                }
            }
        }
    } else {
        return;
    }
    if (!select) { alert("No machine selected."); return; }
    if(!checkFormAllInput(formID)){
        alert("Please Remove Illegal Character!");
        return false;
    }
    var xhrArgs = {
        form: dojo.byId(formID),
        handleAs: "text",
        load: function(data) {
        },
        error: function(error) {
            showInfo(error);
        }
    }
    var deferred = dojo.xhrPost(xhrArgs);

    for(var i=0;i<inputs.length;i++) {
        if(inputs[i].getAttribute("type") == "checkbox" ) {
            inputs[i].checked = false; 
        }
    }

    setTimeout("onMachTimer()", 10000);
}

function onMachTimer() {
    var deferred = dojo.xhrGet(machStatusXhrArgs);
}

function onMachDataUpdate(data) {
    var machs = data.split("|");
    for(var i=0; i < machs.length; i++) {
        var kv = machs[i].split(":");
        var tds = document.getElementsByName("pst_"+kv[0]);
        for (var j=0; j<tds.length; j++) {
            tds[j].innerHTML = kv[1];
        }
        var tds = document.getElementsByName("psav_"+kv[0]);
        for (var j=0; j<tds.length; j++) {
            tds[j].innerHTML = kv[2];
        }
        var tds = document.getElementsByName("st_"+kv[0]);
        for (var j=0; j<tds.length; j++) {
            tds[j].innerHTML = kv[3];
        }
    }
}

function refreshMachStatus() {
    onMachTimer();
}
