/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* Restricted Materials of IBM                                            */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2010,2011          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* sccsid = "@(#) src/hpcc/webui/hpccloud/scripts/multiUpload.js, hpc.cloud.ui, hpcc_rbei, rbeis001a 1.2 12/31/10 03:47:21"; */

var uid;

function MultiSelector( listDiv, max ){
    this.listDiv = listDiv;
    this.count = 0;
    if( max ) {
        this.max = max;
    } else {
        this.max = -1;
    };

    this.addFileInput = function(fInput) {
        fInput.name = 'localFile';
        fInput.multiSelector = this;
        fInput.onchange = function() {
            var newFInput = document.createElement('input');
            newFInput.type = 'file';
            
            this.parentNode.appendChild(newFInput, this);
            this.multiSelector.addFileInput(newFInput);
            this.multiSelector.addFileToList(this);
            
            // Hide used file input
            this.style.position = 'absolute';
            this.style.left = '-1000px';

	};
	if( this.max != -1 && this.count >= this.max ){
	    fInput.disabled = true;
	};

	this.count++;
	this.curFile = fInput;
    };

    this.addFileToList = function(file) {
        var newRow = document.createElement('div');
        newRow.className = "flist_row";
        var cancel = document.createElement('a');
        cancel.href='#';
        cancel.title='Cancel';
        cancel.id = "file_" + file.value;
        cancel.name = "file_status";
        var img = document.createElement('img');
        img.src = '/hpccloud/images/red_cross.gif';
        cancel.appendChild(img); 
        
        newRow.file = file;
        file.cancelLink = cancel;
        
        cancel.onclick= function() {
            this.parentNode.file.parentNode.removeChild(this.parentNode.file);
            this.parentNode.parentNode.removeChild(this.parentNode);
            this.parentNode.file.multiSelector.count--;
        
            this.parentNode.file.multiSelector.curFile.disabled = false;
            return false;
        };
    
        newRow.appendChild(cancel);
        var fi = document.createElement('img');
        fi.src = '/hpccloud/images/file.gif';
        newRow.appendChild(fi);
        var fd = document.createElement('div');
        fd.innerHTML += file.value;
        newRow.appendChild(fd);
        //newRow.innerHTML += "<img src=\"/hpccloud/images/file.gif\">" + file.value;;
        this.listDiv.appendChild( newRow );
    };
};

function do_upload() {
    if (multiSelector.count <= 1 ) {
        alert("Select files to upload");
        return false;
    }
    multiSelector.curFile.disabled = true;
    //document.getElementById("uploadButton").disabled = true;
    dijit.byId("uploadButton").attr('disabled', true);
    dijit.byId("resetButton").attr('disabled', true);
    //document.getElementById("resetButton").disabled = true;

    //showDlg('uploadstatus', 400, 40);

    uploadNext();
}

function uploadNext() {
    var fileform = document.getElementById("FileForm");
    fileform.uploadingFile = null;
    var nextFile = document.getElementsByName("localFile")[0];
    if (nextFile && nextFile.value != "" && nextFile.disabled == false) {
        fileform.appendChild(nextFile);
        if (nextFile.cancelLink) {
            nextFile.cancelLink.innerHTML = "<img src=\"/hpccloud/images/loader.gif\">";
            nextFile.cancelLink.onclick = stopUpload;
            nextFile.cancelLink.title = "Uploading...Click to stop";
        }
        fileform.uploadingFile = nextFile;
        fileform.submit();
    } else {
        multiSelector.count = 1;
    
        multiSelector.curFile.disabled = false;
        //document.getElementById("uploadButton").disabled = false;
        //document.getElementById("resetButton").disabled = false;
        dijit.byId("uploadButton").attr('disabled', false);
        dijit.byId("resetButton").attr('disabled', false);
    }
}

function upload_done(res) {
    //closeDlg('uploadstatus');
    var fileform = document.getElementById("FileForm");
    var curFile = fileform.uploadingFile;
    if (curFile && curFile.cancelLink) {
        if (res == 0) {
            curFile.cancelLink.innerHTML = "<img src=\"/hpccloud/images/tick.png\">";
            curFile.cancelLink.title = "Uploaded successfully";
        } else {
            curFile.cancelLink.innerHTML = "<img src=\"/hpccloud/images/red_cross.gif\">";
            curFile.cancelLink.title = "Failed to upload";
        }
        curFile.cancelLink.parentNode.className = "flist_row_done";
        curFile.cancelLink.onclick = function() { return false;};
    }
    if (curFile) fileform.removeChild(curFile);
    fileform.uploadingFile = null;
    setTimeout("uploadNext()", 500);
}

function stopUpload() {
    if (!document.all) {
        window.stop();
    } else {
        window.document.execCommand('Stop');
    }
    var fileform = document.getElementById("FileForm");
    var curFile = fileform.uploadingFile;
    if (curFile && curFile.cancelLink) {
        curFile.cancelLink.innerHTML = "<img src=\"/hpccloud/images/red_cross.gif\">";
        curFile.cancelLink.title = "Stopped";
        curFile.cancelLink.parentNode.className = "flist_row_done";
        curFile.cancelLink.onclick = function() { return false;};
    }
    if (curFile) fileform.removeChild(curFile);
    fileform.uploadingFile = null;
    setTimeout("uploadNext()", 500);
    return false;
}

function reset_form() {
    var fileform = document.getElementById("FileForm");
    fileform.reset();
    multiSelector.curFile.disabled = false;
    multiSelector.curFile.value = "";

    var file = document.getElementsByName("localFile")[0];
    while (file && file != multiSelector.curFile) {
        file.parentNode.removeChild(file);
        file = document.getElementsByName("localFile")[0];
    }
    
    var status_spot = document.getElementsByName("file_status")[0];
    while (status_spot) {
        var div = status_spot.parentNode;
        div.parentNode.removeChild(div);
        status_spot = document.getElementsByName("file_status")[0];
    }
}

