/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* Restricted Materials of IBM                                            */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2010,2012          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* sccsid = "@(#) src/hpcc/webui/hpccloud/scripts/utils.js, hpc.cloud.ui, hpcc_rbei, rbeis002a 1.42 1/31/12 06:18:45"; */

var legal_patt = new RegExp(/^[0-9a-zA-Z@\+\-_\. \/]*$/);

function navLink(link, url) {
	var u = (url && link != url) ? url : ("portal.cgi?function=" + link);
	dijit.byId("mainContent").setHref(u);
	selectTreeNodeByLink(navTree, link);
}

function recursiveHunt(lookfor, model, buildme, item) {
	var id = model.getIdentity(item);
	buildme.push(id);
	if (id == lookfor) {
		if (navTree._selectedNode) dojo.removeClass(navTree._selectedNode.rowNode, "lotusSelected");
		var node = navTree._itemNodesMap[item.id[0]];
		navTree._selectedNode = node[0];
		dojo.addClass(navTree._selectedNode.rowNode, "lotusSelected");
		return buildme;
	}
	for (var idx in item.children) {
		var buildmebranch = buildme.slice(0);
		var r = recursiveHunt(lookfor, model, buildmebranch, item.children[idx]);
		if (r) {
			return r;
		}
	}
	return undefined;
}

function selectTreeNodeByLink(tree, lookfor) {
	var buildme = new Array();
	var result = recursiveHunt(lookfor, tree.model, buildme, tree.model.root);
	if (result && result.length > 0) {
		tree.attr('path', result);
	}
}

function active() {
	var isDurActive = -1;
	var endDate = document.getElementById("end_mon|end_day|end_year");
	var endHour = document.getElementById("end_hour");
	var endMin = document.getElementById("end_min");
	var dur = document.getElementById("duration");
	var calImg = document.getElementById("calImgE");
	var durRadio = document.getElementsByName("durActive");
	for(var i=0; i < durRadio.length; i++) {
		if (durRadio[i].checked && !durRadio[i].disabled) { isDurActive = durRadio[i].value; }
	}

	if (isDurActive == 1) {
		dur.disabled = false;
		endDate.disabled = true;
		endHour.disabled = true;
		endMin.disabled = true;
		calImg.style.visibility = "hidden";
	} else if (isDurActive == 0){
		dur.disabled = true;
		endDate.disabled = false;
		endHour.disabled = false;
		endMin.disabled = false;
		calImg.style.visibility = "visible";
	}
}

function activeAll() {
	var endDate = document.getElementById("end_mon|end_day|end_year");
	var endHour = document.getElementById("end_hour");
	var endMin = document.getElementById("end_min");
	var dur = document.getElementById("duration");

	endDate.disabled = false;
	endHour.disabled = false;
	endMin.disabled = false;
	dur.disabled = false;
}

function submitReqForm() {
	var form = dojo.byId("reqForm");

	var userSel = dojo.byId("allowedUsers");
	var grpSel = dojo.byId("allowedGrps");

	for (var i = 0; i < userSel.options.length; i++) {
		userSel.options[i].selected = true;
	}
	for (var i = 0; i < grpSel.options.length; i++) {
		grpSel.options[i].selected = true;
	}

	var xhrArgs = {
		form: form,
		handleAs: "text",
		load: function(data) {
			var userSel = dojo.byId("allowedUsers");
			var grpSel = dojo.byId("allowedGrps");
			for (var i = 0; i < userSel.options.length; i++) {
				userSel.options[i].selected = false;
			}
			for (var i = 0; i < grpSel.options.length; i++) {
				grpSel.options[i].selected = false;
			}

			hideWaitingDlg();
			var summaryDlg = dijit.byId("summaryDialog");
			summaryDlg.set('content', data);
			summaryDlg.show();
		},
		error: function(error) {
			alert("Form posted error");
		}
	}
	//Call the asynchronous xhrPost
	showWaitingDlg();
	var deferred = dojo.xhrPost(xhrArgs);
}

function createReq() {
	var form = dojo.byId("createForm");
	if (!checkFormAllInput('createForm')) {
		alert("Please Remove Illegal Character!");
		return false;
	}
	var xhrArgs = {
		form: form,
		handleAs: "text",
		load: function(data) {
			hideWaitingDlg();
			navLink('listProv');
			showInfobySearch(data, "<");
		},
		error: function(error) {
			alert("Form posted error");
		}
	}

	dijit.byId("summaryDialog").hide();
	showWaitingDlg();

	var deferred = dojo.xhrPost(xhrArgs);
}

function addEventToDate() {
	var startDate = document.getElementById("start_mon|start_day|start_year");
	var startHour = document.getElementById("start_hour");
	var startMin = document.getElementById("start_min");
	var endDate = document.getElementById("end_mon|end_day|end_year");
	var endHour = document.getElementById("end_hour");
	var endMin = document.getElementById("end_min");
	startDate.onblur = updateEndFromDuration;
	startHour.onchange = updateEndFromDuration;
	startMin.onchange = updateEndFromDuration;
	endDate.onblur = updateDurationFromEnd;
	endHour.onchange = updateDurationFromEnd;
	endMin.onchange = updateDurationFromEnd;
	active();
}

function addNameToField(uid, formName, fieldName, index) {
	var form = document.forms[formName];
	var field;
	if (index) {
		field = form.elements[fieldName][index-1];
	} else {
	field = form.elements[fieldName];
	}
  
	if (field.value == "") {
		field.value = uid;
	} else {
		field.value += ","+uid;
	}
}

function addUser(uid) {
	addNameToField(uid, "UGForm", "userlist");
}
function addGrp(uid) {
	addNameToField(uid, "UGForm", "grplist");
}
function moveItem(sel1, sel2) {
	var itemSel1 = document.getElementById(sel1);
	var itemSel2 = document.getElementById(sel2);

	for (var i = 0; i < itemSel1.options.length;) {
		if (itemSel1.options[i].selected == true) {
			var u = new Option(itemSel1.options[i].text, itemSel1.options[i].value);
			itemSel2.options.add(u);
			itemSel1.options[i] = null;
		} else {
			i++;
		}
	}
}

function showInfo(str) {
	var infoDiv = document.createElement("div");
	infoDiv.setAttribute("class", "lotusMessage2 lotusInfo lotusInfoTable");
	infoDiv.setAttribute("role", "status");

	var msg = "";
	if (!str) {
		msg = "No response.";
	} else if (str.charAt(0) == '<') {
		var xmlDoc = dojox.xml.parser.parse(str);
		var resultNode = xmlDoc.documentElement;
		var rc = getElementDataFromNode(resultNode, "status");
		msg = rc == "success" ? "Execution succeeded." : "Execution failed.";
		var reason;
		if (rc == "failure") {
			reason = getElementDataFromNode(resultNode, "reasonMessage");
			msg += "<br>" + dojox.html.entities.encode(reason);
		}
	} else {  // Not XML
		// encode is needed, otherwise some div including special chars cannot be closed
		var strs = new Array();
		strs = str.split("<br>");
		for (var i = 0; i<strs.length; i++) {
			if (msg != "") {
				msg += "<br>" + dojox.html.entities.encode(strs[i]);
			} else { 
				msg = dojox.html.entities.encode(strs[i]);
			}
		}
	}

	infoDiv.innerHTML = "<img class=\"lotusIcon yourProductSprite yourProductSprite-msgInfo16\" src=\"oneui30/css/images/blank.gif\" alt=\"Information\" /><span class=\"lotusAltText\">Information:</span> <div class=\"lotusMessageBody\">"
	   + msg + "<a class=\"lotusClose\" style=\"right:0;top:2px;\" href=\"javascript:;\" onclick=\"dojo.byId('mainDiv').removeChild(this.parentNode.parentNode);\"><img src=\"oneui30/css/images/blank.gif\" alt=\"Close\" /><span class=\"lotusAltText\">X</span></a></div>";

	var mc = dojo.byId("mainDiv");
	mc.insertBefore(infoDiv, mc.firstChild);
}

function showInfoDeleteImage(str) {
	var infoDiv = document.createElement("div");
	infoDiv.setAttribute("class", "lotusMessage2 lotusInfo lotusInfoTable");
	infoDiv.setAttribute("role", "status");

	var msg="";
	if (!str) {
		msg = "No response.";
	} else if (str.indexOf("<")!=-1) {
		var xmlDoc = dojox.xml.parser.parse(str.slice(str.indexOf("<")));
		var resultNode = xmlDoc.documentElement;
		var resultArray= resultNode.getElementsByTagName("result");
		if (resultArray && resultArray.length>0) {
			for (var i = 0; i < resultArray.length; ++i) {
				// Get the image name
				var image_name= getElementDataFromNode(resultArray[i], "imagename");
				msg += "Image: " + image_name+ ". ";
				// Get the status.
				var status = getElementDataFromNode(resultArray[i], "status");
				if (status == "success") {
					msg += "Execution succeeded.<br>";
				} else {
					msg += "Execution failed.";
					// Get the reason message
					var reason = getElementDataFromNode(resultArray[i], "reasonMessage");
					msg += " Reason: " + dojox.html.entities.encode(reason) + "<br>";
				}
			} // end for 
		} // end if resultArray
	} else {  // Not XML
		msg = dojox.html.entities.encode(str);
	}
	infoDiv.innerHTML = "<img class=\"lotusIcon yourProductSprite yourProductSprite-msgInfo16\" src=\"oneui30/css/images/blank.gif\" alt=\"Information\" /><span class=\"lotusAltText\">Information:</span> <div class=\"lotusMessageBody\">"
	   + msg + "<a class=\"lotusClose\" style=\"right:0;top:2px;\" href=\"javascript:;\" onclick=\"dojo.byId('mainDiv').removeChild(this.parentNode.parentNode);\"><img src=\"oneui30/css/images/blank.gif\" alt=\"Close\" /><span class=\"lotusAltText\">X</span></a></div>";

	var mc = dojo.byId("mainDiv");
	mc.insertBefore(infoDiv, mc.firstChild);
}
function showInfobySearch(str, searched) {
	var infoDiv = document.createElement("div");
	infoDiv.setAttribute("class", "lotusMessage2 lotusInfo lotusInfoTable");
	infoDiv.setAttribute("role", "status");

	var msg;
	if (!str) {
		msg = "No response.";
	} else if (str.indexOf(searched)!=-1) {
		var xmlDoc = dojox.xml.parser.parse(str.slice(str.indexOf(searched)));
		var resultNode = xmlDoc.documentElement;
		var rc = getElementDataFromNode(resultNode, "status");
		msg = rc == "success" ? "Execution succeeded." : "Execution failed.";
		var reason;
		if (rc == "failure") {
			reason = getElementDataFromNode(resultNode, "reasonMessage");
			msg += "<br>" + dojox.html.entities.encode(reason);
		}
	} else {  // Not XML
		msg = dojox.html.entities.encode(str);
	}

	infoDiv.innerHTML = "<img class=\"lotusIcon yourProductSprite yourProductSprite-msgInfo16\" src=\"oneui30/css/images/blank.gif\" alt=\"Information\" /><span class=\"lotusAltText\">Information:</span> <div class=\"lotusMessageBody\">"
	   + msg + "<a class=\"lotusClose\" style=\"right:0;top:2px;\" href=\"javascript:;\" onclick=\"dojo.byId('mainDiv').removeChild(this.parentNode.parentNode);\"><img src=\"oneui30/css/images/blank.gif\" alt=\"Close\" /><span class=\"lotusAltText\">X</span></a></div>";

	var mc = dojo.byId("mainDiv");
	mc.insertBefore(infoDiv, mc.firstChild);
}

// This function is only for deleting energy schemes
function showInfoScheme(str) {
	var infoDiv = document.createElement("div");
	infoDiv.setAttribute("class", "lotusMessage2 lotusInfo lotusInfoTable");
	infoDiv.setAttribute("role", "status");

	// The str looks like
	// <results>
	//	<result>
	//	 <energyScheme>
	//	   <name>forUT-cloudadm</name>
	//	   <owner>cloudadm</owner>
	//	 </energyScheme>
	//	 <policies>7</policies>
	//	 <reasonMessage>At least one of the scheme is used by some policies.</reasonMessage>
	//	 <status>failure</status>
	//   </result>
	//   <result>
	//	  ...
	//   </result>
	// </results>
	var msg = "";
	var failCount = 0;
	var resultArray;
	if (!str) {
		msg = "No response.";
	} else if (str.charAt(0) == '<') {
		var xmlDoc = dojox.xml.parser.parse(str);
		var resultNode = xmlDoc.documentElement;
		var resultArray= resultNode.getElementsByTagName("result");
		if (resultArray && resultArray.length>0) {
			for (var i = 0; i < resultArray.length; ++i) {
				// Get the scheme name
				var energyScheme = getElementDataFromNode(resultArray[i], "name");
				msg += "Energy Scheme: " + energyScheme + ". ";
				// Get the status.
				var status = getElementDataFromNode(resultArray[i], "status");
				
				if (status == "success") {
					msg += "Execution succeeded.<br>";
				} else {
					failCount++;
					msg += "Execution failed.";
					// Get the reason message
					var reason = getElementDataFromNode(resultArray[i], "reasonMessage");
					msg += "	reasonMessage: " + dojox.html.entities.encode(reason) + "<br>";
				}
			} // end for 
			msg += "Error(s) found: " + failCount + ".";
		} // end if resultArray
	} else {
		msg = dojox.html.entities.encode(str);
	}
	infoDiv.innerHTML = "<img class=\"lotusIcon yourProductSprite yourProductSprite-msgInfo16\" src=\"oneui30/css/images/blank.gif\" alt=\"Information\" /><span class=\"lotusAltText\">Information:</span> <div class=\"lotusMessageBody\">"
	   + msg + "<a class=\"lotusClose\" style=\"right:0;top:2px;\" href=\"javascript:;\" onclick=\"dojo.byId('mainDiv').removeChild(this.parentNode.parentNode);\"><img src=\"oneui30/css/images/blank.gif\" alt=\"Close\" /><span class=\"lotusAltText\">X</span></a></div>";

	var mc = dojo.byId("mainDiv");
	mc.insertBefore(infoDiv, mc.firstChild);
}

// This function is only for deleting users 
function showInfoUser(str) {
	var infoDiv = document.createElement("div");
	infoDiv.setAttribute("class", "lotusMessage2 lotusInfo lotusInfoTable");
	infoDiv.setAttribute("role", "status");

	// The str looks like
	// <delete_result>
	//	<result>
	//	   <reasonMessage>Failed to delete the Cloud user. Reason: No permission to do this operation.</reasonMessage>
	//	   <user>test</name>
	//	   <status>failure</status>
	//   </result>
	//   <result>
	//	  ...
	//   </result>
	// </delete_result>
	var msg = "";
	var failCount = 0;
	var resultArray;
	if (!str) {
		msg = "No response.";
	} else if (str.charAt(0) == '<') {
		var xmlDoc = dojox.xml.parser.parse(str);
		var resultNode = xmlDoc.documentElement;
		var resultArray= resultNode.getElementsByTagName("result");
		if (resultArray && resultArray.length>0) {
			for (var i = 0; i < resultArray.length; ++i) {
				// Get the user name
				var userName = getElementDataFromNode(resultArray[i], "user");
				msg += "User: " + userName + ". ";
				// Get the status
				var status = getElementDataFromNode(resultArray[i], "status");
				
				if (status == "success") {
					msg += "Execution succeeded.<br>";
				} else {
					failCount++;
					msg += "Execution failed.";
					// Get the reason message
					var reason = getElementDataFromNode(resultArray[i], "reasonMessage");
					msg += "	reasonMessage: " + dojox.html.entities.encode(reason) + "<br>";
				}
			} // end for 
			msg += "Error(s) found: " + failCount + ".";
		} // end if resultArray
	} else {
		msg = dojox.html.entities.encode(str);
	}
	infoDiv.innerHTML = "<img class=\"lotusIcon yourProductSprite yourProductSprite-msgInfo16\" src=\"oneui30/css/images/blank.gif\" alt=\"Information\" /><span class=\"lotusAltText\">Information:</span> <div class=\"lotusMessageBody\">"
	   + msg + "<a class=\"lotusClose\" style=\"right:0;top:2px;\" href=\"javascript:;\" onclick=\"dojo.byId('mainDiv').removeChild(this.parentNode.parentNode);\"><img src=\"oneui30/css/images/blank.gif\" alt=\"Close\" /><span class=\"lotusAltText\">X</span></a></div>";

	var mc = dojo.byId("mainDiv");
	mc.insertBefore(infoDiv, mc.firstChild);
}

function showWaitingDlg() {
	var dlg = dijit.byId("waitingDialog");
	if(!dlg) {
		dlg = new dijit.Dialog({id:'waitingDialog'});
		dlg.set('title', 'Processing...');
		dlg.set('draggable', 'false');
		dlg.set('onkeypress', 'escapeCatch');
		dlg.set('content', "<table><tr><td><img height=\"20\" with=\"20\" src=\"images/spin.gif\"></td><td>Please wait......</td></tr></table>");
	}

	dlg.closeButtonNode.style.display='none';
	dlg.show();
}

function hideWaitingDlg() {
	var dlg = dijit.byId("waitingDialog");
	if(dlg)
		dijit.byId("waitingDialog").hide();
}

function escapeCatch(evt) {
	if (evt.keyCode == dojo.keys.ESCAPE)
		dojo.stopEvent(evt);
} 

function navReqListTab(url) {
	var u = "portal.cgi?function=listProvList&" + url;
	dijit.byId("tabProvList").setHref(u);
}

function getBilling(reqname) {
	var modTypeRadio = document.getElementsByName("modifymethod");
	var ModifyMeth="";
	for(var i=0; i < modTypeRadio.length; i++) {
		if (modTypeRadio[i].checked) { ModifyMeth= modTypeRadio[i].value; }
	}
	if(ModifyMeth == ""){
		alert("Can not get change machine method!");
		return false;
	}
	var mlist = "";
	var dur = document.getElementById("duration").value;
	var reqname = "&reqname=" + reqname;
	if (ModifyMeth == "Machine Type"){
		var machType = document.getElementById("machType");
		if (machType){
			mlist = mlist + "&machType=" + machType.value;
		}else{
			alert("Failed to get machine type!");
			return false;
		}
		var machNum = document.getElementById("machNum");
		var OrimachNum = document.getElementById("oriMachNum");
		if((machNum) && (OrimachNum)){
			if(integercheck(machNum.value) && integercheck(OrimachNum.value)){
				if(machNum.value == 0){
					alert("Machine number can not be 0!");
					return false;
				}
				var changed = machNum.value - OrimachNum.value;
				mlist = mlist + "&addmachnum=" + changed;
				var oriMachList = document.getElementById("OrigMachListStr").value;
				mlist = mlist + "&orimachList=" + oriMachList;
			}else{
				alert("Machine Number only accept positive integral number!");
				return false;
			}
		}else{
			alert("Failed to get machine number!");
			return false;
		} 
	}else{
		var machSel = document.getElementById("reqdMaches");
		if (machSel) {
			for(var i=0; i < machSel.length; i++) {
				mlist = mlist + "&machList=" + machSel.options[i].value;
			}
		}
	}
	var hypvFlag = document.getElementsByName("hypvflag");
	if(hypvFlag){
		if(hypvFlag[0].value == -1){
			var vcpu = document.getElementById("modVCPU");
			if((vcpu)&& (integercheck(vcpu.value))){
				mlist = mlist + "&vcpunum=" + vcpu.value;
			}else{
				alert("Failed to get VCPU number!");
				return false;
			}
		}
	}
	var xhrArgs = {
		url: "GetInfoXML.cgi",
		postData: "function=getbilling4modify&duration=" + dur + mlist + reqname,
		handleAs: "text",
		load: function(ret) {
			var enough = ret.split("|")[0];
			var cost = ret.split("|")[1];
			var changed = ret.split("|")[2];
			var res = "US \$" + cost;
			
			hideWaitingDlg();
			if (enough == 0) {
				res = res + "  Insufficient balance";
			}else if (enough == -1) {
				res = res + "  Invalid modification";
			}
			else{
			    dojo.byId("chargeTxt_modified").value ="US \$" + changed;
			}
			dojo.byId("chargeTxt").value = res;
		}
	}
	
	showWaitingDlg();
	var deferred = dojo.xhrPost(xhrArgs);
}

function submitChangeReqForm() {
	var modTypeRadio = document.getElementsByName("modifymethod");
	var ModifyMeth="";
	for(var i=0; i < modTypeRadio.length; i++) {
		if (modTypeRadio[i].checked) { ModifyMeth= modTypeRadio[i].value; }
	}
	if(ModifyMeth == ""){
		alert("Can not get change machine method!");
		return false;
	}
	var dur = document.getElementById("duration").value;
	if(!integercheck(dur)){
		alert("Duration can only be positive integral number!");
		return false;
	}
	if (ModifyMeth == "Machine Type"){
		var machNum = document.getElementById("machNum");
		var OrimachNum = document.getElementById("oriMachNum");
		if((machNum) && (OrimachNum)){
			if(integercheck(machNum.value) && integercheck(OrimachNum.value)){
				if(machNum.value == 0){
					alert("Machine number can not be 0!");
					return false;
				}
				var modMeth = document.getElementById("modMachbymethod");
				modMeth.value="Machine Type";
			}else{
				alert("Machine Number only accept positive integral number!");
				return false;
			}
		}else{
			alert("Failed to get machine number!");
			return false;
		} 
	}else{
		var machSel = document.getElementById("reqdMaches");
		for (var i = 0; i < machSel.options.length; i++) {
			machSel.options[i].selected = true;
		}
		var modMeth = document.getElementById("modMachbymethod");
		modMeth.value="Machine List";
	}
	var hypvFlag = document.getElementsByName("hypvflag");
	if(hypvFlag){
		if(hypvFlag[0].value == -1){
			var vcpu = document.getElementById("modVCPU");
			if(!((vcpu)&& (integercheck(vcpu.value)))){
				alert("Failed to get VCPU number!");
				return false;
			}
			var memory = document.getElementById("modMemory");
			if(!((memory)&& (integercheck(memory.value)))){
				alert("Failed to get memory size!");
				return false;
			}
		}
	}
	var form = dojo.byId("reqDetailForm");
	var userSel = dojo.byId("allowedUsers");
	var grpSel = dojo.byId("allowedGrps");

	if (userSel) { // userSel and grpSel can be null for hypv requests
		for (var i = 0; i < userSel.options.length; i++) {
			userSel.options[i].selected = true;
		}
	}
	if (grpSel) {
		for (var i = 0; i < grpSel.options.length; i++) {
			grpSel.options[i].selected = true;
		}
	}

	var xhrArgs = {
		form: form,
		handleAs: "text",
		load: function(data) {
			hideWaitingDlg();
			navLink('listProv');
			showInfo(data);
		},
		error: function(error) {
			alert("Form posted error");
		}
	}
	showWaitingDlg();
	var deferred = dojo.xhrPost(xhrArgs);
}

function checkMachForm() {
	var empty = true;
	var inputs = document.getElementsByTagName("input");
	for(var i=0;i<inputs.length;i++) {
	   if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].getAttribute("name") == "machName") {
		   if (inputs[i].checked) {
			   empty = false;
			   break;
		   }
	   }
	}

	if (empty) {
		alert("Select some machines.");
		return false;
	}
	return true;
}

function requestMach() {
	if (!checkMachForm()) return false;
	dojo.byId("reqMachAction").value = "reqByName";

	var form = dojo.byId("MachineListForm");

	var xhrArgs = {
		form: form,
		handleAs: "text",
		load: function(data) {
			hideWaitingDlg();
			dijit.byId("mainContent").setContent(data);
		},
		error: function(error) {
			alert("Form posted error");
		}
	}

	showWaitingDlg();
	var deferred = dojo.xhrPost(xhrArgs);
}

function makeHypv() {
	var form1 = dojo.byId("MachineListForm");
	if (!form1) {
		return false;
	}
	if (!checkMachForm()) {
		 return false;
	}
  	dijit.byId("HypvOSDialog").show();
}
function Hypv_os_check(){
	var valued = dojo.byId("hypvos").value;
	dojo.byId("hypv_os").value = valued;
	dojo.byId("reqMachAction").value = "makeHypv";

	dijit.byId("HypvOSDialog").hide();
	var form1 = dojo.byId("MachineListForm");

	var xhrArgs = {
		form:form1, 
		handleAs: "text",
		load: function(data) {
			hideWaitingDlg();
		//	dijit.byId("mainContent").setContent(data);
			showInfo(data);
			navLink("listProv");
		},
		error: function(error) {
			hideWaitingDlg();
			showInfo(error);
		}
	}
//
	showWaitingDlg();
	var deferred = dojo.xhrPost(xhrArgs);
}

function checkJobForm(formId) {
	var action = dojo.byId(formId).jobActionMenu.value;
	if(action == "none") {
		alert("Select an action.");
		return false;
	}

	var selected = false;
	//var jobs = document.getElementById(formId).jobID;
	var jobs = dojo.query('[name=\"jobID\"]', dojo.byId(formId));
	for (var i = 0; i < jobs.length; i++) {
		if (jobs[i].checked) {
			selected = true;
			break;
		}
	}
	if (!selected) {
		alert("Select one job at least.");
		return false;
	}

	if(action == "cancel") {
		if(confirm("Are you sure you want to cancel these jobs?")) {
			return true;
		} else {
			return false;
		}
	}
	return true;
}

function submitJobForm(formId, tabId) {
	var doit = checkJobForm(formId);
	if(!doit) return;
	var xhrArgs = {
		form: dojo.byId(formId),
		handleAs: "text",
		load: function(data) {
			hideWaitingDlg();
			showInfo(data);
			dijit.byId(tabId).refresh();
		},
		error: function(error) {
			hideWaitingDlg();
			showInfo(error);
			dijit.byId(tabId).refresh();
		}
	}
	showWaitingDlg();
	var deferred = dojo.xhrPost(xhrArgs);
}

function submitJCFForm(pid) {
	showWaitingDlg();
	dojo.io.iframe.send({
		form: 'JCFForm',
		handleAs: "text",

		load: function(response, ioArgs) {
			hideWaitingDlg();
			showInfo(response);
			navLink('viewJobs&selpid='+pid);
			return response;
		}
	});
}

function submitBuildJob() {
	showWaitingDlg();
	dojo.io.iframe.send({
		form: 'buildJobForm',
		handleAs: "text",

		load: function(response, ioArgs) {
			hideWaitingDlg();
			showInfo(response);
			navLink('viewJobs');
			return response;
		}
	});
}

function submitChangePasswd() {
	if((dojo.byId('passwdform').oldpasswd.value!="")&&
		(dojo.byId('passwdform').passwd.value!="")&&
		(dojo.byId('passwdform').rePasswd.value!="")) {
		if(dojo.byId('passwdform').passwd.value!=dojo.byId('passwdform').rePasswd.value) {
			alert("New Password and Repeat Password do not match.");
			return false;
		}
	} else {
		alert("Please fill the Old Password, New Password and Repeat Password at same time to change password.");
		return false;
	}
 
	var xhrArgs = {
		form: dojo.byId('passwdform'),
		handleAs: "text",
		load: function(data) {
			hideWaitingDlg();
			showInfo(data);
			dojo.byId('passwdform').reset();
		},
		error: function(error) {
			hideWaitingDlg();
			showInfo(error);
			dojo.byId('passwdform').reset();
		}
	}
	showWaitingDlg();
	var deferred = dojo.xhrPost(xhrArgs);
}

function submitDeleteUser() {
	var select = false;
	var form = document.getElementById("userForm");
	if (form) {
		var inputs = form.getElementsByTagName("input");
		for(var i=0;i<inputs.length;i++) {
			if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].getAttribute("name") == "userID") {
				if (inputs[i].checked == true) {
					select = true;
					break;
				}
			}
		}
	} else {
		return;
	}
	if (!select) { alert("No User selected."); return; }
	if (!confirm("Do you want to delete these users?")) {
		return false;
	}
	var xhrArgs = {
		form: dojo.byId('userForm'),
		handleAs: "text",
		load: function(data) {
			hideWaitingDlg();
			showInfoUser(data);
			dijit.byId('mainContent').refresh();
		},
		error: function(error) {
			hideWaitingDlg();
			showInfoUser(error);
			dijit.byId('mainContent').refresh();
		}
	}
	showWaitingDlg();
	var deferred = dojo.xhrPost(xhrArgs);
}

function submitAddUser() {
	if(!checkFormAllInput('addUserForm')){
		alert("Please Remove Illegal Character!");
		return false;
	}
	if(dojo.byId('addUserForm').userid.value==""){
		alert("Specify a user name.");
		return false;
	}
	if(!criticalcheckinput(dojo.byId('addUserForm').userid.value)){
		alert("User name only accept 0-9, a-z, A-Z and _");
		return false;
	}
	if(dojo.byId('addUserForm').passwd.value==""){
		alert("Specify a password.");
		return false;
	}
	if(dojo.byId('addUserForm').passwd.value!=dojo.byId('addUserForm').rePasswd.value){
		alert("Password and Repeat Password do not match.");
		return false;
	}
	if(dojo.byId('addUserForm').balance.value == ""){
		dojo.byId('addUserForm').balance.value = 0;
    }else{
		if(!decimalcheck(dojo.byId('addUserForm').balance.value)){
			alert("Only accept decimal in Recharge field!");
			return false;
		}
	}
	var xhrArgs = {
		form: dojo.byId('addUserForm'),
		handleAs: "text",
		load: function(data) {
			hideWaitingDlg();
			showInfo(data);
			navLink("listUser");
		},
		error: function(error) {
			hideWaitingDlg();
			showInfo(error);
		}
	}
	showWaitingDlg();
	var deferred = dojo.xhrPost(xhrArgs);
}

function submitDeleteGroup() {
	var select = false;
	var form = document.getElementById("groupForm");
	if (form) {
		var inputs = form.getElementsByTagName("input");
		for(var i=0;i<inputs.length;i++) {
			if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].getAttribute("name") == "groupID") {
				if (inputs[i].checked == true) {
					select = true;
					break;
				}
			}
		}
	} else {
		return;
	}
	if (!select) { alert("No Group selected."); return; }
	if(!confirm("Do you want to delete these groups?")) {
		return false;
	}
	var xhrArgs = {
		form: dojo.byId('groupForm'),
		handleAs: "text",
		load: function(data) {
			hideWaitingDlg();
			showInfo(data);
			dijit.byId('mainContent').refresh();
		},
		error: function(error) {
			hideWaitingDlg();
			showInfo(error);
			dijit.byId('mainContent').refresh();
		}
	}
	showWaitingDlg();
	var deferred = dojo.xhrPost(xhrArgs);
}

function submitAddGroup() {
	if(!checkFormAllInput('addGroupForm')){
		alert("Please Remove Illegal Character!");
		return false;
	}
	if(dojo.byId('addGroupForm').groupname.value==""){
		alert("Specify a group name.");
		return false;
	}
	if(!criticalcheckinput(dojo.byId('addGroupForm').groupname.value)){
		alert("Group name only accept 0-9, a-z, A-Z and _");
		return false;
	}
	var userSel = document.getElementById("guser");

	if (userSel.options.length == 0) {
		alert("No user is specified.");
		return false;
	}
	for (var i = 0; i < userSel.options.length; i++) {
		userSel.options[i].selected = true;
	}

	var xhrArgs = {
		form: dojo.byId('addGroupForm'),
		handleAs: "text",
		load: function(data) {
			hideWaitingDlg();
			showInfo(data);
			navLink("listGroup");
		},
		error: function(error) {
			hideWaitingDlg();
			showInfo(error);
		}
	}
	showWaitingDlg();
	var deferred = dojo.xhrPost(xhrArgs);
}

function submitChangeGroup() {
	var userSel = document.getElementById("guser");
	if(!checkFormAllInput('changeGroupForm')){
		alert("Please Remove Illegal Character!");
		return false;
	}

	if (userSel.options.length == 0) {
		alert("No user is specified.");
		return false;
	}
	for (var i = 0; i < userSel.options.length; i++) {
		userSel.options[i].selected = true;
	}

	var xhrArgs = {
		form: dojo.byId('changeGroupForm'),
		handleAs: "text",
		load: function(data) {
			hideWaitingDlg();
			showInfo(data);
			navLink("listGroup");
		},
		error: function(error) {
			hideWaitingDlg();
			showInfo(error);
		}
	}
	showWaitingDlg();
	var deferred = dojo.xhrPost(xhrArgs);
}

function getElementDataFromNode(node,attr) {
	var elements = node.getElementsByTagName(attr);
	var isArray = arguments[2];
	var res = [];
	if (elements && elements.length>0) {
	   if (elements[0].firstChild && elements[0].firstChild.data) {
		   if (!isArray) {
			   if (elements[0].firstChild.data!="null"){
					   return elements[0].firstChild.data;
			   } else {
					   return "";
			   }
		   } else {
			   for (var i = 0; i < elements.length; ++i) {
				   if (elements[i].firstChild.data!="null"){
					   res.push(elements[i].firstChild.data);
				   }
			   }
			   return res;
		   }
	   }
	}

	if (isArray) return res;
	else return "";
}

function onSelectMachType() {
	var type = dojo.byId('machType');
	if(!type || type.value == "")
		return;
	var cpu = dojo.byId('reqCPU');
	var mem = dojo.byId('reqMem');
	var disk = dojo.byId('reqDisk');

	if (type.value == "IBM_KVM") {
		if(cpu) cpu.style.visibility = "visible";
		if(mem) mem.style.visibility = "visible";
		if(disk) disk.style.visibility = "visible";
	} else {
		if(cpu) cpu.style.visibility = "collapse";
		if(mem) mem.style.visibility = "collapse";
		if(disk) disk.style.visibility = "collapse";
	}
}

function checkIllegalChar(str){
//	var patt = new RegExp(/[\'\`\"#\$%\^\&\*]+/);
	return legal_patt.test(str);
}

function criticalcheckinput(str){
	return /^[0-9a-zA-Z\_]+$/.test(str);
}
function integercheck(str){
	return /^\d+$/.test(str);
}
function decimalcheck(str){
	return /^\d+\.?\d*$/.test(str);
}
function checkFormAllInput(table_name )
{
	if(!table_name || table_name=="")
	   return false;
	var rc=true;
	var table_cont = dojo.byId(table_name);	

	if(table_cont)
	{
		for(var i=0; i<table_cont.length;i++)  
		{
			if((table_cont[i].readOnly)||(table_cont[i].disabled))
				continue;
			if(table_cont[i].type == "text"){
				rc = checkIllegalChar(table_cont[i].value);
				if(!rc)
					break;
			}
		}
	}
	return rc;
}

function submitModifySysConf()
{
	var form = dojo.byId("sysConfForm");
	var rc=true;
	for(var i=0; i<form.length;i++) {
		if(form[i].name=="modsysconf_vlanFlag"){
			if(form[i].checked){
				var machelem= document.getElementById("modsysconf_machTypeName");
				for(var j=0; j<form.length;j++) {
					if(form[j].name=="modsysconf_vlanFlag_result"){
						form[j].value = form[i].value;
						break;
					}
				}
			}
			continue;
		}
		if(form[i].name=="modsysconf_machTypeName_result"){
			var machelem= document.getElementById("modsysconf_machTypeName");
			form[i].value = machelem.text;
			continue;
		}
		if((form[i].readOnly)||(form[i].disabled)||(form[i].name=="modsysconf_prefix"))
			continue;
		if((form[i].type == "text") && (form[i].value != "")) {
			rc = integercheck(form[i].value);
			if(!rc){
				alert("Only accept positive integer");
				return false;
			}
		}
	}
	var xhrArgs = {
		form: form,
		handleAs: "text",
		load: function(data) {
			hideWaitingDlg();
			navLink('sysConfigInfo');
//	showInfobySearch(data, "<");
			showInfo(data);
		},
		error: function(error) {
			hideWaitingDlg();
			showInfo(error);
		}
	}
	showWaitingDlg();
	var deferred = dojo.xhrPost(xhrArgs);	
}

function submitaddmach2cloud()
{
	var form = dojo.byId("addmach2cloudForm");
	var rc=true;
	for(var i=0; i<form.length;i++)
	{
		if((form[i].readOnly)||(form[i].disabled))
			continue;
		if ((form[i].name == "machName" || form[i].name == "osimage") && (form[i].value == "")) {
			alert("Error: The machine name(s) and os image are mandatory.");
			return false;
		} else {
			continue;
		}
		if((form[i].type == "text")&&(form[i].value !="")){
			rc = integercheck(form[i].value);
			if(!rc) {
				alert("Error: Only accept positive integer.");
				return false;
			}
		}
	}
	var xhrArgs = {
		form: form,
	  	handleAs: "text",
	  	load: function(data) {
		  hideWaitingDlg();
		  navLink('listMach&all=1');
	  		showInfobySearch(data, "<");
	  },
		error: function(error) {
		   hideWaitingDlg();
		   showInfo(error);
	   }
	}
	showWaitingDlg();
	var deferred = dojo.xhrPost(xhrArgs);
}



function checkIP(ip)
{
	var re = /^((\d)|(([1-9])\d)|(1\d\d)|(2(([0-4]\d)|5([0-5]))))\.((\d)|(([1-9])\d)|(1\d\d)|(2(([0-4]\d)|5([0-5]))))\.((\d)|(([1-9])\d)|(1\d\d)|(2(([0-4]\d)|5([0-5]))))\.((\d)|(([1-9])\d)|(1\d\d)|(2(([0-4]\d)|5([0-5]))))$/;
	  
	if(re.test(ip))
	   return true;
	else  
	   return false;

}
function IsDisable()
{
	var dis = document.getElementsByName("uploadselect");
	var localPkg = document.getElementById("localPkg");
	var pathorig = document.getElementById("pathorig");
	if (dis[0].checked) {
		localPkg.value = "";
		localPkg.disabled = true; 
		pathorig.disabled = false;
	}
	if (dis[1].checked) {
		pathorig.value = "";
		localPkg.disabled = false; 
		pathorig.disabled = true;
	}
	return true;
}

function isDisable_script()
{
	var dis = document.getElementsByName("radio_path");
	var localS = document.getElementById("localS");
	var pathorig = document.getElementById("script_path");
	if (dis[0].checked) { 
		localS.value = "";
		localS.disabled = true; 
		pathorig.disabled = false;
	}
	if (dis[1].checked) {
		pathorig.value = "";
		pathorig.disabled = true;
		localS.disabled = false; 
	}
	return true;
}

function changevalue() {
	var valued = dojo.byId('newImageForm').filesystem_select.value;
	dojo.byId('newImageForm').otherpkg.value = valued;
}

function passSelectValue() {
	var scheduler = document.getElementById('scheduler_select').value;
	var environment = document.getElementById('environment_select').value;
	var network = document.getElementById('network_select').value;
	var filesystem = document.getElementById('filesystem_select').value;
	if (filesystem == "NA") { filesystem = ""; };
	var prefield = document.getElementById('prefield');
	var prefield2 = document.getElementById('prefield2');
	var premulti = document.getElementById('prefieldtaken');
	var premulti2 = document.getElementById('prefieldtaken2');
	var postfield = document.getElementById('postfield');
	var postfield2 = document.getElementById('postfield2');
		var postmulti = document.getElementById('postfieldtaken');
	var postmulti2 = document.getElementById('postfieldtaken2');	
	if (prefield2 != null && premulti2 != null) {
		for (var k=0;k<prefield.options.length;) {
			prefield.options[k] = null;
		}
		for (var k=0;k<premulti.options.length;) {
			premulti.options[k] = null;
		}
		for (var k=0;k<prefield2.options.length;k++) {
			var u = new Option(prefield2.options[k].text, prefield2.options[k].value);
			prefield.options.add(u);
		}
		for (var i = 0; i < premulti2.options.length;i++) {
			var str = premulti2.options[i].value.split("+");
			var u = new Option(premulti2.options[i].text, premulti2.options[i].text);
			u.disabled = true;
			if (((str[1] == "scheduler" && str[0] == scheduler) || 
				(str[1] == "parallelenv" && str[0] == environment) ||
				(str[1] == "interconnect" && str[0] == network) ||
				(str[1] == "sharedfs" && str[0] == filesystem))) {
				//premulti.options[i].disabled = true;
				premulti.options.add(u);
				
				for (var j=0;j < prefield.options.length;) {
					if (prefield.options[j].text == premulti2.options[i].text) {
						prefield.options[j] = null;
					} else {
						j++;
					}
				}
				
		   	}
		}
	}
	if (postfield2 != null && postmulti2 != null) {
		for (var k=0;k<postfield.options.length;) {
			postfield.options[k] = null;
		}
		for (var k=0;k<postmulti.options.length;) {
			postmulti.options[k] = null;
		}
		for (var k=0;k<postfield2.options.length;k++) {
			var u = new Option(postfield2.options[k].text, postfield2.options[k].value);
			postfield.options.add(u);
		}
		for (var i = 0; i < postmulti2.options.length;i++) {
			var str = postmulti2.options[i].value.split("+");
			var u = new Option(postmulti2.options[i].text, postmulti2.options[i].text);
			u.disabled = true;
			if (((str[1] == "scheduler" && str[0] == scheduler) || 
				(str[1] == "parallelenv" && str[0] == environment) ||
				(str[1] == "interconnect" && str[0] == network) ||
				(str[1] == "sharedfs" && str[0] == filesystem))) {
				//postmulti.options[i].disabled = true;
				postmulti.options.add(u);
				
				for (var j=0;j < postfield.options.length;) {
					if (postfield.options[j].text == postmulti2.options[i].text) {
						postfield.options[j] = null;
					} else {
						j++;
					}
				}
		   	}
		}
		
	}
}
function clearscript() {
	var prefield = document.getElementById('prefield');
	var premulti = document.getElementById('prefieldtaken');
	var postfield = document.getElementById('postfield');
		var postmulti = document.getElementById('postfieldtaken');
	if (prefield != null) {
			for (var i = 0; i < premulti.options.length;) {
				if (premulti.options[i].disabled == true) { 
					i++;
				} else {
					var u = new Option(premulti.options[i].text, premulti.options[i].value);
				   	prefield.options.add(u);
					premulti.options[i] = null;
				}
			}
		}
	if (postfield != null) {
		for (var i = 0; i < postmulti.options.length;) {
			if (postmulti.options[i].disabled == true) {
				i++;
			} else {
				var u = new Option(postmulti.options[i].text, postmulti.options[i].value);
	   		 	postfield.options.add(u);
				postmulti.options[i] = null;
			}
		}
	}
}
function getRowObj(obj){
	var i = 0;
	while (obj.tagName.toLowerCase() != "tr") { 
		obj = obj.parentNode;
		if (obj.tagName.toLowerCase() == "table"){      
			return null;           
	   	}
	}
	return obj;    
}
function getRowNo(obj){
	var trObj = getRowObj(obj); 
	var trArr = trObj.parentNode.children; 
	var trNo = 0;
	for (var trNo = 0; trNo < trArr.length; trNo++) {
		if (trObj == trObj.parentNode.children[trNo]) {  
			break;
		}   
	} 
	if(trNo == trArr.length){
		trNo = 0;
	}
	return trNo;
}
function rmModTypePriceRow(element)
{
	var rowidx = getRowNo(element);
	if(rowidx !=0){
		var table= dojo.byId("mod_mach_price_tab");
		if(table.rows.length <= 3){//the last one 
			addModTypePriceRow(element);
		}else if(rowidx == table.rows.length -1 ){//last row 
			var cell3 = table.rows[rowidx-1].insertCell(3);
			cell3.innerHTML = "<td><input type=\"image\" border=\"0\" align=\"middle\" onclick=\"addModTypePriceRow(this)\" src=\"/hpccloud/images/addbutton.png     \"></td>";
		}
		table.deleteRow(rowidx);
		return true;
	}
	return false;
}
function addModTypePriceRow(element)
{
	var trObj = getRowObj(element);
	trObj.deleteCell(3);
	var table= dojo.byId("mod_mach_price_tab");
	var row = table.insertRow(table.rows.length);
    row.className = "tab_content";
    var cell0 = row.insertCell(0);
    cell0.innerHTML = "Add new machine type";
    var cell1 = row.insertCell(1);
    cell1.innerHTML = "Add new machine price";
    var cell2 = row.insertCell(2);
    cell2.innerHTML = "<td><input type=\"image\" border=\"0\" align=\"middle\" onclick=\"rmModTypePriceRow(this)\" src=\"/hpccloud/images/subbutton.png\"></td>";
    var cell3 = row.insertCell(3);
    cell3.innerHTML = "<td><input type=\"image\" border=\"0\" align=\"middle\" onclick=\"addModTypePriceRow(this)\" src=\"/hpccloud/images/addbutton.png\"></td>";
    SetRowCanEdit(row,0,1);

}
function UpdateMachandPrice(){
	var table= dojo.byId("mod_mach_price_tab");
	var type_reg = new RegExp(/^[0-9a-zA-Z\@\-\_\.\=\#]+$/);
	var price_reg = new RegExp(/^\d+\.{0,1}\d*$/);
	var last_str="";
	
    for(var rowidx=2; rowidx < table.rows.length; rowidx++){
		if(table.rows[rowidx].cells[0].innerHTML == "Add new machine type"){
			continue;
		}
		if(!type_reg.test(table.rows[rowidx].cells[0].innerHTML)){
			alert("Illegal character in machine type name!");
			return false;
		}
		if(!price_reg.test(table.rows[rowidx].cells[1].innerHTML)){
			alert("Illegal character in machine price!");
			return false;
		}
		last_str += table.rows[rowidx].cells[0].innerHTML+"("+table.rows[rowidx].cells[1].innerHTML+"$),";

	}
	if(last_str == ""){
		last_str = "NULL";
	}
	var comma_reg = /,$/;
	last_str = last_str.replace(comma_reg, "");
	var machelem= document.getElementById("modsysconf_machTypeName");
	if(machelem){
		machelem.setAttribute("value",last_str);
		machelem.setAttribute("href","javascript:modTypeandPrice(\'"+last_str+"\');");
		machelem.href = "javascript:modTypeandPrice(\'"+last_str+"\');";
		machelem.innerHTML = last_str;
		machelem.text = last_str;
		machelem.textContent = last_str;
	}
	dijit.byId('mach_type_price').destroy();
	return true;
}
function modTypeandPrice(inputstr){
	
	var dlg = dijit.byId("mach_type_price");
    if (dlg) dlg.destroy();
	var mlst = "<form name=modmachPriceForm id=modmachPriceForm method=post action=portal.cgi>";
//	mlst += "<table id=mod_mach_price_tab width=100% border=0 cellpadding=1 cellspacing=1 bgcolor=#e3e3d1 style=\"text-align:center\">";
	mlst += "<table id=mod_mach_price_tab width=100% border=0 cellpadding=1 cellspacing=1 style=\"text-align:center\">";
	mlst += "<tr><td colspan=0 align=middle>";
	mlst += "<table><tr>";
//	mlst += "<td><input type=\"submit\" value=\"Go\" id=\"jobActionButton\" name=\"jobActionButton\" class=\"commandExButton\" title=\"Select an action from the menu on the left and click this button to execute the action \" /></td>";
	mlst += "</tr></table>";
	mlst += "</td></tr>";
	mlst += "<tr class=\'tab_head\'>";
	mlst += "<td width=200 style=\"padding-left:0px;padding-right:0px;\" name=\"MachType\" EditType=\"TextBox\"><b>Machine Type</b></td>";
	mlst += "<td width=140 style=\"padding-left:0px;padding-right:0px;\" name=\"MachPrice\" EditType=\"TextBox\"><b>Machine Price($)</b></td>";
	mlst += "</tr>";
	mlst += "<table><tr valign=\"middle\">";
	mlst += "<td align=\"middle\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<button dojoType=\"dijit.form.Button\" type=\"button\" baseClass=soria iconClass=\"dijitEditorIcon dijitEditorIconSave\" onClick=\"UpdateMachandPrice();\">Confirm</button>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp";
	mlst += "<button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"dijit.byId(\'mach_type_price\').destroy();\" baseClass=soria iconClass=\"dijitEditorIcon dijitEditorIconCancel\">Cancel</button></td>";
	mlst += "</tr></table>";
	mlst += "</table></from>";
			
	
	machTypePriceDlg = new dijit.Dialog({
			id: "mach_type_price",
			title: "Machine Type and Price",
			content: mlst,
			style: "width: 340px"
			});
	machTypePriceDlg.show();

	var theTable = dojo.byId("mod_mach_price_tab");
	var maches = new Array();
	maches = inputstr.split(",");
	var mache_price_reg = new RegExp(/^(\S+)\((\d+.{0,1}\d*)\$\)$/);
	for(i=0;i<maches.length;i++){
		var result = mache_price_reg.test(maches[i]);
		if(result){
			var row = theTable.insertRow(theTable.rows.length);
			row.className = "tab_content";
			var cell0 = row.insertCell(0);
			cell0.innerHTML = RegExp.$1;
			var cell1 = row.insertCell(1);
			cell1.innerHTML = RegExp.$2;
			var cell2 = row.insertCell(2);
			cell2.innerHTML = "<td><input type=\"image\" border=\"0\" align=\"middle\" onclick=\"rmModTypePriceRow(this)\" src=\"/hpccloud/images/subbutton.png\"></td>";
			if(i == maches.length -1){
				var cell3 = row.insertCell(3);
				cell3.innerHTML = "<td><input type=\"image\" border=\"0\" align=\"middle\" onclick=\"addModTypePriceRow(this)\" src=\"/hpccloud/images/addbutton.png\"></td>";
			}
			SetRowCanEdit(row,0,1);
		}
	}
	if(theTable.rows.length == 2){//no tab content
		var row = theTable.insertRow(theTable.rows.length);
		row.className = "tab_content";
		var cell0 = row.insertCell(0);
		cell0.innerHTML = "Add new machine type";
        var cell1 = row.insertCell(1);
        cell1.innerHTML = "Add new machine price";
		var cell2 = row.insertCell(2);
		cell2.innerHTML = "<td><input type=\"image\" border=\"0\" align=\"middle\" onclick=\"rmModTypePriceRow(this)\" src=\"/hpccloud/images/subbutton.png\"></td>";
        var cell3 = row.insertCell(3);
        cell3.innerHTML = "<td><input type=\"image\" border=\"0\" align=\"middle\" onclick=\"addModTypePriceRow(this)\" src=\"/hpccloud/images/addbutton.png\"></td>";
        SetRowCanEdit(row,0,1);
	}
}

function SetRowCanEdit(row, startcell, endcell){
	for(var j=startcell;j<=endcell;j++){
		row.cells[j].onclick = function(){
			EditCell(this);
		}
	}
}

function EditCell(element){
	var editState = element.getAttribute("EditState");
	if(editState != "true"){
		var textBox = document.createElement("INPUT");
		textBox.type = "text";
		textBox.className="EditCell_TextBox";
		var value = element.innerHTML;
		textBox.value = value;
		textBox.onblur = function (){
		CancelEditCell(this.parentNode, this.value);
		}
		ClearChild(element);
		element.appendChild(textBox);
		textBox.focus();
		textBox.select();
		element.setAttribute("EditState", "true");
		element.parentNode.parentNode.setAttribute("CurrentRow", element.parentNode.rowIndex);
	}
}
function CancelEditCell(element, value){
	element.setAttribute("Value", value);
	element.innerHTML = value;
	element.setAttribute("EditState", "false");
}
function ClearChild(element){
	element.innerHTML = "";
}

function select_all(pid){
    var checked;
    if (document.getElementById("jobForm_" + pid).selectAll.checked) checked=true;
    else checked=false;
    var inputs = document.getElementsByTagName("input");
    for(var i=0;i<inputs.length;i++)
    {
       if(inputs[i].getAttribute("type") == "checkbox")
        {
         inputs[i].checked = checked;
        }
    }
}
function refreshContent(param, pid) {
    var url = dijit.byId('tabJobList_' + pid).href;
    url = url.split("?")[0] + "?function=viewJobsListContent&pid=" + pid + "&" + param;
    dijit.byId('tabJobList_' + pid).href = url;
    dijit.byId('tabJobList_' + pid).refresh();
}

