#!/usr/bin/perl
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
#  
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# (C) COPYRIGHT International Business Machines Corp. 2010,2012 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 

# sccsid = "@(#) src/hpcc/webui/hpccloud/portal.cgi, hpc.cloud.ui, hpcc_rbei, rbeis002a 1.82 1/31/12 06:18:43";

#-------------------------------------------------------------------------------
my $USERID;
my $THISHOST;
my $CLOUD_BIN_DIR;
my $BIN_DIR ;
my $dir = ".";  # use current working directory
my $timeZone;
# sub function
sub init {
	$timeZone = $ENV{TZ} || `date +%Z 2>/dev/null`;
	$timeZone =~ s/\n//;
	if( $timeZone =~ /^([A-Z]+)[^A-Z]+([A-Z]+)/ ) {
		$timeZone = $2;
	}
	elsif( $timeZone =~ /^([A-Z]+)/ ) {
		$timeZone = $1;
	}
	my @gmtOffset = split(/\s+/,`date -R 2>/dev/null`);
	my $gmtOffset_pop = pop(@gmtOffset);
	if( $gmtOffset_pop =~ /^([\+\-]\d\d)\d\d$/ ) {
		$gmtOffset_pop = $1;
		$timeZone .= " (GMT $gmtOffset_pop)";
	}

	open(STDERR, ">&STDOUT") || die "can't dup stdout to stderr";

	use POSIX qw(uname);
	my ($thisHost) = split(/\./, (uname)[1]);
	$THISHOST = $thisHost;
}

sub sendHeader {
	my ($query) = @_;

	my $catalog = $query->param('catalog');
	if(defined($catalog)){
		$catalog =~ s/['"`]//g;
	}
  
	my $function = $query->param('function');
	if(defined($function)){
		$function =~ s/['"`]//g;
	}

	my $preloader;
	if ($catalog) {
		$preloader = <<"HTML";
<style type="text/css">
#preloader {
padding:3px;
position:absolute;
left:0;
top:0;
width:70px;
background:#3c3;
color:#fff;
font-family: Verdana,Arial,Helvetica,sans-serif;
font-size: 8pt;
}
</style>
<script type="text/javascript">
var hideLoader = function(){
	dojo.style(dojo.byId("preloader"), "display", "none");
}
HTML
	} elsif (!$function) {
		 $preloader = <<"HTML";
<style type="text/css">
#preloader {
left:0px;top:0px;
width:100%; height:100%; margin:0; padding:0;
background:#fff url('images/loading.gif') no-repeat center center;
position:absolute;
z-index:99999;
}
</style>
<script type="text/javascript">
var hideLoader = function(){
	dojo.fadeOut({
		node:"preloader",
		duration:1000,
		onEnd: function() {
			dojo.style("preloader", "display", "none");
		}
	}).play();
}
HTML
	}
	$preloader = $preloader . <<"HTML";
dojo.addOnLoad(function(){
	dojo.require("dijit.Dialog");
	dojo.require("dojox.layout.ContentPane");
	dojo.require("dijit.layout.TabContainer");
	dojo.require('dojo.data.ItemFileReadStore');
	dojo.require('dijit.Tree');
	dojo.require('dijit.layout.AccordionContainer');
	dojo.require('dijit.layout.AccordionPane');
	dojo.require("dijit.layout.TabContainer");
	dojo.require("dojox.widget.Wizard");
	dojo.require('dijit.form.Button');
	dojo.require("dijit.form.DateTextBox");
	dojo.require("dojo.io.iframe");
	dojo.require("dojox.xml.parser");
	dojo.require("dojox.html.entities");
	dojo.addOnLoad(function(){
		hideLoader();
	});
});
</script>
HTML
	my $commonHeader;
	if( open(F,"<$dir/html/header.htm") ) {
	  while( <F> ) {
		 $_ =~ s/USER/$USERID/g;
		 $_ =~ s/HOST/$THISHOST/g;
		 $_ =~ s/<!--Preloader-->/$preloader/;
		 $commonHeader .= $_;
	  }
	  close(F);
	}

	print $commonHeader;
	if(!defined($catalog)){
		$catalog = "";
	}
	print "<nav><ul class=\"lotusTabs\" role=\"navigation\">\n";
	print "<li class=" . ($catalog eq "request" ? "\"lotusSelected\"":"") . "><div><a href=\"portal.cgi?catalog=request\"><b>Request Resources</b></a></div></li>\n";
	print "<li class=" . ($catalog eq "image" ? "\"lotusSelected\"":"") . "><div><a href=\"portal.cgi?catalog=image\"><b>Image Library</b></a></div></li>\n";
	print "<li class=" . ($catalog eq "job" ? "\"lotusSelected\"":"") . "><div><a href=\"portal.cgi?catalog=job\"><b>Job Management</b></a></div></li>\n";
	print "<li class=" . ($catalog eq "system" ? "\"lotusSelected\"":"") . "><div><a href=\"portal.cgi?catalog=system\"><b>System Management</b></a></div></li>\n" if($::ISADMIN);
	print "<li class=" . ($catalog eq "energy" ? "\"lotusSelected\"":"") . "><div><a href=\"portal.cgi?catalog=energy\"><b>Energy Management</b></a></div></li>\n";
	print "<li class=" . ($catalog eq "billing" ? "\"lotusSelected\"":"") . "><div><a href=\"portal.cgi?catalog=billing\"><b>Billing / Metering</b></a></div></li>\n";
	print "<li class=" . ($catalog eq "user" ? "\"lotusSelected\"":"") . "><div><a href=\"portal.cgi?catalog=user\"><b>Users / Groups</b></a></div></li>\n";
	print "</ul></nav>\n";
	print "</div></div></header>\n";
}
sub sendFooter {
	my ($query) = @_;

	my $commonFooter;
	if( open(F,"<$dir/html/footer.htm") ) {
	  while( <F> ) {
		 $_ =~ s/USER/$USERID/g;
		 $_ =~ s/HOST/$THISHOST/g;
		 $commonFooter .= $_;
	  }
	  close(F);
	}

	print $commonFooter;
}

sub error {
	print "Error: $_[0]";
	exit(1);
}

sub logout {
	print "You have logged out of the Self-service Web Portal. Thank you for using IBM HPC Management Suite for Cloud.";
	my $script = <<"SCRIPT";
<script type="text/javascript" language="JavaScript">
function logout() {
	var ret = confirm("Thank you for using IBM HPC Management Suite for Cloud. Are you sure you want to logout ?");
	if (ret) {
		if (window.XMLHttpRequest) {
			// for IE7+, Firefox, Chrome, Opera, Safari
			xmlhttp = new XMLHttpRequest();
		} else {
			// for older versions of IE
			xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
		}

		var logoutUrl = window.location.protocol + "//logout:logout@" + window.location.host + "/hpccloud/portal.cgi";
		xmlhttp.open("GET", logoutUrl, true);
		xmlhttp.send(null);
		setTimeout("window.location.href='portal.cgi'", 200);
	} else {
		window.location.href = "portal.cgi";
	} 
}

logout();
</script>
SCRIPT
	print $script;

	print "</body></html>";
}

sub printMenuTree {
	my ($url, $id) = @_;

	print "<div class=\"lotusMenu\" role=\"menu\"><div class=\"lotusBottomCorner\"><div class=\"lotusInner\">\n";

	print "<div class=\"lotusMenuSection\">\n";
	print "<div class=\"oneui30\">\n";
	print "<div dojoType=\"dojo.data.ItemFileReadStore\" jsId=\"menuStore\" url=" . $url . "></div>\n";
	print "<div dojoType=\"dijit.tree.ForestStoreModel\" jsId=\"menuModel\" store=\"menuStore\" query=\"{type:'mainMenu'}\" rootId=\"menuRoot\" rootLabel=\"Public Folders\" childrenAttrs=\"children\"></div>\n";
	print "<div id=\"dojoMenuTree\" class=\"lotusMenu\" role=\"menu\">\n";
	print "<div class=\"lotusBottomCorner\">\n";
	print "<div class=\"lotusInner\">\n";
	print "<div dojoType=\"dijit.Tree\" jsId=\"navTree\" model=\"menuModel\" openOnClick=\"True\" showRoot=\"false\" class=\"lotusTree\" role=\"menu\">\n";

	my $script = <<"SCRIPT";
				<script type="dojo/method" event="onClick" args="item, node">
					/* method overrides the onClick event */
					if (this._selectedNode)
						dojo.removeClass(this._selectedNode.rowNode, "lotusSelected");
					this._selectedNode = node;
					dojo.addClass(this._selectedNode.rowNode, "lotusSelected");
					navLink(menuStore.getValue(item, "id"), menuStore.getValue(item, "link"));
				</script>
				<script type="dojo/connect" event="startup">
					/* set the indent before the tree is displayed */
					this._nodePixelIndent = 10;
					var tmph = dojo.connect(this, 'onLoad', function() {
						selectTreeNodeByLink(navTree, '$id');
					});
				</script>
SCRIPT

	print $script. "\n";
	print "</div></div></div></div><!--end menutree-->\n";
	print "</div></div><!--end section-->\n";
	print "</div></div></div><!--end menu-->\n";
}

sub home {
	print "<div class=\"lotusMain\">\n";
	print "<div class=\"lotusColLeft\"></div>\n";

	my $me = $USERID;
	print "<div class=\"lotusContent\" role=\"main\" id=\"mainDiv\">\n";

	print "<h4><b>IBM HPC Management Suite for Cloud</b></h4>
			 Welcome to the Self-service Web Portal for Administrators and Users<p>";

	print "<br>";
	print "Logged in as <b>$me</b><p>";
	print "Check your account balance info <a href=\"portal.cgi?catalog=billing\">here</a>.</p>";
	print "</div>";
	print "</div><!--end main-->";

	sendFooter();
}

sub getQueryStr {
	my ($query) = @_;
	my $qstr = $query->query_string;

	$qstr =~ s/catalog=//g;

	return $qstr;
}

sub request {
	my ($query) = @_;
	my $function = $query->param('function');
	if(defined($function)){
		$function =~ s/['"`]//g;
	}
	my $menuId;
	my $extra_qstr = getQueryStr($query);
	if(!$function) {
		$function = 'listProv';
		$extra_qstr = $extra_qstr . "&function=$function";
	}

	if($function eq "editProv") {
		$menuId = 'listProv';
	} elsif ($function eq "listMach") {
		$menuId = 'reqByName';
	} else {
		$menuId = $function;
	}

	print "<div class=\"lotusMain\">\n";
	print "<div class=\"lotusColLeft\">\n";

	my $menujson = "json/menutree/";
	if ($::ISADMIN) {
		$menujson = $menujson . "admin/";
	} else {
		$menujson = $menujson . "user/";
	}
	$menujson = $menujson . "reqMenu.json";

	printMenuTree($menujson, $menuId);

	print "</div><!--end colLeft-->\n";
 
	print "<aside class=\"lotusColRight\"></aside><!--end colRight-->\n";

	print "<a id=\"lotusMainContent\" name=\"lotusMainContent\"></a>\n";
	print "<div class=\"lotusContent\" role=\"main\" id=\"mainDiv\">\n";
	print "<div dojoType=\"dojox.layout.ContentPane\" executeScripts=true id=\"mainContent\" doLayout=\"false\" href=\"portal.cgi?$extra_qstr\"></div>\n";
	print "</div><!--end content-->\n";
	print "</div><!--end main-->";

	sendFooter();
}

sub systemMgt {
	print "<div class=\"lotusMain\">\n";
	print "<div class=\"lotusColLeft\">\n";

	my $menujson = "json/menutree/";
	if ($::ISADMIN) {
		$menujson = $menujson . "admin/";
	} else {
		$menujson = $menujson . "user/";
	}
	$menujson = $menujson . "sysMgtMenu.json";

	printMenuTree($menujson, "listMach");

	print "</div><!--end colLeft-->\n";
		
	print "<aside class=\"lotusColRight\"></aside><!--end colRight-->\n";

	print "<a id=\"lotusMainContent\" name=\"lotusMainContent\"></a>\n";
	print "<div class=\"lotusContent\" role=\"main\" id=\"mainDiv\">\n";
	print "<div dojoType=\"dojox.layout.ContentPane\" executeScripts=true id=\"mainContent\" doLayout=\"false\" href=\"portal.cgi?function=listMach&all=1\"></div>\n";
	print "</div><!--end content-->\n";
	print "</div><!--end main-->";

	sendFooter();
}

sub imageMgt {
	print "<div class=\"lotusMain\">\n";
	print "<div class=\"lotusColLeft\">\n";

	my $menujson = "json/menutree/";
	if ($::ISADMIN) {
		$menujson = $menujson . "admin/";
	} else {
		$menujson = $menujson . "user/";
	}
	$menujson = $menujson . "imageMgtMenu.json";

	printMenuTree($menujson, "listImage");

	print "</div><!--end colLeft-->\n";

	print "<aside class=\"lotusColRight\"></aside><!--end colRight-->\n";

	print "<a id=\"lotusMainContent\" name=\"lotusMainContent\"></a>\n";
	print "<div class=\"lotusContent\" role=\"main\" id=\"mainDiv\">\n";
	print "<div dojoType=\"dojox.layout.ContentPane\" executeScripts=true id=\"mainContent\" doLayout=\"false\" href=\"portal.cgi?function=listImage\"></div>\n";
	print "</div><!--end content-->\n";
	print "</div><!--end main-->";

	sendFooter();
}

sub jobMgt {
	my ($query) = @_;
	my $function = $query->param('function');
	$function =~ s/['"`]//g;

	my $menuId;

	my $extra_qstr = getQueryStr($query);
	if(!$function) {
		$function = 'viewJobs';
		$extra_qstr = $extra_qstr . "&function=$function";
	}

	$menuId = $function;

	print "<div class=\"lotusMain\">\n";
	print "<div class=\"lotusColLeft\">\n";

	my $menujson = "json/menutree/";
	if ($::ISADMIN) {
		$menujson = $menujson . "admin/";
	} else {
		$menujson = $menujson . "user/";
	}
	$menujson = $menujson . "jobMgtMenu.json";

	printMenuTree($menujson, $menuId);

	print "</div><!--end colLeft-->\n";

	print "<aside class=\"lotusColRight\"></aside><!--end colRight-->\n";

	print "<a id=\"lotusMainContent\" name=\"lotusMainContent\"></a>\n";
	print "<div class=\"lotusContent\" role=\"main\" id=\"mainDiv\">\n";
	print "<div dojoType=\"dojox.layout.ContentPane\" executeScripts=true id=\"mainContent\" doLayout=\"false\" href=\"portal.cgi?$extra_qstr\"></div>\n";
	print "</div><!--end content-->\n";
	print "</div><!--end main-->";

	sendFooter();
}

sub energyMgt {
	my ($query) = @_;
	print "<div class=\"lotusMain\">\n";
	print "<div class=\"lotusColLeft\">\n";

	my $menujson = "json/menutree/";
	if ($::ISADMIN) {
		$menujson = $menujson . "admin/";
	} else {
		$menujson = $menujson . "user/";
	}
	$menujson = $menujson . "energyMgtMenu.json";
	my $menuId;

	my $extra_qstr = getQueryStr($query);
	my $function = $query->param('function');
	if(!$function) {
		$function = 'energyScheme';
		$extra_qstr = $extra_qstr . "&function=$function";
	}

	$menuId = $function;

	printMenuTree($menujson, $menuId);

	print "</div><!--end colLeft-->\n";

	print "<aside class=\"lotusColRight\"></aside><!--end colRight-->\n";

	print "<a id=\"lotusMainContent\" name=\"lotusMainContent\"></a>\n";
	print "<div class=\"lotusContent\" role=\"main\" id=\"mainDiv\">\n";
	print "<div dojoType=\"dojox.layout.ContentPane\" executeScripts=true id=\"mainContent\" doLayout=\"false\" href=\"portal.cgi?$extra_qstr\"></div>\n";
	print "</div><!--end content-->\n";
	print "</div><!--end main-->";

	sendFooter();
}

sub billing {
	my ($query) = @_;
	my $function = $query->param('function');
	$function =~ s/['"`]//g;

	print "<div class=\"lotusMain\">\n";
	print "<div class=\"lotusColLeft\">\n";

	my $menujson = "json/menutree/";
	if ($::ISADMIN) {
		$menujson = $menujson . "admin/";
	} else {
		$menujson = $menujson . "user/";
	}
	$menujson = $menujson . "billingMenu.json";
	my $menuId;

	my $extra_qstr = getQueryStr($query);
	if(!$function) {
		$function = 'billingInfo';
		$extra_qstr = $extra_qstr . "&function=$function";
	}

	if($function eq "accounting") {
		$menuId = 'billingInfo';
	} else {
		$menuId = $function;
	}

	printMenuTree($menujson, $menuId);

	print "</div><!--end colLeft-->\n";

	print "<aside class=\"lotusColRight\"></aside><!--end colRight-->\n";

	print "<a id=\"lotusMainContent\" name=\"lotusMainContent\"></a>\n";
	print "<div class=\"lotusContent\" role=\"main\" id=\"mainDiv\">\n";
	print "<div dojoType=\"dojox.layout.ContentPane\" executeScripts=true id=\"mainContent\" doLayout=\"false\" href=\"portal.cgi?$extra_qstr\"></div>\n";
	print "</div><!--end content-->\n";
	print "</div><!--end main-->";

	sendFooter();
}

sub userMgt {
	my ($query) = @_;
	my $function = $query->param('function');
	$function =~ s/['"`]//g;

	print "<div class=\"lotusMain\">\n";
	print "<div class=\"lotusColLeft\">\n";

	my $menujson = "json/menutree/";
	if ($::ISADMIN) {
		$menujson = $menujson . "admin/";
	} else {
		$menujson = $menujson . "user/";
	}
	$menujson = $menujson . "userMgtMenu.json";

	my $menuId = "listUser";

	if($::ISADMIN && $function eq "addUserForm") {
		$menuId = "listUser";
	} elsif ($function eq "addGroupForm") {
		$menuId = "listGroup";
	}

	printMenuTree($menujson, $menuId);

	print "</div><!--end colLeft-->\n";

	print "<aside class=\"lotusColRight\"></aside><!--end colRight-->\n";

	print "<a id=\"lotusMainContent\" name=\"lotusMainContent\"></a>\n";
	print "<div class=\"lotusContent\" role=\"main\" id=\"mainDiv\">\n";
	print "<div dojoType=\"dojox.layout.ContentPane\" executeScripts=true id=\"mainContent\" doLayout=\"false\" href=\"portal.cgi?function=$menuId\"></div>\n";
	print "</div><!--end content-->\n";
	print "</div><!--end main-->";

	sendFooter();
}

sub listProv {

	my $html = <<"HTML";
	<div dojoType="dijit.layout.TabContainer" style="width: 100%;" id="tabProv" doLayout="false">
	<div dojoType="dojox.layout.ContentPane" executeScripts=true id="tabProvList" title="<b>List View</b>" href="portal.cgi?function=listProvList" refreshOnShow="true" selected="true">
	<script type="dojo/connect" event="onLoad">
		var tab = dojo.byId('tabProvList');
		dijit.byId('tabProv').resize({h:tab.scrollHeight+300});
		dijit.byId('tabProv').resize({h:tab.scrollHeight+300});
	</script>
	<script type="dojo/connect" event="onShow">
		onTop = "list";
	</script>
	</div>
	<div dojoType="dojox.layout.ContentPane" executeScripts=true id="tabProvCal" title="<b>Calendar View</b>" href="portal.cgi?function=listProvCal">
	<script type="dojo/connect" event="onLoad">
		var tab = dojo.byId('tabProvCal');
		dijit.byId('tabProv').resize({h:tab.scrollHeight+500});
	</script>
	<script type="dojo/connect" event="onShow">
		onTop = "cal";
		dijit.byId('tabProv').resize({h:600});
	</script>
	</div>
	</div>
HTML

	print $html;

	my $script = <<"SCRIPT";
<script type="text/javascript" language="JavaScript">
var onTop = "list";
</script>
SCRIPT
	print $script;
}

sub viewProvInList {

	my($query) = @_;

	my $var4js;
	my $i = 0;
	my $myES = EnergyUtils->getEnergyScheme($USERID);
	# getEnergySchemeAllInfo has been enhanced to return the scheme owner by $USERID or default.
	foreach my $id (keys %$myES) {
		$var4js .= "var scheme$i = new Object();\nscheme$i.name=\"$myES->{$id}->{'energy_scheme.name'}\";\nscheme$i.owner=\"$myES->{$id}->{'energy_scheme.owner'}\";\narray_scheme.push(scheme$i);\n";
		$i++;
	}

	my $script = <<"SCRIPT";
<script type="text/javascript" language="JavaScript">
var array_scheme = new Array();
$var4js
function select_all(){
	var checked;
	if (document.provForm.selectAll.checked) checked=true;
	else checked=false;
	var inputs = document.getElementsByTagName("input");
	for(var i=0;i<inputs.length;i++)
	{
		if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].getAttribute("name") == "provID")	 
		{
			inputs[i].checked = checked;	 
		} 
	}  
}
function select_allM(formId) {
	var checked;
	var mform = document.getElementById(formId);
	if (mform.selectAllM.checked) checked=true;
	else checked=false;
	var inputs = mform.getElementsByTagName("input");
	for(var i=0;i<inputs.length;i++)
	{
		if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].getAttribute("name") == "machName")
		{
			inputs[i].checked = checked;
		}
	}
}
</script>
SCRIPT

	print $script;
	print "<script language=\"javascript\" type=\"text/javascript\" src=\"/hpccloud/scripts/ProvisionStatus.js\"></script>\n";
	print "<script language=\"javascript\" type=\"text/javascript\" src=\"/hpccloud/scripts/machAction.js\"></script>\n";

	my $prov_tab;

	$prov_tab .= "<form name='provForm' id='provForm' method=post action=portal.cgi>";
	$prov_tab .= "<input type=hidden name=function value=removeProv>";

	$prov_tab .= "<table id=\"reqlistTab\" border=0 cellpadding=2 cellspacing=2 bgcolor=#e3e3d1 style=\"text-align:center\">";
	$prov_tab .= "<tr valign=\"middle\">
	<th align=left colspan=8><table>";
	$prov_tab .= "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"provAction('provForm');\" baseClass=tundra iconClass=\"dijitIcon dijitIconDelete\">Cancel Request</button></td><td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"dijit.byId('tabProvList').refresh();\" baseClass=tundra iconClass=\"dijitIcon dijitIconUndo\">Refresh</button></td><td>Show Failed Provision</td><td><input type=checkbox name=showfailedprov  id=showfailedprov value=0 onClick=\"onDispFailedProvCheckBox()\" ></td></table></th></tr>";

	$prov_tab .= "<tr class='tab_head'><td><input type=checkbox name=selectAll onClick=\"select_all()\" title=\"Select/Deselect all\"></td>
	<td width=200><a href=\"javascript:sortReqTab('name');\" title=\"Sort by name\">Request</a></td>
	<td width=80><a href=\"javascript:sortReqTab('owner');\" title=\"Sort by owner\">Owner</a></td>
	<td width=160><a href=\"javascript:sortReqTab('sdate')\" title=\"Sort by start date\">Start Date</a></td>
	<td width=60><a href=\"javascript:sortReqTab('duration');\" title=\"Sort by duration\">Duration(m)</a></td>
	<td width=160><a href=\"javascript:sortReqTab('edate');\" title=\"Sort by end date\">End Date</td>
	<td width=80><a href=\"javascript:sortReqTab('state');\" title=\"Sort by state\">State</a></td>
	<td width=80>Modify</td>
	<td width=70>Type</td>
	<td width=80><a href=\"javascript:sortReqTab('num');\" title=\"Sort by number\"># Machines</a></td>
	<td width=100>OS Image</td>
	<td width=50>Sub C</td>
	<td>Energy(kWh)</td>
	<td>Vlan Flag</td>
	<td>Vlan ID</td>
	</tr>";

	print $prov_tab;
	print "<tr><td colspan=16><b>Loading...</b></td></tr>";
	print "</table>";
	print "</form>";
}

sub viewProvInCal {
	my($query) = @_;

	print "<script language=\"javascript\" type=\"text/javascript\" src=\"/hpccloud/scripts/datePicker.js\"></script>\n";
	print "<SCRIPT language=\"javascript\" type=\"text/javascript\" src=\"/hpccloud/scripts/LLWebUI.js\"></SCRIPT>";
	print "<SCRIPT language=\"javascript\" type=\"text/javascript\" src=\"/hpccloud/scripts/ReservationViewLib.js\"></SCRIPT>";
	print "<SCRIPT language=\"javascript\" type=\"text/javascript\" src=\"/hpccloud/scripts/ProvisionCalendarView.js\"></SCRIPT>";

	my $isAdmin = "false";
	if ( $::ISADMIN ) { $isAdmin = "true"; }

	print "<input id=\"isAdmin\" type=\"hidden\" name=\"isAdmin\" value=\"$isAdmin\" />";
	print "<input type=\"hidden\" id=\"userName\" value=\"$USERID\"/>";
	print "<input id=\"refreshInterval\" type=\"hidden\" name=\"refreshInterval\" value=300000 />";
	print "<table><tr><td width=200>You can select the date</td><td><div id=\"cv_options\"></div></td></tr></table><p><p>";

	print "<div id=\"reservation_calendar_view\" style=\"border:1px solid gray\"></div>";

	my $script = <<"SCRIPT";
<script type="text/javascript" language="JavaScript">
lib_init("/hpccloud");
cv_init();
cv_show();
var tab = dojo.byId('tabProvList');
dijit.byId('tabProv').resize({h:600});
</script>
SCRIPT
	print $script;

	print "</body></html>";
}

sub validFormDate {
	my ($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$isdst);
	($mon,$day,$year) = @_;

	if ("$mon$day$year" eq "") {
		($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$isdst) = localtime;
		$year += 1900;
	}

	error("Invalid date [$mon/$day/$year] - use the Date Selector icon (<img src=/hpccloud/images/cal.gif alt=\"Date Picker\">) for easy input")
	if( "$mon$day$year" !~ /^\d+$/ ||
		$mon > 12 ||
		$day > 31
	);

	return($mon,$day,$year);
}

#-------------------------------------------------------------------------------

sub isLeap {

	my ($year) = @_;

	return (($year % 4 == 0) && ($year % 100 != 0)) ||
		  (($year % 4 == 0) && ($year % 400 == 0));
}

#-------------------------------------------------------------------------------


sub validDay {

	# adjust input date for exceptions to avoid fantasy dates

	my ($day,$mon,$year) = @_;
	my @monthDays = (31,0,31,30,31,30,31,31,30,31,30,31);
	$monthDays[1] = isLeap($year) ? 29 : 28;

	return( ($day > $monthDays[$mon]) ? $monthDays[$mon] : $day );
}

#-------------------------------------------------------------------------------

sub formDate {

	# prompt for date and, optionally, time input, use passed values as selected
	# starting points

	my($mday,$mon,$year,$dayFormvar,$monFormvar,$yearFormvar,$getTime,
	  $hour,$min,$hourFormvar,$minFormvar,$dontShowMins, $attr, $imgid) = @_;

	#
	# date input form
	#

	$mday = sprintf("%02d",$mday);
	$mon++; $mon = sprintf("%02d",$mon);
	my $fieldValue = "$mon/$mday/$year";
	my $fieldName = "$monFormvar|$dayFormvar|$yearFormvar";
	if(!defined($attr)){
		$attr = "";
	}
	print "<input class=formfield type=text name=\"$fieldName\" id=\"$fieldName\" size=10 value=\"$fieldValue\" onchange=\"\" $attr>";
	#print "<input class=formfield type=text name=\"$fieldName\" id=\"$fieldName\" style=\"width:80px\" size=10 value=\"$fieldValue\" dojoType=\"dijit.form.DateTextBox\" $attr>";
	#print " <img src=/syspool.doc/cal.gif alt=\"Date Picker\" onmouseover=\"bubble('bubbles','Date Selector');\" onmouseout=\"bubble('bubbles','');\" onclick=\"displayDatePicker('" . $fieldName . "', false, 'mdy', '/');\"> ";
	my $vis = "";
	if ($attr eq "disabled") {
		$vis = "style=\"visibility: hidden;\"";
	}
	$imgid = "calImg" if (!$imgid);
	print " <img id=$imgid src=/hpccloud/images/cal.gif alt=\"Date Picker\" onclick=\"displayDatePicker('" . $fieldName . "', false, 'mdy', '/');\" $vis> ";

	#
	# time input form
	#

	return unless( $getTime );

	print "&nbsp;&nbsp;&nbsp;<select class=formfield name=$hourFormvar id=$hourFormvar $attr>";
	for(my $i=0; $i<24; $i++) {
	  if( $hour == $i ) {
		 printf("<option value=$i selected>%02d</option>",$i);
	  }
	  else {
		 printf("<option value=$i>%02d</option>",$i);
	  }
	}
	print "</select>";

	unless( $dontShowMins ) {
	  print " : <select class=formfield name=$minFormvar id=$minFormvar $attr>";
	  for(my $i=0; $i<60; $i++) {
		 if( $min == $i ) {
			printf("<option value=$i selected>%02d</option>",$i);
		 }
		 else {
			printf("<option value=$i>%02d</option>",$i);
		 }
	  }
	}
	else {
	  if( $fieldName =~ /end/i ) {
		 print ":59";
	  }
	  else {
		 print ":00";
	  }
	}
	print "</select>";
}

sub addEventToDate {
	my $script = <<"SCRIPT";
\n<script type="text/javascript" language="JavaScript">
addEventToDate();
</script>
SCRIPT
	print $script;
}

sub reqByName {
	my ($query) = @_;

	my @machlist;
	push @machlist, $query->param('machName');

	my $allMach = CloudUtils->getAllPMachName;

	print "<div id=\"reqWizard\" dojoType=\"dojox.widget.Wizard\" style=\"width:100%\">\n";
	print "<form id=reqForm method=post action=portal.cgi>";
	print "<input type=hidden name=function value=summary>";

	print "<div dojoType=\"dojox.widget.WizardPane\" canGoBack=\"false\" passFunction=\"checkReqForm\">\n";
	print "<blockquote>";
	print "<table border=0 cellpadding=2 cellspacing=2>";
	print "<tr><td class='tab_highlight' colspan=1>Select machines</td><td> </td></tr>";
	print "<tr>
			 <td class=formprompt width=200>Selected machine(s)</td>
			 <td><select class=formfield multiple=\"multiple\" id=machList name=machList size=5 style=\"width:300px;\">";
	foreach my $mach ( sort @{$allMach} ) {
		my $selected = (grep /^$mach$/, @machlist) ? "selected" : "";
		print "<option value=$mach $selected>$mach</option>";
	}
	print "</select></td></tr>";
	&reqCommonField;
}

sub reqByType {

	print "<div id=\"reqWizard\" dojoType=\"dojox.widget.Wizard\" style=\"width:100%\">\n";
	print "<form id=reqForm method=post action=portal.cgi>";
	print "<input type=hidden name=function value=summary>";

	print "<div dojoType=\"dojox.widget.WizardPane\" canGoBack=\"false\" passFunction=\"checkReqForm\">\n";
	print "<blockquote>\n";
	print "<table border=0 cellpadding=2 cellspacing=2>";
	print "<tr><td class='tab_highlight' colspan=1>Select machines</td><td> </td></tr>";

	my $syscnf = CloudUtils->getConfig();
	my @types;
	if ($syscnf) {
		if (defined($syscnf->{'machTypeName'})) {
			@types = split(/,/, $syscnf->{'machTypeName'});
		}
	}

	my $opts = "";
	foreach my $type (@types) {
		$opts .= "<option value=\"$type\">$type</option>";
	}
	print "<tr><td class=formprompt rowspan=2>";
	print "<table cellpadding=2 cellspacing=2>";
	print "<tr><td>Type</td></tr>";
	print "<tr><td>How many machines would you like?</td></tr>";
	print "</table></td>";
	print "  <td>
			 <select class=formfield name=\"machType\" id=\"machType\" onchange=\"javascript:onSelectMachType();\">$opts</select>
			 </td></tr>";
	print "<tr>";
	print "<td class=formfield><input type=text name=machNum id=machNum value=1 size=4>";
	print "</td></tr>";
	print "<tr id=\"reqCPU\" style=\"visibility:collapse;\"><td class=formprompt>VCPU</td><td class=formfield><input type=text name=vmCPU id=vmCPU value=2 size=2></td></tr>";
	print "<tr id=\"reqMem\" style=\"visibility:collapse;\"><td class=formprompt>Memory</td><td class=formfield><input type=text name=vmMem id=vmMem value=4000 size=8>MB</td></tr>";
# Do not support disk now.
#	print "<tr id=\"reqDisk\" style=\"visibility:collapse;\"><td class=formprompt>Disk</td><td class=formfield><input type=text name=vmDisk id=vmDisk size=8></td></tr>";
	&reqCommonField;
}

sub reqCommonField {
	my ($query) = @_;
	my $stime=0;
	my $etime=6000;
	if(defined($query->param('stime'))){
		$stime = $query->param('stime');
	}
	if(defined($query->param('etime'))){
		$etime = $query->param('etime');
	}
	my $duration;
	if (!defined($query->param('stime')) || !defined($query->param('etime'))) { $duration = 100; }
	else { $duration = int (($etime - $stime) / 60);}
	print "<tr><td class=formprompt rowspan=5>Options</td></tr>";
	my $script = <<"SHOW_4ITEM";
	<script language="JavaScript">
	<!--  
	function show_4item(  ) { 
		if (document.getElementById("subcluster").checked == true) {
			document.getElementById("scheduler_select").style.display = "block";
		} else {
			document.getElementById("scheduler_select").style.display = "none";
		}
		if (document.getElementById("setuppe").checked == true) {
			document.getElementById("environment_select").style.display = "block";
		} else {
			document.getElementById("environment_select").style.display = "none";
		}
	}
	-->
	</script> 
SHOW_4ITEM
	print $script;
	print "<tr><td class=formfield>Setup Sub Cluster<input type=checkbox name=subcluster id=subcluster value=1 onClick=\"show_4item();\" title=\"Setup your machines as a separate sub cluster\"><select id=\"scheduler_select\" name=\"scheduler_select\" style = \"display:none\" size=1>";
	my @scheduler_option = qw/loadl lsf pbs sge others/;
	foreach my $scheduler(@scheduler_option) {
		print "<option value=\"$scheduler\">$scheduler</option>";
	}
	print "</select>";
	print "</td></tr>";

	print qq(<tr><td class=formfield>Setup PE<input type=checkbox name=setuppe id=setuppe value=1 onClick="show_4item()" title="Setup parallel evnironment">);
	print "<select id=\"environment_select\" name=\"environment_select\" style = \"display:none\" size=1>";
	my @environment_option = qw/pe openmpi others/;
	foreach my $environment(@environment_option) {
		print "<option value=\"$environment\">$environment</option>";
	}
	print "</select>";
	print "</td></td></tr>";

	print "<tr><td class=formfield>Network <select id=\"network_select\" name=\"network_select\" size=1>";
	my @network_option = qw/eth ib others/;
	foreach my $network(@network_option) {
		print "<option value=\"$network\">$network</option>";
	}
	print "</select>";
	print "</td></tr>";

	print "<tr><td class=formfield>Shared file system <select id=\"filesystem_select\" name=\"filesystem_select\" size=1>";
	my @filesystem_option = qw/NA nfs gpfs others/;
	foreach my $filesystem(@filesystem_option) {
		print "<option value=\"$filesystem\">$filesystem</option>";
	}
	print "</select>";
	print "</td></tr>";
	print "<tr><td class='tab_highlight' colspan=1><font color=#f7f9e5><b>Schedule Your Request</b></font></td><td> </td></tr>";
	# start date and repeats

	my $stamp = scalar localtime() . " $timeZone";
	my ($nsec,$nmin,$nhour,$nmday,$nmon,$nyear,$nwday,$nyday,$nisdst) = localtime();
	$nyear += 1900;
	$nmon += 1;
	my $now_time = "$nmon/$nmday/$nyear/$nhour/$nmin";
	print "<input type=hidden id=now_time value=$now_time>";

	print "<tr>
			 <td class=formprompt>Start Date</td>
			 <td class=formfield>";
	my $mark = $stime || (time + 900);
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($mark);
	$year += 1900;
	formDate($mday,$mon,$year,"start_day","start_mon","start_year",1,
			 $hour,$min,"start_hour","start_min");
	print "<br>Time on this machine is <b>$stamp</b><br>Allow <b>5 minutes</b> for setup</b></td>";
	print "</tr>";

	print "<tr><td class=formprompt rowspan=2>";
	print "<table align=right><tr><td><input type=radio checked name=durActive value=1 onclick=\"active();\">&nbsp;Duration</td></tr>";
	print "<tr><td><input type=radio name=durActive value=0 onclick=\"active();\">End Date</td></tr></table>";
	print "</td>";
	print "<td class=formfield><input type=text name=duration id=duration value=\"$duration\" size=8 onblur=\"updateEndFromDuration();\">minutes";
	print "</td></tr>";

	# end date

	print "<tr>";
	print "<td class=formfield>";
	$mark = $etime || $mark + 6000;
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($mark);
	$year += 1900;
	formDate($mday,$mon,$year,"end_day","end_mon","end_year",1,
			 $hour,$min,"end_hour","end_min","","disabled","calImgE");

	print "<td> </td></td></tr>";
	print "</table>";
	print "<input type=hidden name=origstime value=$stime>
		<input type=hidden name=origetime value=$etime>";
	print "<p>";

	&addEventToDate;
	print "</blockquote>";
	print "</div>\n";
	print "<div dojoType=\"dojox.widget.WizardPane\" canGoBack=\"true\"  passFunction=\"checkReqFormNext\">\n";
	print "<table border=0 name=\"reqmimaglist_tab\" id=\"reqmimaglist_tab\" cellpadding=2 cellspacing=2>";
	print "<tr><td class='tab_highlight' colspan=6>Choose an OS image from the list below</td><td> </td></tr>";
	print "<tr class='tab_head'>";
	print "<td width=30></td>";
	print "<td width=100>Name</td>";
	print "<td width=240>OS</td>";
	print "<td width=100>Machine Type supported</td>";
	print "<td width=100>Infrastracture</td>";
	print "<td width=300>Description</td>";
	print "</tr>";
	print "</table>";
	print "</div>\n";

	print "<div dojoType=\"dojox.widget.WizardPane\" doneFunction=\"submitReqForm\">\n";
	my $uhash = CloudUtils->getAllUser;
	my @allUName = sort keys %$uhash;
	my $allUserOpts;
	my $defaultOpts="";
	foreach my $uname (@allUName) {
		if($uname eq $USERID) {
			$defaultOpts .= "<option value=\"$uname\" disabled>$uname</option>";
		}else {
			$allUserOpts .= "<option value=\"$uname\">$uname</option>";
		}
	}

	print "<h2>Select the users and groups who can use the Request: <p></h2>";

	print "<table border=0 cellpadding=2 cellspacing=2>";
	print "<tr><td class='tab_highlight' colspan=2><font color=#f7f9e5><b>For Users</b></font></td><td> </td></tr>";
	print "<tr><td><!--input type=radio checked name=mode_u value=1--></td><td class=formprompt>Allow these users to use this request</td>";
	print "<td>";
	print "<table>";
	print "<tr><td>Users</td><td></td><td>Authorized Users</td></tr>";
	print "<tr><td><select class=formfield multiple=\"multiple\" name=allUsers id=allUsers size=6 style=\"width:200px;\">$allUserOpts</select></td>";
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"moveItem('allUsers', 'allowedUsers');\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconRedo\" showLabel=false>-></button><br>";
	print "<button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"moveItem('allowedUsers', 'allUsers');\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconUndo\" showLabel=false><-</button></td>";
	print "<td><select class=formfield multiple=\"multiple\" name=allowedUsers id=allowedUsers size=6 style=\"width:200px;\">$defaultOpts</select></td>";
	print "</table>";
	print "</td></tr>";

	my $ghash = CloudUtils->getAllGroup;
	my @allGName = sort keys %$ghash;
	my $allGrpOpts;
	foreach my $gname (@allGName) {
		$allGrpOpts .= "<option value=\"$gname\">$gname</option>" if($gname);
	}

	print "<tr><td class='tab_highlight' colspan=2><font color=#f7f9e5><b>For Groups</b></font></td><td> </td></tr>";
	print "<tr><td><!--input type=radio checked name=mode_g value=1--></td><td class=formprompt>Allow these groups to use this request</td>";
	print "<td>";
	print "<table>";
	print "<tr><td>Groups</td><td></td><td>Authorized Groups</td></tr>";
	print "<tr><td><select class=formfield multiple=\"multiple\" name=allGrps id=allGrps size=6 style=\"width:200px;\">$allGrpOpts</select></td>";
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"moveItem('allGrps', 'allowedGrps');\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconRedo\" showLabel=false>-></button><br>";
	print "<button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"moveItem('allowedGrps', 'allGrps');\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconUndo\" showLabel=false><-</button></td>";
	print "<td><select class=formfield multiple=\"multiple\" name=allowedGrps id=allowedGrps size=6 style=\"width:200px;\"></select></td>";
	print "</table>";
	print "</td></tr>";
	print "</table>";
	print "</div>\n";

	print "</form>\n";

	print "<script type=\"dojo/method\" event=\"cancelFunction\">\n
			 if(confirm(\"Do you want to quit the guide?\")) {
				navLink(\"listProv\");
			 }
			</script>\n";
	print "</div>";

	print "<div id=\"summaryDialog\" dojoType=\"dijit.Dialog\" title=\"Summary\">\n";
	print "</div>";
}

sub summary {
	my ($query) = @_;

	my ($start_mon,$start_day,$start_year) = validFormDate(split(/\//,$query->param('start_mon|start_day|start_year')));
	my $start_hour = $query->param('start_hour');
	my $start_min = $query->param('start_min');
	my($end_mon,$end_day,$end_year);
	if(defined($query->param('end_mon|end_day|end_year'))){
		($end_mon,$end_day,$end_year)  = validFormDate(split(/\//,$query->param('end_mon|end_day|end_year')));
	}
	my $end_hour = $query->param('end_hour');
	my $end_min = $query->param('end_min');
	my $duration = $query->param('duration');

	$start_mon--;
	$start_day  = validDay($start_day,$start_mon,$start_year);
	my $start_date = timelocal(0,$start_min,$start_hour,$start_day,$start_mon,$start_year,0,0,0);

	my $end_date;

	if ($duration) {
		$end_date = $start_date + $duration * 60;
	} else {
		$end_mon--;
		$end_day  = validDay($end_day,$end_mon,$end_year);
		$end_date = timelocal(0,$end_min,$end_hour,$end_day,$end_mon,$end_year,0,0,0);

		$duration = ($end_date - $start_date) / 60;
	}

	my $stime = $start_date;
	my $etime = $end_date;

	my $machType = $query->param('machType');
	my $machNum = $query->param('machNum');
	my @machList = $query->param('machList');
	my $osimage = $query->param('osimage');
	my @authUsers = $query->param('allowedUsers');
	my $user_list = join ",", @authUsers;
	my @authGrps = $query->param('allowedGrps');
	my $grp_list = join ",", @authGrps;
	my $subcluster = $query->param('subcluster');
	if(!defined($subcluster)){
		$subcluster = 0;
	}

	# The following fields are only for VM
	my $vm_cpu = $query->param('vmCPU');
	my $vm_mem = $query->param('vmMem');

	print "You requested the following - Confirm your selections or Cancel to make changes<p>";
	print "<table border=0 cellpadding=2 cellspacing=2>";
	print "<tr><td class='tab_highlight' colspan=1>Selected machines</td><td> </td></tr>";
	if ($machType) {
		print "<tr><td class=formprompt>Machine Type</td>
				<td class=formfield>$machType</td></tr>";
		print "<tr><td class=formprompt>Number</td>
				<td class=formfield>$machNum</td></tr>";
		if ($machType eq "IBM_KVM") {
			print "<tr><td class=formprompt>CPU</td>
					<td class=formfield>$vm_cpu</td></tr>";
			print "<tr><td class=formprompt>Memory</td>
					<td class=formfield>$vm_mem</td></tr>";
		}
	} else {
		my $lst = join "<br>", @machList;
		print "<tr><td class=formprompt>Machine List</td>
				<td class=formfield>$lst</td></tr>";
	}

	print "<tr><td class='tab_highlight' colspan=1><font color=#f7f9e5><b>Configuration</b></font></td><td> </td></tr>";
	print "<tr><td class=formprompt>Operating System Image</td>
			<td class=formfield>$osimage</td></tr>";
	my $subc = $subcluster ? 'Yes' : 'No';
	print "<tr><td class=formprompt>Setup LoadLeveler Cluster</td>
			<td class=formfield>$subc</td></tr>";

	print "<tr><td class='tab_highlight' colspan=1><font color=#f7f9e5><b>Schedule</b></font></td><td> </td></tr>";
	my $start_time = localtime($stime);
	my $end_time = localtime($etime);
	print "<tr><td class=formprompt>Start Date</td>
			<td class=formfield>$start_time</td></tr>";
	print "<tr><td class=formprompt>Duration</td>
			<td class=formfield>$duration minutes</td></tr>";
	print "<tr><td class=formprompt>End Date</td>
			<td class=formfield>$end_time</td></tr>";

	my @users = split /,/, $user_list;
	my $new_ulist = join "<br>", @users;
	print "<tr><td class='tab_highlight' colspan=1><font color=#f7f9e5><b>Authorized Users/Groups</b></font></td><td> </td></tr>";
	print "<tr><td class=formprompt>Allow these users to use this request</td>
	<td class=formfield>$new_ulist</td></tr>";

	my @grps = split /,/, $grp_list;
	my $new_glist = join "<br>", @grps;
	print "<tr><td class=formprompt>Allow these groups to use this request</td>
	<td class=formfield>$new_glist</td></tr>";

	my ($enough, $cost) = getBilling($stime, $etime, $query);

	my $bal = "";
	if (!$enough) {
		$bal = "<font color=red>Insufficient balance</font>";
	}

	my $cost_str = sprintf("%d.%02d", ($cost/100), ($cost%100));
	print "<tr><td class='tab_highlight' colspan=1><font color=#f7f9e5><b>Billing</b></font></td><td> </td></tr>";
	print "<tr><td class=formprompt>Charge</td>
			<td class=formfield>US \$${cost_str}  $bal</td></tr>";
	print "<tr><td class='tab_highlight' colspan=1><font color=#f7f9e5><b>Vlan</b></font></td><td> </td></tr>";
	my $sysconf = CloudUtils->getConfig;
	my $vlanflag;
	if((lc($sysconf->{'vlanFlag'}) eq "enable") && ($subcluster == 1))
	{
			$vlanflag = "Enable";
	}
	else{
			$vlanflag = "Disable";
	}
	print "<tr><td class=formprompt>Flag</td>
			<td class=formfield>$vlanflag</td></tr>";

	print "</table>";

	print "<form id=\"createForm\" method=post action=portal.cgi>";
	print "<input type=hidden name=function value=createProv>";
	print "<input type=hidden name=stime value=$stime>";
	print "<input type=hidden name=etime value=$etime>";
	print "<input type=hidden name=duration value=$duration>";
	print "<input type=hidden name=subcluster value=$subcluster>";

	if ($machType) {
		print "<input type=hidden name=machType value=\"$machType\">";
		print "<input type=hidden name=machNum value=$machNum>";
		if ($machType eq "IBM_KVM") {
			print "<input type=hidden name=vmCPU value=\"$vm_cpu\">";
			print "<input type=hidden name=vmMem value=\"$vm_mem\">";
		}
	} else {
		foreach (@machList) {
			print "<input type=hidden name=machList value=\"$_\">";
		}
	}

	print "<input type=hidden name=osimage value=\"$osimage\">";
	print "<input type=hidden name=userlist value=$user_list>
			<input type=hidden name=grplist value=$grp_list>";

	print "\n<p><div style=\"padding: 8px 0; text-align: center;\">";
	print "<button dojoType=\"dijit.form.Button\" type=\"button\" baseClass=soria iconClass=\"dijitEditorIcon dijitEditorIconSave\" onClick=\"createReq();\">Confirm</button>&nbsp;&nbsp;&nbsp;&nbsp;";
	print "<button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"dijit.byId('summaryDialog').hide();\" baseClass=soria iconClass=\"dijitEditorIcon dijitEditorIconCancel\">Cancel</button>";
	print "</div>";
	print "</form>";
}

sub getBilling {
	my ($stime, $etime, $query) = @_;
	my $prov;
	if(defined($query->param('duration'))){
		$prov->{"duration"} = $query->param('duration');
	}else{
		$prov->{"duration"} = ($etime - $stime) / 60 
	};
	if(defined($query->param('machType'))){
		$prov->{"machtype"} = $query->param('machType');
	}
	if(defined($query->param('machNum'))){
		$prov->{"machnum"} = $query->param('machNum');
	}
	if(defined($query->param('machList'))){
		$prov->{"machlist"} = join(",", $query->param('machList'));
	}
	if(defined($query->param('osimage'))){
		$prov->{"osimage"} = $query->param('osimage');
	}
	my ($enough, $cost, $changed) = ProvUtils->getBilling($prov, 'Create');

	return ($enough, $cost);
}

sub createProv {
	my ($query) = @_;

	my $stime = $query->param('stime');
	my $etime = $query->param('etime');
	my $duration = $query->param('duration');
	my $machType = $query->param('machType');
	my $machNum = $query->param('machNum');
	my @machList = $query->param('machList');
	my $osimage = $query->param('osimage');
	my $user_list = $query->param('userlist');
	my $grp_list = $query->param('grplist');
	my $strict = $query->param('strict');
	my $subcluster = $query->param('subcluster');

	# The following fields are only for VM
	my $vm_cpu = $query->param('vmCPU');
	my $vm_mem = $query->param('vmMem');

	my $cmd;
	if (defined($machType) and ($machType eq "IBM_KVM")) {
		$cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/prov/hcmkvm ";
	} else {
		$cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/prov/hcmkreq ";
	}

	if (!$machType) { # make request by machine list
		$cmd .= " --machlist=" . (join ',', @machList);
	} elsif($machType eq "IBM_KVM") { # make vm
		$cmd .= " --vmtype=$machType --vmcount=$machNum --cpus=$vm_cpu --memory=$vm_mem";
	} else { # make request by type (blade/idataplex)
		$cmd .= " --machtype=$machType --machnum=$machNum";
	}

	my $timestr = strftime('%m-%d-%Y %H:%M:%S', localtime($stime));
	$cmd .= " --startdate='$timestr'";
	$cmd .= " --duration=$duration";

	$cmd .= " --osimage=$osimage";
	$cmd .= " --users=$user_list" if($user_list);
	$cmd .= " --groups=$grp_list" if($grp_list);
	$cmd .= " --cluster=" . ($subcluster ? "yes" : "no");
	$cmd .= "\"";

	my $output = `$cmd`;
	print $output;
}

sub editProv {
	my ($query) = @_;

	my $pid = $query->param('id');

	# The 3rd argument 2 indicates the machines being added should be included.
	my $prov = CloudUtils->getProvInfoById($pid, 1, 2);
	if (!$prov) {
		error("Failed to get information of Provision $pid.");
	}
	my $user = CloudUtils->getUserByName($USERID);
	if(!CloudUtils->checkProvAuth($prov, $user->{$USERID}) && !$::ISADMIN) {
		error("You are not authorized to do this.");
	}

	my $isOwner = $prov->{'request.owner'} eq $USERID;
	# only the owner can modify the requests not in "Canceling" "Canceled" "Expired" "Failed" status.
	my $dis = ((!$isOwner) || $prov->{'request.status'} eq "Canceling" 
				|| $prov->{'request.status'} eq "Canceled" || $prov->{'request.status'} eq "Expired"	 
				|| $prov->{'request.status'} eq "Failed"	  
				) ? "disabled" : "";
	# set 3 labels. Each of them is on the behalf of a request's situation. 
	my $provActive = 0;
	if ($prov->{'request.status'} eq "Ready" || $prov->{'request.status'} eq "Setup" || $prov->{'request.status'} eq "Reserved"
		|| $prov->{'request.status'} eq "Verifying" || $prov->{'request.status'} eq "Waiting") {
		$provActive = 1;
	}

	my $t = time;

	print "<button dojoType=\"dijit.form.Button\" type=\"button\" iconClass=\"dijitEditorIcon dijitEditorIconUndo\" onclick=\"navLink('listProv');\">Back to Request List</button>";
	print "<h2>Detailed request information" . ($dis eq "" ? " - You can update the options.<p>" : "<p>") . "</h2>";
	print "<form id=\"reqDetailForm\" method=post action=portal.cgi>";
	print "<table border=0 cellpadding=2 cellspacing=2>";
	print "<tr><td class='tab_highlight' colspan=2>Information</td><td> </td></tr>";
	print "<tr><td class=formprompt colspan=2>Request Name</td><td class=formfield>$prov->{'request.name'}</td></tr>";
	print "<input type=hidden name=id value=\"$prov->{'request.name'}\">";
	print "<input type=hidden name=oriMachNum id=oriMachNum value=\"$prov->{'request.machine_num'}\">";
	print "<input type=hidden name=modMachbymethod id=modMachbymethod value=\"\">";
	print "<tr><td class=formprompt colspan=2>Status</td><td class=formfield>$prov->{'request.status'}</td></tr>";
	print "<tr><td class='tab_highlight' colspan=2>Machine</td><td> </td></tr>";
	my $syscnf = CloudUtils->getConfig();
	my @types;
	if ($syscnf) {
		if (defined($syscnf->{'machTypeName'})) {
			@types = split(/,/, $syscnf->{'machTypeName'});
		}
	}
	my $opts = "";
	if(defined($prov->{'request.machine_type'})){
		foreach my $type (@types) {
			$opts .= "<option " . ($prov->{'request.machine_type'} eq $type ? "selected" : "") . " value=\"$type\">$type</option>";
		}
	}
	my $disable_modifymethod="";
	my $selectbytypeCheck="checked";
	my $selectbylistCheck="";
	my $selectbylistshow="none";
	my $selectbytypeshow="block";
	if($prov->{'request.select_method'} == 0){
		$disable_modifymethod="disabled";
		$selectbytypeCheck="";
		$selectbylistCheck="checked";
		$selectbylistshow="block";
		$selectbytypeshow="none";
	}
	if($prov->{'request.hypv_flag'} == -1){
		$disable_modifymethod="disabled";
	}
	print "<tr><td class=formprompt colspan=2 rowspan=4><table align=right cellpadding=2 cellspacing=2><tr><td class=formprompt>Machine Changed by</td></tr></table></td></tr>";
	my $script = <<"SHOW_MachinetypeOrlist";
	<script language="JavaScript">
	<!--  
	function display_MachTypeorlist(  ) { 
		var modTypeRadio = document.getElementsByName("modifymethod");
		var selectType;
		for(var i=0; i < modTypeRadio.length; i++) {
		if (modTypeRadio[i].checked) { selectType= modTypeRadio[i].value; }
	}
		if (selectType == "Machine Type"){
			document.getElementById("ModifyTypeTable").style.display = "block";
			document.getElementById("ModifyListTable").style.display = "none";
		} else {
			document.getElementById("ModifyTypeTable").style.display = "none";
			document.getElementById("ModifyListTable").style.display = "block";
		}
	}
	-->
	</script> 
SHOW_MachinetypeOrlist
	print $script;
#Machine Select
	print "<tr>
			 <td class=formfield >
			 <input type=radio $selectbytypeCheck name=\"modifymethod\" id=\"modifymethod_type\" value=\"Machine Type\" onclick=\"display_MachTypeorlist();\" $disable_modifymethod $dis>Machine Type &nbsp; &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;
			 <input type=radio $selectbylistCheck name=\"modifymethod\" id=\"modifymethod_list\" value=\"Machine List\" onclick=\"display_MachTypeorlist();\" $disable_modifymethod $dis>Machine List</td>	
			 </tr>";
#machine type
	print "<tr><td><table id=\"ModifyTypeTable\" style=\"display:$selectbytypeshow\" ><tr><td>Machine Type</td><td></td><td>Machine Number</td></tr>
		<td><select class=formfield name=\"machType\" id=\"machType\" disabled >$opts</select></td>";
	print "<td></td>";
	print "<td><input type=text name=\"machNum\" id=\"machNum\" size=4 value=\"$prov->{'request.machine_num'}\" $dis></td>";
	print "</table></td></tr>";
#machine list
	my $machlist = $prov->{'machList'}; # All machines of the request.
	my @machArray = keys(%$machlist);
	my $oriMachList=join(",", @machArray);
	print "<input type=hidden name=OrigMachListStr id=OrigMachListStr value=\"$oriMachList\">";

	if($prov->{'request.hypv_flag'} != -1){
		my $allMach = CloudUtils->getAllPMachName; # All bare metal machines in this cloud.
		my @notReqMachs = CloudUtils->diff($allMach, \@machArray);
  		my $allMachOpts="";
		my $allReqOpts=""; 
		
	  	foreach my $mach ( sort(@notReqMachs)){
			$allMachOpts.= "<option value=\"$mach\">$mach</option>";
		}
	  	foreach my $mach ( sort(@machArray)){
			$allReqOpts .= "<option value=\"$mach\">$mach</option>";
		}
		print "<tr><td><table id=\"ModifyListTable\" style=\"display:$selectbylistshow\" $dis><tr><td>Machines</td><td></td><td>Requested Machines</td></tr>
		<td><select class=formfield multiple=\"multiple\" name=\"allMaches\" id=\"allMaches\" size=6 style=\"width:200px;\" $dis>$allMachOpts</select></td>
		<td><button dojoType=\"dijit.form.Button\" type=\"button\" name=\"AddButtonMachL\" id=\"AddButtonMachL\" onClick=\"moveItem('allMaches', 'reqdMaches');\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconRedo\" showLabel=false $dis>-></button><br>
		<button dojoType=\"dijit.form.Button\" type=\"button\" name=\"RmvButtonMachL\" id=\"RmvButtonMachL\" onClick=\"moveItem('reqdMaches', 'allMaches');\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconUndo\" showLabel=false $dis><-</button></td>
		<td><select class=formfield multiple=\"multiple\" name=\"reqdMaches\" id=\"reqdMaches\" size=6 style=\"width:200px;\" $dis>$allReqOpts</select></td></table></td></tr>";
	}else{
	#virtual machine cpu and memory
		my $vm_dis = "disabled";
		if ($prov->{'request.status'} eq "Reserved" ) {
			$vm_dis = "";
		}
		print "<tr><td class=formfield><table><tr><td>VCPU</td><td>Memory(MB)</td><td>Disk Size(MB)</td></tr>";
		print "<td><input type=text name=\"modVCPU\" id=\"modVCPU\" size=4 value=\"$prov->{'request.machine_cpu'}\" $vm_dis></td>";
		print "<td><input type=text name=\"modMemory\" id=\"modMemory\" size=8 value=\"$prov->{'request.machine_memory'}\" $vm_dis></td>";
		print "<td><input type=text name=\"modDisk\" id=\"modDisk\" size=8 value=\"$prov->{'request.machine_disk'}\" disabled></td>";
		print "</table></td></tr>";
	}

	my $allImage = CloudUtils->getAllImage;
	print "<tr><td class='tab_highlight' colspan=2><font color=#f7f9e5><b>Configuration</b></font></td><td> </td></tr>";
	foreach my $img (sort @$allImage) {
		my $selected = ($img eq $prov->{'request.machine_os'}) ? "selected" : "";
		$opts .= "<option value=\"$img\" $selected>$img</option>";
	}
	print "<tr><td class=formprompt colspan=2>Operating System Image</td>
			<td><select class=formfield name=\"osimage\" disabled >$opts</select>";
	print "</td></tr>";

	my $checked = $prov->{'request.cluster'} eq "Sub" ? "checked" : "";
	my $subdis = "disabled";
	print "<tr><td class=formprompt colspan=2>Options</td>
			 <td class=formfield><input type=checkbox name=subcluster id=subcluster $checked value=1 $subdis> Setup Cluster";
	print "</td></tr>";

	print "<tr><td class='tab_highlight' colspan=2><font color=#f7f9e5><b>Schedule Your Request</b></font></td><td> </td></tr>";
	# start date

	my $stamp = scalar localtime() . " $timeZone";
	my ($nsec,$nmin,$nhour,$nmday,$nmon,$nyear,$nwday,$nyday,$nisdst) = localtime();
	$nyear += 1900;
	$nmon += 1;
	my $now_time = "$nmon/$nmday/$nyear/$nhour/$nmin";
	print "<input type=hidden id=now_time value=$now_time>";

	my $stime = $prov->{'request.start_time'};
	my $etime = $prov->{'request.expiry_time'};
	print "<tr>
			 <td class=formprompt colspan=2>Start Date</td>
			 <td class=formfield>";
	my $mark = $stime || time;
	my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($mark);
	$year += 1900;
  
		print "<input type=hidden name=CurprovStatus id=CurprovStatus value=\"$prov->{'request.status'}\">";
	my $start_dis = "disabled";
	if ( $dis eq "" && $prov->{'request.status'} eq "Reserved" ) {
		$start_dis = "";
	}
	formDate($mday,$mon,$year,"start_day","start_mon","start_year",1,
			 $hour,$min,"start_hour","start_min","",$start_dis);
	print "<br>Time on this machine is <b>$stamp</b>
			</td>";
	print "</tr>";

	my $disMon=$mon+1;
	print "<input type=hidden name=oriStartDate id=oriStartDate value=\"$year-$disMon-$mday $hour:$min\">";
	my $dd = $dis;
	if ($dis eq "" && $prov->{'request.hypv_flag'} == 1) {
		$dd = "disabled";
	}
	print "<tr><td class=formprompt colspan=2 rowspan=2>";
	print "<table align=right><tr><td><input type=radio checked name=durActive value=1 onclick=\"active();\" $dd>&nbsp;Duration</td></tr>";
	print "<tr><td><input type=radio name=durActive value=0 onclick=\"active();\" $dd>End Date</td></tr></table>";
	print "</td>";
	my $duration = ($etime - $stime) / 60;
	print "<td class=formfield><input type=text name=duration id=duration value=\"$duration\" size=8 onblur=\"updateEndFromDuration();\" $dd>minutes";
	print "</td></tr>";

	# end date
	print "<tr>";
	print "<td class=formfield>";
	$mark = $etime || $mark+(7*86400);
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($mark);
	$year += 1900;
	formDate($mday,$mon,$year,"end_day","end_mon","end_year",1,
			 $hour,$min,"end_hour","end_min","",$dd,"calImgE");
	print "<td> </td></td></tr>";
	&addEventToDate;

	# do not display users/groups/billing for hypv requests
	if ($prov->{'request.hypv_flag'} == 1) {
		goto SUBMIT;
	}
	my @ulist = ();
	if(defined($prov->{'incUsers'})){
		@ulist = @{$prov->{'incUsers'}};
	}
	my @glist = ();
	if(defined($prov->{'incGrps'})){
		@glist = @{$prov->{'incGrps'}};
	}
	
	# record the original list so that we are able to remove the whole list when required
	my $origUlist = join(",", @ulist);
	my $origGlist = join(",", @glist);
	print "<input type=hidden name=origUlistStr id=origUlistStr value=\"$origUlist\">";
	print "<input type=hidden name=origGlistStr id=origGlistStr value=\"$origGlist\">";

	my $uhash = CloudUtils->getAllUser;
	my @allUName = sort keys %$uhash;
	my $allUserOpts="";
	my $allowedUserOpts="";
	foreach my $uname (@allUName) {
		if (grep /^$uname$/, @ulist) {
			# can not delete the owner from the user list
            		my $deletable = $uname eq $prov->{'request.owner'} ? "disabled" : "";
			$allowedUserOpts .= "<option value=\"$uname\" $deletable>$uname</option>";
		} else {
			$allUserOpts .= "<option value=\"$uname\">$uname</option>";
		}
	}
	my $ghash = CloudUtils->getAllGroup;
	my @allGName = sort keys %$ghash;
	my $allGrpOpts="";
	my $allowedGrpOpts="";
	foreach my $gname (@allGName) {
		if($gname eq ""){
			next;
		}
		if (grep /^$gname$/, @glist) {
			$allowedGrpOpts .= "<option value=\"$gname\">$gname</option>";
		} else {
			$allGrpOpts .= "<option value=\"$gname\">$gname</option>";
		}
	}
	print "<tr><td class='tab_highlight' colspan=2><font color=#f7f9e5><b>Authorized Users/Groups</b></font></td><td> </td></tr>";
	print "<tr><td class='tab_highlight' colspan=2><font color=#f7f9e5><b>For Users</b></font></td><td> </td></tr>";
	print "<tr><td><!--input type=radio " . "checked" . " name=mode_u value=1 $dis--></td><td class=formprompt>Allow these users to use this request</td>";
	print "<td>";
	print "<table>";
	print "<tr><td>Users</td><td></td><td>Authorized Users</td></tr>";
	print "<tr><td><select class=formfield multiple=\"multiple\" name=allUsers id=allUsers $dis size=6 style=\"width:200px;\">$allUserOpts</select></td>";
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"moveItem('allUsers', 'allowedUsers');\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconRedo\" showLabel=false $dis>-></button><br>";
	print "<button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"moveItem('allowedUsers', 'allUsers');\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconUndo\" showLabel=false $dis><-</button></td>";
	print "<td><select class=formfield multiple=\"multiple\" name=allowedUsers id=allowedUsers $dis size=6 style=\"width:200px;\">$allowedUserOpts</select></td>";
	print "</table>";
	print "</td></tr>";

	print "<input type=hidden name=mode_u value=1>";
	print "<input type=hidden name=mode_g value=1>";
	print "<tr><td class='tab_highlight' colspan=2><font color=#f7f9e5><b>For Groups</b></font></td><td> </td></tr>";
	print "<tr><td><!--input type=radio " . "checked" . " name=mode_g value=1 $dis--></td><td class=formprompt>Allow these groups to use this request</td>";
	print "<td>";
	print "<table>";
	print "<tr><td>Groups</td><td></td><td>Authorized Groups</td></tr>";
	print "<tr><td><select class=formfield multiple=\"multiple\" name=allGrps id=allGrps $dis size=6 style=\"width:200px;\">$allGrpOpts</select></td>";
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"moveItem('allGrps', 'allowedGrps');\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconRedo\" showLabel=false $dis>-></button><br>";
	print "<button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"moveItem('allowedGrps', 'allGrps');\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconUndo\" showLabel=false $dis><-</button></td>";
	print "<td><select class=formfield multiple=\"multiple\" name=allowedGrps id=allowedGrps $dis size=6 style=\"width:200px;\">$allowedGrpOpts</select></td>";
	print "</table>";
	print "</td></tr>";

	print "<tr><td class='tab_highlight' colspan=2><font color=#f7f9e5><b>Billing</b></font></td><td> </td></tr>";

	print "<tr><td class=formprompt colspan=2><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"getBilling('$prov->{'request.name'}')\" baseClass=tundra $dd>Calculate charge</button></td><td  class=formfield ><input type=text name=chargeTxt id=chargeTxt size=30 style=\"font-family:verdana\" readonly $dd></td></tr>";
	print "<tr><td id=chargeTxt_modified_r class=formprompt colspan=2><button dojoType=\"dijit.form.Button\" type=\"button\" disabled=true baseClass=tundra >Affected charge</button></td><td  class=formfield ><input type=text name=chargeTxt_modified id=chargeTxt_modified size=30 style=\"font-family:verdana\" readonly $dd></td></tr>";
	print "</table>";

SUBMIT:
	print "<input type=hidden name=hypvflag value=$prov->{'request.hypv_flag'} >";
	print "<input type=hidden name=function value=updateProv>";
	print "<p><button dojoType=\"dijit.form.Button\" type=\"button\" iconClass=\"dijitEditorIcon dijitEditorIconSave\" onclick=\"submitChangeReqForm('ProvForm');\" $dis>Update</button>";
	print "</form>";

}

sub removeProv {
	my ($query) = @_;
	my @pids = $query->param('provID');
	my $hpyvflag = 0;
	my $cmd = "";

	print "<results>";
	foreach my $pid (@pids) {
		$cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/prov/hcrmreq ";
		$cmd .= " --reqid=$pid";
		$cmd .= "\"";
	
		my $output = `$cmd`;
		print $output;
	}
	print "</results>";
}

sub updateProv {
	my ($query) = @_;

	my $pid = $query->param('id');
	my $modType = $query->param('modMachbymethod');
	my ($start_mon,$start_day,$start_year);
	if(defined($query->param('start_mon|start_day|start_year'))){
		($start_mon,$start_day,$start_year) = validFormDate(split(/\//,$query->param('start_mon|start_day|start_year')));
	}
	my $start_hour = $query->param('start_hour');
	my $start_min = $query->param('start_min');
	my $start_sec = $query->param('start_sec');
	my $duration = $query->param('duration');
	my @authUsers = $query->param('allowedUsers');
	my $user_list = join ",", @authUsers;
	my @authGrps = $query->param('allowedGrps');
	my $grp_list = join ",", @authGrps;
	my $strict = $query->param('loose') ? 0 : 1;
	my $subcluster = $query->param('subcluster') ? 1 : 0;
	my @machList = $query->param('reqdMaches');
	my $machNum = $query->param('machNum');
	my $cpus = $query->param('modVCPU');
	my $memory = $query->param("modMemory");
	my $reqStatus = $query->param('CurprovStatus');
	my $origUlist = $query->param('origUlistStr');
	my $origGlist = $query->param('origGlistStr');

	my $chgCmd;
	if($query->param('hypvflag') == -1){
		$chgCmd ="hcchvm";
	}else{
		$chgCmd ="hcchreq";
	}
	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/prov/$chgCmd";

	$cmd .= " --reqid=$pid";
	if(defined($query->param('start_mon|start_day|start_year'))){
		my $oriStartDatestr = $query->param('oriStartDate');
		my $currStartDatestr = "$start_year-$start_mon-$start_day $start_hour:$start_min";
		if(($reqStatus eq "Reserved")and ($currStartDatestr ne $oriStartDatestr)){
			$cmd .= " --startdate=\'$start_mon-$start_day-$start_year $start_hour:$start_min:00\'";
		}
	}
	if( $query->param('hypvflag') == -1){
	#vmnumber, cpu, memory, disk
		if($reqStatus eq "Reserved"){
			$cmd .= " --cpus=$cpus";
			$cmd .= " --memory=$memory";
		}
		$cmd .= " --vmcount=$machNum";
	}else{
		if($modType eq "Machine Type"){
			my $OrimachNum = $query->param("oriMachNum");
			if($machNum > $OrimachNum){
				$cmd .= " --addmachnum=".($machNum - $OrimachNum);
			}elsif($machNum < $OrimachNum){
				my $rmnum = $OrimachNum - $machNum;
				my @originalArr = sort(split(",", $query->param('OrigMachListStr')));
				my $oriNum = scalar(@originalArr);
				my @rmmachs;
				for( my $idx=1; $idx<=$rmnum; $idx++){
					push(@rmmachs, $originalArr[$oriNum - $idx]);
				}
				$cmd .= " --rmmach=" . (join ',', @rmmachs);
			}
		}else{
			$cmd .= " --machlist=" . (join ',', @machList) if (@machList);
		}
	}
		
	# Modification of duration, userlist and grouplist are only for non-hypv requewsts..
	# Actually, only the machinelist can be changed for hypv requests.
	if ( $query->param('hypvflag') != 1 ){
		if (!$duration) {
			my($end_mon,$end_day,$end_year) = validFormDate(split(/\//,$query->param('end_mon|end_day|end_year')));
			my $end_hour = $query->param('end_hour');
			my $end_min = $query->param('end_min');

			$end_mon--;
			$end_day  = validDay($end_day,$end_mon,$end_year);
			my $end_date = timelocal(0,$end_min,$end_hour,$end_day,$end_mon,$end_year,0,0,0);
			my $start_date = timelocal(0,$start_min,$start_hour,$start_day,$start_mon-1,$start_year,0,0,0);

			$duration = ($end_date - $start_date) / 60;
		}
		$cmd .= " --duration=$duration";
		
		if ($user_list) {
			$cmd .= " --users=$user_list";
		} elsif ($origUlist) {
			# remove the userlist
			$cmd .= " --rmuser=$origUlist";
		}
		if ($grp_list) {
			$cmd .= " --groups=$grp_list";
		} elsif ($origGlist) {
			# remove the grouplist
			$cmd .= " --rmgroup=$origGlist";
		}
	}

	$cmd .= "\"";

	my $output = `$cmd`;
	print $output;
}


sub makeHypv {
	my ($query) = @_;
	my @machList = $query->param('machName');
	my $os = $query->param('hypv_os');
	if (!@machList) {
		error("Specify some machines");
	}

	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/prov/hcmkhypv";
	my $hypvList = join ',', @machList;
	$cmd .= " --hypv=$hypvList";
	$cmd .= " --os=$os";
	$cmd .= "\"";

	my $output = `$cmd`;
	print $output;
}
#-------------------------------------------------------------------------------

sub firstSunday {

	# return epoch time of next closest Sunday from start argument

	my($start) = @_;

	my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($start);
	while( $wday != 0 ) {	# first Sunday
	  $start += 86400;
	  $wday = ($wday + 1) % 7;
	}

	return $start;
}

#-------------------------------------------------------------------------------

sub normalize {	# set time to start of that day
	my($time) = @_;

	my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($time);
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($time+3600)
	  if( $hour == 23 );	# DST sux
	$year += 1900;
	return timelocal(0,0,0,$mday,$mon,$year,$wday,$yday,$isdst);
}

sub listMach {
	my ($query) = @_;
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime;
	$year += 1900;
	my ($view_mon,$view_day,$view_year); 
	if(defined($query->param('view_mon|view_day|view_year'))){
		($view_mon,$view_day,$view_year) = validFormDate(split(/\//,$query->param('view_mon|view_day|view_year')));
	}else{
		($view_mon,$view_day,$view_year) = ($mon+1, $mday, $year);
	}
	my $zoom = $query->param('zoom') || "weeks";
	$view_mon--;
	$view_day = validDay($view_day,$view_mon,$view_year);
	my $machFilter = $query->param('MachFilter');
	if(!defined($machFilter)){
		$machFilter = "";
	}
	my $validFilter = 1;
	eval { "" =~ /$machFilter/ };
	$validFilter = 0 if( $@ );
	my $isAll = $query->param('all');
	if(!defined($isAll)){
		$isAll = 0;
	}
	if ($isAll && !$::ISADMIN) {
		error("You are not authorized to do this.");
	}

	# The argument 1 indicates only request names are needed.
	# last argument 1 indicates get machine list by hashref
	my $allprov = CloudUtils->getProvInfo(0,2,1);
	my $allMach;
	$allMach = CloudUtils->getAllMach;

	my $user = CloudUtils->getUserByName($USERID);
	my $weekstyle = "class=\"off\"";
	my $daystyle = "class=\"off\"";
	my $hourstyle = "class=\"off\"";

	if ($zoom eq "weeks") {
		$weekstyle = "class=\"on\"";
	} elsif ($zoom eq "days") {
		$daystyle = "class=\"on\"";
	} elsif ($zoom eq "subday") {
		$hourstyle = "class=\"on\"";
	}

	print "<table border=0 cellspacing=0>
			<tr>
			<td style=\"font-size: 10pt;\" valign=middle><b><font color=#3d3d3d>Scope:</font></b>
			  &nbsp;<a href=\"javascript:navLink('listMach', 'portal.cgi?function=listMach&all=$isAll&zoom=weeks&MachFilter=$machFilter');\" $weekstyle>Weeks</a></td>
			<td style=\"font-size: 10pt;\" valign=middle>&nbsp;&nbsp;<a href=\"javascript:navLink('listMach', 'portal.cgi?function=listMach&all=$isAll&zoom=days&MachFilter=$machFilter');\" $daystyle>Days</a>&nbsp;</td>
			<td style=\"font-size: 10pt;\" valign=middle>
			<a href=\"javascript:void(0);\" onclick=\"navLink('listMach', 'portal.cgi?function=listMach&all=$isAll&zoom=subday&MachFilter=$machFilter&view_mon|view_day|view_year=' + dojo.byId('view_mon|view_day|view_year').value);\" $hourstyle>Hourly around</a> ";
	formDate($mday,$mon,$year,"view_day","view_mon","view_year",0);

	print " </td>
		  </tr>
		  </table>";

	print "<table>
		  <tr>
			<td style=\"font-size: 10pt;\" valign=middle>
				<b><font color=#3d3d3d>Filter by machine name:</font></b>
				<input class=formfield type=text id=MachFilter value=\"$machFilter\" size=15>
			</td>
			<td><input type=image src=/hpccloud/images/go.gif border=0 align=middle onclick=\"navLink('listMach', 'portal.cgi?function=listMach&all=$isAll&zoom=$zoom&view_day=$view_day&view_mon=$view_mon&view_year=$view_year&MachFilter=' + dojo.byId('MachFilter').value);\"></td>
		  </tr>
		  </table><p><br>";

    #
    # render view of requests
    #
 
	# determine first and last block time for specified view
 
	my ($tableStart,$tableEnd,$tableMid);
 
	if( $zoom eq "subday" ) {	# 3 days around specified day
		$tableStart = timelocal(0,0,0,$view_day,$view_mon,$view_year,0,0,0);# - 86400;
		$tableMid = timelocal(0,0,0,$view_day,$view_mon,$view_year,0,0,0) + 86400;
		$tableEnd = timelocal(59,59,23,$view_day,$view_mon,$view_year,0,0,0) + 2*86400;
	}
	elsif( $zoom eq "days" || $zoom eq "weeks") {	# 3 months around specified day
		my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
		$year += 1900;
		my $nmon = $mon; my $nyear = $year;	# next month
		$nmon = ($nmon + 1) % 12;
		$nyear++ if( $nmon < $mon );
		$tableMid = ($query->param('view_mon|view_day|view_year')) ? timelocal(0,0,0,$view_day,$view_mon,$view_year,0,0,0) : timelocal(0,0,0,15,$nmon,$nyear,0,0,0);
 
		($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($tableMid);
		$year += 1900;
		my $smon = $mon; my $syear = $year;	# month before midpoint
		my $emon = $mon; my $eyear = $year;	# month after midpoint
		$smon = ($smon - 1 + 12) % 12;
		$syear-- if( $smon > $mon );
		$emon = ($emon + 1) % 12;
		$eyear++ if( $emon < $mon );
		$tableStart = timelocal(0,0,0,15,$smon,$syear,0,0,0);
		$tableEnd = timelocal(59,59,23,15,$emon,$eyear,0,0,0);
	}
	my @monthDays = (31,0,31,30,31,30,31,31,30,31,30,31);
	my @monthNames = ("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");
 
	unless( $zoom eq "subday" ) {	# adjust to full months for day/week zoom
		$tableStart = time unless( $tableStart );
		($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($tableStart);
		$year += 1900;
		$tableStart = timelocal(0,0,0,1,$mon,$year,0,0,0);	# 1st of month
 
		$tableEnd = $tableStart unless( $tableEnd );
		($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($tableEnd);
		$year += 1900;
		$monthDays[1] = isLeap($year) ? 29 : 28;
		$tableEnd = timelocal(59,59,23,$monthDays[$mon],$mon,$year,0,0,0);	# last of month
	}

my $script = <<"SCRIPT";
<script type="text/javascript" language="JavaScript">
function select_all() {
	var checked;
	if (document.MachineListForm.selectAll.checked) checked=true;
	else checked=false;
	var inputs = document.getElementsByTagName("input");
	for(var i=0;i<inputs.length;i++) {
		if(inputs[i].getAttribute("type") == "checkbox") {
			inputs[i].checked = checked;
		}
	}
}

</script>
SCRIPT

	print $script;

	print "<script language=\"javascript\" type=\"text/javascript\" src=\"/hpccloud/scripts/machAction.js\"></script>\n";

	print "<div>";

	print "<form id='MachineListForm' name='MachineListForm' method=post action=portal.cgi onsubmit=\"return checkMachForm();\">";
	if(!$isAll) {
		print "<input id=\"reqMachAction\" type=hidden name=function value=reqByName>";
		print "<button dojoType=\"dijit.form.Button\" type=\"button\" iconClass=\"dijitEditorIcon dijitEditorIconTabIndent\" onclick=\"requestMach();\">Request Machines</button>";
		print "<input id = 'hypv_os' type=hidden name=hypv_os value=''>";
		print qq(<div id="HypvOSDialog" dojoType="dijit.Dialog" title="Hypv OS Selection">);
		print qq(<table>);
		print "<tr><td class=formprompt>Base operating system *:</td><td><select class=formfield name=\"hypvos\" id=\"hypvos\" size=3 style=\"width:300px;\"><option value=\"rhels6\" selected>Redhat Enterprise Linux Version 6</option><option value=\"centos6\" >CentOS Version 6</option></select></td></tr></table>";
		print qq( </table>	);
		print qq( <p><div style="padding: 8px 0; text-align: center;">	);
		print qq( <button dojoType="dijit.form.Button" type="button" baseClass=soria iconClass="dijitEditorIcon dijitEditorIconSave" onClick="Hypv_os_check();">Confirm</button>&nbsp;&nbsp;&nbsp;&nbsp;	);
		print qq( <button dojoType="dijit.form.Button" type="button" onClick="dijit.byId('HypvOSDialog').hide();" baseClass=soria iconClass="dijitEditorIcon dijitEditorIconCancel">Cancel</button>	);
		print qq( </div>	);
		print qq(</div>	);
		print "<button dojoType=\"dijit.form.Button\" type=\"button\" iconClass=\"dijitEditorIcon dijitEditorIconTabIndent\" onclick=\"makeHypv();\">Make Hypervisor</button>" if ($::ISADMIN);
	} else {
		print "<table><tr>";
		print "<td style=\"font-size: 10pt;\">Power Settings</td>";
		print "<td>";
		print "<input id=\"machAction\" type=hidden name=function value=setMachPower>";
		print "<select id=\"machPowerMenu\" name=\"machPowerMenu\" size=1>";
		print "<option value=\"none\" selected>- Select Action -</option>";
		print "<option value=\"powerOn\">Power On</option>";
		print "<option value=\"powerOff\">Power Off</option>";
		print "<option value=\"powerReset\">Power Reset</option>";
		print "</select>";
		print "</td>";
		print "<td>";
		print "<a href=\"javascript:void(0);\" onclick=\"machPower('MachineListForm');\" title=\"Select an action from the menu on the left and click this button to execute the action\"><img src=/hpccloud/images/go.gif border=0 align=middle></a>";
		print "</td>";
		print "<td></td>";
		print "<td style=\"font-size: 10pt;\">Energy Schemes</td>";
		print "<td>";
		print "<select id=\"machEScheme\" name=\"machEScheme\" size=1>";
		print "<option value=\"none\" selected>- Select Energy Scheme -</option>";
		my $myES = EnergyUtils->getEnergySchemeAllInfo($USERID);

		# getEnergySchemeAllInfo has been enhanced to return the scheme owner by $USERID or default.
		#my $defaultES = EnergyUtils->getEnergySchemeAllInfo("default");
		#
		foreach my $id (keys %$myES) {
			# Hard code poweroff-default for now, need to be enhanced.
			if ($myES->{$id}->{'energy_scheme.name'} ne "poweroff-default") { 
				print "<option value=\"$myES->{$id}->{'energy_scheme.name'}|$myES->{$id}->{'energy_scheme.owner'}\">$myES->{$id}->{'energy_scheme.name'}</option>";
			}
		}
#		foreach my $id (keys %$defaultES) {
#			print "<option value=\"$defaultES->{$id}->{'energy_scheme.name'}|default\">$defaultES->{$id}->{'energy_scheme.name'}</option>";
#		}
		print "</select>";
		print "</td>";
		print "<td>";
		print "<button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"machEScheme('MachineListForm');\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconTabIndent\" title=\"Select an energy scheme from the menu on the left and click this button to apply it\">Apply</button>";
		print "</td>";
		print "<td></td>";
		print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"navLink('listMach', 'portal.cgi?function=addmach2cloudForm');\" baseClass=tundra iconClass=\"dijitIcon dijitIconNewTask\" title=\"Click to add bare-metal machine \">Add/Update  machine</button></td>\n";
		print "<td></td>";
		print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"dijit.byId('mainContent').refresh();\" baseClass=tundra iconClass=\"dijitIcon dijitIconUndo\" title=\"Click to refresh machine status\">Refresh</button></td>\n";

		print "</tr></table>";
	}

	# Add scroll bar div
	print qq(<div style ="overflow:scroll;width:900px;height:300px;clear:both">);

	print "<table border=0 cellpadding=1 cellspacing=1 bgcolor=#e3e3d1>";
	# column headers
	calColumnHeader("Machine", $tableStart,$tableEnd,\@monthDays,\@monthNames,$zoom,$tableMid,
					$view_day,$view_mon,$view_year,$machFilter,"listMach", 0, $isAll);

	my $daycount = ($zoom eq "weeks") ? 7 : 1;
	my $rowsPrinted = 0;
	my (@rowcolors) = ("#cac28e","#f7f9e4");
	my ($colorindex) = 0;
	my $pcolor = CloudUtils->status2Color;

	foreach my $machine ( sort keys %$allMach ) {

		my $mach = CloudUtils->getMachine($machine);
		foreach my $key (keys %$mach) {
			$allMach->{"$machine"}->{$key} = $mach->{$key};
		}
		my %printed;
		if( $machFilter ) {
			next unless( $validFilter && $machine =~ /$machFilter/i );
		}
		# if !isAll, do not show VM and hypvisor
		next if ($allMach->{"$machine"}->{"machine.hypv_flag"} != 0 && !$isAll);

		$rowsPrinted++;
		calColumnHeader("Machine", $tableStart,$tableEnd,\@monthDays,\@monthNames,$zoom,$tableMid,
						$view_day,$view_mon,$view_year,$machFilter,"listMach",1,$isAll)
			if( ! ($rowsPrinted % 20) );
		print "<tr class='tab_content' align=center>";
		calRowHeader($allMach->{"$machine"}, $zoom, $rowcolors[$colorindex], $isAll);
		$colorindex = ($colorindex+1) % 2;

		if ($allMach->{$machine}->{'machine.provision_mode'} != 2 && $allMach->{$machine}->{'machine.provision_mode'} != 3) {
			next;
		}

		# $point2 is the end of the tracking marker window along the period of the
		# column resolution being rendered
  
		my($point,$point2);
		if( $zoom eq "subday" ) {
			$point = $tableStart;
			$point2 = $point + 3600 - 1;
		}
		else {
			$tableStart = firstSunday($tableStart) if( $zoom eq "weeks" );
			$point = normalize($tableStart);
			$point2 = normalize($point + $daycount*86400) - 1;
		}
  
		while( $point < $tableEnd ) {
			my $reserved = 0;
			my $single = "";
			my @multi = ();
  
			# for any reservations in this time slice, build a single and
			# overlapping (multi) entry piece of HTML
  
			foreach my $pid ( keys %$allprov ) {
			  #my($sdate,$edate,$cust,$status,$autoprov,$app,$topts) = split(/\,/,$block);
			  my $prov = $allprov->{$pid};
			  my $status = $prov->{'request.status'};
			  next if ($status eq "Expired" || $status eq "Failed" || $status eq "Canceled");
			  my $sdate = $prov->{'request.start_time'};
			  my $edate = $prov->{'request.expiry_time'};

			  my $bubbleMsg = "<b>Provision : " . $prov->{'request.name'} . "</b><br>";
			  $bubbleMsg .= "<b>Status</b> : " . $prov->{'request.status'} . "<br>";
			  $bubbleMsg .= localtime($sdate) . " - <br>";
			  $bubbleMsg .= localtime($edate) . "<br>";
			  if( ( ($point <= $sdate) &&
					($sdate <= $point2) ) ||
				  ( ($point <= $edate) &&
					($edate <= $point2) ) ||
				  ( ($sdate < $point) &&
					($point2 < $edate) )
				 ) {
  
				 if ( !exists($prov->{'machList'}->{$machine})) { next; }

				 my $href = ($::ISADMIN || CloudUtils->checkProvAuth($prov, $user->{$USERID})) ? "portal.cgi?catalog=request&function=editProv&id=$prov->{'request.name'}" : "javascript:void(0)";
				 $single = "<td style=\"BACKGROUND-COLOR: $pcolor->{$prov->{'request.status'}}; white-space: nowrap\">";
				 push(@multi,"<a href=\"$href\" onmouseover=\"bubble('bubbles','$bubbleMsg');\" onmouseout=\"bubble('bubbles','');\"><font color=#000000 style=\"BACKGROUND-COLOR: $pcolor->{$prov->{'request.status'}}\">$prov->{'request.owner'}</font></a>");
				 if( ! $printed{$prov->{'request.name'} } ) {
					$single .= "<a href=\"$href\" onmouseover=\"bubble('bubbles','$bubbleMsg');\" onmouseout=\"bubble('bubbles','');\">
							<font color=#000000>$prov->{'request.owner'}</font></a>";
				 }
				 elsif (!$isAll) {
					$single .= "<a href=\"javascript:navLink('reqByName', 'portal.cgi?function=reqByName&machName=$machine&stime=$point&etime=$point2');\">
							<center><img border=0 src=/hpccloud/images/newBts.gif></center></a>";
				 }
				 $printed{$prov->{'request.name'} } = 1;
				 $single .= "</td>";
				 $reserved++;
			  }
			}
  
			# show HTML for unreserved, single reservation, or overlapping (multi)
			# reservations as appropriate

			if( ! $reserved ) {
			  print "<td style=\"background-color:#ffffff;\">";
			  print "<a href=\"javascript:navLink('reqByName', 'portal.cgi?function=reqByName&machName=$machine&stime=$point&etime=$point2');\"><center><img border=0 src=/hpccloud/images/newBts.gif></center></a>" if (!$isAll);
			  print "</td>";
			}
			elsif( $reserved == 1 ) {
			  print $single;
			}
			else {
			  print "<td style=\"white-space: nowrap\">" . join("<br>",@multi) . "</td>";
			}
  
			# shift inspection window per resolution
  
			if( $zoom eq "subday" ) {
			  $point += 3600;
			  $point2 = $point + 3600 - 1;
			}
			else {
			  $point += $daycount*86400; $point = normalize($point);
			  $point2 = normalize($point + $daycount*86400) - 1;
			}
		}
		print "</tr>";
	}
	print "</table>";

	# Add scroll bar div
	print "</div>";
	if (!$isAll) {
		#print "<button dojoType=\"dijit.form.Button\" type=\"submit\" baseClass=tundra>Next >></button>";
	}
	print "</form></div><p><br>";
  
	print qq(<table ><tr>	);

	my @statuses = qw/Reserved Setup Verifying Waiting Ready/;
	foreach my $status(@statuses) {
		print qq(<td width=80>$status);
		print qq(<table bgcolor=$pcolor->{$status} border="1" width="15" height="15" cellspacing="0" cellpadding="0">);
		print qq(<tr></tr></table></td>);
	}
	print qq(</tr></table>	);

}

#-------------------------------------------------------------------------------

sub calColumnHeader {

	my ($tHead, $tableStart,$tableEnd,$monthDaysRef,$monthNamesRef,$zoom,$tableMid,$view_day,
	  $view_mon,$view_year,$machFilter,$function,$flag,$isAll) = @_;

	# everything by weeks beginning on Sunday, 3-month window by day, or 3-day window by hour
	# $point is the tracking marker along the period of the column resolution
	# being rendered

	my $colspan;
	if($::ISADMIN && $isAll) {
	  $colspan = 9;
	} else {
	  $colspan = 6;
	}
	print "<tr class='tab_head'><td style=\"background:#ffffff;\"></td>
		  <td style=\"background:#ffffff;\" colspan=$colspan> </td>";	# top left corner

	my $point = $tableStart;
	while( $point < $tableEnd ) {
	  my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($point);
	  $year += 1900;
	  $$monthDaysRef[1] = isLeap($year) ? 29 : 28;
	  my $colspan;
	  if( $zoom eq "weeks" ) {
		 my $mark = timelocal(0,0,0,1,$mon,$year,0,0,0);
		 my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($mark);
		 my $monthDay = 1;
		 while( $wday != 0 ) {	# first Sunday
			$monthDay++;
			$wday = ($wday + 1) % 7;
		 }
		 $colspan = 0;
		 while( $monthDay <= $$monthDaysRef[$mon] ) {	# number of Sundays
			$colspan++;
			$monthDay += 7;
		 }
	  }
	  elsif( $zoom eq "days" ) {
		 $colspan = $$monthDaysRef[$mon];
	  }
	  else {
		 $colspan = 24;
	  }
 
	  # print column headers for title row #1 based on resolution, include
	  # back/forward window shift links as appropriate to view

	  if( $zoom eq "subday" ) {
		 my($backlink,$fwdlink); $backlink = $fwdlink = "";
		 if( $point < $tableMid ) {
			my $mark = timelocal(0,0,0,$view_day,$view_mon,$view_year,0,0,0) - 86400;
			my($sec,$min,$hour,$vday,$vmon,$vyear,$wday,$yday,$isdst) = localtime($mark);
			$vmon++;
			$vyear += 1900;
			$backlink = "&nbsp;<a href=\"javascript:navLink('$function', 'portal.cgi?function=$function&all=$isAll&zoom=subday&view_mon|view_day|view_year=$vmon/$vday/$vyear&MachFilter=$machFilter');\"><font style=\"BACKGROUND-COLOR: #f7f9e5;color:#000\"><b>&nbsp;&lt;&nbsp;</b></font></a>&nbsp;";
		 }
		 elsif( $point > $tableMid ) {
			my $mark = timelocal(0,0,0,$view_day,$view_mon,$view_year,0,0,0) + 86400;
			my($sec,$min,$hour,$vday,$vmon,$vyear,$wday,$yday,$isdst) = localtime($mark);
			$vmon++;
			$vyear += 1900;
			$fwdlink = "&nbsp;<a href=\"javascript:navLink('$function', 'portal.cgi?function=$function&all=$isAll&zoom=subday&view_mon|view_day|view_year=$vmon/$vday/$vyear&MachFilter=$machFilter');\"><font style=\"BACKGROUND-COLOR: #f7f9e5;color:#000\"><b>&nbsp;&gt;&nbsp;</b></font></a> ";
		 }
		 print "<td colspan=$colspan style=\"color:#2554C7;\">$backlink$$monthNamesRef[$mon]
				$mday $year$fwdlink</td>";
	  }
	  elsif( $zoom eq "days" ) {
		 my($xsec,$xmin,$xhour,$xmday,$xmon,$xyear,$xwday,$xyday,$xisdst) = localtime($tableMid);
		 $xyear += 1900;
		 my $smon = $xmon; my $syear = $xyear;	# last month
		 my $emon = $xmon; my $eyear = $xyear;	# next month
		 $smon = ($smon - 1 + 12) % 12;
		 $syear-- if( $smon > $xmon );
		 $emon = ($emon + 1) % 12;
		 $eyear++ if( $emon < $xmon );

		 my($backlink,$fwdlink); $backlink = $fwdlink = "";
		 my($vday,$vmon,$vyear);
		 $vday = 15;

		 my($psec,$pmin,$phour,$pmday,$pmon,$pyear,$pwday,$pyday,$pisdst) = localtime($point);
		 if( $pmon == $smon ) {
			$vmon = $smon + 1;
			$vyear = $syear;
			$backlink = "&nbsp;<a href=\"javascript:navLink('$function', 'portal.cgi?function=$function&all=$isAll&zoom=days&view_mon|view_day|view_year=$vmon/$vday/$vyear&MachFilter=$machFilter');\"><font style=\"BACKGROUND-COLOR: #f7f9e5;color:#000\"><b>&nbsp;&lt;&nbsp;</b></font></a>&nbsp;";
		 }
		 elsif( $pmon == $emon ) {
			$vmon = $emon + 1;
			$vyear = $eyear;
			$fwdlink = "&nbsp;<a href=\"javascript:navLink('$function', 'portal.cgi?function=$function&all=$isAll&zoom=days&view_mon|view_day|view_year=$vmon/$vday/$vyear&MachFilter=$machFilter');\"><font style=\"BACKGROUND-COLOR: #f7f9e5;color:#000\"><b>&nbsp;&gt;&nbsp;</b></font></a> ";
		 }
		 print "<td colspan=$colspan style=\"color:#2554C7;\">$backlink$$monthNamesRef[$mon] ",
				substr($year,length($year)-2,2),"$fwdlink</td>";
	  }
	  else {
		 my($xsec,$xmin,$xhour,$xmday,$xmon,$xyear,$xwday,$xyday,$xisdst) = localtime($tableMid);
		 $xyear += 1900;
		 my $smon = $xmon; my $syear = $xyear;	# last month
		 my $emon = $xmon; my $eyear = $xyear;	# next month
		 $smon = ($smon - 1 + 12) % 12;
		 $syear-- if( $smon > $xmon );
		 $emon = ($emon + 1) % 12;
		 $eyear++ if( $emon < $xmon );

		 my($backlink,$fwdlink); $backlink = $fwdlink = "";
		 my($vday,$vmon,$vyear);
		 $vday = 15;

		 my($psec,$pmin,$phour,$pmday,$pmon,$pyear,$pwday,$pyday,$pisdst) = localtime($point);
		 if( $pmon == $smon ) {
			$vmon = $smon + 1;
			$vyear = $syear;
			$backlink = "&nbsp;<a href=\"javascript:navLink('$function', 'portal.cgi?function=$function&all=$isAll&zoom=weeks&view_mon|view_day|view_year=$vmon/$vday/$vyear&MachFilter=$machFilter');\"><font style=\"BACKGROUND-COLOR: #f7f9e5;color:#000\"><b>&nbsp;&lt;&nbsp;</b></font></a>&nbsp;";
		 }
		 elsif( $pmon == $emon ) {
			$vmon = $emon + 1;
			$vyear = $eyear;
			$fwdlink = "&nbsp;<a href=\"javascript:navLink('$function', 'portal.cgi?function=$function&all=$isAll&zoom=weeks&view_mon|view_day|view_year=$vmon/$vday/$vyear&MachFilter=$machFilter');\"><font style=\"BACKGROUND-COLOR: #f7f9e5;color:#000\"><b>&nbsp;&gt;&nbsp;</b></font></a> ";
		 }
		 print "<td colspan=$colspan align=center style=\"color:#2554C7;\">$backlink$$monthNamesRef[$mon] ",
				#substr($year,length($year)-2,2),"$fwdlink</font></b></td>";
				$year, "$fwdlink</td>";
#		 print "<td colspan=$colspan bgcolor=#950a0a><b><font color=#f7f9e5>$$monthNamesRef[$mon] ",
#				substr($year,length($year)-2,2),
#				"</font></b></td>";
	  }

	  if( $zoom eq "subday" ) {
		 $point += 86400;
	  }
	  else {
		 $point += ($$monthDaysRef[$mon] + 1)*86400;
	  }
	}
	#print "<td bgcolor=#ffffff> </td>";	# right corner for trailing row headers
	print "</tr>";

	#print "<tr><td bgcolor=#950a0a><b><font color=#f7f9e5>Rack/System</font></b></td>";	# corner
	print "<tr class='tab_head' align=center><td style=\"background:#ffffff;\">" . ($flag ? "" : "<input type=checkbox name=selectAll onClick=\"select_all()\" title=\"Select/Deselect all\">") . "</td>";
	print "<td width=80>$tHead</td>";	# corner
	print "<td width=50>Arch</td>";
	print "<td width=100>Type</td>";
	print "<td width=100>Default Image</td>" if ($::ISADMIN && $isAll );
	print "<td width=100>Current Image</td>" if ($::ISADMIN && $isAll );
	print "<td width=50>Status</td>";
	print "<td width=90>Power Status</td>";
	print "<td width=100>Energy Schemes</td>";
	if ($::ISADMIN && $isAll ) {
	  #print "<td bgcolor=#950a0a><b><font color=#f7f9e5>Group</font></b></td>";
	  print "<td>Mode</td>";
	  #print "<td bgcolor=#950a0a><b><font color=#f7f9e5>IP</font></b></td>";
	  print "<td width=100>Energy</td>";
	}

	# print column headers for title row #2 based on resolution

	if( $zoom eq "weeks" ) {
	  #
	  # weeks
	  #
	  my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($tableStart);
	  while( $wday != 0 ) {	# first Sunday
		 $tableStart += 86400;
		 $wday = ($wday + 1) % 7;
	  }
	  $point = $tableStart;
	  while( $point < $tableEnd ) {
		 ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($point);
		 if( $hour == 23 ) {	# adjust for crossing DST border
			$point += 3600;
			($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($point);
		 }
		 if( $hour == 1 ) {	# adjust for crossing DST border
			$point -= 3600;
			($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($point);
		 }
		 print "<td style=\"color:#2554C7;\">$mday</td>";
		 $point += 7*86400;
	  }
	}
	elsif( $zoom eq "days" ) {
	  #
	  # days
	  #
	  $point = $tableStart;
	  my %seen = ();
	  while( $point < $tableEnd ) {
		 my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($point);
		 if( $seen{"$year$mon$mday"} ) {
			$point += 86400;
			next;
		 }
		 print "<td style=\"color:#2554C7;\">$mday</td>";
		 $point += 86400;
		 $seen{"$year$mon$mday"} = 1;
	  }
	}
	else {
	  #
	  # sub-day
	  #
	  $point = $tableStart;
	  while( $point < $tableEnd ) {
		 my $i;
		 for( $i=0; $i<24; $i++ ) {
			print "<td style=\"color:#2554C7;\">$i</td>";
		 }
		 $point += 86400;
	  }
	}

	# right corner for trailing row headers
	#print "<td bgcolor=#950a0a><b><font color=#f7f9e5>Rack/System</font></b></td>";
	#print "<td bgcolor=#950a0a><b><font color=#f7f9e5>System</font></b></td>";

	print "</tr>";
}

#-------------------------------------------------------------------------------

sub calRowHeader {
	my ($mach, $zoom, $color, $isAll) = @_;
	my @mode = ("None", "JO", "PO", "J+P");

	my $daycount = ($zoom eq "weeks") ? 7 : 1;

	my $bgcolor = "#1589FF";

	my $machName = $mach->{'machine.name'}; 
	my $machine = CloudUtils->getMachine($machName);
	if (!$isAll) { # For reserve by name
		# provision_mode = 0/1 indicates the node is JO, can not be provisoined.
		if ($machine->{'machine.provision_mode'} == 0 || $machine->{'machine.provision_mode'} == 1) {
			print "<td style=\"background-color:#ffffff;\"></td>";
			print "<td class='tab_head' style=\"background-color:#4A70AA;\">$machName</b>";
		} else {
			print "<td style=\"background-color:#ffffff;\"><input type=checkbox name=machName value=\"$machName\"></td>";
			#print "<td class='tab_head' style=\"background-color:#4A70AA;\">
			#	<a href=\"portal.cgi?function=reqMach&machName=$machName\">
			#	$machName</a>";
			print "<td class='tab_head' style=\"background-color:#4A70AA;color:#FFF;\">$machName</a>";
			#print "<br><a href=\"telnet://$machName\">login</a>";
			print "</b>";
		}
	} else {
		# 0 indicates it is the MN. hypv_flag == 0 indicates it is a hypvisor.
		# MN and hypvisor cannot be selected to operate.
		if ($machine->{'machine.provision_mode'} != 0 && $machine->{'machine.hypv_flag'} != 1) {
			print "<td style=\"background-color:#ffffff;\"><input type=checkbox name=machName value=\"$machName\"></td>";
		} else {
			print "<td style=\"background-color:#ffffff;\"></td>";
		}

		if ($machine->{'machine.power_state'} eq "on" && $machine->{'machine.hypv_flag'} != 1) {
			print "<td class='tab_head' style=\"background-color:#4A70AA;\">
			  <a href=\"/vnc/$machName\" target=_blank title=\"Click to open VNC to login this node\">
			  $machName</a>";
			print "</b>";
		} else {
			print "<td class='tab_head' \"background-color:#4A70AA;\">$machName</td>";
		}
	}

	print "</td>";
	print "<td>" . $machine->{'machine.arch'} . "</td>";
	print "<td>" . $machine->{'machine.type'} . "</td>";
	print "<td>" . ($machine->{'machine.default_os'} ? $machine->{'machine.default_os'} : 'NA') . "</td>" if ($::ISADMIN && $isAll);
	print "<td>" . ($machine->{'machine.current_os'} ? $machine->{'machine.current_os'} : 'NA') . "</td>" if ($::ISADMIN && $isAll);

	# status
	my $machstatus = $machine->{'machine.status'};

	# energy related
	my $energyScheme = EnergyUtils->getESchemeByMachine($machName,1);
	$energyScheme = $energyScheme ? $energyScheme : "NA";
	my $energyInfo = EnergyUtils->getEnergyOfMachProv($machName, $machine->{'request_machine.request_name'}) . " kWh";
	if ($energyInfo eq "0 kWh") { $energyInfo = "NA"; }

	print "<td id=\"st_$machName\" name=\"st_$machName\">" . $machstatus . "</td>";

	print "<td id=\"pst_$machName\" name=\"pst_$machName\">" . $machine->{'machine.power_state'} . "</td>";
	print "<td id=\"psav_$machName\" name=\"psav_$machName\">" . $energyScheme . "</td>";
	if ($::ISADMIN && $isAll) {
	  #print "<td bgcolor=$color><font color=#910000>" . $machine->{'mgmtGroup'} . "</font></td>";
	  print "<td>" . $mode[$machine->{'machine.provision_mode'}] . "</td>";
	  #print "<td bgcolor=$color><font color=#910000>" . $machine->{'ip'} . "</font></td>";
	  print "<td>" . $energyInfo . "</td>";
	}
}

sub setMachPower {
	my ($query) = @_;
	my @machs = $query->param("machName");

	my $action = $query->param("machPowerMenu");
	my $status;
	if ($action eq "powerOn") {
		$status = "power_on";
	} elsif ($action eq "powerOff") {
		$status = "power_off";
	} elsif ($action eq "powerReset") {
		$status = "power_reset";
	} else {
		error("Unknown power status");
	}

	my $mlist = join ",", @machs;
	#`$CLOUD_BIN_DIR/utils/thcsu -u root 'ssh $::CONFIG{'XCAT_MN'} "$CLOUD_BIN_DIR/energy/xcat/changepowerstatus $mlist $status"'`;
	`$CLOUD_BIN_DIR/utils/thcsu -u root '$CLOUD_BIN_DIR/energy/xcat/changepowerstatus $mlist $status'`;
}

sub applyEScheme {
	my ($query) = @_;
	my @machs = $query->param("machName");
	my $scheme = $query->param("machEScheme");

	my $mlist = join ",", @machs;
	my ($shemeName, $shemeOwner) = split /\|/, $scheme;

	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/energy/hcapplyescheme";
	$cmd .= " --owner=$shemeOwner";
	$cmd .= " --name=$shemeName";
	$cmd .= " --machlist=$mlist";
	$cmd .= "\"";
	
	my $output = `$cmd`;
	print $output;
}
sub machStatus {
	my ($query) = @_;
	my $allMach;
	$allMach = CloudUtils->getAllMach;

	foreach my $mach (keys %$allMach) {
		my $machName = $allMach->{$mach}->{'machine.name'};
		my $energyScheme = EnergyUtils->getESchemeByMachine($machName, 1);
		$energyScheme = $energyScheme ? $energyScheme : "NA";
		my $machine = CloudUtils->getMachine($machName);
		print "$machName:$machine->{'machine.power_state'}:$energyScheme:$machine->{'machine.status'}|";
	}
}


sub listImage {
	my ($query) = @_;

	print "<h2><b>All Images:</b></h2><p>";
	print "<form id='allImageForm' name='allImageForm' method=post action=portal.cgi>";
	print "<input id=\"imageAction\" type=hidden name=function value=deleteImage>";

	print "<table id=\"imagelistTab\" border=0 cellpadding=2 cellspacing=2 bgcolor=#e3e3d1 style=\"text-align:center\">";
	print "<tr valign=\"middle\">
			<th align=\"left\" colspan=8>\n";
	print "<table>";
	my $flag="";
	if(CloudUtils->checkCapability($USERID, "delete-image")==0){
		$flag="disabled";
	}
		print "<tr><td><button dojoType=\"dijit.form.Button\" type=\"button\" baseClass=tundra iconClass=\"dijitIcon dijitIconDelete\" title=\"Delete selected images\" onclick=\"deleteImage();\" $flag>Delete</button></td>\n";
	$flag="";
	if(CloudUtils->checkCapability($USERID, "create-image")==0){
		$flag="disabled";
	}
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"navLink('listImage', 'portal.cgi?function=innerMakeImageForm');\" baseClass=tundra iconClass=\"dijitIcon dijitIconNewTask\" title=\"Add a new image\" $flag>Make</button></td>\n";
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"navLink('listImage', 'portal.cgi?function=innerCapImageForm');\" baseClass=tundra iconClass=\"dijitIcon dijitIconNewTask\" title=\"Capture a new image\" $flag>Capture</button></td>\n";
	$flag="";
	if(CloudUtils->checkCapability($USERID, "approve-image")==0){
		$flag="disabled";
	}
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"approveImage();\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconTabIndent\" title=\"Approve new images\" $flag>Approve</button></td>\n";
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"dijit.byId('mainContent').refresh();\" baseClass=tundra iconClass=\"dijitIcon dijitIconUndo\">Refresh</button></td>\n";
	print "<td>Show Removed Images</td><td><input type=checkbox name=showrmimage id=showrmimage onClick=\"onDispRmImageCheckBox()\" ></td>";
	print "</tr></table>\n";
	print "</th></tr>";

	print "<tr class='tab_head'><td id='selectImage' name='selectImage' width=50>Select</td>
			<td width=100><a href=\"javascript:sortImageTab('name');\" title=\"Sort by Name\">Name</a></td>
			<td width=240><a href=\"javascript:sortImageTab('base');\" title=\"Sort by OS\">OS</a></td>
			<td width=100><a href=\"javascript:sortImageTab('status');\" title=\"Sort by status\">Status</a></td>	
			<td width=100>Machine Type Supported</td>
			<td width=300>Infrastructure</td>
			<td width=300>Description</td>
		  </tr>";
	print "<tr><td colspan=8><b>Loading...</b></td></tr>";
	print "</table>";
	print "</form>";

	print "<script language=\"javascript\" type=\"text/javascript\" defer=true src=\"/hpccloud/scripts/ImageView.js\"></script>\n";
	my $script = <<"SCRIPT";
<script type="text/javascript" language="JavaScript">
showImages();
</script>
SCRIPT

	print $script;
}

sub listImageDetail {
	my ($query) = @_;
	my $imageName = $query->param('imagename');
	my $imginfo = CloudUtils->getImageInfo({'name' => $imageName});
	my $table_name="image";
	my @display_itmes=(
		#name, formprompt, type, flag, size, show depend on field
		["name","Image Name:","text","readonly",30,"NA"],
		["base","Base OS:","text","readonly",30,"NA"],
		["arch","Architecture:","text","readonly",30,"NA"],
		["profile","Profile Name:","text","readonly",30,"NA"],
		["status","Status:","text","readonly",30,"NA"],
		["captured_on", "Captured From Machine:","text","readonly",30,"captured_on"],
		["captured_time", "Captured Time:","text","readonly",30,"captured_on"],
		["captured_by", "Captured by user:","text","readonly",30,"captured_on"],
		["approved_by", "Captured by user:","text","readonly",30,"status,AVAILABLE"],
		["pkglist_path", "Package List:","text","readonly",30,"NA"],
		["pkg_location", "Additional Package Path:","text","readonly",30,"pkg_location"],
		["scheduler", "Scheduler:","text","readonly",30,"scheduler"],
		["parallel_env", "Parallel Enviroment:","text","readonly",30,"parallel_env"],
		["pre_scripts", "Pre-scripts:","text","readonly",30,"pre_scripts"],
		["post_scripts", "Post-scripts:","text","readonly",30,"post_scripts"],
		["interconnect", "Interconnection Type:","text","readonly",30,"NA"],
		["shared_fs", "Shared File System:","text","readonly",30,"NA"],
		["description", "Description:","text","readonly",30,"NA"],
	);
	
	print "<h3><b>Image  $imageName detailed information: </b></h3><p>";
	print "<blockquote><table border=0 cellpadding=2 cellspacing=2>";
	foreach my $display_info(@display_itmes){	
		my ($name, $formprompt, $type, $flag, $size, $depend) = @$display_info;
		my $field_name=$table_name.".".$name;
		my $tmp_v = $imginfo->{$imageName}->{$field_name};
		my $disp_flag=1;
		if($depend ne "NA"){#need check condition for display
			my ($conditon_n, $condition_v)=split(",", $depend);
			my $depend_str=$table_name.".".$conditon_n;
			if(exists($imginfo->{$imageName}->{$depend_str})){				
				if(defined($condition_v)){#
					if($imginfo->{$imageName}->{$depend_str} ne $condition_v){
						$disp_flag = 0;
					}
				}
			}else{
				$disp_flag = 0;
			}
		}		
		if($disp_flag){
			print "<tr><td class=formprompt>$formprompt</td>";
			print "<td><input type=$type name=$name size=$size style=\"font-family:verdana\" value=\'$tmp_v\' $flag></td></tr>\n";
		}
	}

	print "</table></blockquote>";

}

sub listImagePackage {
	my ($query) = @_;
	my $flag="";
	
	print "<h2><b>All Package Lists:</b></h2><p>";
	print "<form id='PackageForm' name='PackageForm' method=post action=portal.cgi>";
	print "<input id=\"packageAction\" type=hidden name=function value=deletePackage>";

	print "<table id=\"packageListTab\" border=0 cellpadding=2 cellspacing=2 bgcolor=#e3e3d1 style=\"text-align:center\">";
	print "<tr valign=\"middle\">
			<th align=\"left\" colspan=8>\n";
	print "<table>";
	if(CloudUtils->checkCapability($USERID, "delete-pkglist")==0){
		$flag="disabled";
	}
	print "<tr><td><button dojoType=\"dijit.form.Button\" type=\"button\" baseClass=tundra iconClass=\"dijitIcon dijitIconDelete\" title=\"Delete selected package lists\" onclick=\"submitDeletePackage()\" $flag>Delete</button></td>\n";
	$flag="";
	if(CloudUtils->checkCapability($USERID, "create-pkglist")==0){
		$flag="disabled";
	}
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"navLink('vlanConfig', 'portal.cgi?function=addPackageDlg');\" baseClass=tundra iconClass=\"dijitIcon dijitIconNewTask\" title=\"Add a new package list\" $flag>Add</button></td>\n";
	$flag="";
	if(CloudUtils->checkCapability($USERID, "modify-pkglist")==0){
		$flag="disabled";
	}
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"submitApprovePackage();\" baseClass=tundra iconClass=\"dijitIcon dijitIconNewTask\" title=\"Approve\" $flag>Approve</button></td>\n";
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"dijit.byId('mainContent').refresh();\" baseClass=tundra iconClass=\"dijitIcon dijitIconUndo\">Refresh</button></td>\n";
	print "<td>Show Removed Package Lists</td>";
	print "<td><input type=checkbox name=showremoved  id=showremoved value=0 onClick=\"Selected()\"></td>";
	print "</tr></table>\n";
	print "</th></tr>";

	print "<tr class='tab_head'><td id='selectPackage' name='selectPackage' width=50>Select</td>
			<td width=100><a href=\"javascript:sortPackageTab('name');\" title=\"Sort by Name\">Name</td>
			<td width=240>Path Orig</td>
			<td width=100><a href=\"javascript:sortPackageTab('status');\" title=\"Sort by Status\">Status</td>
			<td width=100>Creator</td>
			<td width=300>Description</td>
		  </tr>";
	print "<tr><td colspan=8><b>Loading...</b></td></tr>";
	print "</table>";
	print "</form>";

	print "<script language=\"javascript\" type=\"text/javascript\" defer=true src=\"/hpccloud/scripts/PackageView.js\"></script>\n";
	my $script = <<"SCRIPT";
<script type="text/javascript" language="JavaScript">
function Selected()
{
	if(document.PackageForm.showremoved.checked) document.PackageForm.showremoved.value=1;
	else document.PackageForm.showremoved.value=0;
	refreshPackageTab();
}
showPackage();
</script>
SCRIPT

	print $script;
}
sub deletePackage {
	my ($query) = @_;
	my @packages = $query->param('PackageCheck');

	print "<delete_result>\n";
	foreach my $package (@packages) {
		my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/imgmgt/hcrmpkglist --name=$package\"";
		my $output = `$cmd`;
		print $output;
	}
	print "</delete_result>\n";
}

sub approvePackage {
	my ($query) = @_;
	my @packages = $query->param('PackageCheck');
	
	print "<results>";
	foreach my $package (@packages) {
		my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/imgmgt/hcchpkglist --name=$package --status=APPROVED\"";
		my $output = `$cmd`;
		print $output;
	}
	print "</results>";
}

sub addPackageDlg {
	my ($query) = @_;
	print "<h3><b>Specify the information of the package list you want to add: </b></h3><p>";
	print "<form id=\"addPackageForm\" method=\"post\" action=\"portal.cgi\" enctype=\"multipart/form-data\">";
	print "<blockquote><table border=0 cellpadding=2 cellspacing=2>";
	print "<input type=hidden name=function value=addPackage>\n";
	print "<tr><td class='tab_highlight' colspan=3><font color=#f7f9e5>Add Package List</font></td></tr>";

	print "<tr><td class=formprompt rowspan=2>Path *:</td>";
	print "<td><input type=radio checked name=uploadselect value=1 onclick=\"IsDisable();\">From server</td><td class=formfield><input type=\"text\" name=\"pathorig\" id=\"pathorig\"></td></tr>";
	print "<tr><td><input type=radio name=uploadselect value=0 onclick=\"IsDisable();\">From local</td>";
	print "<td><input type=\"file\" name=\"localPkg\" id=\"localPkg\" value=\"\"/ disabled></td></tr>";

	print "<tr><td class=formprompt>Description *:</td><td class=formfield><input type=\"text\" name=\"description\" id=\"description\"></td></tr>";
	print "<tr><td class=formprompt>ReName :</td><td class=formfield><input type=\"text\" name=\"packagename\" id=\"packagename\"></td></tr>";
	print "</table></blockquote>";
	print "<input type=hidden name=function value=addPackage>";
	print "<p><button dojoType=\"dijit.form.Button\" type=\"button\" iconClass=\"dijitEditorIcon dijitEditorIconTabIndent\" onClick=\"submitAddPackage();\">Add Package</button>";
	print "</form>";
}
sub addPackage {
	my($query) = @_;
	my @output;

	my $ret = "<html><body><textarea>";
	my $retEnd = "</textarea></body></html>";

	use File::Basename;
	$CGI::POST_MAX = 1024 * 5000;  
	my $safe_filename_characters = "a-zA-Z0-9_.-";
	my $upload_dir = "/tmp";
	my $upload_dir_new = "/hpcc/home/$USERID/upload";
	my $cmd;
	my $pathorig = $query->param('pathorig');
	my $local_jcf = $query->param("localPkg");
	my $description = $query->param('description');
	my $newname = $query->param('packagename');	
	if ($description eq "")
	{
		error("Specify a description.");
	}
	if ($pathorig)
	{
		$cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/imgmgt/hcmkpkglist --path=\'$pathorig\' --desc=\'$description\'";
	}
	elsif ($local_jcf) {
		my ( $name, $path, $extension ) = fileparse ( $local_jcf, '\..*' );
		my $filename = $name . $extension;  
		$filename =~ tr/ /_/;  
		$filename =~ s/[^$safe_filename_characters]//g;
		if ( $filename =~ /^([$safe_filename_characters]+)$/ ) {  
			$filename = $1;
		} else {
			$ret = $ret . "Filename contains invalid characters" . $retEnd;
			print $ret;
			exit 1;
		}
		my $upload_filehandle = $query->upload("localPkg");
		my $pkglistname = $filename;
		open ( UPLOADFILE, ">$upload_dir/$pkglistname" ) || error("$!");
		binmode UPLOADFILE;
		my $buff;
		while ( my $bytes_read = read($upload_filehandle, $buff, 2096) ) {
			print UPLOADFILE $buff;
		}

		close UPLOADFILE;

		`$CLOUD_BIN_DIR/utils/thcsu -u root 'chown $USERID: $upload_dir/$pkglistname 2>&1'`;
		`$CLOUD_BIN_DIR/utils/thcsu -u $USERID 'mv $upload_dir/$pkglistname $upload_dir_new/ 2>&1'`;

		if ($? != 0) {
			`$CLOUD_BIN_DIR/utils/thcsu -u root 'rm -f $upload_dir/$pkglistname 2>&1'`;
			$ret = $ret . "Failed to upload the pkglist." . $retEnd;
			print $ret;
			exit 1;
		}

		`$CLOUD_BIN_DIR/utils/thcsu -u $USERID '/usr/bin/dos2unix $upload_dir_new/$pkglistname 2>&1'`;
		$cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/imgmgt/hcmkpkglist --path=\'$upload_dir_new/$pkglistname\' --desc=\'$description\'";
	} else {
		error("Specify a path.");
	}
	if ($newname ne "") {
		$cmd .= " --newname=\'$newname\'";
	}
	$cmd .= "\"";
	@output = `$cmd`;
	print $ret;
	print @output;
	print $retEnd;
}

sub listImageScript {
	my ($query) = @_;

	print "<h2><b>All Scripts:</b></h2><p>";
	print "<form id='ScriptForm' name='ScriptForm' method=post action=portal.cgi>";
	print "<input id=\"ScriptAction\" type=hidden name=function value=deleteScript>";

	print "<table id=\"scriptListTab\" border=0 cellpadding=2 cellspacing=2 bgcolor=#e3e3d1 style=\"text-align:center\">";
	print "<tr valign=\"middle\">
			<th align=\"left\" colspan=8>\n";
	print "<table>";
	my $flag="";
	if(CloudUtils->checkCapability($USERID, "delete-script")==0){
		$flag="disabled";
	}
	print "<tr><td><button dojoType=\"dijit.form.Button\" type=\"button\" baseClass=tundra iconClass=\"dijitIcon dijitIconDelete\" title=\"Delete selected scripts\" onclick=\"submitDeleteScript();\" $flag >Delete</button></td>\n";
	$flag="";
	if(CloudUtils->checkCapability($USERID, "create-script")==0){
		$flag="disabled";
	}
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"navLink('vlanConfig', 'portal.cgi?function=addScriptDlg');\" baseClass=tundra iconClass=\"dijitIcon dijitIconNewTask\" title=\"Add a new script\" $flag >Add</button></td>\n";
	$flag="";
	if(CloudUtils->checkCapability($USERID, "modify-script")==0){
		$flag="disabled";
	}
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"submitApproveScript();\" baseClass=tundra iconClass=\"dijitIcon dijitIconNewTask\" title=\"Approve\" $flag>Approve</button></td>\n";
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"dijit.byId('mainContent').refresh();\" baseClass=tundra iconClass=\"dijitIcon dijitIconUndo\">Refresh</button></td>\n";
	print "<td>Show Removed Scripts</td>";
	print "<td><input type=checkbox name=showremoved  id=showremoved value=0 onClick=\"showRemovedS()\"></td>";

	print "</tr></table>\n";
	print "</th></tr>";

	print "<tr class='tab_head'><td id='selectScript' name='selectScript' width=50>Select</td>
			<td width=100><a href=\"javascript:sortScriptTab('name');\" title=\"Sort by Name\">Name</td>
			<td width=50><a href=\"javascript:sortScriptTab('flag');\" title=\"Sort by Flag\">Flag</td>
			<td width=50><a href=\"javascript:sortScriptTab('status');\" title=\"Sort by Status\">Status</td>
			<td width=300>Description</td>
		  </tr>";
	print "<tr><td colspan=8><b>Loading...</b></td></tr>";
	print "</table>";
	print "</form>";

	print "<script language=\"javascript\" type=\"text/javascript\" src=\"/hpccloud/scripts/ScriptView.js\"></script>\n";
	my $script = <<"SCRIPT";
<script type="text/javascript" language="JavaScript">
	showScript();
function showRemovedS() {
	if(document.ScriptForm.showremoved.checked) document.ScriptForm.showremoved.value=1;
	else document.ScriptForm.showremoved.value=0;
	refreshScriptTab();
}
</script>
SCRIPT

	print $script;
}

sub deleteScript {
	my ($query) = @_;
	my @scripts = $query->param('ScriptCheck');

	print "<delete_result>\n";
	foreach my $script (@scripts) {
		my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/imgmgt/hcrmscript --name=$script\"";
		my $output = `$cmd`;
		print $output;
	}
	print "</delete_result>\n";
}

sub approveScript {
	my ($query) = @_;
	my @packages = $query->param('ScriptCheck');
	
	print "<results>";
	foreach my $package (@packages) {
		my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/imgmgt/hcchscript --name=$package --status=APPROVED\"";
		my $output = `$cmd`;
		print $output;
	}
	print "</results>";
}


sub addScriptDlg {
	my ($query) = @_;
	print "<h3><b>Specify the information of the script you want to add: </b></h3><p>";
	print "<form id=\"addScriptForm\" method=\"post\" action=\"portal.cgi\" enctype=\"multipart/form-data\">";
	print "<blockquote><table border=0 cellpadding=2 cellspacing=2>";
	print "<input type=hidden name=function value=addScript >\n";
	print "<tr><td class='tab_highlight' colspan=3><font color=#f7f9e5>Add Script</font></td></tr>";

	# path
	print "<tr><td class=formprompt rowspan=2>Path *:</td>";
	print "<td><input type=radio checked name=radio_path value=1 onclick=\"isDisable_script();\">From server</td><td class=formfield><input type=\"text\" name=\"script_path\" id=\"script_path\"></td></tr>";
	print "<tr><td><input type=radio name=radio_path value=0 onclick=\"isDisable_script();\">From local</td>";
	print "<td><input type=\"file\" name=\"localS\" id=\"localS\" value=\"\"/ disabled></td></tr>";

	# flag
	print "<tr><td class=formprompt>Flag *:</td>";
	print "<td><select id=\"flag_select\" name=\"flag_select\" size=1>";
	my @flag_option = qw/PRE POST/;
	foreach my $flag(@flag_option) {
		print "<option value=\"$flag\">$flag</option>";
	}
	print "</select>";
	print "</td></tr>";

	print "<tr><td class=formprompt>Description *:</td><td class=formfield><input type=\"text\" name=\"description\" id=\"description\"></td></tr>";
	print "<tr><td class=formprompt>ReName :</td><td class=formfield><input type=\"text\" name=\"scriptname\" id=\"scriptname\"></td></tr>";
	print "</table></blockquote>";

	print "<input type=hidden name=function value=addScript>";
	print "<p><button dojoType=\"dijit.form.Button\" type=\"button\" iconClass=\"dijitEditorIcon dijitEditorIconTabIndent\" onClick=\"submitAddScript();\">Add Script</button>";
	print "</form>";
}

sub addScript {
	my ($query) = @_;
	my @output;
	my $ret = "<html><body><textarea>";
	my $retEnd = "</textarea></body></html>";
	use File::Basename;
	$CGI::POST_MAX = 1024 * 5000;
	my $safe_filename_characters = "a-zA-Z0-9_.-";
	my $upload_dir = "/tmp";
	my $upload_dir_new = "/hpcc/home/$USERID/upload";

	my $pathorig = $query->param('script_path');
	my $local_script = $query->param('localS');
	my $flag = $query->param('flag_select');
	my $description = $query->param('description');
	my $name = $query->param('scriptname');
	if ($flag eq "") {
		error("Specify a flag.");
	}
	if ($description eq "") {
		error("Specify a description.");
	}

	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u cloudadm \"$BIN_DIR/imgmgt/hcmkscript --flag=\'$flag\' --desc=\'$description\'";
	if ($name ne "") {
		 $cmd .= " --newname=\'$name\'";
	}
	if ($pathorig) {
		$cmd .= " --path=\'$pathorig\'";
	} elsif ($local_script){
		my ( $name, $path, $extension ) = fileparse ( $local_script, '\..*' );
		my $filename = $name . $extension;
		$filename =~ tr/ /_/;
		$filename =~ s/[^$safe_filename_characters]//g;
		if ( $filename =~ /^([$safe_filename_characters]+)$/ ) {
			$filename = $1;
		} else {
			$ret = $ret . "Filename contains invalid characters" . $retEnd;
			print $ret;
			exit 1;
		}
		my $upload_filehandle = $query->upload("localS");
		my $script_name = $filename;
		open ( UPLOADFILE, ">$upload_dir/$script_name" ) || error("$!");
		binmode UPLOADFILE;
		my $buff;
		while ( my $bytes_read = read($upload_filehandle, $buff, 2096) ) {
			print UPLOADFILE $buff;
		}
		close UPLOADFILE;

		`$CLOUD_BIN_DIR/utils/thcsu -u root 'chown $USERID: $upload_dir/$script_name 2>&1'`;
		`$CLOUD_BIN_DIR/utils/thcsu -u $USERID 'mv $upload_dir/$script_name $upload_dir_new/ 2>&1'`;
		if ($? != 0) {
			`$CLOUD_BIN_DIR/utils/thcsu -u root 'rm -f $upload_dir/$script_name 2>&1'`;
			$ret = $ret . "Failed to upload the script." . $retEnd;
			print $ret;
			exit 1;
		}
		@output = `$CLOUD_BIN_DIR/utils/thcsu -u $USERID '/usr/bin/dos2unix $upload_dir_new/$script_name 2>&1'`;
		$cmd .= " --path=\'$upload_dir_new/$script_name\'";
	} else {
		error("Specify a path.");
	}

	$cmd .= "\"";
	@output = `$cmd`;
	print $ret;
	print @output;
	print $retEnd;
}

sub innerMakeImageForm {
	my ($query) = @_;

	print "<div id=\"reqWizard\" dojoType=\"dojox.widget.Wizard\" style=\"width:100%\">\n";
	print "<form name=\"newImageForm\" id=\"newImageForm\" method=post action=\"portal.cgi\">";
	print "<input type=hidden name=function value=\"makeImage\" >\n";
	print "<div dojoType=\"dojox.widget.WizardPane\" canGoBack=\"false\" passFunction=\"checkImagefirstpage\">\n";
	print "<blockquote>\n";
	print "<table border=0 cellpadding=2 cellspacing=2>";
	print "<tr><td class='tab_highlight' colspan=2><font color=#f7f9e5>Image attributes-base</font></td></tr>";
	print "<tr><td class=formprompt>Profile name *:</td><td class=formfield><input type=\"text\" name=\"name\" id=\"profile\"></td></tr>";
	print "<tr><td class=formprompt>Processor architecture *:</td><td><select class=formfield name=\"arch\" id=\"arch\" size=3 style=\"width:300px;\">
	<option value=\"x86_64\" selected>x86_64</option>
	</select></td></tr>\n";

	print "<tr><td class=formprompt>Base operating system *:</td><td><select class=formfield name=\"os\" id=\"os\" size=3 style=\"width:300px;\">
	<option value=\"rhels6\" selected>Redhat Enterprise Linux Version 6</option>
	<option value=\"centos6\" >CentOS Version 6</option>
	</select></td></tr>\n";

	print "<tr><td class=formprompt>Image description *:</td><td class=formfield><input type=\"text\" textarea name=\"desc\" id=\"desc\" rows=5 style=\"width:300px;\"></textarea></td></tr>";	
	print "</table>";
	print "</blockquote>\n";
	print "</div>";
	print "<div dojoType=\"dojox.widget.WizardPane\" canGoBack=\"true\" passFunction=\"passSelectValue\">\n";
	print "<blockquote>\n";
	print "<table border=0 cellpadding=2 cellspacing=2>";
	print "<tr><td class='tab_highlight' colspan=2><font color=#f7f9e5>Image attributes-infrastructure</font></td></tr>";
	print "<tr><td class=formprompt>Scheduler :</td>";
	print "<td><select id=\"scheduler_select\" name=\"scheduler_select\" size=1 style=\"width:150px\">";
	my @scheduler_option = qw/NA loadl lsf pbs sge others/;
	foreach my $scheduler(@scheduler_option)
	{
	 print "<option value=\"$scheduler\">$scheduler</option>";
	}
	print "</select>";
	print "</td></tr>";

	print "<tr><td class=formprompt>Parallel environment :</td>";
	print "<td><select id=\"environment_select\" name=\"environment_select\" size=1 style=\"width:150px\">";
	my @environment_option = qw/NA pe openmpi others/;
	foreach my $environment(@environment_option)
	{
	 print "<option value=\"$environment\">$environment</option>";
	}
	print "</select>";
	print "</td></tr>";

	print "<tr><td class=formprompt>Network *:</td>";
	print "<td><select id=\"network_select\" name=\"network_select\" size=1 style=\"width:150px\">";
	my @network_option = qw/eth IB others/;
	foreach my $network(@network_option)
	{
	 print "<option value=\"$network\">$network</option>";
	}
	print "</select>";
	print "</td></tr>";

	print "<tr><td class=formprompt>Shared file system :</td>";
	print "<td><select id=\"filesystem_select\" name=\"filesystem_select\" size=1 style=\"width:150px\">";
	my @filesystem_option = qw/nfs gpfs others/; 
	foreach my $filesystem(@filesystem_option)
	{
	 print "<option value=\"$filesystem\">$filesystem</option>";
	}
	print "</select>";
	print "</td></tr>";
	print "</table>";

	print "<table border=0 cellpadding=2 cellspacing=2>";
	print "<tr><td class='tab_highlight' colspan=2><font color=#f7f9e5><b>Location of other packages</b></font></td></tr>";
	print "<tr><td class=formprompt>Location of other packages:</td>";
	print "<td class=formfield><input type=\"text\" textarea name=\"otherpkg\" id=\"otherpkg\"></textarea></td>";
	print "</tr>";
	print "</table>";
	
	print "</blockquote>\n";
	print "</div>";
	print "<div dojoType=\"dojox.widget.WizardPane\" canGoBack=\"true\" doneFunction=\"submitNewImage\">\n";
	my $prescript;
	my $conditions={
		'flag'=>'PRE',
		'status'=>'APPROVED',
	};
	my $allprescript = CloudUtils->getScriptInfo($conditions);
	my @allpreoption = sort keys %$allprescript;		
	foreach my $script (@allpreoption) {	 
		 $prescript .= "<option value=\"$script\">$script</option>";  
	}

	my $preinfrastructure;
	my $postinfrastructure;
	my ($rc,$allinfrastructure) = CloudUtils->getInfrastructureScriptInfo();
	my @allinf = sort keys %$allinfrastructure; 
	foreach my $script (@allinf) {
		if (defined($allinfrastructure->{$script}->{'infrastr_script.pre_scripts'}) and ($allinfrastructure->{$script}->{'infrastr_script.pre_scripts'} ne ""))
		{	 
			 $preinfrastructure .= "<option value=\"$allinfrastructure->{$script}->{'infrastr_script.name'}+$allinfrastructure->{$script}->{'infrastr_script.type'}\">$allinfrastructure->{$script}->{'infrastr_script.pre_scripts'}</option>";  
		}
		if (defined($allinfrastructure->{$script}->{'infrastr_script.post_scripts'}) and ($allinfrastructure->{$script}->{'infrastr_script.post_scripts'} ne ""))
		{	 
			 $postinfrastructure .= "<option value=\"$allinfrastructure->{$script}->{'infrastr_script.name'}+$allinfrastructure->{$script}->{'infrastr_script.type'}\">$allinfrastructure->{$script}->{'infrastr_script.post_scripts'}</option>";  
		}
	}
		 
	print "<table border=0 cellpadding=2 cellspacing=2>";
	print "<tr><td class='tab_highlight' colspan=3><font color=#f7f9e5><b>Scripts</b></font></td></tr>";
	print "<tr><td><!--input type=radio checked name=mode_u value=1--></td><td class=formprompt>Pre  scripts:</td>";
	print "<td>";
	print "<table>";
	print "<tr><td>PRE</td><td></td><td><button dojoType=\"dijit.form.Button\" type=\"button\" iconClass=\"dijitEditorIcon dijitEditorIconTabIndent\" onClick=\"clearscript();\">Clear</button></td></tr>";
	print "<tr><td><select class=formfield multiple=\"multiple\" name=prefield id=prefield size=4 style=\"width:200px;\"></select><select class=formfield multiple=\"multiple\" name=prefield2 id=prefield2 size=4 style=\"display:none;\">$prescript</select></td>";
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"moveItem('prefield', 'prefieldtaken');\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconRedo\" showLabel=false>-></button><br>";
	print "<button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"moveItem('prefieldtaken', 'prefield');\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconUndo\" showLabel=false><-</button></td>";
	print "<td><select class=formfield multiple=\"multiple\" name=prefieldtaken id=prefieldtaken size=4 style=\"width:200px;\">$preinfrastructure</select><select class=formfield multiple=\"multiple\" name=prefieldtaken2 id=prefieldtaken2 size=4 style=\"display:none;\">$preinfrastructure</select></td>";
	print "</table>";
	print "</td></tr>";
	print "</table>";
	##########
	my $postscript;
	$conditions={
		'flag'=>'POST',
		'status'=>'APPROVED',
	};
	my $allpostscript = CloudUtils->getScriptInfo($conditions);
	my @allpostoption = sort keys %$allpostscript;
	foreach my $script (@allpostoption) {	 
		 $postscript .= "<option value=\"$script\">$script</option>";  
	}
	print "<table border=0 cellpadding=2 cellspacing=2>";
	print "<tr><td><!--input type=radio checked name=mode_u value=1--></td><td class=formprompt>Post scripts:</td>";
	print "<td>";
	print "<table>";
	print "<tr><td>POST</td><td></td><td><button dojoType=\"dijit.form.Button\" type=\"button\" iconClass=\"dijitEditorIcon dijitEditorIconTabIndent\" onClick=\"clearscript();\">Clear</button></td></tr>";
	print "<tr><td><select class=formfield multiple=\"multiple\" name=postfield id=postfield size=4 style=\"width:200px;\"></select><select class=formfield multiple=\"multiple\" name=postfield2 id=postfield2 size=6 style=\"display:none;\">$postscript</select></td>";
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"moveItem('postfield', 'postfieldtaken');\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconRedo\" showLabel=false>-></button><br>";
	print "<button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"moveItem('postfieldtaken', 'postfield');\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconUndo\" showLabel=false><-</button></td>";
	print "<td><select class=formfield multiple=\"multiple\" name=postfieldtaken id=postfieldtaken size=4 style=\"width:200px;\"></select><select class=formfield multiple=\"multiple\" name=postfieldtaken2 id=postfieldtaken2 size=6 style=\"display:none;\">$postinfrastructure</select></td>";
	print "</table>";
	print "</td></tr>";
	print "</table>";

	print "<table border=0 cellpadding=2 cellspacing=2>";
	print "<tr><td class='tab_highlight' colspan=2><font color=#f7f9e5><b>Package list</b></font></td><td> </td></tr>";
	print "<tr><td class=formprompt>Package list file path :</td>";
	print "<td><select id=\"packagelist_select\" name=\"packagelist_select\" size=1>";
	$conditions={
		'status'=>'APPROVED',
	};
	my $allpackagelist = CloudUtils->getPkgListInfo($conditions);
	my @allpkglistoption = sort keys %$allpackagelist;

	print "<option value=\"\" title=\"The default pkglist will be used.\">NA</option>";
	foreach my $packagelist (@allpkglistoption)
	{
		print "<option value=\"$packagelist\">$packagelist</option>";
	}
	print "</select>";
	print "</td></tr>";
	print "</table>";
	
	print "</td></tr>";
	print "</table>";
	print "</div>";
	print "</form>";
	print "<script type=\"dojo/method\" event=\"cancelFunction\">\n 
	if(confirm(\"Do you want to quit the guide?\")) { 
		navLink(\"listImage\");			 
	}			
	</script>\n";
	print "</div>";
}

sub innerCapImageForm {
	my ($query) = @_;

	print "<div id=\"reqWizard\" dojoType=\"dojox.widget.Wizard\" style=\"width:100%\">\n";
	print "<form name=\"capImageForm\" id=\"capImageForm\" method=post action=\"portal.cgi\">";
	print "<input type=hidden name=function value=\"captureImage\" >\n";
	print "<div dojoType=\"dojox.widget.WizardPane\" canGoBack=\"false\" passFunction=\"checkImageCapfirstpage\">\n";
	print "<blockquote>\n";
	print "<table border=0 cellpadding=2 cellspacing=2>";
	print "<tr><td class='tab_highlight' colspan=2><font color=#f7f9e5>Image attributes-base</font></td></tr>";
	print "<tr><td class=formprompt>Profile name *:</td><td class=formfield><input type=\"text\" name=\"name\" id=\"profile\"></td></tr>";
	print "<tr><td class=formprompt>Processor architecture *:</td><td><select class=formfield name=\"arch\" id=\"arch\" size=3 style=\"width:300px;\">
	<option value=\"x86_64\" selected>x86_64</option>
	</select></td></tr>\n";

	print "<tr><td class=formprompt>Base operating system *:</td><td><select class=formfield name=\"os\" id=\"os\" size=3 style=\"width:300px;\">
	<option value=\"rhels6\" selected>Redhat Enterprise Linux Version 6</option>
	<option value=\"centos6\" >CentOS Version 6</option>
	</select></td></tr>\n";

	print "<tr><td class=formprompt>Image description *:</td><td class=formfield><input type=\"text\" textarea name=\"desc\" id=\"desc\" rows=5 style=\"width:300px;\"></textarea></td></tr>";	
	print "</table>";
	print "</blockquote>\n";
	print "</div>";
	print "<div dojoType=\"dojox.widget.WizardPane\" canGoBack=\"true\" passFunction=\"passSelectValue\">\n";
	print "<blockquote>\n";
	print "<table border=0 cellpadding=2 cellspacing=2>";
	print "<tr><td class='tab_highlight' colspan=2><font color=#f7f9e5>Image attributes-infrastructure</font></td></tr>";
 
	print "<tr><td class=formprompt>Scheduler :</td>";
	print "<td><select id=\"scheduler_select\" name=\"scheduler_select\" style=\"width:150px\" size=1>";
	my @scheduler_option = qw/NA loadl lsf pbs sge others/;
	foreach my $scheduler(@scheduler_option) {
		print "<option value=\"$scheduler\">$scheduler</option>";
	}
	print "</select>";
	print "</td></tr>";

	print "<tr><td class=formprompt>Parallel environment :</td>";
	print "<td><select id=\"environment_select\" name=\"environment_select\" style=\"width:150px\" size=1>";
	my @environment_option = qw/NA pe openmpi others/;
	foreach my $environment(@environment_option) {
		print "<option value=\"$environment\">$environment</option>";
	}
	print "</select>";
	print "</td></tr>";

	print "<tr><td class=formprompt>Network *:</td>";
	print "<td><select id=\"network_select\" name=\"network_select\" style=\"width:150px\" size=1>";
	my @network_option = qw/eth IB others/;
	foreach my $network(@network_option) {
		print "<option value=\"$network\">$network</option>";
	}
	print "</select>";
	print "</td></tr>";

	print "<tr><td class=formprompt>Shared file system :</td>";
	print "<td><select id=\"filesystem_select\" name=\"filesystem_select\" style=\"width:150px\" size=1>";
	my @filesystem_option = qw/NA nfs gpfs others/;
	foreach my $filesystem(@filesystem_option) {
		print "<option value=\"$filesystem\">$filesystem</option>";
	}
	print "</select>";
	print "</td></tr>";
	print "</table>";
	print "</blockquote>\n";
	print "</div>";
	print "<div dojoType=\"dojox.widget.WizardPane\" canGoBack=\"true\" doneFunction=\"submitCapImage\">\n";
	my $prescript;
	my $conditions={
			'flag'=>'PRE',
			'status'=>'APPROVED',
		};
	my $allprescript = CloudUtils->getScriptInfo($conditions);
	my @allpreoption = sort keys %$allprescript;		
	foreach my $script (@allpreoption) {	 
		 $prescript .= "<option value=\"$script\">$script</option>";  
	}

	my $preinfrastructure;
	my $postinfrastructure;
	my ($rc,$allinfrastructure) = CloudUtils->getInfrastructureScriptInfo();
	my @allinf = sort keys %$allinfrastructure; 
	foreach my $script (@allinf) {
		if (defined($allinfrastructure->{$script}->{'infrastr_script.pre_scripts'}) and ($allinfrastructure->{$script}->{'infrastr_script.pre_scripts'} ne "")) {
			$preinfrastructure .= "<option value=\"$allinfrastructure->{$script}->{'infrastr_script.name'}+$allinfrastructure->{$script}->{'infrastr_script.type'}\">$allinfrastructure->{$script}->{'infrastr_script.pre_scripts'}</option>";  
		}
		if (defined($allinfrastructure->{$script}->{'infrastr_script.post_scripts'}) and ($allinfrastructure->{$script}->{'infrastr_script.post_scripts'} ne "")) {
			$postinfrastructure .= "<option value=\"$allinfrastructure->{$script}->{'infrastr_script.name'}+$allinfrastructure->{$script}->{'infrastr_script.type'}\">$allinfrastructure->{$script}->{'infrastr_script.post_scripts'}</option>";  
		}
	}
		 
	##########
	my $postscript;
	$conditions={
		'flag'=>'POST',
		'status'=>'APPROVED',
	};
	my $allpostscript = CloudUtils->getScriptInfo($conditions);
	my @allpostoption = sort keys %$allpostscript;
	foreach my $script (@allpostoption) {	 
		 $postscript .= "<option value=\"$script\">$script</option>";  
	}
	print "<table border=0 cellpadding=2 cellspacing=2>";
	print "<tr><td class='tab_highlight' colspan=3><font color=#f7f9e5><b>Scripts</b></font></td></tr>";
	print "<tr><td><!--input type=radio checked name=mode_u value=1--></td><td class=formprompt>Post scripts :</td>";
	print "<td>";
	print "<table>";
	print "<tr><td>POST</td><td></td><td><button dojoType=\"dijit.form.Button\" type=\"button\" iconClass=\"dijitEditorIcon dijitEditorIconTabIndent\" onClick=\"clearscript();\">Clear</button></td></tr>";
	print "<tr><td><select class=formfield multiple=\"multiple\" name=postfield id=postfield size=4 style=\"width:200px;\"></select><select class=formfield multiple=\"multiple\" name=postfield2 id=postfield2 size=6 style=\"display:none;\">$postscript</select></td>";
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"moveItem('postfield', 'postfieldtaken');\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconRedo\" showLabel=false>-></button><br>";
	print "<button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"moveItem('postfieldtaken', 'postfield');\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconUndo\" showLabel=false><-</button></td>";
	print "<td><select class=formfield multiple=\"multiple\" name=postfieldtaken id=postfieldtaken size=4 style=\"width:200px;\"></select><select class=formfield multiple=\"multiple\" name=postfieldtaken2 id=postfieldtaken2 size=6 style=\"display:none;\">$postinfrastructure</select></td>";
	print "</table>";
	print "</td></tr>";
	print "</table>";
	print "<table border=0 cellpadding=2 cellspacing=2>";
	print "<tr><td class='tab_highlight' colspan=3><font color=#f7f9e5><b>Machine</b></font></td><td> </td></tr>";
	print "<tr><td><!--input type=radio checked name=mode_u value=1--></td><td class=formprompt>Machine :</td>";
	print "<td>";
	print "<table>";
	print "<tr><td><select class=formfield name=machine id=\"capMach\" size=5 style=\"width:300px;\">";
	my $allMach = CloudUtils->getAllPhyMachName;
	foreach my $mach ( sort @{$allMach} ) {
		print "<option value=$mach>$mach</option>";
	}
	print "</select></td></tr>\n";
	print "</table>";
	print "</td></tr>";
	print "</table>";
	print "<table border=0 cellpadding=2 cellspacing=2>";
	print "<tr><td class='tab_highlight' colspan=2><font color=#f7f9e5><b>Package list</b></font></td><td> </td></tr>";
	print "<tr><td class=formprompt>Package list file path :</td>";
	print "<td><select id=\"packagelist_select\" name=\"packagelist_select\" size=1>";
	$conditions={
		'status'=>'APPROVED',
	};
	my $allpackagelist = CloudUtils->getPkgListInfo($conditions);
	my @allpkglistoption = sort keys %$allpackagelist;
	print "<option value=\"\" title=\"The default pkglist will be used.\">NA</option>";
	foreach my $packagelist (@allpkglistoption) {
		print "<option value=\"$packagelist\">$packagelist</option>";
	}
	print "</select>";
	print "</td></tr>";
	print "</table>";
	
	print "</td></tr>";
	print "</table>";
	print "</div>";
	print "</form>";
	print "<script type=\"dojo/method\" event=\"cancelFunction\">\n 
	if(confirm(\"Do you want to quit the guide?\")) { 
		navLink(\"listImage\");			 
	}			
	</script>\n";
	print "</div>";
}

sub makeImage {
	my ($query) = @_;

	my $profile = $query->param('name');
	my $os = $query->param('os');
	my $arch = $query->param('arch');
	my $desc = $query->param('desc');
	my $scheduler = $query->param('scheduler_select');
	my $environment = $query->param('environment_select');
	my $network = $query->param('network_select');
	my $filesystem = $query->param('filesystem_select');
	my $otherpkg = $query->param('otherpkg');
	my @prescripts = $query->param('prefieldtaken');
	my $prescript = join ",", @prescripts;
	my @postscripts = $query->param('postfieldtaken');
	my $postscript = join ",", @postscripts;
	my $packagelist = $query->param('packagelist_select');
	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/imgmgt/hcmkimage --backend";
	if ($profile eq "") {
		error("Specify a profile.");
	}
	if ($os eq "") {
		error("Specify a os.");
	}
	if ($arch eq "") {
		error("Specify an architecture.");
	}
	if ($desc eq "") {
		error("Specify a description.");
	}
	$cmd .= " --profile=$profile";
	$cmd .= " --os=\'$os\'";
	$cmd .= " --arch=$arch";
	$cmd .= " --desc=\'$desc\'";
	if ($scheduler ne "NA") {
	  $cmd .= " --scheduler=\'$scheduler\'";
	}

	if ($environment ne "NA") {
		$cmd .= " --parallelenv=\'$environment\'";
	}
	if ($network ne "") {
		$cmd .= " --interconnect=\'$network\'";
	}
	if ($filesystem ne "" && $filesystem ne "NA") {
		$cmd .= " --sharedfs=\'$filesystem\'";
	}
	if ($otherpkg ne "") {
		$cmd .= " --pkglocation=\'$otherpkg\'";
	}
	if ($prescript ne "") {
		$cmd .= " --prescripts=\'$prescript\'";
	}
	if ($postscript ne "") {
		$cmd .= " --postscripts=\'$postscript\'";
	}
	if ($packagelist ne "") {
		$cmd .= " --pkglist=\'$packagelist\'";
	}
	$cmd .= "\"";
	my($ret) = system($cmd);

}

sub captureImage {
	my ($query) = @_;

	my $machine = $query->param('machine');
	my $profile = $query->param('name');
	my $os = $query->param('os');
	my $arch = $query->param('arch');
	my $desc = $query->param('desc');
	my $scheduler = $query->param('scheduler_select');
	my $environment = $query->param('environment_select');
	my $network = $query->param('network_select');

	my $filesystem = $query->param('filesystem_select');
	my @postscripts = $query->param('postfieldtaken');
	my $postscript = join ",", @postscripts;
	my $packagelist = $query->param('packagelist_select');
	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/imgmgt/hccapimage --backend";
	if ($machine eq "") {
		error("Specify a machine.");
	}
	if ($profile eq "") {
		error("Specify a profile.");
	}
	if ($os eq "") {
		error("Specify a os.");
	}
	if ($arch eq "") {
		error("Specify an architecture.");
	}
	if ($desc eq "") {
		error("Specify a description.");
	}
	$cmd .= " --mach=$machine";
	$cmd .= " --profile=$profile";
	$cmd .= " --os=\'$os\'";
	$cmd .= " --arch=$arch";
	$cmd .= " --desc=\'$desc\'";
	if ($scheduler ne "NA") {
	  $cmd .= " --scheduler=\'$scheduler\'";
	}

	if ($environment ne "NA") {
		$cmd .= " --parallelenv=\'$environment\'";
	}
	if ($network ne "") {
		$cmd .= " --interconnect=\'$network\'";
	}
	if ($filesystem ne "" && $filesystem != "NA") {
		$cmd .= " --sharedfs=\'$filesystem\'";
	}
	if ($postscript ne "") {
		$cmd .= " --postscripts=\'$postscript\'";
	}
	if ($packagelist ne "") {
		$cmd .= " --pkglist=\'$packagelist\'";
	}
	$cmd .= "\"";

	my $output = `$cmd`;
	print $output;
}

sub deleteImage {
	my ($query) = @_;
	my @images = $query->param('imageId');

	 print "<deleteImages>";
	 foreach my $image (@images) {
		if(!$::ISADMIN){
			my $image_info=ImageDAO->new();
			my ($rc, $param) = $image_info->queryImage({'name'=>$image});
			if ($rc != 0) {
				my $result->{"imagename"}=$image;
				$result->{'reasonMessage'}="Image not be found";
				$result->{'reasonCode'}=2;
				$result->{"status"} = "failure";
				CmdUtils->printXML($result, "result");
				next;
			}
		}
		my ($os, $profile) = ($image, $image);
			$os	=~ s/-.*//;
			$profile=~ s/.*?-//;
		if ($profile) {
				my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/imgmgt/hcrmimage --profile=$profile --os=$os --arch='x86_64'\"";
				my $output = `$cmd`;
				print $output;
		}
	 }
	 print "</deleteImages>";
}

sub approveImage {
	my ($query) = @_;
	my @images = $query->param('imageId');

	print "<results>";
	foreach my $image (@images) {
		my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/imgmgt/hcchimage --label=$image --approve=yes\"";
		my $output = `$cmd`;
		print $output;
	}
	print "</results>";
}

sub viewJobs {
	my ($query) = @_;
	my $selpid = 0;
	if(defined($query->param('selpid'))){
		$selpid = $query->param('selpid');
	}

	my $allprovs = $::ISADMIN ? CloudUtils->getProvInfo() : CloudUtils->getProvByUser($USERID);
	my $count = 0;
	foreach my $p (sort keys %$allprovs) {
		my $status = $allprovs->{$p}->{'request.status'};
		if (( $status ne "Ready" && $status ne "Reserved" && $status ne "Waiting" && $status ne "Setup") || ($allprovs->{$p}->{'request.cluster'} eq "Sub" && $status ne "Ready")) { next; }
		$count += 1;
	}

	my $height = 450 + $count * 20;
	my $select_style = "style=\"width: 100%; height: 400px;\"";
	print "<div style=\"width: 100%;\" class=soria>";
	print "<div dojoType=\"dijit.layout.AccordionContainer\" style=\"width: 99%; height: 100%;\">";
	if ($selpid) {
		print "<div dojoType=\"dijit.layout.AccordionPane\"  title=\"<b>Jobs in Public Area</b>\" href=\"portal.cgi?function=viewJobsListContent\" $select_style id=\"tabJobList_\" refreshOnShow=\"true\" >";
	}else{
		print "<div dojoType=\"dijit.layout.AccordionPane\"  title=\"<b>Jobs in Public Area</b>\" href=\"portal.cgi?function=viewJobsListContent\" $select_style id=\"tabJobList_\" refreshOnShow=\"true\" selected=\"true\">";
	}
	print "</div>";
	foreach my $p (sort keys %$allprovs) {
		my $status = $allprovs->{$p}->{'request.status'};
		if (($allprovs->{$p}->{'request.hypv_flag'} == 1) || ( $status ne "Ready" && $status ne "Reserved" && $status ne "Waiting" && $status ne "Setup") || ($allprovs->{$p}->{'request.cluster'} eq "Sub" && $status ne "Ready")) { next; }

		if ($selpid eq $p){
			print "<div dojoType=\"dijit.layout.AccordionPane\"  title=\"<b>Jobs in $p</b>\" href=\"portal.cgi?function=viewJobsListContent&pid=$p\" $select_style id=\"tabJobList_$p\" refreshOnShow=\"true\" selected=\"true\">";
		}else{
			print "<div dojoType=\"dijit.layout.AccordionPane\"  title=\"<b>Jobs in $p</b>\" href=\"portal.cgi?function=viewJobsListContent&pid=$p\" $select_style id=\"tabJobList_$p\" refreshOnShow=\"true\" >";
		}
		print "</div>";
	}
	print "</div></div>";
}


sub viewJobsbyListContent {
	my ($query) = @_;
	my $pid = $query->param('pid');
	if (!defined($pid)){
		$pid="";
	}
	my $script = <<"SCRIPT";
<script type="text/javascript" language="JavaScript">
function select_all(){
	var checked;
	if (document.getElementById("jobForm_$pid").selectAll.checked) checked=true;
	else checked=false;
	var inputs = document.getElementsByTagName("input");	 
	for(var i=0;i<inputs.length;i++)	 
	{	 
		if(inputs[i].getAttribute("type") == "checkbox")	 
		{	 
		 inputs[i].checked = checked;	 
		}	 
	}	 
}
function refreshContent(param) {
	var url = dijit.byId('tabJobList_$pid').href;
	url = url.split("?")[0] + "?function=viewJobsListContent&pid=$pid&" + param;
	dijit.byId('tabJobList_$pid').href = url;
	dijit.byId('tabJobList_$pid').refresh();
}
</script>
SCRIPT

	print $script;

	print "<div>";
	print "<form name='jobForm_$pid' id='jobForm_$pid' method=post action=\"portal.cgi\">";
	print "<input type=hidden name=function value=jobAction>";

	print "<table border=0 cellpadding=2 cellspacing=2 bgcolor=#e3e3d1 style=\"text-align:center\">";
	print "<tr valign=\"middle\">
			<th align=left colspan=6><table><tr><td><select id=\"jobActionMenu_$pid\" name=\"jobActionMenu\" size=1 title=\"Select an action and click the Execute button on the right\">
			<option value=\"none\"  selected>- Select Action -</option>
			<option value=\"cancel\">Cancel Selected Jobs</option>
			<option value=\"hold\">Hold Selected Jobs</option>
			<option value=\"release\">Release Selected Jobs</option>
			<option value=\"idle_reason\">Show Why Jobs Are Not Running</option>";
			#<option value=\"bind\">Bind Selected Jobs to a provision</option>
			#<option value=\"unbind\">Unbind Selected Jobs</option>
	print "</select></td>
			<td><button dojoType=\"dijit.form.Button\" type=\"button\" onclick=\"submitJobForm('jobForm_$pid', 'tabJobList_$pid')\" baseClass=tundra title=\"Select an action from the menu on the left and click this button to execute the action \">Go</button></td>
			<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"dijit.byId('tabJobList_$pid').refresh();\" baseClass=tundra iconClass=\"dijitIcon dijitIconUndo\">Refresh</button></td></tr></table></th></tr>";

	print "<tr class='tab_head'><td><input type=checkbox name=selectAll onClick=\"select_all('$pid')\" title=\"Select/Deselect all\"></td>
			<td width=200><a onclick=\"refreshContent('sort=id','$pid');\" href=\"javascript:void(0)\" target=_self title=\"Sort jobs by ID\">ID</a></td>
			<td width=150><a onclick=\"refreshContent('sort=name','$pid');\" href=\"javascript:void(0)\" target=_self title=\"Sort jobs by name\">Name</a></td>
			<td width=80><a onclick=\"refreshContent('sort=state','$pid');\" href=\"javascript:void(0)\" title=\"Sort jobs by job status\">State</a></td>
			<td width=80><a onclick=\"refreshContent('sort=owner','$pid');\" href=\"javascript:void(0)\" title=\"Sort jobs by owner\">Owner</a></td>
			<td width=200>Time Submitted</td>
			<td width=80><a onclick=\"refreshContent('sort=class','$pid');\" href=\"javascript:void(0)\" title=\"Sort jobs by job class\">Class</a></td>
		  </tr>";

	use lib "/opt/ibm/hpccloud/lib";
	use LoadL;

	my $reqid = $pid ? $pid : '';

	my ($rv, $alljobs) = LoadL->getJobs(undef, $USERID);
	if ($rv != 0) {	
		goto TABLEEND;
	}
	foreach my $jid (keys(%$alljobs)) {
		if ($alljobs->{$jid}->{'Request ID'} ne $reqid) {
			delete($alljobs->{$jid});
		}
	}

	my @sortedKeys;
	my $sort = $query->param('sort');
=need re-write
	if ($sort eq "state") { @sortedKeys = sort byState keys %$alljobs; }
	elsif ($sort eq "owner") { @sortedKeys = sort byOwner keys %$alljobs; }
	elsif ($sort eq "class") { @sortedKeys = sort byClass keys %$alljobs; }
	elsif ($sort eq "name") { @sortedKeys = sort byName keys %$alljobs; }
	else { @sortedKeys = sort keys %$alljobs; }
=cut
	@sortedKeys = sort(keys(%$alljobs));
	my $total = 0;
	my @rowcolors = ('#cac28e', '#f7f9e4');
	my $colorindex = 0;
	foreach my $key (@sortedKeys) {
		my($color) = $rowcolors[$colorindex];
		my $jobElem = $$alljobs{$key};
		if ($USERID ne $jobElem->{'Owner'} && !$::ISADMIN) {
			next;
		}
		if ($query->param('owner') && $query->param('owner') ne "" && $query->param('owner') ne $jobElem->{'Owner'}) {
			next;
		}

		$total += 1;
		my $detail;
		$detail .= "<strong>ID:</strong></td><td>" . $$jobElem{"Job Step Id"} . "</td></tr>";
		$detail .= "<tr><td><strong>Job Name:</strong></td><td>" . $$jobElem{"Job Name"} . "</td></tr>";
		$detail .= "<tr><td><strong>Step Name:</strong></td><td>" . $$jobElem{"Step Name"} . "</td></tr>";
		$detail .= "<tr><td><strong>State:</strong></td><td>" . $$jobElem{"Status"} . "</td></tr>";
		$detail .= "<tr><td><strong>Class:</strong></td><td>" . $$jobElem{"Class"} . "</td></tr>";
		$detail .= "<tr><td><strong>Owner:</strong></td><td>" . $$jobElem{"Owner"} . "</td></tr>";
		$detail .= "<tr><td><strong>Priority:</strong></td><td>" . $$jobElem{"User Priority"} . "</td></tr>";
		$detail .= "<tr><td><strong>JobType:</strong></td><td>" . $$jobElem{"Step Type"} . "</td></tr>";
		$detail .= "<tr><td><strong>Hosts Running:</strong></td><td>";
		if ($$jobElem{"Allocated Host"} ne "") {
			$detail .= $$jobElem{"Allocated Host"};
		} else {
			my @hosts = split /::/, $$jobElem{"Allocated Hosts"};
				foreach my $host (@hosts) {
					$detail .= $host . "<br>";
				}
		}
		$detail .= "</td></tr>";
		$detail .= "<tr><td><strong>Group:</strong></td><td>" . $$jobElem{"LoadLeveler Group"} . "</td></tr>";
		$detail .= "<tr><td><strong>Unix Group:</strong></td><td>" . $$jobElem{"Unix Group"} . "</td></tr>";

		$detail .= "<tr><td><strong>Queue Date:</strong></td><td>" . $$jobElem{"Queue Date"} . "</td></tr>";
		$detail .= "<tr><td><strong>Hold Until Date:</strong></td><td>" . $$jobElem{"Hold Job Until"} . "</td></tr>";
		$detail .= "<tr><td><strong>Dispatched Date:</strong></td><td>" . $$jobElem{"Dispatch Time"} . "</td></tr>";
		$detail .= "<tr><td><strong>Completed Date:</strong></td><td>" . $$jobElem{"Completion Date"} . "</td></tr>";
		$detail .= "<tr><td><strong>Completion Code:</strong></td><td>" . $$jobElem{"Completion Code"} . "</td></tr>";
		$detail .= "<tr><td><strong>Account Number:</strong></td><td>" . $$jobElem{"Account"} . "</td></tr>";
		$detail .= "<tr><td><strong>Image Size:</strong></td><td>" . $$jobElem{"Virtual Image Size"} . "</td></tr>";
		$detail .= "<tr><td><strong>Provision ID:</strong></td><td>" . $$jobElem{"Reservation ID"} . "</td></tr>";
		$detail .= "<tr><td><strong>Submitting User:</strong></td><td>" . $$jobElem{"Submitting User"} . "</td></tr>";
		$detail .= "<tr><td><strong>Queue:</strong></td><td>" . "</td></tr>";

		print "<tr class='tab_content'>
				<td><input type=checkbox name=jobID value=$jobElem->{'Job Step Id'}></td>
				<td><a href='javascript:void(0)' onmouseover=\"bubble2('bubbles', '$detail');\" onmouseout=\"bubble('bubbles','');\">$jobElem->{'Job Step Id'}</a></td>
				<td>$jobElem->{'Step Name'}</td>
				<td>$jobElem->{'Status'}</td>
				<td><a onclick=\"refreshContent('sort=$sort&owner=$jobElem->{Owner}','$pid');\" href=\"javascript:void(0)\" title=\"View all jobs of $jobElem->{'Owner'}\">$jobElem->{'Owner'}</a></td>
				<td>$jobElem->{'Queue Date'}</td>
				<td>$jobElem->{'Class'}</td>
			 </tr>";
		$colorindex = ($colorindex+1) % 2;
	}

TABLEEND:
	print "<tr><th colspan=7>Total $total jobs</th></tr>";
	print "</table>";
	print "</form>";

	print "<table border=0 cellspacing=0 width=100%><tr><td>";
	my $t = localtime(time);
	print "Last update: $t";
	print "</td></tr><tr><td>";
	print "<a href=\"javascript:navLink('submitJCF', 'portal.cgi?function=submitJCF&pid=$pid');\" title=\"Submit an existing job command file\"><span>Submit Job</span></a>";
	print "</td></tr></table>";
	print "</div>";

}

=not right
sub byName {
	my $jobElem1 = $$alljobs{$a};
	my $jobElem2 = $$alljobs{$b};

	$jobElem1->{'Step Name'} cmp $jobElem2->{'Step Name'};
}

sub byState {
	my $jobElem1 = $$alljobs{$a};
	my $jobElem2 = $$alljobs{$b};

	$jobElem1->{'Status'} cmp $jobElem2->{'Status'};
}

sub byOwner {
	my $jobElem1 = $$alljobs{$a};
	my $jobElem2 = $$alljobs{$b};

	$jobElem1->{'Owner'} cmp $jobElem2->{'Owner'};
}

sub byClass {
	my $jobElem1 = $$alljobs{$a};
	my $jobElem2 = $$alljobs{$b};

	$jobElem1->{'Class'} cmp $jobElem2->{'Class'};
}
=cut
sub submitJCF {
	my ($query) = @_;

	my $pid = $query->param('pid');

	my $allprovs = CloudUtils->getProvByUser($USERID);

	my $opts;
	foreach my $p (sort keys %$allprovs) {
		if ($allprovs->{$p}->{'request.status'} eq "Failed"
			|| $allprovs->{$p}->{'request.status'} eq "Expired"
			|| $allprovs->{$p}->{'request.status'} eq "Canceled"
			|| $allprovs->{$p}->{'request.status'} eq "Canceling"
			|| $allprovs->{$p}->{'request.status'} eq "None"
			|| $allprovs->{$p}->{'request.hypv_flag'} == 1) { next; }
		if ($allprovs->{$p}->{'request.cluster'} eq "Sub"
			&& $allprovs->{$p}->{'request.status'} ne "Ready") { next; }
		my $selected = $pid eq $p ? "selected" : "";
		$opts .= "<option value=\"$p\" $selected>$p  " . $allprovs->{$p}->{'request.status'} . "</option>";
	}

	print "<p>";
	#print "<textarea style=\"display:none;\"></textarea>";
	print "<form id=\"JCFForm\" method=\"post\" action=\"portal.cgi\" enctype=\"multipart/form-data\">";

	if ($opts) {
		print "<h3><b>Submit to:</b></h3><p>";
	  
		my $checked;
		$checked = "checked" if ($pid);
		print "<input type=radio checked name=area value=1>Public area (Not in any request)<p>";
		print qq(<input  id="JM_sjcf_rc" type=radio $checked name=area value=0>Request: );
		print qq(<select name="pid" onclick="document.getElementById('JM_sjcf_rc').checked=true">$opts</select><p>);
	} else {
		print "<h3><b>Submit to Public area cluster:</b></h3><p>";
		print "<input type=hidden name=area value=1>";
	}
	print "<p>";
	print "<input type=hidden name=function value=runJCF>";
	print "<input type=\"file\" name=\"localJcf\" value=\"\"/>";
	print "<p>";
	print "Or, specify the name of a LoadLeveler job command file on the server. You can specify either the full path name of a file, or a file name relative to the logged-in user's home directory.";
	print "<p>";
	print "Enter the file name: <input type=text name=\"remoteJcf\">";
	print "<input type=\"text\" style=\"display:none\">";
	print "<p>";
	print "<table>";
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onclick=\"submitJCFForm('$pid');\" iconClass=\"dijitEditorIcon dijitEditorIconTabIndent\">Submit</button></td>";
	print "<td><button dojoType=\"dijit.form.Button\" type=\"reset\" iconClass=\"dijitEditorIcon dijitEditorIconNewPage\">Clear</button></td>";
	print "</tr></table>";
	print "</form>";
}

sub runJCF {
	my($query) = @_;
	my @retstr;
	my @output;
	my $rv;

	my $ret = "<html><body><textarea>";
	my $retEnd = "</textarea></body></html>";

	use File::Basename;
	$CGI::POST_MAX = 1024 * 5000;  
	my $safe_filename_characters = "a-zA-Z0-9_.-";
	my $upload_dir = "/tmp";
	my $upload_dir_new = "/hpcc/home/$USERID/upload";

	my $area = $query->param("area");
	my $pid = $query->param("pid");
	if ($area == 0 && !$pid) { $area = 1; }

	my $submitCmd = "$BIN_DIR/prov/hcsubmitjob";
	if ($area == 1) {
		$submitCmd .= " --req=default";
	} else {
		$submitCmd .= " --req=$pid";
	}

	my $local_jcf = $query->param("localJcf");
	my $remote_jcf = $query->param("remoteJcf");
	my $jcfdata = $query->param("jcfdata");

	if ($local_jcf) {
		my ($name, $path, $extension) = fileparse ( $local_jcf, '\..*' );
		my $filename = $name . $extension;  
		$filename =~ tr/ /_/;  
		$filename =~ s/[^$safe_filename_characters]//g;
		if ( $filename =~ /^([$safe_filename_characters]+)$/ ) {  
			$filename = $1;
		} else {
			$ret = $ret . "Filename contains invalid characters" . $retEnd;
			print $ret;
			exit 1;
		}

		my $upload_filehandle = $query->upload("localJcf");
		my $jcfname = $filename;

		open(my $UPLOADFILE, '>', "$upload_dir/$jcfname") || error("$!");
		my $buff;
		while (read($upload_filehandle, $buff, 4096)) {
			print($UPLOADFILE $buff);
		}

		close($UPLOADFILE);

		CmdUtils->runcmd("chown $USERID: $upload_dir/$jcfname", "root", 1);

		# Move the JCF to the home directory so that sub cluster can also read it.
		($rv, @output) = CmdUtils->runcmd("mv $upload_dir/$jcfname ~/", $USERID, 1);
		if ($rv != 0) {
			CmdUtils->runcmd("rm -f $upload_dir/$jcfname", "root", 1);
			$ret = $ret . "Failed to upload the job command file." . $retEnd;
			print $ret;
			exit 1;
		}

		# Submit the job after dos2unix.
		($rv, @output) = CmdUtils->runcmd("dos2unix ~/$jcfname", $USERID, 1);
		if ($rv != 0) {
			$ret = $ret . "Failed to change the file format." . $retEnd;
			print $ret;
		} else {
			($rv, @output) = CmdUtils->runcmd("$submitCmd --jcf=~/$jcfname", $USERID, 1);
			push @retstr, @output;
		}

		# Move the jcf to HOME/upload either the submition is successfull or not.
		($rv, @output) = CmdUtils->runcmd("mv ~/$jcfname $upload_dir_new/", $USERID, 1);
		if ($rv != 0) { # Remove it if failed to move
			CmdUtils->runcmd("rm -f ~/$jcfname", "root", 1);
		}
	}

	# A JCF on the server is specified.
	if ($remote_jcf) {
		if ($remote_jcf =~ /^\//) {
			($rv, @output) = CmdUtils->runcmd("dos2unix $remote_jcf", $USERID, 1);
			if ($rv != 0) {
				$ret = $ret . "Failed to change the file format." . $retEnd;
				print $ret;
				exit 1;
			}

			($rv, @output) = CmdUtils->runcmd("$submitCmd --jcf=$remote_jcf", $USERID, 1);
		}
		else {
			($rv, @output) = CmdUtils->runcmd("dos2unix ~/$remote_jcf", $USERID, 1);
			if ($rv != 0) {
				$ret = $ret . "Failed to change the file format." . $retEnd;
				print $ret;
				exit 1;
			}

			($rv, @output) = CmdUtils->runcmd("$submitCmd --jcf=~/$remote_jcf", $USERID, 1);
		}
		push @retstr, @output;
	}

	# JCF created by the user by editing in portal.
	if ($jcfdata) {
		my $jcfname = $USERID . time . ".jcf";
		open ( UPLOADFILE, ">$upload_dir/$jcfname" ) || error("$!");
		binmode UPLOADFILE;

		print UPLOADFILE $jcfdata;
		print UPLOADFILE "\n";

		close UPLOADFILE;

		# Chown and mv the file from /tmp to home
		`$CLOUD_BIN_DIR/utils/thcsu -u root 'chown $USERID: $upload_dir/$jcfname 2>&1'`;
		`$CLOUD_BIN_DIR/utils/thcsu -u $USERID 'mv $upload_dir/$jcfname ~/ 2>&1'`;

		if ($? != 0) {
			`$CLOUD_BIN_DIR/utils/thcsu -u root 'rm -f $upload_dir/$jcfname 2>&1'`;
			$ret = $ret . "Failed to upload the job command file." . $retEnd;
			print $ret;
			exit 1;
		}

		($rv, @output) = CmdUtils->runcmd("dos2unix ~/$jcfname", $USERID, 1);
		if ($rv != 0) {
			$ret = $ret . "Failed to change the file format." . $retEnd;
			print $ret;
		} else {
			($rv, @output) = CmdUtils->runcmd("$submitCmd --jcf=~/$jcfname", $USERID, 1);
			push @retstr, @output;
		}

		($rv, @output) = CmdUtils->runcmd("mv ~/$jcfname $upload_dir_new/", $USERID, 1);
		if ($rv != 0) { # Remove it if failed to move
			CmdUtils->runcmd("rm -f ~/$jcfname", "root", 1);
		}
	}

	print $ret;
	if ($local_jcf eq "" && $remote_jcf eq "" && $jcfdata eq "") {
		print "No job command file is specified.";
	} else {
		print @retstr;
	}
	print $retEnd;
}

sub buildJob {
	my($query) = @_;
	my $startline = "#!/bin/sh\n#\n";

	my $pid = $query->param('pid');

	my $allprovs = CloudUtils->getProvByUser($USERID);
	my $opts;
	foreach my $p (sort keys %$allprovs) {
		if ($allprovs->{$p}->{'request.status'} eq "Failed"
			|| $allprovs->{$p}->{'request.status'} eq "Expired"
			|| $allprovs->{$p}->{'request.status'} eq "Canceled"
			|| $allprovs->{$p}->{'request.status'} eq "Canceling"
			|| $allprovs->{$p}->{'request.status'} eq "None"
			|| $allprovs->{$p}->{'request.hypv_flag'} == 1) { next; }
		if ($allprovs->{$p}->{'request.cluster'} eq "Sub"
			&& $allprovs->{$p}->{'request.status'} ne "Ready") { next; }
		my $selected = $pid eq $p ? "selected" : "";
		$opts .= "<option value=\"$p\" $selected>$p  " . $allprovs->{$p}->{'request.status'} . "</option>";
	}

	print "<form id=\"buildJobForm\" method=post action=portal.cgi>";

	if ($opts) {
		print "<h3><b>Submit to:</b></h3><p>";
	
		my $checked;
		$checked = "checked" if ($pid);
		print "<input type=radio checked name=area value=1>Public area (Not in any request)<p>";
		print qq(<input  id="JM_csj_rc" type=radio $checked name=area value=0>Request: );
		print qq(<select name="pid" onclick="document.getElementById('JM_csj_rc').checked=true">$opts</select><p>);
	} else {
		print "<h3><b>Submit to Public area cluster:</b></h3><p>";
		print "<input type=hidden name=area value=1>";
	}

	print "<h3><b>Edit contents of your job command file:</b></h3>";
	print "<p>";
	print "<textarea class=formfield name=jcfdata cols=80 rows=20 wrap=off>" . $startline .
		  "</textarea>
			<input type=hidden name=function value=runJCF>
			<p>";

	print "<button dojoType=\"dijit.form.Button\" type=\"button\" onclick=\"submitBuildJob();\" iconClass=\"dijitEditorIcon dijitEditorIconTabIndent\">Submit</button>";
	print "</form>";
}

sub jobAction {
	my ($query) = @_;
	my @checkedJobs;
	@checkedJobs = $query->param('jobID');
	if (!@checkedJobs) {
		@checkedJobs = $query->param('job');
	}
	my $action = $query->param('jobActionMenu');
	my $joblst;
	my $llcmd;
	my $cmd;
	my %jobsGroupbyHost;
	my @errJob;
	my $errMsg = "";

	use lib "/opt/ibm/hpccloud/lib";
	use LoadL;
	use CloudUtils;
	my ($rv, $alljobs) = LoadL->getJobs(undef, $USERID);

	if ($rv) {
		$errMsg = "Could not find any job.";
		goto ERROR;
	}

	foreach my $job (@checkedJobs) {
		if (!$alljobs->{$job}) {
			push @errJob, $job;
			next;
		}

		print $job . '<br>';
		$jobsGroupbyHost{$alljobs->{$job}->{'Submitting Host'}} .= $job . " ";
	}

	foreach my $shost (keys %jobsGroupbyHost) {
	  my @shortnanme = split(/\./, $shost);
	  my $thost= CloudUtils->getTrueHostName($shortnanme[0]);
	  if ($action eq "cancel") {
		 $llcmd = "llcancel";
		 $cmd .= "$CLOUD_BIN_DIR/utils/thcsu -u $USERID 'ssh $thost \"$llcmd $jobsGroupbyHost{$shost} 2>&1\" 2>/dev/null';";
	  } elsif ($action eq "hold") {
		 $llcmd = "llhold";
		 $cmd .= "$CLOUD_BIN_DIR/utils/thcsu -u $USERID 'ssh $thost \"$llcmd $jobsGroupbyHost{$shost} 2>&1\" 2>/dev/null';";
	  } elsif ($action eq "release") {
		 $llcmd = "llhold -r";
		 $cmd .= "$CLOUD_BIN_DIR/utils/thcsu -u $USERID 'ssh $thost \"$llcmd $jobsGroupbyHost{$shost} 2>&1\" 2>/dev/null';";
	  } elsif ($action eq "idle_reason") {
		 $llcmd = "llq -s";
		 $cmd .= "$CLOUD_BIN_DIR/utils/thcsu -u $USERID 'ssh $thost \"$llcmd $jobsGroupbyHost{$shost} 2>&1\" 2>/dev/null';";
	  } elsif ($action eq "unbind") {
		 $llcmd = "llbind -r";
		 $cmd .= "$CLOUD_BIN_DIR/utils/thcsu -u $USERID 'ssh $thost \"$llcmd $jobsGroupbyHost{$shost} 2>&1\" 2>/dev/null';";
	  }
	}

#	print $cmd;
	my @output = `$cmd`;
	if ($? != 0) {
		print "Command execution failed<br>";
	} else {
		chomp @output;
		foreach my $line (@output) {
			print $line . "<br>";
		}
	}

ERROR:
	if (@errJob) {
		print "Could not find Job " . (join ", ", @errJob);
	} elsif ($errMsg ne "") {
		print $errMsg;
	}
}

sub multiUpload {
	print "<script language=\"javascript\" type=\"text/javascript\" src=\"/hpccloud/scripts/multiUpload.js\"></script>\n";

	print "<h3><b>Specify multiple files in your local filesystem to upload</b></h3><p>";
	print "<p>";
	print "<input id=\'file_selector\' type=\"file\" name=\"localFile\" value=\"\"/>";

	print "<form name=\"FileForm\" id=\"FileForm\" method=\"post\" target=\"upload_target\" action=\"portal.cgi\" enctype=\"multipart/form-data\">";

	print "<input type=hidden name=function value=xuploadFile>";
	print "</form>";
	print "<div id=\"files_list\"></div>";
	print "<p>";

	print "<button dojoType=\"dijit.form.Button\" type=\"button\" id=uploadButton onClick=\"do_upload();\" iconClass=\"dijitEditorIcon dijitEditorIconSave\">Upload</button>";
	print "&nbsp;";
	print "<button dojoType=\"dijit.form.Button\" type=\"button\" id=resetButton onClick=\"reset_form();\" iconClass=\"dijitEditorIcon dijitEditorIconNewPage\">Reset</button>";


	print "<iframe id=\"upload_target\" name=\"upload_target\" src=\"#\" style=\"width:0;height:0;border:0px solid #fff;\"></iframe>";

	my $script = <<"SCRIPT";
\n<script type="text/javascript" language="JavaScript">
var multiSelector = new MultiSelector(document.getElementById('files_list'));
multiSelector.addFileInput(document.getElementById('file_selector'));
</script>
SCRIPT
	print $script;
}

sub xuploadFile {
	my($query) = @_;

	use File::Basename;
	$CGI::POST_MAX = 1024 * 5000;
	my $safe_filename_characters = "a-zA-Z0-9_.-";
	my $upload_dir = "/tmp";
	my $result;

	my $i;
	my $file = $query->param("localFile");
	next if (!$file || ($file =~ /^\s*$/));

	my ( $name, $path, $extension ) = fileparse ( $file, '\..*' );
	my $filename = $name . $extension;
	$filename =~ tr/ /_/;
	$filename =~ s/[^$safe_filename_characters]//g;
	if ( $filename =~ /^([$safe_filename_characters]+)$/ ) {
		$filename = $1;
	} else {
		#error("Filename contains invalid characters");
		$result = 1;
		next;
	}
	if(!$filename) {
		$result = 1;
		next;
	}

	my $upload_filehandle = $query->upload("localFile");

	if (!open ( UPLOADFILE, ">$upload_dir/$filename" ) ) {
		$result = 1;
		next;
	}
	binmode UPLOADFILE;
	my $buff;
	while ( my $bytes_read = read($upload_filehandle, $buff, 2096) ) {
		print UPLOADFILE $buff;
	}

	close UPLOADFILE;

	`$CLOUD_BIN_DIR/utils/thcsu -u root 'chown $USERID: $upload_dir/$filename 2>&1'`;
	`$CLOUD_BIN_DIR/utils/thcsu -u $USERID 'mv $upload_dir/$filename ~/ 2>&1'`;

	if ($? != 0) {
		$result = 1;
		next;
		`$CLOUD_BIN_DIR/utils/thcsu -u root 'rm -f $upload_dir/$filename 2>&1'`;
	} else {
		$result = 0;
	}

	print "<script language=\"javascript\" type=\"text/javascript\">window.top.window.upload_done('$result');</script>";
}

sub energyScheme {
	my ($query) = @_;

	print "<h3><b>Energy Schemes:</b></h3><p>";
	print "<form id='energySchemeForm' name='energySchemeForm' method=post action=portal.cgi>";
	print "<input type=hidden name=function value=deleteEnergyScheme>";

	print "<table id=\"eschemelistTab\" border=0 cellpadding=2 cellspacing=2 bgcolor=#e3e3d1 style=\"text-align:center\">";
	print "<tr valign=\"middle\">
			<th align=\"left\" colspan=8>\n";
	print "<table>";
	print "<tr><td><button dojoType=\"dijit.form.Button\" type=\"button\" baseClass=tundra iconClass=\"dijitIcon dijitIconDelete\" onClick=\"deleteEScheme();\" title=\"Delete selected schemes\">Delete</button></td>";
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"showNewSchemeDlg();\" baseClass=tundra iconClass=\"dijitIcon dijitIconNewTask\" title=\"Add a new scheme\">Add</button></td>\n";
	print "</tr></table>\n";
	print "</th></tr>";

	print "<tr class='tab_head'><td width=25><input type=checkbox name=selectAll onClick=\"select_all()\" title=\"Select/Deselect all\"></td>
			<td width=100><a href=\"javascript:sortESchemeTab('name');\" title=\"Sort by Name\">Name</a></td>
			<td width=100><a href=\"javascript:sortESchemeTab('owner');\" title=\"Sort by Owner\">Owner</a></td>
			<td width=100><a href=\"javascript:sortESchemeTab('type');\" title=\"Sort by type\">Type</a></td>
			<td width=100>Fixed CPU Freq</td>
			<td width=200>CPU Freq Scope</td>
			<td width=100>Up Threshold<br>(% CPU Load)</td>
			<td width=100>Down Threshold<br>(% CPU Load)</td>
			<td width=100>Sampling Rate<br>(milliseconds)</td>
			<td width=100>Freq Step</td>
			<td width=100>Applied To</td>
			<td width=200>Remark</td>
		  </tr>";
	print "<tr><td colspan=12><b>Loading...</b></td></tr>";
	print "</table>";
	print "</form>";

	print "<script language=\"javascript\" type=\"text/javascript\" src=\"/hpccloud/scripts/EnergySchemeView.js\"></script>\n";
	my $script = <<"SCRIPT";
\n<script type="text/javascript" language="JavaScript">
function select_all(){
	var checked;
	if (document.energySchemeForm.selectAll.checked) checked=true;
	else checked=false;
	var inputs = document.getElementsByTagName("input");
	for (var i=0; i<inputs.length; i++) {	 
		if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].getAttribute("name") == "energySchemeName") {
		  inputs[i].checked = checked;
		}
	}
}

function activeSchemeFormField() {
	var type = document.getElementById('schemeType');
	if(type.value == "static") {
		document.getElementById('fixedFreq').disabled = false;
		document.getElementById('scopeHighest').disabled = true;
		document.getElementById('scopeLowest').disabled = true;
		document.getElementById('up_threshold').disabled = true;
		document.getElementById('down_threshold').disabled = true;
		document.getElementById('samplingRate').disabled = true;
		document.getElementById('freqStep').disabled = true;
	} else {
		document.getElementById('fixedFreq').disabled = true;
		document.getElementById('scopeHighest').disabled = false;
		document.getElementById('scopeLowest').disabled = false;
		document.getElementById('up_threshold').disabled = false;
		document.getElementById('down_threshold').disabled = false;
		document.getElementById('samplingRate').disabled = false;
		document.getElementById('freqStep').disabled = false;
	}
}
showESchemes();

</script>
SCRIPT
	print $script;

	print "<div id=\"schemeDiv\" dojoType=\"dijit.Dialog\" title=\"Energy Scheme\">
			<form name=\"eschemeForm\" id=\"eschemeForm\" method=\"post\" action=\"portal.cgi\">
			<input type=hidden name=function id=\"eschemeAction\" value=\"addEnergyScheme\">
			<input type=hidden name=\"schemeOwner\" id=\"schemeOwner\" disabled>
			<table border=0 cellpadding=2 cellspacing=2 style=\"height:100%; width: 100%;\">
			<tr><td colspan=1 class=\"tab_highlight\" id=\"schemeFromTitle\">New Energy Scheme</td></tr>
			<tr>
			<td class=formprompt>Name *: </td>
			<td><input type=\"text\" style=\"font-family: verdana;\" size=30 name=\"schemeName\" id=\"schemeName\"/></td>
			</tr>
			<tr>
			<td class=formprompt>Type: </td>
			<td><select name=\"schemeType\" id=\"schemeType\" class=formfield onchange=\"activeSchemeFormField();\">
				<option value=\"static\" selected>Static</option>
				<option value=\"dynamic\">Dynamic</option></select></td>
			</tr>
			<tr>
			<td class=formprompt>Fixed CPU Freq (KHz): </td>
			<td><select name=fixedFreq id=fixedFreq />";
	use EnergyUtils;
	my $freqs = EnergyUtils->getAvailCPUFreq();
	my @freqs = split /\s+/, $freqs;
	print "<option value=\"MIN\">MIN_AVAIL_FREQ</option>";
	print "<option value=\"MAX\">MAX_AVAIL_FREQ</option>";
	foreach my $freq (@freqs) {
		print "<option value=\"$freq\">$freq</option>";
	}
	print "</select></td>";

	print "</tr>
			<tr>
			<td class=formprompt>CPU Freq Scope: </td>
			<td><select name=scopeLowest id=scopeLowest disabled/>";
	print "<option value=\"MIN\">MIN_AVAIL_FREQ</option>";
	print "<option value=\"MAX\">MAX_AVAIL_FREQ</option>";
	foreach my $freq (@freqs) {
		print "<option value=\"$freq\">$freq</option>";
	}

	print "</select>MIN &nbsp;~&nbsp;  
			<select name=scopeHighest id=scopeHighest disabled/>";
	print "<option value=\"MAX\">MAX_AVAIL_FREQ</option>";
	print "<option value=\"MIN\">MIN_AVAIL_FREQ</option>";
	foreach my $freq (@freqs) {
		print "<option value=\"$freq\">$freq</option>";
	}
	print "</select>MAX</td>
			</tr>
			<tr>
			<td class=formprompt>Up Threshold (%): </td>
			<td><input type=\"text\" style=\"font-family: verdana;\" size=2 name=up_threshold id=up_threshold disabled/>&nbsp;[20 - 95]</td>
			</tr>
			<tr>
			<td class=formprompt>Down Threshold (%): </td>
			<td><input type=\"text\" style=\"font-family: verdana;\" size=2 name=down_threshold id=down_threshold disabled/>&nbsp;[20 - 95]</td>
			</tr>
			<tr>
			<td class=formprompt>Sampling Rate (milliseconds): </td>
			<td><input type=\"text\" style=\"font-family: verdana;\" size=10 name=samplingRate id=samplingRate disabled/>&nbsp;&gt;=60000</td>
			</tr>
			<tr>
			<td class=formprompt>Freq Step: </td>
			<td><input type=\"text\" style=\"font-family: verdana;\" size=10 name=freqStep id=freqStep disabled/>&nbsp;[5 - 100]</td>
			</tr>
			<tr>
			<td class=formprompt>Remark: </td>
			<td><input type=\"text\" style=\"font-family: verdana;\" size=30 name=\"remark\" id=\"schemeDesc\" /></td>
			</tr>
			<tr id=\"eschemeForce\">
			<td class=formprompt>Force the change: </td>
			<td><input type=checkbox name=\"force\" value=1 ></td>
			</tr>
			<tr>
			<td align=center colspan=2>
			<div style=\"padding: 8px 0; text-align: center;\">
			<button dojoType=\"dijit.form.Button\" type=\"button\" baseClass=soria iconClass=\"dijitEditorIcon dijitEditorIconTabIndent\" onClick=\"submitEnergySchemeForm();\">Submit</button>&nbsp;&nbsp;
			<button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"resetSchemeForm();dijit.byId('schemeDiv').hide();\" baseClass=soria iconClass=\"dijitEditorIcon dijitEditorIconCancel\">Cancel</button>
			</div>
			</td>
			</tr>
			</table>
			</form>
			</div>";
}

sub addEnergyScheme {
	my ($query) = @_;

	my $name = $query->param('schemeName');
	if (!$name) {
		error("Error: Specify a scheme name.");
	}

	my $type = $query->param('schemeType');

	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/energy/hcmkescheme";
	$cmd .= " --owner=$USERID --name=$name";

	if ($type eq "static") {
		$cmd .= " --type=0";
		my $fixedFreq = $query->param('fixedFreq');
		my $desc = $query->param('remark');
		$cmd .= " --cpu-freq-fixed=$fixedFreq";
		$cmd .= " --desc='$desc'" if ($desc);
	} elsif ($type eq "dynamic") {
		$cmd .= " --type=1";
		my $desc = $query->param('remark');
		my $minFreq = $query->param('scopeLowest');
		my $maxFreq = $query->param('scopeHighest');
		my $up_threshold = $query->param('up_threshold');
		my $down_threshold = $query->param('down_threshold');
		my $samplingRate = $query->param('samplingRate');
		my $freqStep = $query->param('freqStep');

		$cmd .= " --cpu-freq-min=$minFreq";
		$cmd .= " --cpu-freq-max=$maxFreq";
		$cmd .= " --threshold-up=$up_threshold";
		$cmd .= " --threshold-down=$down_threshold";
		$cmd .= " --sampling-rate=$samplingRate";
		$cmd .= " --freq-step=$freqStep";
		$cmd .= " --desc='$desc'" if ($desc);
	} else {
		error("Error: Invalid scheme type.");
	}

	$cmd .= "\"";
	my $output = `$cmd`;
	print $output;
} 

sub modEnergyScheme {
	my ($query) = @_;

	my $name = $query->param('schemeName');
	if (!$name) {
		error("Error: Specify a scheme name.");
	}

	my $type = $query->param('schemeType');
	my $owner = $query->param('schemeOwner');

	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/energy/hcchescheme";
	$cmd .= " --owner=$owner --name=$name";

	if ($type eq "static") {
		$cmd .= " --type=0";
		my $fixedFreq = $query->param('fixedFreq');
		my $desc = $query->param('remark');
		$cmd .= " --cpu-freq-fixed=$fixedFreq";
		$cmd .= " --desc='$desc'" if ($desc);
	} elsif ($type eq "dynamic") {
		$cmd .= " --type=1";
		my $desc = $query->param('remark');
		my $minFreq = $query->param('scopeLowest');
		my $maxFreq = $query->param('scopeHighest');
		my $up_threshold = $query->param('up_threshold');
		my $down_threshold = $query->param('down_threshold');
		my $samplingRate = $query->param('samplingRate');
		my $freqStep = $query->param('freqStep');

		$cmd .= " --cpu-freq-min=$minFreq";
		$cmd .= " --cpu-freq-max=$maxFreq";
		$cmd .= " --threshold-up=$up_threshold";
		$cmd .= " --threshold-down=$down_threshold";
		$cmd .= " --sampling-rate=$samplingRate";
		$cmd .= " --freq-step=$freqStep";
		$cmd .= " --desc='$desc'" if ($desc);
	} else {
		error("Error: Invalid scheme type.");
	}

	my $force = $query->param('force');
	$cmd .= " --force" if ($force);

	$cmd .= "\"";
	my $output = `$cmd`;
	print $output;
}

sub deleteEnergyScheme {
	my ($query) = @_;
	my @eschemes = $query->param('energySchemeName');

	print "<results>";
	foreach my $scheme (@eschemes) {
		my ($owner, $name) = split /:/, $scheme;
		my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/energy/hcrmescheme --owner=$owner --name=$name\"";
		my $output = `$cmd`;
		print $output;
	}
	print "</results>";
}

sub sysEnergy {
	my ($query) = @_;
	my $var4js_isAdm;

	print "<h3><b>Energy Policies:</b></h3><p>";
	print "<form id='energyPolicyForm' name='energyPolicyForm' method=post action=portal.cgi>";
	print "<input type=hidden name=function value=deleteEnergyPolicy>";

	print "<table id=\"epolicylistTab\" border=0 cellpadding=2 cellspacing=2 bgcolor=#e3e3d1 style=\"text-align:center\">";
	print "<tr valign=\"middle\">
			<th align=\"left\" colspan=8>\n";
	if ($::ISADMIN) {
		$var4js_isAdm = "var isAdm = 1;\n";
		print "<table>";
		print "<tr><td><button dojoType=\"dijit.form.Button\" type=\"button\" baseClass=tundra iconClass=\"dijitIcon dijitIconDelete\" onClick=\"deleteEPolicy();\" title=\"Delete selected policies\">Delete</button></td>";
		print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"showNewPolicyDlg();\" baseClass=tundra iconClass=\"dijitIcon dijitIconNewTask\" title=\"Add a new policy\">Add</button></td>\n";
		print "</tr></table>\n";
	} else {
		$var4js_isAdm = "var isAdm = 0;\n";
		print "<table><tr><td>Energy policies are read only since you are not an administrator.</td></tr></table>";
	}
	print "</th></tr><tr class='tab_head'>";

	if ($::ISADMIN) {
		print "<td width=25><input type=checkbox name=selectAll onClick=\"select_all()\" title=\"Select/Deselect all\"></td>";
	} else {
		#print "<td width=0></td>";
	}
	print "
			<td width=100><a href=\"javascript:sortEPolicyTab('name');\" title=\"Sort by Name\">Name</a></td>
			<td width=100><a href=\"javascript:sortEPolicyTab('energy');\" title=\"Sort by Energy Scheme\">Energy Scheme</a></td>
			<td width=100><a href=\"javascript:sortEPolicyTab('machine');\" title=\"Sort by Machine Status\">Machine Status</a></td>
			<td width=100><a href=\"javascript:sortEPolicyTab('power');\" title=\"Sort by Power Status\">Power Status</a></td>
			<td width=100><a href=\"javascript:sortEPolicyTab('mode');\" title=\"Sort by Mode\">Mode</a></td>
			<td width=300>Description</td>
		  </tr>";
	print "<tr><td colspan=12><b>Loading...</b></td></tr>";
	print "</table>";
	print "</form>";

	print "<script language=\"javascript\" type=\"text/javascript\" src=\"/hpccloud/scripts/EnergyPolicyView.js\"></script>\n";
	my $script = <<"SCRIPT";
\n<script type="text/javascript" language="JavaScript">
$var4js_isAdm
function select_all(){
	var checked;
	if (document.energyPolicyForm.selectAll.checked) checked=true;
	else checked=false;
	var inputs = document.getElementsByTagName("input");
	for (var i=0; i<inputs.length; i++) {	 
		if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].getAttribute("name") == "energyPolicyId") {
		  inputs[i].checked = checked;
		}
	}
}

showEPolicies();

</script>
SCRIPT
	print $script;

	print "<div id=\"epolicyDlg\" dojoType=\"dijit.Dialog\" title=\"Energy Policy\">
			<form name=\"epolicyForm\" id=\"epolicyForm\" method=\"post\" action=\"portal.cgi\">
			<input type=hidden name=function id=\"epolicyAction\" value=\"addEnergyPolicy\">
			<input type=hidden name=\"policyId\" id=\"policyId\">
			<table border=0 cellpadding=2 cellspacing=2 style=\"height:100%; width: 100%;\">
			<tr><td colspan=1 class=\"tab_highlight\" id=\"policyFormTitle\">New Energy Policy</td></tr>
			<tr>
			<td class=formprompt>Name *: </td>
			<td><input type=\"text\" style=\"font-family: verdana;\" size=30 name=\"policyName\" id=\"policyName\"/></td>
			</tr>
			<tr>
			<td class=formprompt>Machine Status: </td>
			<td><select name=\"mach_status\" id=\"mach_status\" class=formfield>
				<option value=\"Waiting\" selected>Waiting</option>
				<option value=\"InUse\">In use</option></select></td>
			</tr>
			<tr>
			<td class=formprompt>Mode: </td>
			<td><select name=\"pmode\" id=\"pmode\" class=formfield>
				<option value=\"DEFAULT\" selected>Default</option>
				<option value=\"PO\">PO</option>
				<option value=\"J+P\">J+P</option></select></td>
			</tr>
			<tr>
			<td class=formprompt>Energy Scheme: </td>";
	use EnergyUtils;
	my $myES = EnergyUtils->getEnergySchemeAllInfo($USERID);

	print "<td><select name=\"escheme\" id=\"escheme\">";
	foreach my $id (keys %$myES) {
		if ($myES->{$id}->{'energy_scheme.name'} ne "poweroff-default") {
			print "<option value=\"$myES->{$id}->{'energy_scheme.id'}\">$myES->{$id}->{'energy_scheme.name'}</option>";
		}

	}

	print "</select></td></tr>";
	print "<tr>
			<td class=formprompt>Description: </td>
			<td><input type=\"text\" style=\"font-family: verdana;\" size=30 name=\"desc\" id=\"policyDesc\" /></td>
			</tr>
			<tr>
			<td align=center colspan=2>
			<div style=\"padding: 8px 0; text-align: center;\">
			<button dojoType=\"dijit.form.Button\" type=\"button\" baseClass=soria iconClass=\"dijitEditorIcon dijitEditorIconTabIndent\" onClick=\"submitEnergyPolicyForm();\">Submit</button>&nbsp;&nbsp;
			<button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"resetPolicyForm();dijit.byId('epolicyDlg').hide();\" baseClass=soria iconClass=\"dijitEditorIcon dijitEditorIconCancel\">Cancel</button>
			</div>
			</td>
			</tr>
			</table>
			</form>
			</div>";
}

sub addEnergyPolicy {
	my ($query) = @_;

	my $name = $query->param('policyName');
	if (!$name) {
		error("Error: Specify a policy name.");
	}

	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/energy/hcmkepolicy";
	$cmd .= " --name=$name";

	my $mach_status = $query->param('mach_status');
	my $scheme = $query->param('escheme');
	my $pmode = $query->param('pmode');
	my $desc = $query->param('desc');

	$cmd .= " --machstatus=$mach_status";
	$cmd .= " --energyscheme=$scheme";
	$cmd .= " --provmode=$pmode" if($pmode);
	$cmd .= " --desc='$desc'" if ($desc);

	$cmd .= "\"";
	my $output = `$cmd`;
	print $output;
} 

sub modEnergyPolicy {
	my ($query) = @_;

	my $id = $query->param('policyId');
	my $name = $query->param('policyName');
	if (!$id || !$name) {
		error("Error: Specify a policy id and name.");
	}

	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/energy/hcchepolicy";
	$cmd .= " --id=$id";
	$cmd .= " --name=$name";

	my $mach_status = $query->param('mach_status');
	my $scheme = $query->param('escheme');
	my $pmode = $query->param('pmode');
	my $desc = $query->param('desc');

	$cmd .= " --machstatus=$mach_status" if($mach_status);
	$cmd .= " --energyscheme=$scheme" if($scheme);
	$cmd .= " --provmode=$pmode" if($pmode);
	$cmd .= " --desc='$desc'" if ($desc);

	$cmd .= "\"";
	my $output = `$cmd`;
	print $output;
}

sub deleteEnergyPolicy {
	my ($query) = @_;
	my @ids = $query->param('energyPolicyId');

	print "<results>";
	foreach my $id (@ids) {
		my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/energy/hcrmepolicy --id=$id\"";
		my $output = `$cmd`;
		print $output;
	}
	print "</results>";
}

sub sysConfigInfo {
	if (!$::ISADMIN) {
		error("You are not administrator!");
	}
	my $hrefstr;
	require "BillingDemo.pm";
	my $sysconf = CloudUtils->getConfigDetail;
	my %friendly_name = ("billingMod"=>"Billing Mode", "adminList"=>"Administrator Name List", "llAdminFile"=>"LoadLeveler Configuration Dir",
			"llCentralMgr"=>"LoadLeveler Central Manager", "machTypeName"=>"Valid Machine Types", "maxHypvNums"=>"Max # of Hypervisors",
			"maxKvmVms"=>"Max # of KVM VMs", "maxvCpusPerVm"=>"Max # of CPUs per VM", "maxVmsPerHypv"=>"Max # of VMs per Hypervisor",
			"UsedHypvNums"=>"Number of Hypervisors in Use", "UsedKvmVms"=>"Number of VMs in Use", "vlanFlag"=>"VLAN Flag", "prefix"=>"VM Name Prefix");
	my @conf_name = qw/billingMod adminList llAdminFile llCentralMgr maxHypvNums maxKvmVms maxvCpusPerVm maxVmsPerHypv UsedHypvNums UsedKvmVms prefix vlanFlag machTypeName/;#do not use keys since we need speical sequence
	print "<h3><b>System Configuration:</b></h3><p>";
	print "<form id='sysConfForm' name='sysConfForm' method=post action=portal.cgi>";
	print "<input type=hidden name=function value=modSysconf>";
	print "<table id=\"sysConfTab\" border=0 cellpadding=2 cellspacing=2 bgcolor=#e3e3d1 style=\"text-align:center\">";
	print "<tr valign=\"middle\">
			<th align=\"left\" colspan=8>\n";
	print "<table>";
	print "<tr><td><button dojoType=\"dijit.form.Button\" type=\"button\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconTabIndent\" title=\"Modify system configuration\" onclick=\"submitModifySysConf()\">Update</button></td>";
	print "</tr></table>\n";
	print "</th></tr>";
	print "<tr class='tab_head'>
		  <td width=200>Configuration Name</td>
		<td width=400>Configuration Value</td>
	</tr>";
	my $forbid_change_field='billingMod,adminList,llAdminFile,llCentralMgr,machTypeName,UsedHypvNums,UsedKvmVms,';	
	foreach my $eachName (@conf_name){
		my $mod_name="modsysconf_".$eachName;
		my $mod_name_spec=$mod_name."_result";
		my $read_only="";
		if($forbid_change_field =~ /$eachName/){
				$read_only="readonly";
		}
		my $friend_name_str = $friendly_name{$eachName};
		if(defined($sysconf->{$eachName}->{'sysconfig.comments'})){
			$friend_name_str = $sysconf->{$eachName}->{'sysconfig.comments'};
		}
		if($eachName eq "vlanFlag"){
			print "<tr class='tab_content'>
					<td align=left style=\"padding-left:10px;padding-right:10px;\" >$friend_name_str</td>";
			if(lc($sysconf->{$eachName}->{'sysconfig.value'}) eq "disable"){
					print "<td align=left style=\"padding-left:0px;padding-right:0px;\"><input type=radio checked  name=\"$mod_name\" id=\"$mod_name\" value=\"Disable\" onclick=\"active();\">Disable &nbsp; &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;
					<input type=radio name=\"$mod_name\" id=\"$mod_name\" value=\"Enable\" onclick=\"active();\">Enable</td>	
					<input type=hidden name=\"$mod_name_spec\" id=\"$mod_name_spec\" value=\"Disable\">
					</tr>";
			}else{
					print "<td align=left style=\"padding-left:0px;padding-right:0px;\"><input type=radio name=\"$mod_name\" id=\"$mod_name\" value=\"Disable\" onclick=\"active();\">Disable &nbsp; &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;
					<input type=radio checked name=\"$mod_name\" id=\"$mod_name\" value=\"Enable\" onclick=\"active();\">Enable</td>	
					<input type=hidden name=\"$mod_name_spec\" id=\"$mod_name_spec\" value=\"Enable\">
					</tr>";
			}
		}
		elsif($eachName eq "prefix"){
			print "<tr class='tab_content'>
					<td align=left style=\"padding-left:10px;padding-right:10px;\" >$friend_name_str (vhost%02d)</td>
					<td align=left width=400 style=\"padding-left:0px;padding-right:0px;\" ><input type=text size=75 name=\'$mod_name\'value=\'\' $read_only></td>
					</tr>";
		}else{
			if($read_only eq "readonly"){
				if($eachName eq "machTypeName"){
					my @machtypeArray=split(",",$sysconf->{$eachName}->{'sysconfig.value'});
					my @machPrice=();
					foreach my $typeName(@machtypeArray){
						my $price = BillingDemo->getMachinePrice($typeName, 1)/100;
						if(!defined($price)){
							$price=0;
						}
						push(@machPrice, "$typeName($price\$)");
					}
					$sysconf->{$eachName}->{'sysconfig.value'} = join(",",@machPrice);
					$hrefstr="<a href=\"javascript:modTypeandPrice('$sysconf->{$eachName}->{'sysconfig.value'}');\" id=\"$mod_name\" title=\"Modify Type and Price\" name=\'$mod_name\' value=\'$sysconf->{$eachName}->{'sysconfig.value'}\'>";
					print "<tr class='tab_content'>
							<td align=left style=\"padding-left:10px;padding-right:10px;\" >$friend_name_str</td>
							<td align=left style=\"padding-left:0px;padding-right:0px;\">$hrefstr$sysconf->{$eachName}->{'sysconfig.value'}</td>
						<input type=hidden name=\"$mod_name_spec\" id=\"$mod_name_spec\" value=\"$sysconf->{$eachName}->{'sysconfig.value'}\">
							</tr>";
				}else{
					print "<tr class='tab_content'>
							<td align=left style=\"padding-left:10px;padding-right:10px;\" >$friend_name_str</td>
							<td align=left style=\"padding-left:0px;padding-right:0px;\">$sysconf->{$eachName}->{'sysconfig.value'}</td>
							</tr>";
				}
			}else{
				print "<tr class='tab_content'>
					<td align=left style=\"padding-left:10px;padding-right:10px;\" >$friend_name_str</td>
					<td align=left width=400 style=\"padding-left:0px;padding-right:0px;\"><input type=text size=75 name=\'$mod_name\' value=\'$sysconf->{$eachName}->{'sysconfig.value'}\' $read_only></td>
						</tr>";
			}
		}
	}
	print "</table>";
	print "</form>";
}
sub addmach2cloudForm {
	my ($query) = @_;
	print "<h3><b>Specify the information of the bare-metal machine you want to add/update: </b></h3><p>";
	print "<form id=addmach2cloudForm method=post action=portal.cgi>";
	print "<blockquote><table border=0 cellpadding=2 cellspacing=2>";
	print "<input type=hidden name=function value=addmach2cloud>";
	print "<tr><td class=formprompt>Bare-metal machine Name(*):</td>";
	print "<td><input type=text name=\'machName\' size=30 style=\"font-family:verdana\" ></td></tr>\n";

	print "<tr><td class=formprompt>Role(*):</td>";
	print "<td><input type=text name=\'role\' size=30 style=\"font-family:verdana\" value=0 readonly></td></tr>\n";
	print "<tr><td class=formprompt>Provision Mode(*):</td>";
	print "<td><input type=text name=\'mode\' size=30 style=\"font-family:verdana\" value=2></td></tr>\n";
	print "<tr><td class=formprompt>Group(*):</td>";
	print "<td><input type=text name=\'group\' size=30 style=\"font-family:verdana\" value=1 readonly></td></tr>\n";
	my $syscnf = CloudUtils->getConfig();
	my @types;
	if ($syscnf) {
	if (defined($syscnf->{'machTypeName'})) {
		@types = split(/,/, $syscnf->{'machTypeName'});
		}
	}
	my $opts = "";
	foreach my $type (@types) {
		if($type ne "IBM_KVM"){
			$opts .= "<option value=\"$type\">$type</option>";
		}
	}
	print "<tr><td class=formprompt>Type(*):</td>";
	print "  <td>
	<select class=formfield name=\"machType\" id=\"machType\">$opts</select>
	</td></tr>";
	print "</td></tr>\n";
	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/imgmgt/hclsimage --status=AVAILABLE \"";
	my $output = `$cmd`;
	my @Osimage;
	my $lsxml = new XML::Simple(KeyAttr=>[]);
	my $data = $lsxml->XMLin($output);
	if (ref($data->{image}) eq "ARRAY") {
		foreach my $elem (@{$data->{image}}) {
			push @Osimage, $elem->{name};
		}
	} else {
		push @Osimage,$data->{image}->{name};
	}
	
	$opts = "";
	foreach my $osimage (@Osimage) {
		if($osimage ne ""){
			$opts .= "<option value=\"$osimage\">$osimage</option>";
		}
	}
	print "<tr><td class=formprompt>Osimage(*):</td>";
	print "  <td>
	<select class=formfield name=\"osimage\" id=\"osimage\">$opts</select>
	</td></tr>";
	print "</td></tr>\n";
	print "</table></blockquote>";
	print "<p><button dojoType=\"dijit.form.Button\" type=\"button\" onclick=\"submitaddmach2cloud();\" iconClass=\"dijitEditorIcon dijitEditorIconTabIndent\">Submit</button>";
	print "</form>";
}

sub addmach2cloud {
	my ($query) = @_;
	my $name =  $query->param("machName");
	my $role = $query->param("role");
	my $mode = $query->param("mode");
	my $group = $query->param("group");
	my $mType = $query->param("machType");
	my $mImage = $query->param("osimage");
	$name=~ s/^\s*(.*?)\s*$/$1/;
	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u root \"$CLOUD_BIN_DIR/utils/dumpmach \'$name\' \'$mType\' \'$mImage\' $role $mode $group\"";
	my $rc=system($cmd);
	if($rc == 0){
		$cmd = "$CLOUD_BIN_DIR/utils/thcsu -u root \"$CLOUD_BIN_DIR/utils/dumpmach \'$name\' \'$mType\' \'$mImage\' $role $mode $group |  $CLOUD_BIN_DIR/utils/addmach2cloud\"";
		$rc=system($cmd);
		my $errorStr= {
			'1'=>"Failed to connect to Clouduu DB",
			'2'=>"Failed to update $name into Cloud DB",
			'3'=>"Failed to insert $name into Cloud DB",
			'4'=>"Failed to add $name to VNC hosts",
			'5'=>"Failed to create LL dir for $name",
			'6'=>"Failed to set permission for LL dir for $name",
		};
		if($rc==0){
			my $result->{'status'} = "success";
			CmdUtils->printXML($result, "result");
		}
		else{
			$rc=$rc/256;
			if(exists($errorStr->{$rc})){
				CmdUtils->error($errorStr->{$rc},$rc);
			}
			else{
				CmdUtils->error("Unknow reason Code:$rc", $rc);
			}
		}
	}else{
		CmdUtils->error("Can not dump mach $name information", $rc);
	}
}
sub modSysconf {
	my ($query)=@_;
	my @num_changed_field=qw/maxvCpusPerVm maxHypvNums maxKvmVms maxVmsPerHypv/;
	my @str_changed_field=("machTypeName", "vlanFlag");
	my $relation_check_table={
			'maxHypvNums'=>'modsysconf_maxVmsPerHypv',
			'maxVmsPerHypv'=>'modsysconf_maxHypvNums',
			'maxKvmVms'=>'modsysconf_prefix',
		};
	my $value;
	my $rc;
	my $exInfo;
	my $result;
	my $vhostChnum=0;
	my $prefix=$query->param("modsysconf_prefix");
	$prefix =~ s/^\s*(.*?)\s*$/$1/;
	my @machtyps=();
	my @machprices=();
	my @addMType = ();
	my @rmMType = ();
	foreach my $conf_name (@num_changed_field){
			$value =  $query->param("modsysconf_$conf_name");
		my $related_value;
		if(defined($relation_check_table->{$conf_name}) and defined($query->param("$relation_check_table->{$conf_name}"))){
			$related_value = $query->param("$relation_check_table->{$conf_name}");
		}	
		($rc, $exInfo) = CloudUtils->sysConfChangeCheck($conf_name, $value, $related_value, "Number");
		if($rc == 0){
			$exInfo=sprintf("Modify $conf_name failed. Reason: %s", $exInfo);
			goto modFail;
		}
		elsif($rc == 1){#changed
			$result->{$conf_name} = $value;
			if($conf_name eq "maxKvmVms"){
				$vhostChnum = $exInfo;
			}
		}
	}
	foreach my $conf_name (@str_changed_field){
		$value =  $query->param("modsysconf_$conf_name"."_result");
		if($conf_name eq "machTypeName"){
			my @tmp_mach_prices=split(",",$value);
			foreach my $item (@tmp_mach_prices){
				$item =~ /^(\S+)\((\d+.?\d*)\$\)$/;
				push(@machtyps, $1);
				push(@machprices, $2*100);
			}
			$value = join(",",@machtyps);
		}
		my $related_value;
		if(defined($relation_check_table->{$conf_name}) and defined($query->param("$relation_check_table->{$conf_name}"))){
			$related_value = $query->param("$relation_check_table->{$conf_name}");
		}	
		($rc, $exInfo) = CloudUtils->sysConfChangeCheck($conf_name, $value, $related_value, "String");
		if($rc == 0){
				$exInfo=sprintf("Modify $conf_name failed. Reason: %s", $exInfo);
				goto modFail;
		}elsif($rc == 1){#changed
			$result->{$conf_name} = $value;
#			$exInfo =~ /^\[(\S)\]\:\[(\S)\]&/;
#			my $addMTStr = $1;
#			my $rmMTStr = $2;
#			@addMType = split(",", $addMTStr);
#			@rmMType = split(",", $rmMTStr);
		}
	}
	#set machine price
	require "BillingDemo.pm";
	for(my $i=0; $i<scalar(@machtyps); $i++){
		if(BillingDemo->setMachinePrice($machtyps[$i],$machprices[$i])ne "1"){
			$exInfo=sprintf("Set price for machine type %s failed.", join(",", @machtyps));
			goto modFail;
		}
	}
	if(scalar($result)){#start change
		my $changedkeys=join(',',keys(%$result));
		if($vhostChnum < 0){#must put here to avoid db sync failure to cause worse case
			if(CloudUtils->removeVM(0-$vhostChnum, $prefix)==0){
				$exInfo=sprintf("Modify %s failed. Reason: Remove VM from DB failed", $changedkeys);
				goto modFail;
			}
		}
		if(CloudUtils->putConfig($result)==0){
			$exInfo=sprintf("Modify %s failed. Reason: Update DB failed", $changedkeys);
			goto modFail;
		}
		if($vhostChnum > 0){
		  	my $cmd = "$CLOUD_BIN_DIR/utils/addvm2cloud --prefix=\'$prefix\'";
		my ($runrv, @output) = CmdUtils->runcmd($cmd, "root", 1);
		my $outputnum = scalar(@output);
		if($runrv != 0){
			my $errstr = $output[$outputnum-1];
			$exInfo=sprintf("Add virtual machine to Cloud failed. Reason: %s", $errstr);
			goto modFail;
		}
		}
	}
	$result->{'status'} = "success";
	CmdUtils->printXML($result, "result");
	return;
modFail:
	CmdUtils->error("$exInfo",-1); 
}

sub billingInfo {
	my ($query)=@_;
	require "BillingDemo.pm";

	my $query_user = $USERID;

	my $scope = $query->param('scope') || "week";
	my $daystyle = "class=\"off\"";
	my $weekstyle = "class=\"off\"";
	my $monthstyle = "class=\"off\"";
	my $yearstyle = "class=\"off\"";
	my $allstyle = "class=\"off\"";

	my $timeline = time();
	use POSIX qw(strftime);
	my $timestr = strftime("%j:%d:%w:%k:%M:%S", localtime($timeline));
	my ($doy, $dom, $dow, $h, $m, $s) = split(/:/, $timestr);

	if ($scope eq "all") {
		$allstyle = "class=\"on\"";
		# for all;
		$timeline = 0;
	} elsif ($scope eq "day") {
		$daystyle = "class=\"on\"";
		# for today;
		$timeline -= ($s + ($m * 60) + ($h * 3600));
	} elsif ($scope eq "month") {
		$monthstyle = "class=\"on\"";
		# for this month;
		$timeline -= ($s + ($m * 60) + ($h * 3600) + ($dom * (3600 * 24)));
	} elsif ($scope eq "year") {
		$yearstyle = "class=\"on\"";
		# for this year;
		$timeline -= ($s + ($m * 60) + ($h * 3600) + ($doy * (3600 * 24)));
	} else {
		$weekstyle = "class=\"on\"";
		# for this week;
		$timeline -= ($s + ($m * 60) + ($h * 3600) + ($dow * (3600 * 24)));
	}

	my $users = BillingDemo->getAllAccountInfoFromDB();
	my @sortedKeys = sort(keys(%$users));

	unless ($::ISADMIN) {
		@sortedKeys = ($query_user);
	}
	
	my @rowcolors = ('#cac28e', '#f7f9e4');
	my $colorindex = 0;
	
	print "<table border=0 cellpadding=1 cellspacing=1 bgcolor=#e3e3d1>";

	print "<tr><th bgcolor=#FFFFFF colspan=5 align=center>Billing Info</th></tr>";
	print "<tr><th colspan=5 style=\"font-size: 10pt;\" align=left><b><font color=#3d3d3d></font></b>
			&nbsp;<a href=\"portal.cgi?catalog=billing&function=billingInfo&scope=day\" $daystyle>Today</a>
			&nbsp;<a href=\"portal.cgi?catalog=billing&function=billingInfo&scope=week\" $weekstyle>Week</a>
			&nbsp;<a href=\"portal.cgi?catalog=billing&function=billingInfo&scope=month\" $monthstyle>Month</a>
			&nbsp;<a href=\"portal.cgi?catalog=billing&function=billingInfo&scope=year\" $yearstyle>Year</a>
			&nbsp;<a href=\"portal.cgi?catalog=billing&function=billingInfo&scope=all\" $allstyle>All</a></th></tr>";

	print "<tr class='tab_head'><td width=50 align=right style=\"padding-left:10px;padding-right:10px;\">User</td><td width=100 style=\"padding-left:10px;padding-right:10px;\">Account Balance<br/>(US \$)</td><td width=250 style=\"padding-left:10px;padding-right:10px;\">Requests</td><td width=50 style=\"padding-left:10px;padding-right:10px;\">Usage Time<br/>(mins)</td><td width=50 style=\"padding-left:10px;padding-right:10px;\">Total Charge<br/>(US \$)</td></tr>";
	
	my $id;
	my $cost;
	my $duration;
	my $totalCost= 0;
	my $totalDuration = 0;
	my $startTime;
	my $provision_msg = '';
	my $job_msg = '';
	my $i;

	foreach my $key (@sortedKeys) {

			unless ( defined($users->{$key}) ) {
				next;
			}

			my($color) = $rowcolors[$colorindex];
			my $userElem = $users->{$key};
	
			my $userName = $userElem->{'userName'};
			my $balance = $userElem->{'balance'};
			my $init = $userElem->{'init'};
	
			my $provisions = BillingDemo->getUserProvisionInfoFromDB($userName);
			$provision_msg = '';
			$i = 0;
			$totalCost = 0;
			$totalDuration = 0;
			foreach my $p (sort(keys(%$provisions))) {

				$id = $provisions->{$p}->{'provisionId'};
				$startTime = $provisions->{$p}->{'requestTime'};
				if ($startTime < $timeline) {
					next;
				}

				$cost = $provisions->{$p}->{'cost'};
				$totalCost += $cost;
				$cost = $cost / 100;
	
				$provision_msg .= "<a href=portal.cgi?catalog=billing&function=accounting&provision=$id>";
				$provision_msg .= $id . '</a>('. $cost . '),';
				$i++;
				if (($i % 3) == 0) {
					$provision_msg .= '<BR>';
				}

				my $provInfo = CloudUtils->getProvInfoById($id, 0, 2);
				
				if(defined($provInfo->{'request.actual_stop_time'})){
					$duration = ($provInfo->{'request.actual_stop_time'}-$provInfo->{'request.start_time'})/60;
				}else{
					$duration = ($provInfo->{'request.expiry_time'}-$provInfo->{'request.start_time'})/60;
				}
				if ($duration > 0) { # The calculated duration can be <0 if the request is canceled in Reserved status.
					$totalDuration += $duration;
				}
			}

			my $balance_str = sprintf("%d.%02d", ($balance/100), ($balance%100));
			my $cost_str = sprintf("%d.%02d", ($totalCost/100), ($totalCost%100));
			my $totalDuration_str = sprintf("%.2f", $totalDuration);
	
			print "<tr class='tab_content'>
					<td align=right style=\"padding-left:10px;padding-right:10px;\">${userName}</td>
					<td style=\"padding-left:10px;padding-right:10px;\">${balance_str}</td>
					<td style=\"padding-left:10px;padding-right:10px;\">${provision_msg}</td>
					<td style=\"padding-left:10px;padding-right:10px;\">${totalDuration_str}</td>
					<td style=\"padding-left:10px;padding-right:10px;\">${cost_str}</td>
				 </tr>";
	
			$colorindex = ($colorindex+1) % 2;
	}
	
	print "</table>";
}

sub accounting {
	my($query) = @_;

	require "Accounting.pm";
	require "BillingDemo.pm";
	my $pid = $query->param('provision');
	
	#print "<table border=0 cellpadding=2 cellspacing=2 bgcolor=white width=800>
	#		<tr><td align=\"right\"><b><font color=red>* Accounting DEMO *</font></b></td></tr>
	#		</table>";

	if ($pid) {
	
		my $t = time;
		unless ($::ISADMIN) {
			my @allprovs = Accounting->getProvNameByUser($USERID);
			my $found = 0;
			foreach (@allprovs) {
				if ($_ eq $pid) {
					$found = 1;
					last;
				}
			}
			
			if ($found == 0) {
				print "<p>";
				print "User $USERID has no permission to view provision $pid.<br>";
				print "</p>";
				return;
			}
		}
		
		# The 3rd argument 2 indicates the machines being added should be included.
		my $provision = CloudUtils->getProvInfoById($pid, 0, 2);
		
		print "<table border=0 cellpadding=2 cellspacing=2 bgcolor=#e3e3d1 style=\"text-align:center\">";
		print "<tr>
				<th colspan=2 bgcolor=#e3e3d1 width=700 align=left><b><font color=black>Request: $pid</font></b></th>
				</tr>";
		$t = CloudUtils->formatTime($provision->{'request.start_time'});
		print "<tr>
				<td class='tab_head' width=100>Start Date</td>
				<td class='tab_content' width=600 align=left>$t</td>
				</tr>";
		if(defined($provision->{'request.actual_stop_time'})){
			$t = CloudUtils->formatTime($provision->{'request.actual_stop_time'});
		}else{
			$t = CloudUtils->formatTime($provision->{'request.expiry_time'});
		}
		print "<tr>
				<td class='tab_head' width=100>End Date</td>
				<td class='tab_content' width=600 align=left>$t</td>
				</tr>";
		print "<tr>
				<td class='tab_head' width=100>Owner</td>
				<td class='tab_content' width=600 align=left>$provision->{'request.owner'}</td>
				</tr>";
		print "<tr>
				<td class='tab_head' width=100>State</td>
				<td class='tab_content' width=600 align=left>$provision->{'request.status'}</td>
				</tr>";

		my $selectType = $provision->{'request.select_method'};
		if ($selectType == 0) {
			my @machines;
			foreach (@{$provision->{'machList'}}){
				push(@machines, $_->{'machine.name'});
			}
		printf ("<tr> <td class='tab_head' width=100>Machines</td> <td class='tab_content' width=600 align=left> %s </td> </tr>", join(',',@machines )); 
	} else {
		my $reqMachType = $provision->{'request.machine_type'};
		my $reqMachNumber = $provision->{'request.machine_num'};
		print "<tr> <td class='tab_head' width=100>Machines</td>
					 <td class='tab_content' width=600 align=left>(Type: $reqMachType) x $reqMachNumber</td>
				</tr>";
	}

		printf ("<tr> <td class='tab_head' width=100>Energy</td> <td class='tab_content' width=600 align=left>%s (kwh)</td> <tr>", EnergyUtils->getEnergyOfProv($pid));
		my $billInfo = BillingDemo->getProvisionInfoFromDB($pid);
		my $cost = $billInfo->{'cost'};
		my $cost_str = sprintf("%d.%02d", ($cost/100), ($cost%100));
		printf ("<tr> <td class='tab_head' width=100>Charge</td> <td class='tab_content' width=600 align=left>%s (US\$)</td> <tr>", ($cost_str) );
		printf ("<tr> <td class='tab_head' width=100>Vlan Flag</td> <td class='tab_content' width=600 align=left>%s</td> <tr>", $provision->{'request.vlan_flag'});
		if(!defined($provision->{'request.vlan_id'})){
			$provision->{'request.vlan_id'} = "NA";
		}
		printf ("<tr> <td class='tab_head' width=100>Vlan ID</td> <td class='tab_content' width=600 align=left>%s</td> <tr>", $provision->{'request.vlan_id'});		
		print "</table>";
		print "</form>";
=bypass it currently
		my $events = CloudUtils->getProvisionEvents($pid);
		if (defined($events)) {
			print "<table border=0 cellpadding=2 cellspacing=2 bgcolor=#ffffdd>";
			print "<tr><th align=\"left\" colspan=3> Events on Request: </th></tr>\n";
			printf ("<tr class='tab_head'><td width=50 align=center>Owner</td><td width=200>Event</td><td width=300>Comments</td></tr>");

			foreach my $k (sort(keys(%$events))) {

				my $user = $events->{$k}->{'user'};
				my $action = $events->{$k}->{'operation'};
				my $time = $events->{$k}->{'eventTime'};
				my $comments = $events->{$k}->{'eventDesc'};

				printf ("<tr><td class=formprompt width=50 align=center>%s</td><td class=formfield width=200>%s</td><td class=formfield width=300>%s</td></tr>", $user, join('@', $action, CloudUtils->formatTime($time)), $comments);
			}
			print "</table>";
		}
=cut

	
	} else {
	
		print "<p>";
		#print "<ul class=\"tabnav\">
		#		<li class=\"\">Executed Provisions</li></ul>";
		#print "<p>";

		print "<table border=0 cellpadding=2 cellspacing=2 bgcolor=#e3e3d1 style=\"text-align:center\">";
		print "<tr><td> </td>
				<td bgcolor=#950a0a width=100><b><font color=#f7f9e5>Account</font></b></a></td>
				<td bgcolor=#950a0a width=600><b><font color=#f7f9e5>Provisions</font></b></a></td>
			  </tr>";

		my @rowcolors = ("#cac28e","#f7f9e4");
		my $colorindex = 0;

		my @allUsers = ();
		if ($::ISADMIN) {
			@allUsers = Accounting->getAllUserName();
		} else {
			@allUsers = ($USERID);
		}

		my $total = 0;
		foreach my $u (sort(@allUsers)) {
			my @provs = Accounting->getProvNameByUser($u);
			my $line = '';
			foreach my $p (@provs) {
				$line .= "<a href=portal.cgi?function=accounting&provision=$p>$p</a> ";
				$total++;
			}
			
			my($color) = $rowcolors[$colorindex];
			print "<tr><td> </td>
				<td bgcolor=$color width=100><b><font color=#910000>$u</font></b></td>
				<td bgcolor=$color width=600 align=left><b><font color=#910000>$line</font></b></td>
			  </tr>";
			
			$colorindex = ($colorindex+1) % 2;
		}
		
		print "<tr><th colspan=3>Total $total Provisions</th></tr>";
		print "</table>";
	}
}

sub listUser {
	my ($query) = @_;
#	Open to normal user for now. Depend on backend code to veriry if the user is authorized.
#	if (!$::ISADMIN) {
#		error("You are not administrator!");
#	} 
	print "<h3><b>All Users:</b></h3><p>";
	print "<form id='userForm' name='userForm' method=post action=portal.cgi>";
	print "<input id = 'usr_functioncntl' type=hidden name=function value=deleteUser>";
	print "<input id = 'usr_resetpwd' type=hidden name=usr_resetpwd value=''>";

	print "<table id=\"userlistTab\" border=0 cellpadding=2 cellspacing=2 bgcolor=#e3e3d1 style=\"text-align:center\">";
	print "<tr valign=\"middle\">
			<th align=\"left\" colspan=8>\n";
	print "<table>";
	my $dis_flag="";
	if(CloudUtils->checkCapability($USERID, "delete-user")== 0) {
		$dis_flag = "disabled";
	}
	print "<tr><td><button dojoType=\"dijit.form.Button\" type=\"button\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconDelete\" title=\"Delete selected users\" onclick=\"submitDeleteUser();\" $dis_flag>Delete</button></td>\n";
	$dis_flag="";
	if(CloudUtils->checkCapability($USERID, "add-user")==0){
		$dis_flag = "disabled";
	}
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"navLink('listUser', 'portal.cgi?function=addUserForm');\" baseClass=tundra iconClass=\"dijitIcon dijitIconNewTask\" title=\"Add a new user\" $dis_flag>Add a user</button></td>\n";
	
	$dis_flag="";
	if($USERID ne "cloudadm"){
		$dis_flag = "disabled";
	}
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconUndo\" title=\"Reset passwords of selected users.\" onclick=\"resetpwdcontrol();\" $dis_flag>Reset User Password</button></td>\n";

	
	print "</tr></table>\n";
	print "</th></tr>";

	print "<tr class='tab_head'><td><input type=checkbox name=selectAll onClick=\"select_all()\" title=\"Select/Deselect all\"></td>
			<td width=100><a href=\"javascript:sortUserTab('name');\" title=\"Sort by ID\">User Name</a></td>
			<td width=80>Role</td>
			<td width=80>First Name</td>
			<td width=80>Last Name</td>
			<td width=150>E-Mail</td>
			<td width=100>Phone</td>
			<td width=100>Department</td>
			<td width=100>Orgnization</td>
			<td width=80>Group(s)</td>
			<td width=100>Balance(\$)</td>
			<td width=60>Shell</td>
			<td width=300>Description</td>
		  </tr>";
	print "<tr><td colspan=8><b>Loading...</b></td></tr>";

	print "</table>";
	print "</form>";
	print "<script language=\"javascript\" type=\"text/javascript\" src=\"/hpccloud/scripts/UserView.js\"></script>\n";
	my $script = <<"SCRIPT";
<script type="text/javascript" language="JavaScript">
function select_all(){
	var checked;
	if (document.userForm.selectAll.checked) checked=true;
	else checked=false;
	var inputs = document.getElementsByTagName("input");	 
	for(var i=0;i<inputs.length;i++)	 
	{	 
		if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].getAttribute("name") == "userID") 
		{	 
		 inputs[i].checked = checked;	 
		}	 
	}	 
}
showUsers();
</script>
SCRIPT

	print $script;

	print qq(<div id="resetpwdDialog" dojoType="dijit.Dialog" title="ResetPassword">);
	print qq(<table>);
	print qq( <tr><td class=formprompt colspan=2>New Password * :</td>	);
	print qq(  <td><input type=password id=resetpwd1 name=resetpwd1 size=30 style="font-family:verdana"></td><td class=formprompt>Equal or greater than 6 characters</td></tr>  );
	print qq( <tr><td class=formprompt colspan=2>Repeat Password * :</td>	);
	print qq( <td><input type=password id=resetpwd2 name=resetpwd2 size=30 style="font-family:verdana"></td><td class=formprompt>Equal or greater than 6 characters</td></tr>	);
	print qq( </table>	);
	print qq( <p><div style="padding: 8px 0; text-align: center;">	);
	print qq( <button dojoType="dijit.form.Button" type="button" baseClass=soria iconClass="dijitEditorIcon dijitEditorIconSave" onClick="checkresetpwd();">Confirm</button>&nbsp;&nbsp;&nbsp;&nbsp;	);
	print qq( <button dojoType="dijit.form.Button" type="button" onClick="dijit.byId('resetpwdDialog').destroy();" baseClass=soria iconClass="dijitEditorIcon dijitEditorIconCancel">Cancel</button>	);
	print qq( </div>	);
	print qq(</div>	);

}

sub deleteUser {
my ($query) = @_;
my @users = $query->param('userID');

	print "<delete_result>\n";
foreach my $user (@users) {
	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/usermgt/hcrmuser --userid=$user\"";
	my $output = `$cmd`;
	print $output;
}
	print "</delete_result>\n";
}


sub resetUser {
my ($query) = @_;
my @users = $query->param('userID');
my $rstpwd = $query->param('usr_resetpwd');

	print "<reset_result>\n";
foreach my $user (@users) {
	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/usermgt/hcresetuser --userid=$user --rstpwd=$rstpwd\"";
	my $output .= `$cmd`;
	print $output;
}
	print "</reset_result>\n";
}

sub addUserForm {
	my ($query) = @_;

#	Open to normal user for now. Depend on backend code to veriry if the user is authorized.
#	if (!$::ISADMIN) {
#		error "You are not administrator!";
#	}

	print "<h3><b>Specify the information of the user you want to add: </b></h3><p>";
	print "<form id=addUserForm method=post action=portal.cgi>";
	print "<blockquote><table border=0 cellpadding=2 cellspacing=2>";
	print "<input type=hidden name=function value=addUser>";

	print "<tr><td class=formprompt>User Name * :</td>";
	print "<td><input type=text name=userid size=30 style=\"font-family:verdana\"></td></tr>\n";

	print "<tr><td class=formprompt>First Name :</td>";
	print "<td><input type=text name=firstname size=30 style=\"font-family:verdana\"></td></tr>\n";
	print "<tr><td class=formprompt>Last Name :</td>";
	print "<td><input type=text name=lastname size=30 style=\"font-family:verdana\"></td></tr>\n";
	print "<tr><td class=formprompt>E-Mail :</td>";
	print "<td><input type=text name=email size=30 style=\"font-family:verdana\"></td></tr>\n";
	print "<tr><td class=formprompt>Phone :</td>";
	print "<td><input type=text name=phone size=30 style=\"font-family:verdana\"></td></tr>\n";
	print "<tr><td class=formprompt>Department :</td>";
	print "<td><input type=text name=department size=30 style=\"font-family:verdana\"></td></tr>\n";
	print "<tr><td class=formprompt>Orgnization :</td>";
	print "<td><input type=text name=organization size=30 style=\"font-family:verdana\"></td></tr>\n";
	print "<tr><td class=formprompt>Description :</td>";
	print "<td><input type=text name=comments size=30 style=\"font-family:verdana\"></td></tr>\n";
	print "<tr><td class=formprompt>Initial Balance(\$):</td>";
	print "<td><input type=text name=balance size=30 style=\"font-family:verdana\" value=50000></td></tr>\n";
	print "<tr><td class=formprompt>Password * :</td>";
	print "<td><input type=password name=passwd size=30 style=\"font-family:verdana\"></td><td class=formprompt>Equal or greater than 6 characters</td></tr>\n";
	print "<tr><td class=formprompt>Repeat Password * :</td>";
	print "<td><input type=password name=rePasswd size=30 style=\"font-family:verdana\"></td><td class=formprompt>Equal or greater than 6 characters</td></tr>\n";
my @support_shells =("sh", "bash", "csh", "dash","ksh", "tcsh");
	print "<tr><td class=formprompt>Shell :</td>";
	print "<td><select name=\"shell\">";
foreach (@support_shells){
	print "<option value=$_>$_</option>";
}
	print "</select>";
	print "</td></tr>\n";

	print "<tr><td class=formprompt>Role :</td>";
	if($::ISADMIN){
		print "<td><select name=\"role\">";
	}else{
		print "<td><select name=\"role\" disabled>";
	}
	my $roles = CloudUtils->getAllRole();
	print "<option value=NA>Normal User</option>";
	foreach my $role (@$roles) {
		print "<option value=$role>$role</option>";
	}
	print "</select>";

	print "</td></tr>\n";

	print "</table></blockquote>";

	print "<p><button dojoType=\"dijit.form.Button\" type=\"button\" onclick=\"submitAddUser();\" iconClass=\"dijitEditorIcon dijitEditorIconTabIndent\">Submit</button>";
	print "</form>";
}

sub addUser {
	my ($query) = @_;

	my $userid = $query->param('userid');
	my $role = $query->param('role');

	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/usermgt/hcmkuser";

	my $rv;
	if ($userid eq "") {
		error("Specify a user ID.");
	}

	my $passwd = $query->param('passwd');
	my $rePasswd = $query->param('rePasswd');
	if (length($passwd)< 6) {
		error("Password length must be equal or greater than 6.");
	}
	if ($passwd ne $rePasswd) {
		error("Password and Repeat Password do not match.");
	}

	$cmd .= " --userid=\'$userid\' --password=\'$passwd\'";
	my $tmp_v = $query->param('firstname');
	if($tmp_v){
		$cmd .= " --firstname=\'$tmp_v\'";
	}
	$tmp_v = $query->param('lastname');
	if($tmp_v){
		$cmd .= " --lastname=\'$tmp_v\'";
	}
	$tmp_v = $query->param('email');
	if($tmp_v){
		$cmd .= " --email=\'$tmp_v\'";
	}
	$tmp_v = $query->param('phone');
	if($tmp_v){
		$cmd .= " --phone=\'$tmp_v\'";
	}
	$tmp_v = $query->param('department');
	if($tmp_v){
	$cmd .= " --department=\'$tmp_v\'";
	}
	$tmp_v = $query->param('organization');
	if($tmp_v){
		$cmd .= " --organization=\'$tmp_v\'";
	}
	$tmp_v = $query->param('balance');
	if(!defined($tmp_v)){
		$tmp_v = 0;
	}
	$cmd .= " --balance=\'$tmp_v\'";
	$tmp_v = $query->param('comments');
	if($tmp_v){
		$cmd .= " --comments=\'$tmp_v\'";
	}
	$tmp_v = $query->param('shell');
	if(!defined($tmp_v)){
		$tmp_v = "sh";
	}
	$cmd .= " --shell=\'$tmp_v\'";
	$cmd .= "\"";

	my $output = "<result>";
	$output .= `$cmd`;
	if ($role && $role ne "NA") {
		$cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/usermgt/hcassignrole";
		$cmd .= " --user=\'$userid\' --role=\'$role\'";
		$cmd .= "\"";
		$output .= `$cmd`;
	}

	$output .= "</result>";
	print $output;
}

sub updateUserForm {
	my ($query) = @_;
	my $username = $query->param('uname');
	my $userinfo = CloudUtils->getUserByName($username);
	my $tmp_v;
	my $disp_flag = "";
	if((CloudUtils->checkCapability($USERID, "modify-user")== 0)&&($USERID ne $username)) {
		$disp_flag= "disabled";
	}

#	Open to normal user for now. Depend on backend code to veriry if the user is authorized.
#	if (!$::ISADMIN) {
#		error "You are not administrator!";
#	}
	print "<h3><b>Specify the information of the user you want to Modify: </b></h3><p>";
	print "<form id=updateUserForm method=post action=portal.cgi>";
	print "<blockquote><table border=0 cellpadding=2 cellspacing=2>";
	print "<input type=hidden name=function value=updateUser>";
	print "<tr><td class=formprompt>User Name * :</td>";
	print "<td><input type=text name=userid size=30 style=\"font-family:verdana\" value=\'$username\' readonly></td></tr>\n";
	print "<tr><td class=formprompt>First Name :</td>";
	if(defined($userinfo->{$username}->{'user.first_name'})){
		$tmp_v = $userinfo->{$username}->{'user.first_name'};
	}else{
		$tmp_v = "";
	}
	print "<td><input type=text name=firstname ize=30 style=\"font-family:verdana\" value=\'$tmp_v\' $disp_flag></td></tr>\n";
	print "<tr><td class=formprompt>Last Name :</td>";
	if(defined($userinfo->{$username}->{'user.last_name'})){
		$tmp_v = $userinfo->{$username}->{'user.last_name'};
	}else{
		$tmp_v = "";
	}
	print "<td><input type=text name=lastname size=30 style=\"font-family:verdana\" value=\'$tmp_v\' $disp_flag></td></tr>\n";
	print "<tr><td class=formprompt>E-Mail :</td>";
	if(defined($userinfo->{$username}->{'user.email'})){
		$tmp_v = $userinfo->{$username}->{'user.email'};
	}else{
		$tmp_v = "";
	}
	print "<td><input type=text name=email size=30 style=\"font-family:verdana\" value=\'$tmp_v\' $disp_flag></td></tr>\n";
	print "<tr><td class=formprompt>Phone :</td>";
	if(defined($userinfo->{$username}->{'user.phone'})){
		$tmp_v = $userinfo->{$username}->{'user.phone'};
	}else{
		$tmp_v = "";
	}
	print "<td><input type=text name=phone size=30 style=\"font-family:verdana\" value=\'$tmp_v\' $disp_flag></td></tr>\n";
	print "<tr><td class=formprompt>Department :</td>";
	if(defined($userinfo->{$username}->{'user.department'})){
		$tmp_v = $userinfo->{$username}->{'user.department'};
	}else{
		$tmp_v = "";
	}
	print "<td><input type=text name=department size=30 style=\"font-family:verdana\" value=\'$tmp_v\' $disp_flag></td></tr>\n";
	print "<tr><td class=formprompt>Orgnization :</td>";
	if(defined($userinfo->{$username}->{'user.organization'})){
		$tmp_v = $userinfo->{$username}->{'user.organization'};
	}else{
		$tmp_v = "";
	}
	print "<td><input type=text name=organization size=30 style=\"font-family:verdana\" value=\'$tmp_v\' $disp_flag></td></tr>\n";
	print "<tr><td class=formprompt>Recharge(\$) :</td>";
	$tmp_v = 0;
	if(CloudUtils->checkCapability($USERID, "modify-user")== 0){
		print "<td><input type=text name=Recharge size=30 style=\"font-family:verdana\" value=\'$tmp_v\' disabled></td></tr>\n";
	}else{
		print "<td><input type=text name=Recharge size=30 style=\"font-family:verdana\" value=\'$tmp_v\' ></td></tr>\n";
	}

	print "<tr><td class=formprompt>Description :</td>";
	if(defined($userinfo->{$username}->{'user.comments'})){
		$tmp_v = $userinfo->{$username}->{'user.comments'};
	}else{
		$tmp_v = "";
	}
	print "<td><input type=text name=comments size=30 style=\"font-family:verdana\" value=\'$tmp_v\' $disp_flag></td></tr>\n";
	if($USERID eq $username){
		print "<tr><td class=formprompt>Old Password * :</td>";
		print "<td><input type=password name=oldpasswd size=30 style=\"font-family:verdana\" $disp_flag></td></tr>\n";
		print "<tr><td class=formprompt>New Password * :</td>";
		print "<td><input type=password name=newpasswd size=30 style=\"font-family:verdana\" $disp_flag></td><td class=formprompt>Equal or greater than 6 characters</td></tr>\n";
		print "<tr><td class=formprompt>Repeat Password * :</td>";
		print "<td><input type=password name=rePasswd size=30 style=\"font-family:verdana\" $disp_flag></td><td class=formprompt>Equal or greater than 6 characters</td></tr>\n";
	}

	my @support_shells =("sh", "bash", "csh", "dash","ksh", "tcsh");
	print "<tr><td class=formprompt>Shell :</td>";
	print "<td><select name=\"shell\">";
	$tmp_v = $userinfo->{$username}->{'shell'};
	print "<option value=$tmp_v>$tmp_v</option>";
	foreach (@support_shells){
		if($_ ne $tmp_v){
			print "<option value=$_>$_</option>";
		}
	}
	print "</select>";
	print "</td></tr>\n";

	$tmp_v = $userinfo->{$username}->{'user.role'};
	print "<tr><td class=formprompt>Role :</td>";
	if($::ISADMIN){
		print "<td><select name=\"role\">";
	}
	else{
		print "<td><select name=\"role\" disabled>";
	}

	my $roles = CloudUtils->getAllRole();
	if($tmp_v){
		print "<option value=$tmp_v>$tmp_v</option>";
		print "<option value=NA>Normal User</option>";
	}
	else{
		print "<option value=NA>Normal User</option>";
	}
	foreach my $role (@$roles) {
		if($role ne $tmp_v){
			print "<option value=$role>$role</option>";
		}
	}
	print "</select>";

	print "</td></tr>\n";


	print "</table></blockquote>";

	print "<p><button dojoType=\"dijit.form.Button\" type=\"button\" onclick=\"submitUpdateUser();\" iconClass=\"dijitEditorIcon dijitEditorIconTabIndent\" $disp_flag>Submit</button>";
	print "</form>";
}

sub updateUser {
	my ($query) = @_;

	my $userid = $query->param('userid');
	my $role = $query->param('role');

	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/usermgt/hcchuser";

	my $rv;
	if (!$userid) {
		error("Specify a user ID.");
	}
	$cmd .= " --userid=\'$userid\'";
	my $oldpasswd = $query->param('oldpasswd');
	my $newpasswd = $query->param('newpasswd');
	my $rePasswd = $query->param('rePasswd');
	if (($oldpasswd ne "")&&($newpasswd ne "")&&($rePasswd ne "")) {
		if((length($oldpasswd)<6)||(length($newpasswd) < 6)||(length($rePasswd) <6)) {
			error("Password length must be equal or greater than 6.");
		}
		if ($newpasswd ne $rePasswd) {
			error("New Password and Repeat New Password do not match.");
	}
		$cmd .= " --oldpassword=\'$oldpasswd\' --newpassword=\'$newpasswd\'";
	}
	else{
		if (($oldpasswd ne "")||($newpasswd ne "")||($rePasswd ne "")){
			error("You must fill Old Password, New Password and Repeat Password at same time to change password.");
		}
	}
	my $tmp_v = $query->param('firstname');
	if($tmp_v){
		$cmd .= " --firstname=\'$tmp_v\'";
	} 
	$tmp_v = $query->param('lastname');  
	if($tmp_v){
		$cmd .= " --lastname=\'$tmp_v\'";
	}
	$tmp_v = $query->param('email');
	if($tmp_v){
		$cmd .= " --email=\'$tmp_v\'";
	}
	$tmp_v = $query->param('phone');
	if($tmp_v){
		$cmd .= " --phone=\'$tmp_v\'";
	}
	$tmp_v = $query->param('department');
	if($tmp_v){
		$cmd .= " --department=\'$tmp_v\'";
	}
	$tmp_v = $query->param('organization');
	if($tmp_v){
		$cmd .= " --organization=\'$tmp_v\'";
	}	
	$tmp_v = $query->param('Recharge');
	if(($tmp_v ne "") and ($tmp_v > 0 )){
		$cmd .= " --recharge=\'$tmp_v\'";
	}	

	$tmp_v = $query->param('shell');
	$cmd .= " --shell=\'$tmp_v\'";
	$tmp_v = $query->param('comments');
	if($tmp_v){
			$cmd .= " --comments=\'$tmp_v\'";
	}
	else{
		$cmd .= " --comments=\' \'";
	}
	$cmd .= "\"";

	my $output = "<result>";
	$output .= `$cmd`;
	if ($role) {
		$cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/usermgt/hcassignrole";
		$cmd .= " --user=\'$userid\' --role=\'$role\'";
		$cmd .= "\"";
		$output .= `$cmd`;
	}

	$output .= "</result>";
	print $output;
}

sub listRole {
	my ($query) = @_;
#	Open to normal user for now. Depend on backend code to veriry if the user is authorized.
#	if (!$::ISADMIN) {
#		error("You are not administrator!");
#	} 
	my $disable_flag="";
	if(!$::ISADMIN){
		$disable_flag="disabled";
	}
	print "<h3><b>All Roles:</b></h3><p>";
	print "<form id='roleForm' name='roleForm' method=post action=portal.cgi>";
	print "<input type=hidden name=function value=deleteRole>";

	print "<table id=\"rolelistTab\" border=0 cellpadding=2 cellspacing=2 bgcolor=#e3e3d1 style=\"text-align:center\">";
	print "<tr valign=\"middle\">
			<th align=\"left\" colspan=8>\n";
	print "<table>";
	print "<tr><td><button dojoType=\"dijit.form.Button\" type=\"button\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconDelete\" title=\"Delete selected roles\" onclick=\"submitDeleteRole();\" $disable_flag>Delete</button></td>\n";
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"navLink('listRole', 'portal.cgi?function=addRoleForm');\" baseClass=tundra iconClass=\"dijitIcon dijitIconNewTask\" title=\"Add a new role\" $disable_flag>Add a role</button></td>\n";
	print "</tr></table>\n";
	print "</th></tr>";

	print "<tr class='tab_head'><td><input type=checkbox name=selectAll onClick=\"select_all()\" title=\"Select/Deselect all\"></td>
			<td width=100><a href=\"javascript:sortRoleTab('name');\" title=\"Sort by ID\">Role Name</a></td>
			<td width=200>Capability</td>
			<td width=100>Description</td>
		  </tr>";
	print "<tr><td colspan=8><b>Loading...</b></td></tr>";

	print "</table>";
	print "</form>";

	print "<script language=\"javascript\" type=\"text/javascript\" src=\"/hpccloud/scripts/RoleView.js\"></script>\n";
	my $script = <<"SCRIPT";
<script type="text/javascript" language="JavaScript">
function select_all(){
	var checked;
	if (document.roleForm.selectAll.checked) checked=true;
	else checked=false;
	var inputs = document.getElementsByTagName("input");	 
	for(var i=0;i<inputs.length;i++)	 
	{	 
		if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].getAttribute("name") == "roleName") 
		{	 
		 inputs[i].checked = checked;	 
		}	 
	}	 
}
showRoles("$USERID");
</script>
SCRIPT

	print $script;
}

sub deleteRole {
	my ($query) = @_;
	my @roles = $query->param('roleName');
	print "<deleteRole>";
	foreach my $role (@roles) {
		my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/usermgt/hcrmrole --role=$role\"";
		my $output = `$cmd`;
		print $output;
	}
	print "</deleteRole>";
}

sub addRoleForm {
	my ($query) = @_;

#	Open to normal user for now. Depend on backend code to veriry if the user is authorized.
#	if (!$::ISADMIN) {
#		error "You are not administrator!";
#	}

	my $caphash = CloudUtils->getAllCapability();
#print Dumper($caphash);
	my @allCaps = keys %$caphash;
	my $allCapsOpts;
	foreach my $cap (@allCaps) {
		$allCapsOpts .= "<option value=\"$cap\">$cap</option>";
	}

	print "<h3><b>Specify the information of the role you want to add: </b><h3><p>";
	print "<form id='addRoleForm' name='addRoleForm' method=post action=portal.cgi>";
	print "<blockquote><table border=0 cellpadding=2 cellspacing=2>";
	print "<input type=hidden name=function value=addRole>";

	print "<tr><td class=formprompt>Role Name * :</td>";
	print "<td><input type=text name=rolename size=10 style=\"font-family:verdana\"></td></tr>\n";

	print "<tr><td class=formprompt>Capabilities * :</td>";
	print "<td>";
	print "<table>";
	print "<tr><td>Capabilities</td><td></td><td>Capabilities of this role</td></tr>";
	print "<tr><td><select class=formfield multiple=\"multiple\" name=allCaps id=allCaps size=6 style=\"width:200px;\">$allCapsOpts</select></td>";
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"moveItem('allCaps', 'roleCaps');\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconRedo\" showLabel=false>-></button><br>";
	print "<button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"moveItem('roleCaps', 'allCaps');\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconUndo\" showLabel=false><-</button></td>";
	print "<td><select class=formfield multiple=\"multiple\" name=roleCaps id=roleCaps size=6 style=\"width:200px;\"></select></td>";
	print "</table>";
	print "</td>";

	print "<tr><td class=formprompt>Description :</td>";
	print "<td><input type=text name=description size=40 style=\"font-family:verdana\"></td></tr>\n";

	print "</table></blockquote>";

	print "<p><button dojoType=\"dijit.form.Button\" type=\"button\" onclick=\"submitAddRole();\" iconClass=\"dijitEditorIcon dijitEditorIconTabIndent\">Submit</button>";
	print "</form>";
}
sub updateRoleForm {
	my ($query) = @_;
	my $role_name = $query->param('rname');

#	Open to normal user for now. Depend on backend code to veriry if the user is authorized.
#	if (!$::ISADMIN) {
#		error "You are not administrator!";
#	}

	my $roleCapshash = CloudUtils->getRole($role_name);
	my $hdl = $roleCapshash->{$role_name}->{'cap-list'}->{'capability'};
	my $rolecaps="";
	my $caphash = CloudUtils->getAllCapability();
	my @allCaps = keys %$caphash;
	my $allCapsOpts="";
	my @current_role_caps;
	my $desc = $roleCapshash->{$role_name}->{'role.desc'};
	my $disable_flag= ($role_name eq "admin")? "disabled" : "";
	$disable_flag= ((!$::ISADMIN) and ($disable_flag ne "disabled")) ? "disabled" : $disable_flag;
	foreach my $i (@$hdl) {
			push @current_role_caps,$i->{'capability.name'};
	}
	foreach my $cap (@allCaps) {
		if (grep /^$cap$/, @current_role_caps) {
			$rolecaps .= "<option value=\"$cap\">$cap</option>";
		} else {
			$allCapsOpts .= "<option value=\"$cap\">$cap</option>";
		}
	}
	print "<h3><b>Specify the information of the role you want to Update: </b><h3><p>";
	print "<form id='updateRoleForm' method=post action=portal.cgi>";
	print "<blockquote><table border=0 cellpadding=2 cellspacing=2>";
	print "<input type=hidden name=function value=updateRole>";

	print "<tr><td class=formprompt>Role Name * :</td>";
	print "<td><input type=text name=rolename size=10 style=\"font-family:verdana\" value=\'$role_name\' readonly></td></tr>\n";

	print "<tr><td class=formprompt>Capabilities * :</td>";
	print "<td>";
	print "<table>";
	print "<tr><td>Capabilities</td><td></td><td>Capabilities of this role</td></tr>";
	print "<tr><td><select class=formfield multiple=\"multiple\" name=allCaps id=allCaps size=6 style=\"width:200px;\">$allCapsOpts</select></td>";
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"moveItem('allCaps', 'roleCaps');\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconRedo\" showLabel=false $disable_flag>-></button><br>";
	print "<button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"moveItem('roleCaps', 'allCaps');\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconUndo\" showLabel=false $disable_flag><-</button></td>";
	print "<td><select class=formfield multiple=\"multiple\" name=roleCaps id=roleCaps size=6 style=\"width:200px;\">$rolecaps</select></td>";
	print "</table>";
	print "</td>";
	print "<tr><td class=formprompt>Description :</td>";
	print "<td><input type=text name=description size=70 style=\"font-family:verdana\" value=\'$desc\' $disable_flag></td></tr>\n";
	print "</table></blockquote>";
	print "<p><button dojoType=\"dijit.form.Button\" type=\"button\" onclick=\"submitUpdateRole();\" iconClass=\"dijitEditorIcon dijitEditorIconTabIndent\" $disable_flag>Submit</button>";
	print "</form>";
}

sub addRole {
	my ($query) = @_;

	my $name = $query->param('rolename');
	if (!$name) {
		error("Specify a role name.");
	}
	if($name eq "NA"){
		error("\'NA\' is not valid as a role name.");
	}
	my @caps = $query->param('roleCaps');
	my $comments = $query->param('description');

	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/usermgt/hcaddrole";
	$cmd .= " --role=\'$name\'";
	if($comments){
		$cmd .= " --comments=\'$comments\'";}
	$cmd .= "\"";

	my $output = "<result>";
	$output .= `$cmd`;
	foreach my $cap (@caps) {
		$cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/usermgt/hcaddcapability";
		$cmd .= " --role=\'$name\' --capability=\'$cap\'";
		$cmd .= "\"";
		$output .= `$cmd`;
	}
	$output .= "</result>";
	print $output;
}

sub updateRole {
	my ($query) = @_;

	my $name = $query->param('rolename');
	if (!$name) {
		error("Specify a role name.");
	}
	my @caps = $query->param('roleCaps');

	my $roleCapshash = CloudUtils->getRole($name);
	my $hdl = $roleCapshash->{$name}->{'cap-list'}->{'capability'};
	my @current_role_caps;
	foreach my $i (@$hdl) {
		push @current_role_caps,$i->{'capability.name'};
	}
	#first remove the dleted caps
	my @delete_caps;
	my @added_caps;
	my $cap;
	foreach $cap(@current_role_caps){
		unless(grep /^$cap$/, @caps){
			push @delete_caps, $cap;
		}
	}
	foreach $cap(@caps){
		unless(grep /^$cap$/, @current_role_caps){
			push @added_caps, $cap;
		}
	}
	my $output = "<updateRole>";
	my $cmd;
	foreach my $cap (@delete_caps) {
		$cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/usermgt/hcrmcapability";
		$cmd .= " --role=\'$name\' --capability=\'$cap\'";
		$cmd .= "\"";
		$output .= `$cmd`;
	}
	foreach my $cap (@added_caps) {
		$cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/usermgt/hcaddcapability";
		$cmd .= " --role=\'$name\' --capability=\'$cap\'";
		$cmd .= "\"";
		$output .= `$cmd`;
	}
	my $desc=' ';
	if($query->param('description')){
		$desc=$query->param('description');
	}
	my $ud = UserDAO->new();
	my ($rc, $param) = $ud->modifyRole({'name'=>$name}, {'desc'=>$desc});
	if ($rc == 0) {
		$ud->commit();
	}	
	else{
		$ud->rollback();
	}
	if(scalar(@delete_caps)==0 and scalar(@added_caps)==0)
	{
		#do not change caps, we print status accourding update desc result
		if($rc==0){
			$output .= "<result><status>success</status></result>";
		}
		else{
			$output .= "<result><status>failed</status></result>";
		}
	}
	$output .= "</updateRole>";
	print $output;
}

sub listGroup {
	my ($query) = @_;

	print $::ISADMIN ? "<h3><b>All Groups:</b></h3><p>" : "<h3><b>All Groups:</b></h3><p>";
	print "<form id='groupForm' name='groupForm' method=post action=portal.cgi>";
	print "<input type=hidden name=function value=deleteGroup>";

	print "<table id=\"grouplistTab\" border=0 cellpadding=2 cellspacing=2 bgcolor=#e3e3d1 style=\"text-align:center\">";
	print "<tr valign=\"middle\">
			<th align=\"left\" colspan=8>\n";
	print "<table>";
	my $dis_flag="";
	if(CloudUtils->checkCapability($USERID, "delete-group")== 0) {
		$dis_flag = "disabled";
	}
	print "<tr><td><button dojoType=\"dijit.form.Button\" type=\"button\" onclick=\"submitDeleteGroup();\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconDelete\" title=\"Delete selected groups\" $dis_flag>Delete</button></td>\n";
	$dis_flag="";
	if(CloudUtils->checkCapability($USERID, "add-group")== 0) {
		$dis_flag = "disabled";
	}
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"navLink('listGroup', 'portal.cgi?function=addGroupForm');\" baseClass=tundra iconClass=\"dijitIcon dijitIconNewTask\" title=\"Create a new group\" $dis_flag>Create a group</button></td>\n";
	print "</tr></table>\n";
	print "</th></tr>";

	print "<tr class='tab_head'><td><input type=checkbox name=selectAll onClick=\"select_all()\" title=\"Select/Deselect all\"></td>
			<td width=100><a href=\"javascript:sortGroupTab('name');\" title=\"Sort by ID\">Group Name</a></td>
			<td width=200><a href=\"javascript:sortGroupTab('owner');\" title=\"Sort by Owner\">Owner</a></td>
			<td width=200>Member</td>
			<td width=100>Description</td>
		  </tr>";
	print "<tr><td colspan=8><b>Loading...</b></td></tr>";

	print "</table>";
	print "</form>";

	print "<script language=\"javascript\" type=\"text/javascript\" src=\"/hpccloud/scripts/UserGroupView.js\"></script>\n";
	my $script = <<"SCRIPT";
<script type="text/javascript" language="JavaScript">
function select_all(){
	var checked;
	if (document.groupForm.selectAll.checked) checked=true;
	else checked=false;
	var inputs = document.getElementsByTagName("input");	 
	for(var i=0;i<inputs.length;i++)	 
	{	 
		if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].getAttribute("name") == "groupID") 
		{	 
		 inputs[i].checked = checked;	 
		}	 
	}
}
showUserGroups();
</script>
SCRIPT

	print $script;


}

sub deleteGroup {
	my ($query) = @_;
	my @groups = $query->param('groupID');
	print "<deleteGroup>";
	foreach my $group (@groups) {
		my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/usermgt/hcrmgroup --groupid=$group\"";
		my $output = `$cmd`;
		print $output;
	}
	print "</deleteGroup>";
}

sub addGroupForm {
	my ($query) = @_;
	my $uhash = CloudUtils->getAllUser;
	my @allUName = sort keys %$uhash;
	my $allUserOpts;
	foreach my $uname (@allUName) {
		if($USERID ne $uname){
			$allUserOpts .= "<option value=\"$uname\">$uname</option>";
		}
	}

	print "<h3><b>Specify the information of the group you want to add: </b><h3><p>";
	print "<form id='addGroupForm' name='addGroupForm' method=post action=portal.cgi>";
	print "<blockquote><table border=0 cellpadding=2 cellspacing=2>";
	print "<input type=hidden name=function value=addGroup>";

	print "<tr><td class=formprompt>Group Name * :</td>";
	print "<td><input type=text name=groupname size=10 style=\"font-family:verdana\"></td></tr>\n";

	print "<tr><td class=formprompt>Group Users * :</td>";
	print "<td>";
	print "<table>";
	print "<tr><td>Users</td><td></td><td>Users in group</td></tr>";
	print "<tr><td><select class=formfield multiple=\"multiple\" name=allUsers id=allUsers size=6 style=\"width:200px;\">$allUserOpts</select></td>";
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"moveItem('allUsers', 'guser');\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconRedo\" showLabel=false>-></button><br>";
	print "<button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"moveItem('guser', 'allUsers');\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconUndo\" showLabel=false><-</button></td>";
	print "<td><select class=formfield multiple=\"multiple\" name=guser id=guser size=6 style=\"width:200px;\"><option value=\"$USERID\">$USERID</option></select></td>";
	print "</table>";
	print "</td>";

	print "<tr><td class=formprompt>Description :</td>";
	print "<td><input type=text name=description size=40 style=\"font-family:verdana\"></td></tr>\n";

	print "</table></blockquote>";

	print "<p><button dojoType=\"dijit.form.Button\" type=\"button\" iconClass=\"dijitEditorIcon dijitEditorIconTabIndent\" onClick=\"submitAddGroup();\">Submit</button>";
	print "</form>";
}

sub addGroup {
	my ($query) = @_;

	my $name = $query->param('groupname');
	if (!$name) {
		error ("Specify a group name.");
	}
	my $comments = $query->param('description');
	my @users = $query->param('guser');
#	Allow the owner is not the member of the group
#	push @users, $USERID;

	my %hash = map { $_, 1} @users;
	my @uniqUsers = keys %hash;

	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/usermgt/hcmkgroup";
	$cmd .= " --groupid=\'$name\' --ownerid=\'$USERID\'";
	$cmd .= " --userlist=" . (join ',', @uniqUsers);
	if($comments){
		$cmd .= " --comments=\'$comments\'";
	}
	$cmd .= "\"";
	my $output = `$cmd`;
	print $output;
}

sub updateGroupForm {
	my ($query) = @_;
	my $gname = $query->param('gname');

	if (!$gname) { error("Specify a group name."); }

	my $groups = CloudUtils->getAllGroup;
	my $group = $groups->{$gname};
	my $desc = $group->{'user_group.description'};
	if(!defined($desc)){
		$desc = "";
	}
	my $disable = "";
	if(($group->{"user_group.owner"} ne $USERID) && (CloudUtils->checkCapability($USERID, "modify-group")== 0)){
		$disable = "disabled";
	}

	my @userInGroup;
	foreach my $username (@{$group->{'user-list'}->{'user'}}) {
		push @userInGroup, $username->{'user.name'};
	}

	if (!$group) { error("The group doesn't exist or you are not owner of this group."); }

	my $uhash = CloudUtils->getAllUser;
	my @allUName = sort keys %$uhash;
	my $allUserOpts="";
	my $gUserOpts="";
	foreach my $uname (@allUName) {
		if (grep /^$uname$/, @userInGroup) {
			$gUserOpts .= "<option value=\"$uname\">$uname</option>";
		} else {
			$allUserOpts .= "<option value=\"$uname\">$uname</option>";
		}
	}
	print "<h3><b>Specify the information of the group: </b></h3><p>";
	print "<form name='changeGroupForm' id='changeGroupForm' method=post action=portal.cgi>";
	print "<blockquote><table border=0 cellpadding=2 cellspacing=2>";
	print "<input type=hidden name=function value=updateGroup>";
	print "<input type=hidden name=gname value='$gname'>";

	print "<tr><td class=formprompt>Group Name * :</td>";
	print "<td><font style=\"font-family:verdana\">$gname</font></td></tr>\n";

	print "<tr><td class=formprompt>Group Users * :</td>";
	print "<td>";
	print "<table>";
	print "<tr><td>Users</td><td></td><td>Users in group</td></tr>";
	print "<tr><td><select class=formfield multiple=\"multiple\" name=allUsers id=allUsers size=6 style=\"width:200px;\" $disable>$allUserOpts</select></td>";
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"moveItem('allUsers', 'guser');\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconRedo\" showLabel=false $disable>-></button><br>";
	print "<button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"moveItem('guser', 'allUsers');\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconUndo\" showLabel=false $disable><-</button></td>";
	print "<td><select class=formfield multiple=\"multiple\" name=guser id=guser size=6 style=\"width:200px;\" $disable>$gUserOpts</select></td>";
	print "</table>";
	print "</td></tr>";
	print "<tr><td class=formprompt>Description :</td>";
	print "<td><input type=text name=description size=70 style=\"font-family:verdana\" value=\'$desc\' $disable></td></tr>\n";
	print "</table></blockquote>";

	print "<p><button dojoType=\"dijit.form.Button\" type=\"button\" iconClass=\"dijitEditorIcon dijitEditorIconTabIndent\" onClick=\"submitChangeGroup();\" $disable>Submit</button>";
	print "</form>";
}

sub updateGroup {
	my ($query) = @_;

	my $name = $query->param('gname');
	my @users = $query->param('guser');
	my $desc = $query->param('description');
	push @users, $USERID;

	my %hash = map { $_, 1} @users;
	my @uniqUsers = keys %hash;

	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/usermgt/hcchgroup";
	$cmd .= " --groupid=\'$name\'";
	$cmd .= " --userlist=" . (join ',', @uniqUsers);
	if($desc){
		$cmd .= " --comments=\'$desc\'";
	}
	else{
		$cmd .= " --comments=\' \'";
	}
	$cmd .= "\"";

	my $output = `$cmd`;
	print $output;
}

sub changePasswordForm {
	my ($query) = @_;

	print "<h3><b>Change password:</b></h3><p>";
	print "<form id=passwdform method=post action=portal.cgi>";
	print "<blockquote><table border=0 cellpadding=2 cellspacing=2>";
	print "<input type=hidden name=function value=changePassword>";
	print "<input type=hidden name=userid value=\"$USERID\">";

	print "<tr><td class=formprompt colspan=2>Old Password * :</td>";
	print "<td><input type=password name=oldpasswd size=30 style=\"font-family:verdana\"></td></tr>\n";

	print "<tr><td class=formprompt colspan=2>New Password * :</td>";
	print "<td><input type=password name=passwd size=30 style=\"font-family:verdana\"></td><td class=formprompt>Equal or greater than 6 characters</td></tr>\n";
	print "<tr><td class=formprompt colspan=2>Repeat Password * :</td>";
	print "<td><input type=password name=rePasswd size=30 style=\"font-family:verdana\"></td><td class=formprompt>Equal or greater than 6 characters</td></tr>\n";

	print "</table></blockquote>";

	print "<p><button dojoType=\"dijit.form.Button\" type=\"button\" onclick=\"submitChangePasswd();\" iconClass=\"dijitEditorIcon dijitEditorIconTabIndent\">Submit</button>";
	print "</form>";
}

sub changePassword {
	my ($query) = @_;

	my $userid = $query->param('userid');

	my $rv;
	if (!$userid) {
		error("Specify a user ID.");
	}

	my $oldpasswd = $query->param('oldpasswd');
	my $passwd = $query->param('passwd');
	my $rePasswd = $query->param('rePasswd');
	if (length($passwd)<6) {
		error("Password length must be equal or greater than 6.");
	}
	if ($passwd != $rePasswd) {
		error("New Password and Repeat Password do not match.");
	}

	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/usermgt/hcchuser --userid=\'$userid\' --oldpassword=\'$oldpasswd\' --newpassword=\'$passwd\'\"";

	my $output = `$cmd`;
	print $output;
}

sub vlanConfigInfo {
	print "<h3><b>Network Topology:</b></h3><p>";
	print "<form id='vlanConfForm' name='vlanConfForm' method=post action=portal.cgi>";
	print "<input type=hidden name=function value=deleteVlan>";
	print "<table id=\"vlanListTab\" border=0;cellpadding=2 cellspacing=2 bgcolor=#e3e3d1 sytle=\"text-align:center\">";
	print "<tr valign=\"middle\">
 <th align=\"left\" colspan=8>\n";
	print "<table>";
	print "<tr><td><button dojoType=\"dijit.form.Button\" type=\"button\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconDelete\" title=\"Delete selected Nodes\" onclick=\"submitDeleteVlan();\" >Delete</button></td>\n";
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"navLink('vlanConfig', 'portal.cgi?function=addVlanForm');\" baseClass=tundra iconClass=\"dijitIcon dijitIconNewTask\" title=\"Add a new node\" >Add a node</button></td>\n";
	print "</tr>";
	print "</table>\n";
	print "</th></tr>";
	print "<tr class='tab_head'>
			<td><input type=checkbox name=selectAll onClick=\"select_all()\" title=\"Select/Deselect all\"></td>
			<td width=100><a href=\"javascript:sortVlanTab('name');\" title=\"Sort by ID\">Node Name</td>
			<td width=100>Switch Name</td>
			<td width=200>bandwitch</td>
			<td width=100>Connected Port</td>
			<td width=100>vlan ID</td>
			<td width=100>comments</td>
		  </tr>";	 
	print "</form>";
	print "<script language=\"javascript\" type=\"text/javascript\" src=\"/hpccloud/scripts/VlanView.js\"></script>\n";
	my $script = <<"SCRIPT";
<script type="text/javascript" language="JavaScript">
function select_all(){
	var checked;
	if (document.vlanConfForm.selectAll.checked) checked=true;
	else checked=false;
	var inputs = document.getElementsByTagName("input");	 
	for(var i=0;i<inputs.length;i++)	 
	{	 
		if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].getAttribute("name") == "VlanCheck") 
		{	 
		 inputs[i].checked = checked;	 
		}	 
	}	 
}
	showVlan();
</script>
SCRIPT

	print $script;
}
sub deleteVlan {
	my ($query) = @_;
	my @vlans = $query->param('VlanCheck');

	print "<delete_result>\n";
	foreach my $vlan (@vlans) {
		my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/sysconfig/hcrmnode2switch --nodeName=$vlan\"";
		my $output = `$cmd`;
		print $output;
	}
	print "</delete_result>\n";
}
sub addVlanForm {
	my ($query) = @_;
	my $switchinfo;
	my $ret;
	($ret,$switchinfo) = CloudUtils->getswitchinfo();
	print "<h3><b>Specify the information of the vlan you want to add: </b></h3><p>";
	print "<form id=addVlanForm method=post action=portal.cgi>";
	print "<blockquote><table border=0 cellpadding=2 cellspacing=2>";
	print "<input type=hidden name=function value=addVlan>";
	print "<tr><td class=formprompt>Node Name * :</td>";
	print "<td><input type=text name=nodename size=30 style=\"font-family:verdana\"></td></tr>\n";
	print "<tr><td class=formprompt>Switch Name * :</td>";
	print "<td><select id=\"swithselect\" name=\"swithselect\" size=1>";
	print "<option value=\"none\" selected>- Select Switch -</option>";
	foreach my $switchname (keys(%$switchinfo))
	{
		print "<option value=\"$switchname\">$switchname</option>";
	}
	print "</select>";
	print "</td>";
	print "<tr><td class=formprompt>Connected Port * :</td>";
	print "<td><input type=text name=portid size=30 style=\"font-family:verdana\"></td></tr>\n";
	print "<tr><td class=formprompt>bandwidth :</td>";
	print "<td><input type=text name=bandwidth size=30 style=\"font-family:verdana\"></td></tr>\n";
	print "<tr><td class=formprompt>comments :</td>";
	print "<td><input type=text name=comments size=30 style=\"font-family:verdana\"></td></tr>\n";
	print "</td></tr>\n";
	print "</table></blockquote>";

	print "<p><button dojoType=\"dijit.form.Button\" type=\"button\" onclick=\"submitAddVlan();\" iconClass=\"dijitEditorIcon dijitEditorIconTabIndent\">Submit</button>";
	print "</form>";
}

sub addVlan {
	my ($query) = @_;

	my $nodename = $query->param('nodename');
	my $switchname = $query->param('swithselect');
	my $bandwidth = $query->param('bandwidth');
	my $portid = $query->param('portid');
	my $vlanid = $query->param('vlanid');
	my $comments = $query->param('comments');
	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/sysconfig/hcmknode2switch";
	if ($nodename eq "") {
		error("Specify a nodename.");
	}
	if ($switchname eq "") {
		error("Specify a switchname.");
	}
	if ($portid eq "") {
		error("Specify a portid.");
	}
	$cmd .= " --nodeName=\'$nodename\' --switchName=\'$switchname\' --port=\'$portid\'";
	if($bandwidth){
		$cmd .= " --bandwidth=\'$bandwidth\'";
	}
	if($comments){
		$cmd .= " --comments=\'$comments\'";
	}
	$cmd .= "\"";
	my $output = "<result>";
	$output .= `$cmd`;
	$output .= "</result>";
	print $output;
}

sub updateVlanForm {
	my ($query) = @_;
	my $nodename = $query->param('nodename');
	my $element={
		'node_name'=>$nodename,
	};
	my $nodeinfo;
	my $ret;
	($ret,$nodeinfo) = CloudUtils->getnode2switchinfo($element);
	my $tmptext;
	my $switchinfo;
	my $ret_temp;
	($ret_temp,$switchinfo) = CloudUtils->getswitchinfo();
		
	print "<h3><b>Specify the information of the Vlan you want to Update: </b><h3><p>";
	print "<form id='updateVlanForm' method=post action=portal.cgi>";
	print "<blockquote><table border=0 cellpadding=2 cellspacing=2>";
	print "<input type=hidden name=function value=updateVlan>";
	print "<tr><td class=formprompt>Node Name * :</td>";
	print "<td><input type=text name=nodename size=10 style=\"font-family:verdana\" value=\'$nodename\' readonly></td></tr>\n";
	$tmptext = $nodeinfo->{"$nodename"}->{"switchportconfig.switch_name"};
	print "<tr><td class=formprompt>Switch Name * :</td>";
	print "<td><select id=\"swithselect\" name=\"swithselect\" size=1>";
	print "<option value=\"$tmptext\" selected>$tmptext</option>";
	foreach my $switchname (keys(%$switchinfo)) {
		if ($switchname ne $tmptext) {
			print "<option value=\"$switchname\">$switchname</option>";
		}
	}
	print "</select>";
	print "<tr><td class=formprompt>Port ID * :</td>";
	$tmptext = $nodeinfo->{"$nodename"}->{"switchportconfig.port_id"};
	print "<td><input type=text name=portid size=10 style=\"font-family:verdana\" value=\'$tmptext\' ></td></tr>\n";
	print "<tr><td class=formprompt>bandwidth :</td>";
	$tmptext = $nodeinfo->{"$nodename"}->{'switchportconfig.bandwidth'};
	print "<td><input type=text name=bandwidth size=10 style=\"font-family:verdana\" value=\'$tmptext\'></td></tr>\n";
	print "<tr><td class=formprompt>comments :</td>";
	$tmptext = $nodeinfo->{"$nodename"}->{"switchportconfig.description"};
	print "<td><input type=text name=comments size=10 style=\"font-family:verdana\" value=\'$tmptext\' ></td></tr>\n";
	print "</table>";
		
	print "</td></tr>\n";
	print "</table></blockquote>";
	print "<p><button dojoType=\"dijit.form.Button\" type=\"button\" onclick=\"submitUpdateVlan();\" iconClass=\"dijitEditorIcon dijitEditorIconTabIndent\">Submit</button>";
	print "</form>";
}

sub updateVlan {
	my ($query) = @_;

	my $nodename = $query->param('nodename');
	my $switchname = $query->param('swithselect');
	my $bandwidth = $query->param('bandwidth');
	my $portid = $query->param('portid');
	my $vlanid = $query->param('vlanid');
	my $comments = $query->param('comments');
		my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/sysconfig/hcchnode2switch";
	if ($nodename eq "") {
		error("Specify a nodename.");
	}
	if ($switchname eq "") {
		error("Specify a switchname.");
	}
	if ($portid eq "") {
		error("Specify a portid.");
	}
	$cmd .= " --nodeName=\'$nodename\' --switchName=\'$switchname\' --port=\'$portid\'";
	if($bandwidth) {
		$cmd .= " --bandwidth=\'$bandwidth\'";
	}
	if($comments) {
		$cmd .= " --comments=\'$comments\'";
	}
	$cmd .= "\"";
	my $output = "<result>";
	$output .= `$cmd`;
	$output .= "</result>";
	print $output;
}
sub switchConfigInfo {
	print "<h3><b>Switch Configuration:</b></h3><p>";
	print "<form id='switchConfForm' name='switchConfForm' method=post action=portal.cgi>";
	print "<input type=hidden name=function value=deleteSwitch>";
	print "<table id=\"switchListTab\" border=0;cellpadding=2 cellspacing=2 bgcolor=#e3e3d1 sytle=\"text-align:center\">";
	print "<tr valign=\"middle\">
 <th align=\"left\" colspan=8>\n";
	print "<table>";
	print "<tr><td><button dojoType=\"dijit.form.Button\" type=\"button\" baseClass=tundra iconClass=\"dijitEditorIcon dijitEditorIconDelete\" title=\"Delete selected Switchs\" onclick=\"submitDeleteSwitch();\" >Delete</button></td>\n";
	print "<td><button dojoType=\"dijit.form.Button\" type=\"button\" onClick=\"navLink('switchConfig', 'portal.cgi?function=addSwitchForm');\" baseClass=tundra iconClass=\"dijitIcon dijitIconNewTask\" title=\"Add a new switch\" >Add a switch</button></td>\n";
	print "</tr>";
	print "</table>\n";
	print "</th></tr>";
	print "<tr class='tab_head'>
			<td><input type=checkbox name=selectAll onClick=\"select_all()\" title=\"Select/Deselect all\"></td>
			<td width=100><a href=\"javascript:sortSwitchTab('name');\" title=\"Sort by Switch Name\">Switch Name</td>
			<td width=200>IP Address</td>
			<td width=100>Switch PortNum</td>
			<td width=100>description</td>
		  </tr>";	 
	print "</form>";
	print "<script language=\"javascript\" type=\"text/javascript\" src=\"/hpccloud/scripts/SwitchView.js\"></script>\n";
	my $script = <<"SCRIPT";
<script type="text/javascript" language="JavaScript">
function select_all(){
	var checked;
	if (document.switchConfForm.selectAll.checked) checked=true;
	else checked=false;
	var inputs = document.getElementsByTagName("input");	 
	for(var i=0;i<inputs.length;i++)	 
	{	 
		if(inputs[i].getAttribute("type") == "checkbox" && inputs[i].getAttribute("name") == "SwitchCheck") 
		{	 
		 inputs[i].checked = checked;	 
		}	 
	}	 
}
	showSwitch();
</script>
SCRIPT

	print $script;
}

sub deleteSwitch {
	my ($query) = @_;
	my @switchs = $query->param('SwitchCheck');

	print "<delete_result>\n";
	foreach my $switch (@switchs) {
		my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/sysconfig/hcrmswitch --switchName=$switch\"";
		my $output = `$cmd`;
		print $output;
	}
	print "</delete_result>\n";
}

sub addSwitchForm {
	my ($query) = @_;
	print "<h3><b>Specify the information of the switch you want to add: </b></h3><p>";
	print "<form id=addSwitchForm method=post action=portal.cgi>";
	print "<blockquote><table border=0 cellpadding=2 cellspacing=2>";
	print "<input type=hidden name=function value=addSwitch>";
	print "<tr><td class=formprompt>Switch Name * :</td>";
	print "<td><input type=text name=switchname size=30 style=\"font-family:verdana\"></td></tr>\n";
	print "<tr><td class=formprompt>IP Address * :</td>";
	print "<td><input type=text name=ipaddress size=30 style=\"font-family:verdana\"></td></tr>\n";
	print "<tr><td class=formprompt>Switch PortNum :</td>";
	print "<td><input type=text name=switchportnum size=30 style=\"font-family:verdana\"></td></tr>\n";
	print "<tr><td class=formprompt>Description :</td>";
	print "<td><input type=text name=description size=30 style=\"font-family:verdana\"></td></tr>\n";
	print "<tr><td class=formprompt>Switch Long Name :</td>";
	print "<td><input type=text name=switchlongname size=30 style=\"font-family:verdana\"></td></tr>\n";
	print "<tr><td class=formprompt>Snmp Version *:</td>";
	print "<td><input type=text name=snmpversion size=30 style=\"font-family:verdana\"></td></tr>\n";
	print "<tr><td class=formprompt>User Name :</td>";
	print "<td><input type=text name=username size=30 style=\"font-family:verdana\"></td></tr>\n";
	print "<tr><td class=formprompt>Password :</td>";
	print "<td><input type=password name=password size=30 style=\"font-family:verdana\"></td></tr>\n";
	print "<tr><td class=formprompt>authMethod :</td>";
	print "<td><input type=text name=authmethod size=30 style=\"font-family:verdana\"></td></tr>\n";
	print "<tr><td class=formprompt>To Other Switch Port :</td>";
	print "<td><input type=text name=linkports size=30 style=\"font-family:verdana\"></td><td class=formprompt>portID:switchName</td></tr>\n";

	print "</td></tr>\n";
	print "</table></blockquote>";

	print "<p><button dojoType=\"dijit.form.Button\" type=\"button\" onclick=\"submitAddSwitch();\" iconClass=\"dijitEditorIcon dijitEditorIconTabIndent\">Submit</button>";
	print "</form>";
}

sub addSwitch {
	my ($query) = @_;

	my $switchname = $query->param('switchname');
	my $ipaddress = $query->param('ipaddress');
	my $switchportnum = $query->param('switchportnum');
	my $description = $query->param('description');
	my $switchlongname = $query->param('switchlongname');
	my $snmpversion = $query->param('snmpversion');
	my $username = $query->param('username');
	my $password = $query->param('password');
	my $authmethod = $query->param('authmethod');
	my $linkports = $query->param('linkports');
	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/sysconfig/hcmkswitch";
	if ($switchname eq "") {
		error("Specify a nodename.");
	}
	if ($ipaddress eq "") {
		error("Specify a switchname.");
	}
	$cmd .= " --switchName=\'$switchname\' --ipAddress=\'$ipaddress\'";
	if($switchportnum){
		$cmd .= " --switchPortNum=\'$switchportnum\'";
	}
	if($description){
		$cmd .= " --comments=\'$description\'";
	}
	if($switchlongname){
		$cmd .= " --switchLongName=\'$switchlongname\'";
	}
	if($snmpversion){
		$cmd .= " --snmpVersion=\'$snmpversion\'";
	}
	if($username){
		$cmd .= " --userName=\'$username\'";
	}
	if($password){
		$cmd .= " --password=\'$password\'";
	}
	if($authmethod){
		$cmd .= " --authMethod=\'$authmethod\'";
	}
	if($linkports){
		$cmd .= " --linkPorts=\'$linkports\'";
	}
	$cmd .= "\"";
	my $output = "<result>";
	$output .= `$cmd`;
	$output .= "</result>";
	print $output;
}

sub updateSwitchForm {
	my ($query) = @_;
	my $switchname = $query->param('switchname');
	my $element={
		'switch_name'=>$switchname,
	};
	my $switchinfo;
	my $ret;
	($ret,$switchinfo) = CloudUtils->getswitchinfo($element);
	my $tmptext;	  
	print "<h3><b>Specify the information of the Switch you want to Update: </b><h3><p>";
	print "<form id='updateSwitchForm' method=post action=portal.cgi>";
	print "<blockquote><table border=0 cellpadding=2 cellspacing=2>";
	print "<input type=hidden name=function value=updateSwitch>";
	print "<tr><td class=formprompt>Switch Name * :</td>";
	print "<td><input type=text name=switchname size=10 style=\"font-family:verdana\" value=\'$switchname\' readonly></td></tr>\n";
	print "<tr><td class=formprompt>IP Address * :</td>";
	$tmptext = $switchinfo->{"$switchname"}->{'switchconfig.ipaddress'};
	print "<td><input type=text name=ipaddress size=20 style=\"font-family:verdana\" value=\'$tmptext\'></td></tr>\n";
	print "<tr><td class=formprompt>Switch PortNum :</td>";
	$tmptext = $switchinfo->{"$switchname"}->{'switchconfig.port_number'};
	print "<td><input type=text name=switchportnum size=10 style=\"font-family:verdana\" value=\'$tmptext\' ></td></tr>\n";
	print "<tr><td class=formprompt>Description :</td>";
	$tmptext = $switchinfo->{"$switchname"}->{'switchconfig.description'};
	print "<td><input type=text name=description size=50 style=\"font-family:verdana\" value=\'$tmptext\' ></td></tr>\n";
		 
	print "<tr><td class=formprompt>Switch Long Name :</td>";
	$tmptext = $switchinfo->{"$switchname"}->{"xcatInfo"}->{'switch'};
	print "<td><input type=text name=switchlongname size=30 style=\"font-family:verdana\" value=\'$tmptext\'></td></tr>\n";
	print "<tr><td class=formprompt>Snmp Version :</td>";
	$tmptext = $switchinfo->{"$switchname"}->{"xcatInfo"}->{'snmpversion'};
	print "<td><input type=text name=snmpversion size=10 style=\"font-family:verdana\" value=\'$tmptext\'></td></tr>\n";
	print "<tr><td class=formprompt>User Name :</td>";
	$tmptext = $switchinfo->{"$switchname"}->{"xcatInfo"}->{'username'};
	print "<td><input type=text name=username size=20 style=\"font-family:verdana\" value=\'$tmptext\'></td></tr>\n";
	print "<tr><td class=formprompt>Password :</td>";
	print "<td><input type=password name=password size=20 style=\"font-family:verdana\"></td></tr>\n";
	print "<tr><td class=formprompt>authMethod :</td>";
	$tmptext = $switchinfo->{"$switchname"}->{"xcatInfo"}->{'auth'};
	print "<td><input type=text name=authmethod size=20 style=\"font-family:verdana\" value=\'$tmptext\'></td></tr>\n";
	print "<tr><td class=formprompt>To Other Switch Port</td>";
	$tmptext = $switchinfo->{"$switchname"}->{"xcatInfo"}->{'linkports'};
	print "<td><input type=text name=linkports size=30 style=\"font-family:verdana\" value=\'$tmptext\'></td></tr>\n";
 
	print "</table>";
	print "</td></tr>\n";
	print "</table></blockquote>";
	print "<p><button dojoType=\"dijit.form.Button\" type=\"button\" onclick=\"submitUpdateSwitch();\" iconClass=\"dijitEditorIcon dijitEditorIconTabIndent\">Submit</button>";
	print "</form>";
}
sub updateSwitch {
	my ($query) = @_;
	my $switchname = $query->param('switchname');
	my $ipaddress = $query->param('ipaddress');
	my $switchportnum = $query->param('switchportnum');
	my $description = $query->param('description');
	my $switchlongname = $query->param('switchlongname');
	my $snmpversion = $query->param('snmpversion');
	my $username = $query->param('username');
	my $password = $query->param('password');
	my $authmethod = $query->param('authmethod');
	my $linkports = $query->param('linkports');
	my $cmd = "$CLOUD_BIN_DIR/utils/thcsu -u $USERID \"$BIN_DIR/sysconfig/hcchswitch";
	if ($switchname eq "") {
		error("Specify a nodename.");
	}
	if ($ipaddress eq "") {
		error("Specify a switchname.");
	}
	$cmd .= " --switchName=\'$switchname\' --ipAddress=\'$ipaddress\'";
	if($switchportnum){
		$cmd .= " --switchPortNum=\'$switchportnum\'";
	}
	if($description){
		$cmd .= " --comments=\'$description\'";
	}
	if($switchlongname){
		$cmd .= " --switchLongName=\'$switchlongname\'";
	}
	if($snmpversion){
		$cmd .= " --snmpVersion=\'$snmpversion\'";
	}
	if($username){
		$cmd .= " --userName=\'$username\'";
	}
	if($password){
		$cmd .= " --password=\'$password\'";
	}
	if($authmethod){
		$cmd .= " --authMethod=\'$authmethod\'";
	}
	if($linkports){
		$cmd .= " --linkPorts=\'$linkports\'";
	}
	$cmd .= "\"";
	my $output = "<result>";
	$output .= `$cmd`;
	$output .= "</result>";
	print $output;
}
################################################################################
#                                    M A I N                                   #
################################################################################

use Time::Local;
use lib "/opt/ibm/hpccloud/lib";
use CloudUtils;
use EnergyUtils;
use Accounting;
use CGI;
use CmdUtils;
use ProvUtils;
use DB::ImageDAO;
use DB::UserDAO;
use POSIX 'strftime';
# Variable define
my $query = new CGI();
my $catalog;
my $function;
# define end
print $query->header;

if (!CloudUtils->isReady) {
	print "Failed to connect to DB.";
	exit(1); 
}

my $REMOTE_USER = $ENV{REMOTE_USER};
$REMOTE_USER =~ s/['"`]//g;
$USERID = $REMOTE_USER;

$catalog = $query->param('catalog');
if(defined($catalog)){
	$catalog =~ s/['"`]//g;
}else{
	$catalog = "";
}
$function = $query->param('function');
if(defined($function)){
	$function =~ s/['"`]//g;
}else{
	$function = "";
}

$::ISADMIN = CloudUtils->isAdmin($USERID);
$CLOUD_BIN_DIR = $::CONFIG{'CLOUD_TOOL_DIR'};
$BIN_DIR = $::CONFIG{'BIN_DIR'};

if (!CloudUtils->isCloudUser($USERID)) {
	print "Sorry, you are not HPC Cloud user.";
	exit(1);
}
init;

if ($catalog || (!$catalog&&!$function)){
	sendHeader($query);
}

if	($catalog eq "" && !$function)		{ home($query); }
elsif ($catalog eq "request" )			 { request($query); }
elsif ($catalog eq "image" )				{ imageMgt($query); }
elsif ($catalog eq "job" )				 { jobMgt($query); }
elsif ($catalog eq "system" )			  { systemMgt($query); }
elsif ($catalog eq "energy" )			  { energyMgt($query); }
elsif ($catalog eq "billing" )			 { billing($query); }
elsif ($catalog eq "user")				 { userMgt($query); }
elsif ($catalog)  { error("Unknown catalog: \"$catalog\""); }

if ($catalog || (!$catalog&&!$function)) { exit 0 };

if ($function eq 'viewJobs')			 { viewJobs($query); }
elsif ($function eq 'viewJobsList')		 { viewJobsbyList($query); }
elsif ($function eq 'viewJobsListContent')  { viewJobsbyListContent($query); }
elsif ($function eq 'viewJobsGraph')		{ viewJobsbyGraphic($query); }
elsif ($function eq 'jobAction')			{ jobAction($query); }
elsif ($function eq 'jobCommand')			{ jobCommand($query); }
elsif ($function eq 'submitJCF')			{ submitJCF($query); }
elsif ($function eq 'runJCF')				{ runJCF($query); }
elsif ($function eq 'buildJob')			 { buildJob($query); }
elsif ($function eq 'listMach')			 { listMach($query); }
elsif ($function eq 'reqMach')			  { reqMach($query); }
elsif ($function eq 'reqImage')			 { reqImage($query); }
elsif ($function eq 'reqApps')			  { reqApps($query); }
elsif ($function eq 'setAuthority')		 { setAuthority($query); }
elsif ($function eq 'summary')			  { summary($query); }
elsif ($function eq 'createProv')			{ createProv($query); }
elsif ($function eq 'lookup')				{ lookup($query); }
elsif ($function eq 'listProv')			 { listProv($query); }
elsif ($function eq 'listProvList')		 { viewProvInList($query); }
elsif ($function eq 'listProvCal')		  { viewProvInCal($query); }
elsif ($function eq 'editProv')			 { editProv($query); }
elsif ($function eq 'listUser')			 { listUser($query); }
elsif ($function eq 'listRole')			 { listRole($query); }
elsif ($function eq 'listGroup')			{ listGroup($query); }
elsif ($function eq "billingInfo" )		 { billingInfo($query); }
elsif ($function eq 'config')				{ config($query); }
elsif ($function eq 'about')				{ about($query); }
elsif ($function eq 'removeProv')			{ removeProv($query); }
elsif ($function eq 'updateProv')			{ updateProv($query); }
elsif ($function eq 'deleteUser')			{ deleteUser($query); }
elsif ($function eq 'resetUser')			{ resetUser($query); }
elsif ($function eq 'addUserForm')		  { addUserForm($query); }
elsif ($function eq 'addUser')			  { addUser($query); }
elsif ($function eq 'updateUserForm')		{ updateUserForm($query); }
elsif ($function eq 'updateUser')			{ updateUser($query); }
elsif ($function eq 'changePasswordForm')	{ changePasswordForm($query); }
elsif ($function eq 'changePassword')		{ changePassword($query); }
elsif ($function eq 'deleteRole')			{ deleteRole($query); }
elsif ($function eq 'addRoleForm')		  { addRoleForm($query); }
elsif ($function eq 'addRole')			  { addRole($query); }
elsif ($function eq 'updateRoleForm')		{ updateRoleForm($query);}
elsif ($function eq 'updateRole')			{ updateRole($query); }
elsif ($function eq 'addGroupForm')		 { addGroupForm($query); }
elsif ($function eq 'addGroup')			 { addGroup($query); }
elsif ($function eq 'deleteGroup')		  { deleteGroup($query); }
elsif ($function eq 'updateGroupForm')	  { updateGroupForm($query); }
elsif ($function eq 'updateGroup')		  { updateGroup($query); }
elsif ($function eq 'accounting')			{ accounting($query); }
elsif ($function eq 'logout')				{ logout($query); }
elsif ($function eq 'upload')				{ upload($query); }
elsif ($function eq 'multiUpload')		  { multiUpload($query); }
elsif ($function eq 'uploadFile')			{ uploadFile($query); }
elsif ($function eq 'xuploadFile')		  { xuploadFile($query); }
elsif ($function eq 'uploadMultiFile')	  { uploadMultiFile($query); }
elsif ($function eq 'fileStatus')			{ fileStatus($query); }
elsif ($function eq 'machStatus')			{ machStatus($query); }
elsif ($function eq 'setMachPower')		 { setMachPower($query); }
elsif ($function eq 'applyEScheme')		 { applyEScheme($query); }
elsif ($function eq 'provStatus')			{ provStatus($query); }
elsif ($function eq 'listImage')			{ listImage($query); }
elsif ($function eq 'listImageDetail')	  { listImageDetail($query); }
elsif ($function eq 'captureImageForm')	 { captureImageForm($query); }
elsif ($function eq 'innerMakeImageForm')	{ innerMakeImageForm($query); }
elsif ($function eq 'innerCapImageForm')	{ innerCapImageForm($query); }
elsif ($function eq 'makeImage')			{ makeImage($query); }
elsif ($function eq 'captureImage')		 { captureImage($query); }
elsif ($function eq 'deleteImage')		  { deleteImage($query); }
elsif ($function eq 'approveImage')		 { approveImage($query); }
elsif ($function eq 'sysEnergy')			{ sysEnergy($query); }
elsif ($function eq 'energyScheme')		 { energyScheme($query); }
elsif ($function eq 'addEnergyScheme')	  { addEnergyScheme($query); }
elsif ($function eq 'modEnergyScheme')	  { modEnergyScheme($query); }
elsif ($function eq 'deleteEnergyScheme')	{ deleteEnergyScheme($query); }
elsif ($function eq 'addEnergyPolicy')	  { addEnergyPolicy($query); }
elsif ($function eq 'modEnergyPolicy')	  { modEnergyPolicy($query); }
elsif ($function eq 'deleteEnergyPolicy')	{ deleteEnergyPolicy($query); }
elsif ($function eq 'reqByName')			{ reqByName($query); }
elsif ($function eq 'reqByType')			{ reqByType($query); }
elsif ($function eq 'makeHypv')			 { makeHypv($query); }
elsif ($function eq 'sysConfigInfo')			  { sysConfigInfo($query); }
elsif ($function eq 'modSysconf')				 { modSysconf($query); }
elsif ($function eq 'addmach2cloudForm')		  { addmach2cloudForm($query); }
elsif ($function eq 'addmach2cloud')			  { addmach2cloud($query); }
elsif ($function eq 'vlanConfigInfo')			 { vlanConfigInfo($query); }
elsif ($function eq 'addVlanForm')				{ addVlanForm($query); }
elsif ($function eq 'updateVlanForm')			 { updateVlanForm($query); }
elsif ($function eq 'listVlanXML')				{ listVlanXML($query); }				
elsif ($function eq 'addVlan')					{ addVlan($query); }
elsif ($function eq 'deleteVlan')				 { deleteVlan($query); }
elsif ($function eq 'updateVlan')				 { updateVlan($query); }
elsif ($function eq 'switchConfigInfo')			{ switchConfigInfo($query); }
elsif ($function eq 'addSwitchForm')			  { addSwitchForm($query); }
elsif ($function eq 'updateSwitchForm')			{ updateSwitchForm($query); }
elsif ($function eq 'addSwitch')				  { addSwitch($query); }
elsif ($function eq 'deleteSwitch')				{ deleteSwitch($query); }
elsif ($function eq 'updateSwitch')				{ updateSwitch($query); }
elsif ($function eq 'listImagePackage')			{ listImagePackage($query); }
elsif ($function eq 'addPackageDlg')			  { addPackageDlg($query); }
elsif ($function eq 'addPackage')				 { addPackage($query); }
elsif ($function eq 'deletePackage')			  { deletePackage($query); }
elsif ($function eq 'listImageScript')			{ listImageScript($query); }
elsif ($function eq 'addScriptDlg')				{ addScriptDlg($query); }
elsif ($function eq 'addScript')				  { addScript($query); }
elsif ($function eq 'deleteScript')				{ deleteScript($query); }
elsif ($function eq 'approvePackage')			 { approvePackage($query); }
elsif ($function eq 'approveScript')			  { approveScript($query); }
else  { error("Unknown function: \"$function\""); }

